"XDBObject_AutoAPI.st Generated at 2018-09-22 00:03:01.564."
'Class AutoAPI file for Class DBObject.'!

!DocumentDictionary100.Core.Model.XDBObject class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XDBObject in the DomainModel DocumentDictionary100f"

	^'Abstract class that holds attributes needed for administration and persistent storage.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XDBObject'.!

canStoreClass: aClass
	"class autoAPI method called by generated code to the object that implements a storage factory."

	"The default implementation assumes it can store instances of aClass if the class responds to the autoAPI protocol. It can be overridden in a manually maintained subclass."
	^(aClass respondsTo: #createInstanceForClass:)!

createInstanceForClass: aClass
	"class autoAPI method called by generated code to the object that implements a storage factory, and is responsible for creating new instances."

	"The default implementation assumes aClass is a standard Smalltalk class that responds to new and initialize. It can be overridden in a manually maintained subclass."

	| inst |
	inst := aClass new.
	inst initialize.
	^inst!

 !

!DocumentDictionary100.Core.Model.XDBObject methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XDBObject in the DomainModel DocumentDictionary100f."

	^'Abstract class that holds attributes needed for administration and persistent storage.'.!

getStorage
	"Return the storage that serves as factory for new instances."

	"The default implementation returns the class of this instance. It can be overridden in the manually maintained subclass."
	^self class.!

dberror: aSourceOfErrorTitle message: anErrorMessage
	"Handler of error messages when automatically generated methods are called with wrong parameters, or report attempted integrity constraint violations."

	"This method can be overridden in subclasses, where for example a chosen exception for this resumable event is thrown."
	"If aSourceOfErrorTitle contains the text Internal Error, this method should throw a non-proceedable exception."

	"The variable names in the signature of this method, and the body statement below can be configured in the OOCASE DomainModelWindow->Generate->Smalltalk export definition file under:"
	"[EXPORT]"
	"DBERROR_MESSAGE_BODY = ^Smalltalk.UI.Dialog warn: (aSourceOfErrorTitle, (String with: Character cr with: Character cr), anErrorMessage )
"

	^self halt.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitApprovedBy.
	self attInitCheckedBy.
	self attInitCreatedBy.
	self attInitDtAdded.
	self attInitDtApproved.
	self attInitDtChecked.
	self attInitDtModified.
	self attInitHighId.
	self attInitLocked.
	self attInitLowId.
	self attInitModifiedBy.
	self attInitRelease.
	self attInitReleaseBasedOnHighId.
	self attInitReleaseBasedOnLowId.
	self attInitReleaseBasedOnRelease.
	self attInitReleaseBasedOnVersion.
	self attInitVersion.



	
!
canDelete
	"Return true if this DBObject can be deleted without violating cardinality constraints."



	^true!

getOwner
	"Return owner of this XDBObject if there is one, else return nil."


	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."





	!

 !

!DocumentDictionary100.Core.Model.XDBObject methodsFor: 'attributeAPI'!

attGetApprovedBy
	"Get value of attribute ApprovedBy"
	"The login-id of the person who has approved this object."

	^attApprovedBy.!

attGetCheckedBy
	"Get value of attribute CheckedBy"
	"The login-id of the person who has checked this object and recommended it for approval."

	^attCheckedBy.!

attGetCreatedBy
	"Get value of attribute CreatedBy"
	"Login identifier for user who created this object."

	^attCreatedBy.!

attGetDtAdded
	"Get value of attribute DtAdded"
	"Timestamp when this object was first added to the data dictionary."

	^attDtAdded.!

attGetDtApproved
	"Get value of attribute DtApproved"
	"Timestamp when this object was approved for release."

	^attDtApproved.!

attGetDtChecked
	"Get value of attribute DtChecked"
	"Timestamp when the checking of this object was completed and reported."

	^attDtChecked.!

attGetDtModified
	"Get value of attribute DtModified"
	"Timestamp when this object was last modified."

	^attDtModified.!

attGetHighId
	"Get value of attribute HighId"
	"Higher part of globally unique object identifier assigned automatically by the datadictionary application. Serves as higher 64-bit part of a 128-bit key."

	^attHighId.!

attGetLocked
	"Get value of attribute Locked"
	"A flag set to signal prevention of changes and deletion of the object. Used for supporting reuse of versions and released versions of submodels."

	^attLocked.!

attGetLowId
	"Get value of attribute LowId"
	"Lower part of globally unique object identifier assigned automatically by the datadictionary application. Serves as lower 64-bit part of a 128-bit key."

	^attLowId.!

attGetModifiedBy
	"Get value of attribute ModifiedBy"
	"Login identifier for the user who did the latest modification to this object."

	^attModifiedBy.!

attGetRelease
	"Get value of attribute Release"
	"Specifies an identifier of the latest release in which this version of the object was published."

	^attRelease.!

attGetReleaseBasedOnHighId
	"Get value of attribute ReleaseBasedOnHighId"
	"HighId part of primary key identifier to the previous version of this object on which it was based, before it was assigned a new globally unique object identifier in the release process."

	^attReleaseBasedOnHighId.!

attGetReleaseBasedOnLowId
	"Get value of attribute ReleaseBasedOnLowId"
	"LowId part of primary key identifier to the previous version of this object on which it was based, before it was assigned a new globally unique object identifier in the release process."

	^attReleaseBasedOnLowId.!

attGetReleaseBasedOnRelease
	"Get value of attribute ReleaseBasedOnRelease"
	"The previous release of this object on which it was based, before it was edited and automatically cleared from its release identifier."

	^attReleaseBasedOnRelease.!

attGetReleaseBasedOnVersion
	"Get value of attribute ReleaseBasedOnVersion"
	"The previous version of this object on which it was based, before it was edited and automatically assigned a new edition identifier or an explicit version identifier."

	^attReleaseBasedOnVersion.!

attGetVersion
	"Get value of attribute Version"
	"Defines the version identifier for the object. See the definition of the ValueDomain Version for more details."

	^attVersion.!

attIqApprovedBy
	"Return the information quantity of attribute ApprovedBy"
	"180413 This is a default implementation that can be extended later"

	^attApprovedBy ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqCheckedBy
	"Return the information quantity of attribute CheckedBy"
	"180413 This is a default implementation that can be extended later"

	^attCheckedBy ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqCreatedBy
	"Return the information quantity of attribute CreatedBy"
	"180413 This is a default implementation that can be extended later"

	^attCreatedBy ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqDtAdded
	"Return the information quantity of attribute DtAdded"
	"180413 This is a default implementation that can be extended later"

	^attDtAdded ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqDtApproved
	"Return the information quantity of attribute DtApproved"
	"180413 This is a default implementation that can be extended later"

	^attDtApproved ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqDtChecked
	"Return the information quantity of attribute DtChecked"
	"180413 This is a default implementation that can be extended later"

	^attDtChecked ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqDtModified
	"Return the information quantity of attribute DtModified"
	"180413 This is a default implementation that can be extended later"

	^attDtModified ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqHighId
	"Return the information quantity of attribute HighId"
	"180413 This is a default implementation that can be extended later"

	^attHighId ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqLocked
	"Return the information quantity of attribute Locked"
	"180413 This is a default implementation that can be extended later"

	^attLocked ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqLowId
	"Return the information quantity of attribute LowId"
	"180413 This is a default implementation that can be extended later"

	^attLowId ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqModifiedBy
	"Return the information quantity of attribute ModifiedBy"
	"180413 This is a default implementation that can be extended later"

	^attModifiedBy ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqRelease
	"Return the information quantity of attribute Release"
	"180413 This is a default implementation that can be extended later"

	^attRelease ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqReleaseBasedOnHighId
	"Return the information quantity of attribute ReleaseBasedOnHighId"
	"180413 This is a default implementation that can be extended later"

	^attReleaseBasedOnHighId ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqReleaseBasedOnLowId
	"Return the information quantity of attribute ReleaseBasedOnLowId"
	"180413 This is a default implementation that can be extended later"

	^attReleaseBasedOnLowId ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqReleaseBasedOnRelease
	"Return the information quantity of attribute ReleaseBasedOnRelease"
	"180413 This is a default implementation that can be extended later"

	^attReleaseBasedOnRelease ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqReleaseBasedOnVersion
	"Return the information quantity of attribute ReleaseBasedOnVersion"
	"180413 This is a default implementation that can be extended later"

	^attReleaseBasedOnVersion ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqVersion
	"Return the information quantity of attribute Version"
	"180413 This is a default implementation that can be extended later"

	^attVersion ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasApprovedBy
	"Return true if the current value of the attribute ApprovedBy carries information."

	^(attApprovedBy ~= nil)!

attHasCheckedBy
	"Return true if the current value of the attribute CheckedBy carries information."

	^(attCheckedBy ~= nil)!

attHasCreatedBy
	"Return true if the current value of the attribute CreatedBy carries information."

	^(attCreatedBy ~= nil)!

attHasDtAdded
	"Return true if the current value of the attribute DtAdded carries information."

	^(attDtAdded ~= nil)!

attHasDtApproved
	"Return true if the current value of the attribute DtApproved carries information."

	^(attDtApproved ~= nil)!

attHasDtChecked
	"Return true if the current value of the attribute DtChecked carries information."

	^(attDtChecked ~= nil)!

attHasDtModified
	"Return true if the current value of the attribute DtModified carries information."

	^(attDtModified ~= nil)!

attHasHighId
	"Return true if the current value of the attribute HighId carries information."

	^(attHighId ~= nil)!

attHasLocked
	"Return true if the current value of the attribute Locked carries information."

	^(attLocked ~= nil)!

attHasLowId
	"Return true if the current value of the attribute LowId carries information."

	^(attLowId ~= nil)!

attHasModifiedBy
	"Return true if the current value of the attribute ModifiedBy carries information."

	^(attModifiedBy ~= nil)!

attHasRelease
	"Return true if the current value of the attribute Release carries information."

	^(attRelease ~= nil)!

attHasReleaseBasedOnHighId
	"Return true if the current value of the attribute ReleaseBasedOnHighId carries information."

	^(attReleaseBasedOnHighId ~= nil)!

attHasReleaseBasedOnLowId
	"Return true if the current value of the attribute ReleaseBasedOnLowId carries information."

	^(attReleaseBasedOnLowId ~= nil)!

attHasReleaseBasedOnRelease
	"Return true if the current value of the attribute ReleaseBasedOnRelease carries information."

	^(attReleaseBasedOnRelease ~= nil)!

attHasReleaseBasedOnVersion
	"Return true if the current value of the attribute ReleaseBasedOnVersion carries information."

	^(attReleaseBasedOnVersion ~= nil)!

attHasVersion
	"Return true if the current value of the attribute Version carries information."

	^(attVersion ~= nil)!

attCreateApprovedBy
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetApprovedBy: (nil)!

attCreateLocked
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetLocked: (nil)!

attCreateApprovedBy
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetApprovedBy: (nil)!

attCreateCheckedBy
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetCheckedBy: (String new: 32)!

attCreateCreatedBy
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetCreatedBy: (String new: 32)!

attCreateDtAdded
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetDtAdded: (TimeStampFactory current)!

attCreateDtApproved
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetDtApproved: (TimeStampFactory current)!

attCreateDtChecked
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetDtChecked: (TimeStampFactory current)!

attCreateDtModified
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetDtModified: (TimeStampFactory current)!

attCreateHighId
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetHighId: (0)!

attCreateLocked
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetLocked: (nil)!

attCreateLowId
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetLowId: (0)!

attCreateModifiedBy
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetModifiedBy: (String new: 32)!

attCreateRelease
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetRelease: (String new: 32)!

attCreateReleaseBasedOnHighId
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetReleaseBasedOnHighId: (0)!

attCreateReleaseBasedOnLowId
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetReleaseBasedOnLowId: (0)!

attCreateReleaseBasedOnRelease
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetReleaseBasedOnRelease: (String new: 32)!

attCreateReleaseBasedOnVersion
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetReleaseBasedOnVersion: (String new: 32)!

attCreateVersion
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetVersion: (String new: 32)!

attDeleteApprovedBy
	"Set the attribute value to undefined, or to a value that makes attIqApprovedBy return 0."

	^self attSetApprovedBy: nil!

attDeleteCheckedBy
	"Set the attribute value to undefined, or to a value that makes attIqCheckedBy return 0."

	^self attSetCheckedBy: nil!

attDeleteCreatedBy
	"Set the attribute value to undefined, or to a value that makes attIqCreatedBy return 0."

	^self attSetCreatedBy: nil!

attDeleteDtAdded
	"Set the attribute value to undefined, or to a value that makes attIqDtAdded return 0."

	^self attSetDtAdded: nil!

attDeleteDtApproved
	"Set the attribute value to undefined, or to a value that makes attIqDtApproved return 0."

	^self attSetDtApproved: nil!

attDeleteDtChecked
	"Set the attribute value to undefined, or to a value that makes attIqDtChecked return 0."

	^self attSetDtChecked: nil!

attDeleteDtModified
	"Set the attribute value to undefined, or to a value that makes attIqDtModified return 0."

	^self attSetDtModified: nil!

attDeleteHighId
	"Set the attribute value to undefined, or to a value that makes attIqHighId return 0."

	^self attSetHighId: nil!

attDeleteLocked
	"Set the attribute value to undefined, or to a value that makes attIqLocked return 0."

	^self attSetLocked: nil!

attDeleteLowId
	"Set the attribute value to undefined, or to a value that makes attIqLowId return 0."

	^self attSetLowId: nil!

attDeleteModifiedBy
	"Set the attribute value to undefined, or to a value that makes attIqModifiedBy return 0."

	^self attSetModifiedBy: nil!

attDeleteRelease
	"Set the attribute value to undefined, or to a value that makes attIqRelease return 0."

	^self attSetRelease: nil!

attDeleteReleaseBasedOnHighId
	"Set the attribute value to undefined, or to a value that makes attIqReleaseBasedOnHighId return 0."

	^self attSetReleaseBasedOnHighId: nil!

attDeleteReleaseBasedOnLowId
	"Set the attribute value to undefined, or to a value that makes attIqReleaseBasedOnLowId return 0."

	^self attSetReleaseBasedOnLowId: nil!

attDeleteReleaseBasedOnRelease
	"Set the attribute value to undefined, or to a value that makes attIqReleaseBasedOnRelease return 0."

	^self attSetReleaseBasedOnRelease: nil!

attDeleteReleaseBasedOnVersion
	"Set the attribute value to undefined, or to a value that makes attIqReleaseBasedOnVersion return 0."

	^self attSetReleaseBasedOnVersion: nil!

attDeleteVersion
	"Set the attribute value to undefined, or to a value that makes attIqVersion return 0."

	^self attSetVersion: nil!

attSetApprovedBy: value 
	"Set the value of attribute ApprovedBy to value, if it is not already equal to value."

	(attApprovedBy = value) ifFalse: [
		attApprovedBy := value.
		self changed: #attApprovedBy.
	]!

attSetCheckedBy: value 
	"Set the value of attribute CheckedBy to value, if it is not already equal to value."

	(attCheckedBy = value) ifFalse: [
		attCheckedBy := value.
		self changed: #attCheckedBy.
	]!

attSetCreatedBy: value 
	"Set the value of attribute CreatedBy to value, if it is not already equal to value."

	(attCreatedBy = value) ifFalse: [
		attCreatedBy := value.
		self changed: #attCreatedBy.
	]!

attSetDtAdded: value 
	"Set the value of attribute DtAdded to value, if it is not already equal to value."

	(attDtAdded = value) ifFalse: [
		attDtAdded := value.
		self changed: #attDtAdded.
	]!

attSetDtApproved: value 
	"Set the value of attribute DtApproved to value, if it is not already equal to value."

	(attDtApproved = value) ifFalse: [
		attDtApproved := value.
		self changed: #attDtApproved.
	]!

attSetDtChecked: value 
	"Set the value of attribute DtChecked to value, if it is not already equal to value."

	(attDtChecked = value) ifFalse: [
		attDtChecked := value.
		self changed: #attDtChecked.
	]!

attSetDtModified: value 
	"Set the value of attribute DtModified to value, if it is not already equal to value."

	(attDtModified = value) ifFalse: [
		attDtModified := value.
		self changed: #attDtModified.
	]!

attSetHighId: value 
	"Set the value of attribute HighId to value, if it is not already equal to value."

	(attHighId = value) ifFalse: [
		attHighId := value.
		self changed: #attHighId.
	]!

attSetLocked: value 
	"Set the value of attribute Locked to value, if it is not already equal to value."

	(attLocked = value) ifFalse: [
		attLocked := value.
		self changed: #attLocked.
	]!

attSetLowId: value 
	"Set the value of attribute LowId to value, if it is not already equal to value."

	(attLowId = value) ifFalse: [
		attLowId := value.
		self changed: #attLowId.
	]!

attSetModifiedBy: value 
	"Set the value of attribute ModifiedBy to value, if it is not already equal to value."

	(attModifiedBy = value) ifFalse: [
		attModifiedBy := value.
		self changed: #attModifiedBy.
	]!

attSetRelease: value 
	"Set the value of attribute Release to value, if it is not already equal to value."

	(attRelease = value) ifFalse: [
		attRelease := value.
		self changed: #attRelease.
	]!

attSetReleaseBasedOnHighId: value 
	"Set the value of attribute ReleaseBasedOnHighId to value, if it is not already equal to value."

	(attReleaseBasedOnHighId = value) ifFalse: [
		attReleaseBasedOnHighId := value.
		self changed: #attReleaseBasedOnHighId.
	]!

attSetReleaseBasedOnLowId: value 
	"Set the value of attribute ReleaseBasedOnLowId to value, if it is not already equal to value."

	(attReleaseBasedOnLowId = value) ifFalse: [
		attReleaseBasedOnLowId := value.
		self changed: #attReleaseBasedOnLowId.
	]!

attSetReleaseBasedOnRelease: value 
	"Set the value of attribute ReleaseBasedOnRelease to value, if it is not already equal to value."

	(attReleaseBasedOnRelease = value) ifFalse: [
		attReleaseBasedOnRelease := value.
		self changed: #attReleaseBasedOnRelease.
	]!

attSetReleaseBasedOnVersion: value 
	"Set the value of attribute ReleaseBasedOnVersion to value, if it is not already equal to value."

	(attReleaseBasedOnVersion = value) ifFalse: [
		attReleaseBasedOnVersion := value.
		self changed: #attReleaseBasedOnVersion.
	]!

attSetVersion: value 
	"Set the value of attribute Version to value, if it is not already equal to value."

	(attVersion = value) ifFalse: [
		attVersion := value.
		self changed: #attVersion.
	]!

attInitApprovedBy
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attApprovedBy := nil!

attInitLocked
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attLocked := nil!

attInitCheckedBy
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetCheckedBy: (String new: 32)!

attInitCreatedBy
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetCreatedBy: (String new: 32)!

attInitDtAdded
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetDtAdded: (TimeStampFactory current)!

attInitDtApproved
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetDtApproved: (TimeStampFactory current)!

attInitDtChecked
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetDtChecked: (TimeStampFactory current)!

attInitDtModified
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetDtModified: (TimeStampFactory current)!

attInitHighId
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetHighId: (0)!

attInitLowId
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetLowId: (0)!

attInitModifiedBy
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetModifiedBy: (String new: 32)!

attInitRelease
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetRelease: (String new: 32)!

attInitReleaseBasedOnHighId
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetReleaseBasedOnHighId: (0)!

attInitReleaseBasedOnLowId
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetReleaseBasedOnLowId: (0)!

attInitReleaseBasedOnRelease
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetReleaseBasedOnRelease: (String new: 32)!

attInitReleaseBasedOnVersion
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetReleaseBasedOnVersion: (String new: 32)!

attInitVersion
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetVersion: (String new: 32)!

 !

!DocumentDictionary100.Core.Model.XDBObject methodsFor: 'relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XDBObject methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XDBObject methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Model.XDBObject methodsFor: 'testing'!

classPrefix
	"Return 'DB' which is a unique prefix for class DBObject within the application."

	^'DB'!

 !

