"XIEC61360Object_AutoAPI.st Generated at 2018-09-22 00:05:28.992."
'Class AutoAPI file for Class IEC61360Object.'!

!DocumentDictionary100.Core.Model.XIEC61360Object class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XIEC61360Object in the DomainModel DocumentDictionary100f"

	^'Holds common attributes for objects that follow IEC 61360.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XIEC61360Object'.!

 !

!DocumentDictionary100.Core.Model.XIEC61360Object methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XIEC61360Object in the DomainModel DocumentDictionary100f."

	^'Holds common attributes for objects that follow IEC 61360.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitCode.
	self attInitNote.
	self attInitPreferredName.
	self attInitRemark.
	self attInitRevisionNumber.
	self attInitSourceDocumentOfDefinition.
	self attInitSynonymousName1.
	self attInitSynonymousName2.
	self attInitVersionNumber.



	
!
canDelete
	"Return true if this IEC61360Object can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XIEC61360Object if there is one, else return nil."


	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."





	super delete!

 !

!DocumentDictionary100.Core.Model.XIEC61360Object methodsFor: 'attributeAPI'!

attGetCode
	"Get value of attribute Code"
	"Unique six-character code of a data element type (format AAANNN). If the meaning changes, a new code must be assigned. See also versionNumber and revisionNumber."

	^attCode.!

attGetNote
	"Get value of attribute Note"
	"Statement which provides further information on any part of the terminological record, which is essential to the understanding of that record."

	^attNote.!

attGetPreferredName
	"Get value of attribute PreferredName"
	"Single-word or multi-word designation assigned to a data element type. Limited to 35 characters according to IEC 61360-1."

	^attPreferredName.!

attGetRemark
	"Get value of attribute Remark"
	"Explanatory text to further clarify the meaning of a terminological record. Remarks shall not influence the meaning of a record."

	^attRemark.!

attGetRevisionNumber
	"Get value of attribute RevisionNumber"
	"Format NN, where N is a digit. New revisions are assigned with increments of 1. Only one revision number is current at any moment. New revision number shall be generated only when editorial changes have been implemented that do not affect meaning."

	^attRevisionNumber.!

attGetSourceDocumentOfDefinition
	"Get value of attribute SourceDocumentOfDefinition"
	"Reference to the source document from which the data element type definition was derived. The document shall be recognised by the ISO and /or IEC committee concerned as having wide acceptance and authoritive status as well as being publicly available."

	^attSourceDocumentOfDefinition.!

attGetSynonymousName1
	"Get value of attribute SynonymousName1"
	"First single-word or multi-word designation that differs from the given preferred name but represents the same data element type concept"

	^attSynonymousName1.!

attGetSynonymousName2
	"Get value of attribute SynonymousName2"
	"Second single-word or multi-word designation that differs from the given preferred name but represents the same data element type concept"

	^attSynonymousName2.!

attGetVersionNumber
	"Get value of attribute VersionNumber"
	"Format NNN, where N is a digit. Version numbers shall be incremented. A new version of the data element type shall be generated if at least one attribute of the data element type is changed which affects the use but which does not affect its meaning."

	^attVersionNumber.!

attIqCode
	"Return the information quantity of attribute Code"
	"180413 This is a default implementation that can be extended later"

	^attCode ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqNote
	"Return the information quantity of attribute Note"
	"180413 This is a default implementation that can be extended later"

	^attNote ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqPreferredName
	"Return the information quantity of attribute PreferredName"
	"180413 This is a default implementation that can be extended later"

	^attPreferredName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqRemark
	"Return the information quantity of attribute Remark"
	"180413 This is a default implementation that can be extended later"

	^attRemark ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqRevisionNumber
	"Return the information quantity of attribute RevisionNumber"
	"180413 This is a default implementation that can be extended later"

	^attRevisionNumber ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqSourceDocumentOfDefinition
	"Return the information quantity of attribute SourceDocumentOfDefinition"
	"180413 This is a default implementation that can be extended later"

	^attSourceDocumentOfDefinition ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqSynonymousName1
	"Return the information quantity of attribute SynonymousName1"
	"180413 This is a default implementation that can be extended later"

	^attSynonymousName1 ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqSynonymousName2
	"Return the information quantity of attribute SynonymousName2"
	"180413 This is a default implementation that can be extended later"

	^attSynonymousName2 ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqVersionNumber
	"Return the information quantity of attribute VersionNumber"
	"180413 This is a default implementation that can be extended later"

	^attVersionNumber ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasCode
	"Return true if the current value of the attribute Code carries information."

	^(attCode ~= nil)!

attHasNote
	"Return true if the current value of the attribute Note carries information."

	^(attNote ~= nil)!

attHasPreferredName
	"Return true if the current value of the attribute PreferredName carries information."

	^(attPreferredName ~= nil)!

attHasRemark
	"Return true if the current value of the attribute Remark carries information."

	^(attRemark ~= nil)!

attHasRevisionNumber
	"Return true if the current value of the attribute RevisionNumber carries information."

	^(attRevisionNumber ~= nil)!

attHasSourceDocumentOfDefinition
	"Return true if the current value of the attribute SourceDocumentOfDefinition carries information."

	^(attSourceDocumentOfDefinition ~= nil)!

attHasSynonymousName1
	"Return true if the current value of the attribute SynonymousName1 carries information."

	^(attSynonymousName1 ~= nil)!

attHasSynonymousName2
	"Return true if the current value of the attribute SynonymousName2 carries information."

	^(attSynonymousName2 ~= nil)!

attHasVersionNumber
	"Return true if the current value of the attribute VersionNumber carries information."

	^(attVersionNumber ~= nil)!

attCreateNote
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetNote: (nil)!

attCreatePreferredName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetPreferredName: (nil)!

attCreateRemark
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetRemark: (nil)!

attCreateSourceDocumentOfDefinition
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetSourceDocumentOfDefinition: (nil)!

attCreateSynonymousName1
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetSynonymousName1: (nil)!

attCreateSynonymousName2
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetSynonymousName2: (nil)!

attCreateVersionNumber
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetVersionNumber: (nil)!

attCreateCode
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetCode: (AAANNN)!

attCreateNote
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetNote: (nil)!

attCreatePreferredName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetPreferredName: (nil)!

attCreateRemark
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetRemark: (nil)!

attCreateRevisionNumber
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetRevisionNumber: (00)!

attCreateSourceDocumentOfDefinition
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetSourceDocumentOfDefinition: (nil)!

attCreateSynonymousName1
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetSynonymousName1: (nil)!

attCreateSynonymousName2
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetSynonymousName2: (nil)!

attCreateVersionNumber
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetVersionNumber: (nil)!

attDeleteCode
	"Set the attribute value to undefined, or to a value that makes attIqCode return 0."

	^self attSetCode: nil!

attDeleteNote
	"Set the attribute value to undefined, or to a value that makes attIqNote return 0."

	^self attSetNote: nil!

attDeletePreferredName
	"Set the attribute value to undefined, or to a value that makes attIqPreferredName return 0."

	^self attSetPreferredName: nil!

attDeleteRemark
	"Set the attribute value to undefined, or to a value that makes attIqRemark return 0."

	^self attSetRemark: nil!

attDeleteRevisionNumber
	"Set the attribute value to undefined, or to a value that makes attIqRevisionNumber return 0."

	^self attSetRevisionNumber: nil!

attDeleteSourceDocumentOfDefinition
	"Set the attribute value to undefined, or to a value that makes attIqSourceDocumentOfDefinition return 0."

	^self attSetSourceDocumentOfDefinition: nil!

attDeleteSynonymousName1
	"Set the attribute value to undefined, or to a value that makes attIqSynonymousName1 return 0."

	^self attSetSynonymousName1: nil!

attDeleteSynonymousName2
	"Set the attribute value to undefined, or to a value that makes attIqSynonymousName2 return 0."

	^self attSetSynonymousName2: nil!

attDeleteVersionNumber
	"Set the attribute value to undefined, or to a value that makes attIqVersionNumber return 0."

	^self attSetVersionNumber: nil!

attSetCode: value 
	"Set the value of attribute Code to value, if it is not already equal to value."

	(attCode = value) ifFalse: [
		attCode := value.
		self changed: #attCode.
	]!

attSetNote: value 
	"Set the value of attribute Note to value, if it is not already equal to value."

	(attNote = value) ifFalse: [
		attNote := value.
		self changed: #attNote.
	]!

attSetPreferredName: value 
	"Set the value of attribute PreferredName to value, if it is not already equal to value."

	(attPreferredName = value) ifFalse: [
		attPreferredName := value.
		self changed: #attPreferredName.
	]!

attSetRemark: value 
	"Set the value of attribute Remark to value, if it is not already equal to value."

	(attRemark = value) ifFalse: [
		attRemark := value.
		self changed: #attRemark.
	]!

attSetRevisionNumber: value 
	"Set the value of attribute RevisionNumber to value, if it is not already equal to value."

	(attRevisionNumber = value) ifFalse: [
		attRevisionNumber := value.
		self changed: #attRevisionNumber.
	]!

attSetSourceDocumentOfDefinition: value 
	"Set the value of attribute SourceDocumentOfDefinition to value, if it is not already equal to value."

	(attSourceDocumentOfDefinition = value) ifFalse: [
		attSourceDocumentOfDefinition := value.
		self changed: #attSourceDocumentOfDefinition.
	]!

attSetSynonymousName1: value 
	"Set the value of attribute SynonymousName1 to value, if it is not already equal to value."

	(attSynonymousName1 = value) ifFalse: [
		attSynonymousName1 := value.
		self changed: #attSynonymousName1.
	]!

attSetSynonymousName2: value 
	"Set the value of attribute SynonymousName2 to value, if it is not already equal to value."

	(attSynonymousName2 = value) ifFalse: [
		attSynonymousName2 := value.
		self changed: #attSynonymousName2.
	]!

attSetVersionNumber: value 
	"Set the value of attribute VersionNumber to value, if it is not already equal to value."

	(attVersionNumber = value) ifFalse: [
		attVersionNumber := value.
		self changed: #attVersionNumber.
	]!

attInitNote
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attNote := nil!

attInitPreferredName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attPreferredName := nil!

attInitRemark
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attRemark := nil!

attInitSourceDocumentOfDefinition
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attSourceDocumentOfDefinition := nil!

attInitSynonymousName1
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attSynonymousName1 := nil!

attInitSynonymousName2
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attSynonymousName2 := nil!

attInitVersionNumber
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attVersionNumber := nil!

attInitCode
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetCode: (AAANNN)!

attInitRevisionNumber
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetRevisionNumber: (00)!

 !

!DocumentDictionary100.Core.Model.XIEC61360Object methodsFor: 'relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XIEC61360Object methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XIEC61360Object methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Model.XIEC61360Object methodsFor: 'testing'!

classPrefix
	"Return 'IO' which is a unique prefix for class IEC61360Object within the application."

	^'IO'!

 !

