"XModelElement_AutoAPI.st Generated at 2018-09-22 00:05:54.810."
'Class AutoAPI file for Class ModelElement.'!

!DocumentDictionary100.Core.Model.XModelElement class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XModelElement in the DomainModel DocumentDictionary100f"

	^'UML V1.4 compatible model element.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XModelElement'.!

 !

!DocumentDictionary100.Core.Model.XModelElement methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XModelElement in the DomainModel DocumentDictionary100f."

	^'UML V1.4 compatible model element.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitDefinition.
	self attInitName.

	self relInitMemberOfCategories.
	self relInitProfileDetails.
	self relInitProfileMasters.
	self relInitProfileValues.


	
!
canDelete
	"Return true if this ModelElement can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XModelElement if there is one, else return nil."


	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."

	self relDeleteAllMemberOfCategories.
	self relDeleteAllProfileDetails.
	self relDeleteAllProfileMasters.
	self relDeleteAllProfileValues.




	super delete!

 !

!DocumentDictionary100.Core.Model.XModelElement methodsFor: 'attributeAPI'!

attGetDefinition
	"Get value of attribute Definition"
	"Short definition in English, preferably less than 160 characters. IEC 61360: Statement that describes the meaning of a data element type (an object) in an unambiguous and unique manner to permit its differentiation from all other data element types."

	^attDefinition.!

attGetName
	"Get value of attribute Name"
	"A maximum 128-character English name for object. Should be of syntax [A-Z|a-z][A-Z|a-z|0-9|_]*. Used for defining human readable standard terminology, and as name for the object in generated human readable source code."

	^attName.!

attIqDefinition
	"Return the information quantity of attribute Definition"
	"180413 This is a default implementation that can be extended later"

	^attDefinition ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqName
	"Return the information quantity of attribute Name"
	"180413 This is a default implementation that can be extended later"

	^attName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasDefinition
	"Return true if the current value of the attribute Definition carries information."

	^(attDefinition ~= nil)!

attHasName
	"Return true if the current value of the attribute Name carries information."

	^(attName ~= nil)!

attCreateDefinition
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetDefinition: (nil)!

attCreateName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetName: (nil)!

attCreateDefinition
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetDefinition: (nil)!

attCreateName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetName: (nil)!

attDeleteDefinition
	"Set the attribute value to undefined, or to a value that makes attIqDefinition return 0."

	^self attSetDefinition: nil!

attDeleteName
	"Set the attribute value to undefined, or to a value that makes attIqName return 0."

	^self attSetName: nil!

attSetDefinition: value 
	"Set the value of attribute Definition to value, if it is not already equal to value."

	(attDefinition = value) ifFalse: [
		attDefinition := value.
		self changed: #attDefinition.
	]!

attSetName: value 
	"Set the value of attribute Name to value, if it is not already equal to value."

	(attName = value) ifFalse: [
		attName := value.
		self changed: #attName.
	]!

attInitDefinition
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attDefinition := nil!

attInitName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attName := nil!

 !

!DocumentDictionary100.Core.Model.XModelElement methodsFor: 'relationshipAPI'!

relAllMemberOfCategories
	"Return collection of all memberOfCategories"

	^relMemberOfCategories copy.!

relAllProfileDetails
	"Return collection of all profileDetails"

	^relProfileDetails copy.!

relAllProfileMasters
	"Return collection of all profileMasters"

	^relProfileMasters copy.!

relAllProfileValues
	"Return collection of all profileValues"

	^relProfileValues copy.!

relSizeMemberOfCategories
	"Return the integer size of the collection returned by relAllMemberOfCategories"

	^relMemberOfCategories size!

relSizeProfileDetails
	"Return the integer size of the collection returned by relAllProfileDetails"

	^relProfileDetails size!

relSizeProfileMasters
	"Return the integer size of the collection returned by relAllProfileMasters"

	^relProfileMasters size!

relSizeProfileValues
	"Return the integer size of the collection returned by relAllProfileValues"

	^relProfileValues size!

relHasMemberOfCategories
	"Return true if the 1-N relationship1 memberOfCategories holds at least one object, else return false."

	^relMemberOfCategories size > 0!

relHasProfileDetails
	"Return true if the 1-N relationship1 profileDetails holds at least one object, else return false."

	^relProfileDetails size > 0!

relHasProfileMasters
	"Return true if the 1-N relationship1 profileMasters holds at least one object, else return false."

	^relProfileMasters size > 0!

relHasProfileValues
	"Return true if the 1-N relationship1 profileValues holds at least one object, else return false."

	^relProfileValues size > 0!

relCreateMemberOfCategories
	"Creates and adds a new XCategoryLink to 1-N relationship MemberOfCategories."

	| cacl2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Model.XCategoryLink) ifTrue: [
		cacl2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Model.XCategoryLink.
		self relAddMemberOfCategories: cacl2.
		^cacl2.
	] ifFalse: [
		self dberror: 'XModelElement.relCreateMemberOfCategories Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Model.XCategoryLink. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateProfileDetails
	"Creates and adds a new XProfileLink to 1-N relationship ProfileDetails."

	| prpl2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Model.XProfileLink) ifTrue: [
		prpl2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Model.XProfileLink.
		self relAddProfileDetails: prpl2.
		^prpl2.
	] ifFalse: [
		self dberror: 'XModelElement.relCreateProfileDetails Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Model.XProfileLink. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateProfileMasters
	"Creates and adds a new XProfileLink to 1-N relationship ProfileMasters."

	| prpl2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Model.XProfileLink) ifTrue: [
		prpl2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Model.XProfileLink.
		self relAddProfileMasters: prpl2.
		^prpl2.
	] ifFalse: [
		self dberror: 'XModelElement.relCreateProfileMasters Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Model.XProfileLink. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateProfileValues
	"Creates and adds a new XProfileValue to 1-N relationship ProfileValues."

	| prpv2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Model.XProfileValue) ifTrue: [
		prpv2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Model.XProfileValue.
		self relAddProfileValues: prpv2.
		^prpv2.
	] ifFalse: [
		self dberror: 'XModelElement.relCreateProfileValues Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Model.XProfileValue. Please open an appropriate substorage first.'.
		^nil.
	].!

relAddMemberOfCategories: cacl2
	"Adds a XCategoryLink cacl2 to 1-N relationship MemberOfCategories."

	| ME1a |
	( cacl2 isKindOf: DocumentDictionary100.Main.XCategoryLink ) ifFalse: [
		self dberror: 'XModelElement:relAddMemberOfCategories: Error ' message: ( cacl2 asString ,
			' is not a XCategoryLink, and can not be added to MemberOfCategories for ',
			' this XModelElement (', self asString, ').' ).
		^nil.
	].
	( (relMemberOfCategories identityIndexOf: cacl2) > 0 ) ifTrue: [
		self dberror: 'XModelElement:relAddMemberOfCategories: Error ' message: 
			'XCategoryLink (', cacl2 asString , ') is already added to this XModelElement (', self asString, ').'.
		^nil.
	].
	( ME1a := cacl2 relGetModelElement ) ifNotNil: [ 
		self dberror: 'XModelElement:relAddMemberOfCategories: Error ' message: 
			'XCategoryLink (', cacl2 asString , ') is already added to another XModelElement (', ME1a asString , ').'.
		^nil.
	]. 
	relMemberOfCategories add: cacl2.
	cacl2 relPrivateSetModelElement: self.
	^cacl2!

relAddProfileDetails: prpl2
	"Adds a XProfileLink prpl2 to 1-N relationship ProfileDetails."

	| ME1a |
	( prpl2 isKindOf: DocumentDictionary100.Core.Profile.XProfileLink ) ifFalse: [
		self dberror: 'XModelElement:relAddProfileDetails: Error ' message: ( prpl2 asString ,
			' is not a XProfileLink, and can not be added to ProfileDetails for ',
			' this XModelElement (', self asString, ').' ).
		^nil.
	].
	( (relProfileDetails identityIndexOf: prpl2) > 0 ) ifTrue: [
		self dberror: 'XModelElement:relAddProfileDetails: Error ' message: 
			'XProfileLink (', prpl2 asString , ') is already added to this XModelElement (', self asString, ').'.
		^nil.
	].
	( ME1a := prpl2 relGetProfileMaster ) ifNotNil: [ 
		self dberror: 'XModelElement:relAddProfileDetails: Error ' message: 
			'XProfileLink (', prpl2 asString , ') is already added to another XModelElement (', ME1a asString , ').'.
		^nil.
	]. 
	relProfileDetails add: prpl2.
	prpl2 relPrivateSetProfileMaster: self.
	^prpl2!

relAddProfileMasters: prpl2
	"Adds a XProfileLink prpl2 to 1-N relationship ProfileMasters."

	| ME1a |
	( prpl2 isKindOf: DocumentDictionary100.Core.Profile.XProfileLink ) ifFalse: [
		self dberror: 'XModelElement:relAddProfileMasters: Error ' message: ( prpl2 asString ,
			' is not a XProfileLink, and can not be added to ProfileMasters for ',
			' this XModelElement (', self asString, ').' ).
		^nil.
	].
	( (relProfileMasters identityIndexOf: prpl2) > 0 ) ifTrue: [
		self dberror: 'XModelElement:relAddProfileMasters: Error ' message: 
			'XProfileLink (', prpl2 asString , ') is already added to this XModelElement (', self asString, ').'.
		^nil.
	].
	( ME1a := prpl2 relGetProfileDetail ) ifNotNil: [ 
		self dberror: 'XModelElement:relAddProfileMasters: Error ' message: 
			'XProfileLink (', prpl2 asString , ') is already added to another XModelElement (', ME1a asString , ').'.
		^nil.
	]. 
	relProfileMasters add: prpl2.
	prpl2 relPrivateSetProfileDetail: self.
	^prpl2!

relAddProfileValues: prpv2
	"Adds a XProfileValue prpv2 to 1-N relationship ProfileValues."

	| ME1a |
	( prpv2 isKindOf: DocumentDictionary100.Core.Profile.XProfileValue ) ifFalse: [
		self dberror: 'XModelElement:relAddProfileValues: Error ' message: ( prpv2 asString ,
			' is not a XProfileValue, and can not be added to ProfileValues for ',
			' this XModelElement (', self asString, ').' ).
		^nil.
	].
	( (relProfileValues identityIndexOf: prpv2) > 0 ) ifTrue: [
		self dberror: 'XModelElement:relAddProfileValues: Error ' message: 
			'XProfileValue (', prpv2 asString , ') is already added to this XModelElement (', self asString, ').'.
		^nil.
	].
	( ME1a := prpv2 relGetModelElement ) ifNotNil: [ 
		self dberror: 'XModelElement:relAddProfileValues: Error ' message: 
			'XProfileValue (', prpv2 asString , ') is already added to another XModelElement (', ME1a asString , ').'.
		^nil.
	]. 
	relProfileValues add: prpv2.
	prpv2 relPrivateSetModelElement: self.
	^prpv2!

relGetMemberOfCategories
	"Return the first XCategoryLink object on the other side of the 1-N relations1 memberOfCategories."
	"Provides compatibility with 1-1 relationships."

	( relMemberOfCategories size = 0 ) ifTrue: [ ^nil ].
	^relMemberOfCategories first!

relGetProfileDetails
	"Return the first XProfileLink object on the other side of the 1-N relations1 profileDetails."
	"Provides compatibility with 1-1 relationships."

	( relProfileDetails size = 0 ) ifTrue: [ ^nil ].
	^relProfileDetails first!

relGetProfileMasters
	"Return the first XProfileLink object on the other side of the 1-N relations1 profileMasters."
	"Provides compatibility with 1-1 relationships."

	( relProfileMasters size = 0 ) ifTrue: [ ^nil ].
	^relProfileMasters first!

relGetProfileValues
	"Return the first XProfileValue object on the other side of the 1-N relations1 profileValues."
	"Provides compatibility with 1-1 relationships."

	( relProfileValues size = 0 ) ifTrue: [ ^nil ].
	^relProfileValues first!

relSetMemberOfCategories: cacl2
	"Force set other end of 1-N relationship to one XCategoryLink cacl2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| ME1a |
	cacl2 ifNil: [
		self relRemoveAllMemberOfCategories.
		^nil.
	].
	( cacl2 isKindOf: DocumentDictionary100.Main.XCategoryLink ) ifFalse: [
		self dberror: 'XModelElement:relSetMemberOfCategories: Error ' message: ( cacl2 asString ,
			' is not a XCategoryLink, and can not be added to' ,
			' this XModelElement (', self asString, ').' ).
		^nil.
	].
	(( ( relMemberOfCategories identityIndexOf: cacl2 ) > 0 ) and: [ relMemberOfCategories size = 1 ]) ifTrue: [
		"XCategoryLink cacl2 is already added to this XModelElement, and it is the only one."
		^nil.
	].
	( relMemberOfCategories size > 0 ) ifTrue: [
		self relRemoveAllMemberOfCategories.
	].

	( ME1a := cacl2 relGetModelElement ) ifNotNil: [ 
		cacl2 relRemoveAllModelElement
	]. 
	relMemberOfCategories add: cacl2.
	cacl2 relPrivateSetModelElement: self.
	^cacl2!

relSetProfileDetails: prpl2
	"Force set other end of 1-N relationship to one XProfileLink prpl2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| ME1a |
	prpl2 ifNil: [
		self relDeleteAllProfileDetails.
		^nil.
	].
	( prpl2 isKindOf: DocumentDictionary100.Core.Profile.XProfileLink ) ifFalse: [
		self dberror: 'XModelElement:relSetProfileDetails: Error ' message: ( prpl2 asString ,
			' is not a XProfileLink, and can not be added to' ,
			' this XModelElement (', self asString, ').' ).
		^nil.
	].
	(( ( relProfileDetails identityIndexOf: prpl2 ) > 0 ) and: [ relProfileDetails size = 1 ]) ifTrue: [
		"XProfileLink prpl2 is already added to this XModelElement, and it is the only one."
		^nil.
	].
	( relProfileDetails size > 0 ) ifTrue: [
		self relDeleteAllProfileDetails.
	].

	( ME1a := prpl2 relGetProfileMaster ) ifNotNil: [ 
		prpl2 relRemoveAllProfileMaster
	]. 
	relProfileDetails add: prpl2.
	prpl2 relPrivateSetProfileMaster: self.
	^prpl2!

relSetProfileMasters: prpl2
	"Force set other end of 1-N relationship to one XProfileLink prpl2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| ME1a |
	prpl2 ifNil: [
		self relRemoveAllProfileMasters.
		^nil.
	].
	( prpl2 isKindOf: DocumentDictionary100.Core.Profile.XProfileLink ) ifFalse: [
		self dberror: 'XModelElement:relSetProfileMasters: Error ' message: ( prpl2 asString ,
			' is not a XProfileLink, and can not be added to' ,
			' this XModelElement (', self asString, ').' ).
		^nil.
	].
	(( ( relProfileMasters identityIndexOf: prpl2 ) > 0 ) and: [ relProfileMasters size = 1 ]) ifTrue: [
		"XProfileLink prpl2 is already added to this XModelElement, and it is the only one."
		^nil.
	].
	( relProfileMasters size > 0 ) ifTrue: [
		self relRemoveAllProfileMasters.
	].

	( ME1a := prpl2 relGetProfileDetail ) ifNotNil: [ 
		prpl2 relRemoveAllProfileDetail
	]. 
	relProfileMasters add: prpl2.
	prpl2 relPrivateSetProfileDetail: self.
	^prpl2!

relSetProfileValues: prpv2
	"Force set other end of 1-N relationship to one XProfileValue prpv2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| ME1a |
	prpv2 ifNil: [
		self relDeleteAllProfileValues.
		^nil.
	].
	( prpv2 isKindOf: DocumentDictionary100.Core.Profile.XProfileValue ) ifFalse: [
		self dberror: 'XModelElement:relSetProfileValues: Error ' message: ( prpv2 asString ,
			' is not a XProfileValue, and can not be added to' ,
			' this XModelElement (', self asString, ').' ).
		^nil.
	].
	(( ( relProfileValues identityIndexOf: prpv2 ) > 0 ) and: [ relProfileValues size = 1 ]) ifTrue: [
		"XProfileValue prpv2 is already added to this XModelElement, and it is the only one."
		^nil.
	].
	( relProfileValues size > 0 ) ifTrue: [
		self relDeleteAllProfileValues.
	].

	( ME1a := prpv2 relGetModelElement ) ifNotNil: [ 
		prpv2 relRemoveAllModelElement
	]. 
	relProfileValues add: prpv2.
	prpv2 relPrivateSetModelElement: self.
	^prpv2!

relRemoveMemberOfCategories: cacl2
	"Removes a XCategoryLink cacl2 from 1-N relationship1 MemberOfCategories."

	| ME1 index |
	( cacl2 isKindOf: DocumentDictionary100.Main.XCategoryLink ) ifFalse: [
		self dberror: 'XModelElement:relRemoveMemberOfCategories: Error ' message: ( cacl2 asString ,
			' is not a XCategoryLink, and can not possibly be removed from MemberOfCategories on' ,
			' this XModelElement (', self asString, ').' ).
		^nil.
	].
	( ( ME1 := cacl2 relGetModelElement ) == self ) ifFalse:[
		self dberror: 'XModelElement:relRemoveMemberOfCategories Error ' message: 
			'XCategoryLink (', cacl2 asString , ') is added to XModelElement (', ME1 asString, ') ',
			'instead of this XModelElement (', self asString , ').'.
		^nil.
	].
	index := relMemberOfCategories identityIndexOf: cacl2.
	(index = 0) ifTrue: [
		self dberror: 'XModelElement:relRemoveMemberOfCategories Error ' message: 
			'XCategoryLink (', cacl2 asString , ') can not be found in MemberOfCategories of this XModelElement(', self asString , ').'.
		^nil.
	]. 
	relMemberOfCategories removeAtIndex: index.
	cacl2 relPrivateSetModelElement: nil.
	^cacl2.!

relRemoveProfileDetails: prpl2
	"Removes a XProfileLink prpl2 from 1-N relationship1 ProfileDetails."

	| ME1 index |
	( prpl2 isKindOf: DocumentDictionary100.Core.Profile.XProfileLink ) ifFalse: [
		self dberror: 'XModelElement:relRemoveProfileDetails: Error ' message: ( prpl2 asString ,
			' is not a XProfileLink, and can not possibly be removed from ProfileDetails on' ,
			' this XModelElement (', self asString, ').' ).
		^nil.
	].
	( ( ME1 := prpl2 relGetProfileMaster ) == self ) ifFalse:[
		self dberror: 'XModelElement:relRemoveProfileDetails Error ' message: 
			'XProfileLink (', prpl2 asString , ') is added to XModelElement (', ME1 asString, ') ',
			'instead of this XModelElement (', self asString , ').'.
		^nil.
	].
	index := relProfileDetails identityIndexOf: prpl2.
	(index = 0) ifTrue: [
		self dberror: 'XModelElement:relRemoveProfileDetails Error ' message: 
			'XProfileLink (', prpl2 asString , ') can not be found in ProfileDetails of this XModelElement(', self asString , ').'.
		^nil.
	]. 
	relProfileDetails removeAtIndex: index.
	prpl2 relPrivateSetProfileMaster: nil.
	^prpl2.!

relRemoveProfileMasters: prpl2
	"Removes a XProfileLink prpl2 from 1-N relationship1 ProfileMasters."

	| ME1 index |
	( prpl2 isKindOf: DocumentDictionary100.Core.Profile.XProfileLink ) ifFalse: [
		self dberror: 'XModelElement:relRemoveProfileMasters: Error ' message: ( prpl2 asString ,
			' is not a XProfileLink, and can not possibly be removed from ProfileMasters on' ,
			' this XModelElement (', self asString, ').' ).
		^nil.
	].
	( ( ME1 := prpl2 relGetProfileDetail ) == self ) ifFalse:[
		self dberror: 'XModelElement:relRemoveProfileMasters Error ' message: 
			'XProfileLink (', prpl2 asString , ') is added to XModelElement (', ME1 asString, ') ',
			'instead of this XModelElement (', self asString , ').'.
		^nil.
	].
	index := relProfileMasters identityIndexOf: prpl2.
	(index = 0) ifTrue: [
		self dberror: 'XModelElement:relRemoveProfileMasters Error ' message: 
			'XProfileLink (', prpl2 asString , ') can not be found in ProfileMasters of this XModelElement(', self asString , ').'.
		^nil.
	]. 
	relProfileMasters removeAtIndex: index.
	prpl2 relPrivateSetProfileDetail: nil.
	^prpl2.!

relRemoveProfileValues: prpv2
	"Removes a XProfileValue prpv2 from 1-N relationship1 ProfileValues."

	| ME1 index |
	( prpv2 isKindOf: DocumentDictionary100.Core.Profile.XProfileValue ) ifFalse: [
		self dberror: 'XModelElement:relRemoveProfileValues: Error ' message: ( prpv2 asString ,
			' is not a XProfileValue, and can not possibly be removed from ProfileValues on' ,
			' this XModelElement (', self asString, ').' ).
		^nil.
	].
	( ( ME1 := prpv2 relGetModelElement ) == self ) ifFalse:[
		self dberror: 'XModelElement:relRemoveProfileValues Error ' message: 
			'XProfileValue (', prpv2 asString , ') is added to XModelElement (', ME1 asString, ') ',
			'instead of this XModelElement (', self asString , ').'.
		^nil.
	].
	index := relProfileValues identityIndexOf: prpv2.
	(index = 0) ifTrue: [
		self dberror: 'XModelElement:relRemoveProfileValues Error ' message: 
			'XProfileValue (', prpv2 asString , ') can not be found in ProfileValues of this XModelElement(', self asString , ').'.
		^nil.
	]. 
	relProfileValues removeAtIndex: index.
	prpv2 relPrivateSetModelElement: nil.
	^prpv2.!

relRemoveAllMemberOfCategories 
	"Remove all XCategoryLink instances from 1-N relationship1 MemberOfCategories and return them in a collection."

	| cacl2Coll |
	( cacl2Coll := relMemberOfCategories copy ) do: [:cacl2 |
		self relRemoveMemberOfCategories: cacl2
	].
	^cacl2Coll.!

relRemoveAllProfileDetails 
	"Remove all XProfileLink instances from 1-N relationship1 ProfileDetails and return them in a collection."

	| prpl2Coll |
	( prpl2Coll := relProfileDetails copy ) do: [:prpl2 |
		self relRemoveProfileDetails: prpl2
	].
	^prpl2Coll.!

relRemoveAllProfileMasters 
	"Remove all XProfileLink instances from 1-N relationship1 ProfileMasters and return them in a collection."

	| prpl2Coll |
	( prpl2Coll := relProfileMasters copy ) do: [:prpl2 |
		self relRemoveProfileMasters: prpl2
	].
	^prpl2Coll.!

relRemoveAllProfileValues 
	"Remove all XProfileValue instances from 1-N relationship1 ProfileValues and return them in a collection."

	| prpv2Coll |
	( prpv2Coll := relProfileValues copy ) do: [:prpv2 |
		self relRemoveProfileValues: prpv2
	].
	^prpv2Coll.!

relDeleteMemberOfCategories: cacl2
	"Remove a XCategoryLink cacl2 from 1-1 relationship1 MemberOfCategories and delete it."
	"Return true if operation succeded else return false."

	| ME1 index |
	( cacl2 isKindOf: DocumentDictionary100.Main.XCategoryLink ) ifFalse: [
		self dberror: 'XModelElement:relDeleteMemberOfCategories: Error ' message: ( cacl2 asString ,
			' is not a XCategoryLink, and can not possibly be deleted from MemberOfCategories on' ,
			' this XModelElement (', self asString, ').' ).
		^false.
	].
	(( ME1 := cacl2 relGetModelElement ) = self ) ifFalse:[
		self dberror: 'XModelElement:relDeleteMemberOfCategories Error ' message: 
			'XCategoryLink (', cacl2 asString , ') is added to XModelElement (', ME1 asString, ') ',
			'instead of this XModelElement (', self asString , ').'.
		^false.
	].
	index := relMemberOfCategories identityIndexOf: cacl2.
	(index = 0) ifTrue: [
		self dberror: 'XModelElement:relDeleteMemberOfCategories Error ' message: 
			'XCategoryLink (', cacl2 asString , ') can not be found in MemberOfCategories of this XModelElement(', self asString , ').'.
		^false.
	]. 
	relMemberOfCategories removeAtIndex: index.
	cacl2 relPrivateSetModelElement: nil.
	cacl2 delete.
	^true.!

relDeleteProfileDetails: prpl2
	"Remove a XProfileLink prpl2 from 1-1 relationship1 ProfileDetails and delete it."
	"Return true if operation succeded else return false."

	| ME1 index |
	( prpl2 isKindOf: DocumentDictionary100.Core.Profile.XProfileLink ) ifFalse: [
		self dberror: 'XModelElement:relDeleteProfileDetails: Error ' message: ( prpl2 asString ,
			' is not a XProfileLink, and can not possibly be deleted from ProfileDetails on' ,
			' this XModelElement (', self asString, ').' ).
		^false.
	].
	(( ME1 := prpl2 relGetProfileMaster ) = self ) ifFalse:[
		self dberror: 'XModelElement:relDeleteProfileDetails Error ' message: 
			'XProfileLink (', prpl2 asString , ') is added to XModelElement (', ME1 asString, ') ',
			'instead of this XModelElement (', self asString , ').'.
		^false.
	].
	index := relProfileDetails identityIndexOf: prpl2.
	(index = 0) ifTrue: [
		self dberror: 'XModelElement:relDeleteProfileDetails Error ' message: 
			'XProfileLink (', prpl2 asString , ') can not be found in ProfileDetails of this XModelElement(', self asString , ').'.
		^false.
	]. 
	relProfileDetails removeAtIndex: index.
	prpl2 relPrivateSetProfileMaster: nil.
	prpl2 delete.
	^true.!

relDeleteProfileMasters: prpl2
	"Remove a XProfileLink prpl2 from 1-1 relationship1 ProfileMasters and delete it."
	"Return true if operation succeded else return false."

	| ME1 index |
	( prpl2 isKindOf: DocumentDictionary100.Core.Profile.XProfileLink ) ifFalse: [
		self dberror: 'XModelElement:relDeleteProfileMasters: Error ' message: ( prpl2 asString ,
			' is not a XProfileLink, and can not possibly be deleted from ProfileMasters on' ,
			' this XModelElement (', self asString, ').' ).
		^false.
	].
	(( ME1 := prpl2 relGetProfileDetail ) = self ) ifFalse:[
		self dberror: 'XModelElement:relDeleteProfileMasters Error ' message: 
			'XProfileLink (', prpl2 asString , ') is added to XModelElement (', ME1 asString, ') ',
			'instead of this XModelElement (', self asString , ').'.
		^false.
	].
	index := relProfileMasters identityIndexOf: prpl2.
	(index = 0) ifTrue: [
		self dberror: 'XModelElement:relDeleteProfileMasters Error ' message: 
			'XProfileLink (', prpl2 asString , ') can not be found in ProfileMasters of this XModelElement(', self asString , ').'.
		^false.
	]. 
	relProfileMasters removeAtIndex: index.
	prpl2 relPrivateSetProfileDetail: nil.
	prpl2 delete.
	^true.!

relDeleteProfileValues: prpv2
	"Remove a XProfileValue prpv2 from 1-1 relationship1 ProfileValues and delete it."
	"Return true if operation succeded else return false."

	| ME1 index |
	( prpv2 isKindOf: DocumentDictionary100.Core.Profile.XProfileValue ) ifFalse: [
		self dberror: 'XModelElement:relDeleteProfileValues: Error ' message: ( prpv2 asString ,
			' is not a XProfileValue, and can not possibly be deleted from ProfileValues on' ,
			' this XModelElement (', self asString, ').' ).
		^false.
	].
	(( ME1 := prpv2 relGetModelElement ) = self ) ifFalse:[
		self dberror: 'XModelElement:relDeleteProfileValues Error ' message: 
			'XProfileValue (', prpv2 asString , ') is added to XModelElement (', ME1 asString, ') ',
			'instead of this XModelElement (', self asString , ').'.
		^false.
	].
	index := relProfileValues identityIndexOf: prpv2.
	(index = 0) ifTrue: [
		self dberror: 'XModelElement:relDeleteProfileValues Error ' message: 
			'XProfileValue (', prpv2 asString , ') can not be found in ProfileValues of this XModelElement(', self asString , ').'.
		^false.
	]. 
	relProfileValues removeAtIndex: index.
	prpv2 relPrivateSetModelElement: nil.
	prpv2 delete.
	^true.!

relDeleteAllMemberOfCategories 
	"Delete all XCategoryLink from 1-N relationship1 MemberOfCategories, and return the count of deleted objects."

	| cacl2Size cacl2Coll |
	cacl2Size := relMemberOfCategories size.
	cacl2Coll := relMemberOfCategories.
	self relInitMemberOfCategories.
	cacl2Coll do: [:cacl2 |
		cacl2 relPrivateSetModelElement: nil.
		cacl2 delete.
	].
	^cacl2Size.!

relDeleteAllProfileDetails 
	"Delete all XProfileLink from 1-N relationship1 ProfileDetails, and return the count of deleted objects."

	| prpl2Size prpl2Coll |
	prpl2Size := relProfileDetails size.
	prpl2Coll := relProfileDetails.
	self relInitProfileDetails.
	prpl2Coll do: [:prpl2 |
		prpl2 relPrivateSetProfileMaster: nil.
		prpl2 delete.
	].
	^prpl2Size.!

relDeleteAllProfileMasters 
	"Delete all XProfileLink from 1-N relationship1 ProfileMasters, and return the count of deleted objects."

	| prpl2Size prpl2Coll |
	prpl2Size := relProfileMasters size.
	prpl2Coll := relProfileMasters.
	self relInitProfileMasters.
	prpl2Coll do: [:prpl2 |
		prpl2 relPrivateSetProfileDetail: nil.
		prpl2 delete.
	].
	^prpl2Size.!

relDeleteAllProfileValues 
	"Delete all XProfileValue from 1-N relationship1 ProfileValues, and return the count of deleted objects."

	| prpv2Size prpv2Coll |
	prpv2Size := relProfileValues size.
	prpv2Coll := relProfileValues.
	self relInitProfileValues.
	prpv2Coll do: [:prpv2 |
		prpv2 relPrivateSetModelElement: nil.
		prpv2 delete.
	].
	^prpv2Size.!

relInitMemberOfCategories
	"Initialize collection of 1-N relationship1 MemberOfCategories"

	relMemberOfCategories := OrderedCollection new!

relInitProfileDetails
	"Initialize collection of 1-N relationship1 ProfileDetails"

	relProfileDetails := OrderedCollection new!

relInitProfileMasters
	"Initialize collection of 1-N relationship1 ProfileMasters"

	relProfileMasters := OrderedCollection new!

relInitProfileValues
	"Initialize collection of 1-N relationship1 ProfileValues"

	relProfileValues := OrderedCollection new!

 !

!DocumentDictionary100.Core.Model.XModelElement methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XModelElement methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Model.XModelElement methodsFor: 'testing'!

classPrefix
	"Return 'ME' which is a unique prefix for class ModelElement within the application."

	^'ME'!

 !

