"XModel_AutoAPI.st Generated at 2018-09-22 00:05:39.073."
'Class AutoAPI file for Class Model.'!

!DocumentDictionary100.Core.Model.XModel class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XModel in the DomainModel DocumentDictionary100f"

	^'Abstract class for models.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XModel'.!

 !

!DocumentDictionary100.Core.Model.XModel methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XModel in the DomainModel DocumentDictionary100f."

	^'Abstract class for models.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitDtSynchronized.

	self relInitProfileObjects.
	self relInitProfiles.


	
!
canDelete
	"Return true if this Model can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XModel if there is one, else return nil."


	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."

	self relDeleteAllProfileObjects.
	self relDeleteAllProfiles.




	super delete!

 !

!DocumentDictionary100.Core.Model.XModel methodsFor: 'attributeAPI'!

attGetDtSynchronized
	"Get value of attribute DtSynchronized"
	"Timestamp when this model was last synchronized with a database."

	^attDtSynchronized.!

attIqDtSynchronized
	"Return the information quantity of attribute DtSynchronized"
	"180413 This is a default implementation that can be extended later"

	^attDtSynchronized ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasDtSynchronized
	"Return true if the current value of the attribute DtSynchronized carries information."

	^(attDtSynchronized ~= nil)!

attCreateDtSynchronized
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetDtSynchronized: (TimeStampFactory current)!

attDeleteDtSynchronized
	"Set the attribute value to undefined, or to a value that makes attIqDtSynchronized return 0."

	^self attSetDtSynchronized: nil!

attSetDtSynchronized: value 
	"Set the value of attribute DtSynchronized to value, if it is not already equal to value."

	(attDtSynchronized = value) ifFalse: [
		attDtSynchronized := value.
		self changed: #attDtSynchronized.
	]!

attInitDtSynchronized
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetDtSynchronized: (TimeStampFactory current)!

 !

!DocumentDictionary100.Core.Model.XModel methodsFor: 'relationshipAPI'!

relAllProfileObjects
	"Return collection of all profileObjects"

	^relProfileObjects copy.!

relAllProfiles
	"Return collection of all profiles"

	^relProfiles copy.!

relSizeProfileObjects
	"Return the integer size of the collection returned by relAllProfileObjects"

	^relProfileObjects size!

relSizeProfiles
	"Return the integer size of the collection returned by relAllProfiles"

	^relProfiles size!

relHasProfileObjects
	"Return true if the 1-N relationship1 profileObjects holds at least one object, else return false."

	^relProfileObjects size > 0!

relHasProfiles
	"Return true if the 1-N relationship1 profiles holds at least one object, else return false."

	^relProfiles size > 0!

relCreateProfileObjects
	"Creates and adds a new XProfileObject to 1-N relationship ProfileObjects."

	| prpo2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Model.XProfileObject) ifTrue: [
		prpo2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Model.XProfileObject.
		self relAddProfileObjects: prpo2.
		^prpo2.
	] ifFalse: [
		self dberror: 'XModel.relCreateProfileObjects Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Model.XProfileObject. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateProfiles
	"Creates and adds a new XProfile to 1-N relationship Profiles."

	| prpe2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Model.XProfile) ifTrue: [
		prpe2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Model.XProfile.
		self relAddProfiles: prpe2.
		^prpe2.
	] ifFalse: [
		self dberror: 'XModel.relCreateProfiles Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Model.XProfile. Please open an appropriate substorage first.'.
		^nil.
	].!

relAddProfileObjects: prpo2
	"Adds a XProfileObject prpo2 to 1-N relationship ProfileObjects."

	| MD1a |
	( prpo2 isKindOf: DocumentDictionary100.Core.Profile.XProfileObject ) ifFalse: [
		self dberror: 'XModel:relAddProfileObjects: Error ' message: ( prpo2 asString ,
			' is not a XProfileObject, and can not be added to ProfileObjects for ',
			' this XModel (', self asString, ').' ).
		^nil.
	].
	( (relProfileObjects identityIndexOf: prpo2) > 0 ) ifTrue: [
		self dberror: 'XModel:relAddProfileObjects: Error ' message: 
			'XProfileObject (', prpo2 asString , ') is already added to this XModel (', self asString, ').'.
		^nil.
	].
	( MD1a := prpo2 relGetModel ) ifNotNil: [ 
		self dberror: 'XModel:relAddProfileObjects: Error ' message: 
			'XProfileObject (', prpo2 asString , ') is already added to another XModel (', MD1a asString , ').'.
		^nil.
	]. 
	relProfileObjects add: prpo2.
	prpo2 relPrivateSetModel: self.
	^prpo2!

relAddProfiles: prpe2
	"Adds a XProfile prpe2 to 1-N relationship Profiles."

	| MD1a |
	( prpe2 isKindOf: DocumentDictionary100.Core.Profile.XProfile ) ifFalse: [
		self dberror: 'XModel:relAddProfiles: Error ' message: ( prpe2 asString ,
			' is not a XProfile, and can not be added to Profiles for ',
			' this XModel (', self asString, ').' ).
		^nil.
	].
	( (relProfiles identityIndexOf: prpe2) > 0 ) ifTrue: [
		self dberror: 'XModel:relAddProfiles: Error ' message: 
			'XProfile (', prpe2 asString , ') is already added to this XModel (', self asString, ').'.
		^nil.
	].
	( MD1a := prpe2 relGetModel ) ifNotNil: [ 
		self dberror: 'XModel:relAddProfiles: Error ' message: 
			'XProfile (', prpe2 asString , ') is already added to another XModel (', MD1a asString , ').'.
		^nil.
	]. 
	relProfiles add: prpe2.
	prpe2 relPrivateSetModel: self.
	^prpe2!

relGetProfileObjects
	"Return the first XProfileObject object on the other side of the 1-N relations1 profileObjects."
	"Provides compatibility with 1-1 relationships."

	( relProfileObjects size = 0 ) ifTrue: [ ^nil ].
	^relProfileObjects first!

relGetProfiles
	"Return the first XProfile object on the other side of the 1-N relations1 profiles."
	"Provides compatibility with 1-1 relationships."

	( relProfiles size = 0 ) ifTrue: [ ^nil ].
	^relProfiles first!

relSetProfileObjects: prpo2
	"Force set other end of 1-N relationship to one XProfileObject prpo2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| MD1a |
	prpo2 ifNil: [
		self relDeleteAllProfileObjects.
		^nil.
	].
	( prpo2 isKindOf: DocumentDictionary100.Core.Profile.XProfileObject ) ifFalse: [
		self dberror: 'XModel:relSetProfileObjects: Error ' message: ( prpo2 asString ,
			' is not a XProfileObject, and can not be added to' ,
			' this XModel (', self asString, ').' ).
		^nil.
	].
	(( ( relProfileObjects identityIndexOf: prpo2 ) > 0 ) and: [ relProfileObjects size = 1 ]) ifTrue: [
		"XProfileObject prpo2 is already added to this XModel, and it is the only one."
		^nil.
	].
	( relProfileObjects size > 0 ) ifTrue: [
		self relDeleteAllProfileObjects.
	].

	( MD1a := prpo2 relGetModel ) ifNotNil: [ 
		prpo2 relRemoveAllModel
	]. 
	relProfileObjects add: prpo2.
	prpo2 relPrivateSetModel: self.
	^prpo2!

relSetProfiles: prpe2
	"Force set other end of 1-N relationship to one XProfile prpe2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| MD1a |
	prpe2 ifNil: [
		self relDeleteAllProfiles.
		^nil.
	].
	( prpe2 isKindOf: DocumentDictionary100.Core.Profile.XProfile ) ifFalse: [
		self dberror: 'XModel:relSetProfiles: Error ' message: ( prpe2 asString ,
			' is not a XProfile, and can not be added to' ,
			' this XModel (', self asString, ').' ).
		^nil.
	].
	(( ( relProfiles identityIndexOf: prpe2 ) > 0 ) and: [ relProfiles size = 1 ]) ifTrue: [
		"XProfile prpe2 is already added to this XModel, and it is the only one."
		^nil.
	].
	( relProfiles size > 0 ) ifTrue: [
		self relDeleteAllProfiles.
	].

	( MD1a := prpe2 relGetModel ) ifNotNil: [ 
		prpe2 relRemoveAllModel
	]. 
	relProfiles add: prpe2.
	prpe2 relPrivateSetModel: self.
	^prpe2!

relRemoveProfileObjects: prpo2
	"Removes a XProfileObject prpo2 from 1-N relationship1 ProfileObjects."

	| MD1 index |
	( prpo2 isKindOf: DocumentDictionary100.Core.Profile.XProfileObject ) ifFalse: [
		self dberror: 'XModel:relRemoveProfileObjects: Error ' message: ( prpo2 asString ,
			' is not a XProfileObject, and can not possibly be removed from ProfileObjects on' ,
			' this XModel (', self asString, ').' ).
		^nil.
	].
	( ( MD1 := prpo2 relGetModel ) == self ) ifFalse:[
		self dberror: 'XModel:relRemoveProfileObjects Error ' message: 
			'XProfileObject (', prpo2 asString , ') is added to XModel (', MD1 asString, ') ',
			'instead of this XModel (', self asString , ').'.
		^nil.
	].
	index := relProfileObjects identityIndexOf: prpo2.
	(index = 0) ifTrue: [
		self dberror: 'XModel:relRemoveProfileObjects Error ' message: 
			'XProfileObject (', prpo2 asString , ') can not be found in ProfileObjects of this XModel(', self asString , ').'.
		^nil.
	]. 
	relProfileObjects removeAtIndex: index.
	prpo2 relPrivateSetModel: nil.
	^prpo2.!

relRemoveProfiles: prpe2
	"Removes a XProfile prpe2 from 1-N relationship1 Profiles."

	| MD1 index |
	( prpe2 isKindOf: DocumentDictionary100.Core.Profile.XProfile ) ifFalse: [
		self dberror: 'XModel:relRemoveProfiles: Error ' message: ( prpe2 asString ,
			' is not a XProfile, and can not possibly be removed from Profiles on' ,
			' this XModel (', self asString, ').' ).
		^nil.
	].
	( ( MD1 := prpe2 relGetModel ) == self ) ifFalse:[
		self dberror: 'XModel:relRemoveProfiles Error ' message: 
			'XProfile (', prpe2 asString , ') is added to XModel (', MD1 asString, ') ',
			'instead of this XModel (', self asString , ').'.
		^nil.
	].
	index := relProfiles identityIndexOf: prpe2.
	(index = 0) ifTrue: [
		self dberror: 'XModel:relRemoveProfiles Error ' message: 
			'XProfile (', prpe2 asString , ') can not be found in Profiles of this XModel(', self asString , ').'.
		^nil.
	]. 
	relProfiles removeAtIndex: index.
	prpe2 relPrivateSetModel: nil.
	^prpe2.!

relRemoveAllProfileObjects 
	"Remove all XProfileObject instances from 1-N relationship1 ProfileObjects and return them in a collection."

	| prpo2Coll |
	( prpo2Coll := relProfileObjects copy ) do: [:prpo2 |
		self relRemoveProfileObjects: prpo2
	].
	^prpo2Coll.!

relRemoveAllProfiles 
	"Remove all XProfile instances from 1-N relationship1 Profiles and return them in a collection."

	| prpe2Coll |
	( prpe2Coll := relProfiles copy ) do: [:prpe2 |
		self relRemoveProfiles: prpe2
	].
	^prpe2Coll.!

relDeleteProfileObjects: prpo2
	"Remove a XProfileObject prpo2 from 1-1 relationship1 ProfileObjects and delete it."
	"Return true if operation succeded else return false."

	| MD1 index |
	( prpo2 isKindOf: DocumentDictionary100.Core.Profile.XProfileObject ) ifFalse: [
		self dberror: 'XModel:relDeleteProfileObjects: Error ' message: ( prpo2 asString ,
			' is not a XProfileObject, and can not possibly be deleted from ProfileObjects on' ,
			' this XModel (', self asString, ').' ).
		^false.
	].
	(( MD1 := prpo2 relGetModel ) = self ) ifFalse:[
		self dberror: 'XModel:relDeleteProfileObjects Error ' message: 
			'XProfileObject (', prpo2 asString , ') is added to XModel (', MD1 asString, ') ',
			'instead of this XModel (', self asString , ').'.
		^false.
	].
	index := relProfileObjects identityIndexOf: prpo2.
	(index = 0) ifTrue: [
		self dberror: 'XModel:relDeleteProfileObjects Error ' message: 
			'XProfileObject (', prpo2 asString , ') can not be found in ProfileObjects of this XModel(', self asString , ').'.
		^false.
	]. 
	relProfileObjects removeAtIndex: index.
	prpo2 relPrivateSetModel: nil.
	prpo2 delete.
	^true.!

relDeleteProfiles: prpe2
	"Remove a XProfile prpe2 from 1-1 relationship1 Profiles and delete it."
	"Return true if operation succeded else return false."

	| MD1 index |
	( prpe2 isKindOf: DocumentDictionary100.Core.Profile.XProfile ) ifFalse: [
		self dberror: 'XModel:relDeleteProfiles: Error ' message: ( prpe2 asString ,
			' is not a XProfile, and can not possibly be deleted from Profiles on' ,
			' this XModel (', self asString, ').' ).
		^false.
	].
	(( MD1 := prpe2 relGetModel ) = self ) ifFalse:[
		self dberror: 'XModel:relDeleteProfiles Error ' message: 
			'XProfile (', prpe2 asString , ') is added to XModel (', MD1 asString, ') ',
			'instead of this XModel (', self asString , ').'.
		^false.
	].
	index := relProfiles identityIndexOf: prpe2.
	(index = 0) ifTrue: [
		self dberror: 'XModel:relDeleteProfiles Error ' message: 
			'XProfile (', prpe2 asString , ') can not be found in Profiles of this XModel(', self asString , ').'.
		^false.
	]. 
	relProfiles removeAtIndex: index.
	prpe2 relPrivateSetModel: nil.
	prpe2 delete.
	^true.!

relDeleteAllProfileObjects 
	"Delete all XProfileObject from 1-N relationship1 ProfileObjects, and return the count of deleted objects."

	| prpo2Size prpo2Coll |
	prpo2Size := relProfileObjects size.
	prpo2Coll := relProfileObjects.
	self relInitProfileObjects.
	prpo2Coll do: [:prpo2 |
		prpo2 relPrivateSetModel: nil.
		prpo2 delete.
	].
	^prpo2Size.!

relDeleteAllProfiles 
	"Delete all XProfile from 1-N relationship1 Profiles, and return the count of deleted objects."

	| prpe2Size prpe2Coll |
	prpe2Size := relProfiles size.
	prpe2Coll := relProfiles.
	self relInitProfiles.
	prpe2Coll do: [:prpe2 |
		prpe2 relPrivateSetModel: nil.
		prpe2 delete.
	].
	^prpe2Size.!

relInitProfileObjects
	"Initialize collection of 1-N relationship1 ProfileObjects"

	relProfileObjects := OrderedCollection new!

relInitProfiles
	"Initialize collection of 1-N relationship1 Profiles"

	relProfiles := OrderedCollection new!

 !

!DocumentDictionary100.Core.Model.XModel methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XModel methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Model.XModel methodsFor: 'testing'!

classPrefix
	"Return 'MD' which is a unique prefix for class Model within the application."

	^'MD'!

 !

