"XParameter_AutoAPI.st Generated at 2018-09-22 00:06:49.191."
'Class AutoAPI file for Class Parameter.'!

!DocumentDictionary100.Core.Model.XParameter class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XParameter in the DomainModel DocumentDictionary100f"

	^'Abstract class for parameter objects that specify, for instance, the parameters of a conversion function.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XParameter'.!

 !

!DocumentDictionary100.Core.Model.XParameter methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XParameter in the DomainModel DocumentDictionary100f."

	^'Abstract class for parameter objects that specify, for instance, the parameters of a conversion function.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitAccessPathExpression.
	self attInitDataType.
	self attInitName.
	self attInitPosition.



	
!
canDelete
	"Return true if this Parameter can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XParameter if there is one, else return nil."


	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."





	super delete!

 !

!DocumentDictionary100.Core.Model.XParameter methodsFor: 'attributeAPI'!

attGetAccessPathExpression
	"Get value of attribute AccessPathExpression"
	"More practical experience is needed to find out how the access path is best defined. The intention is an ODMG 2.0 OQL-based pathexpression with its root at the instance of the classA owning a mapping."

	^attAccessPathExpression.!

attGetDataType
	"Get value of attribute DataType"
	"A CORBA-datatype. Need not be specified when the datatype can be derived from an attribute."

	^attDataType.!

attGetName
	"Get value of attribute Name"
	"A symbolic name for the parameter."

	^attName.!

attGetPosition
	"Get value of attribute Position"
	"Specifies the parameter position in the call to a conversion function. Position 0 identifies the return parameter. Position 1 specifies the 1st parameter, 2 the second etc. in the conversion function call."

	^attPosition.!

attIqAccessPathExpression
	"Return the information quantity of attribute AccessPathExpression"
	"180413 This is a default implementation that can be extended later"

	^attAccessPathExpression ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqDataType
	"Return the information quantity of attribute DataType"
	"180413 This is a default implementation that can be extended later"

	^attDataType ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqName
	"Return the information quantity of attribute Name"
	"180413 This is a default implementation that can be extended later"

	^attName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqPosition
	"Return the information quantity of attribute Position"
	"180413 This is a default implementation that can be extended later"

	^attPosition ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasAccessPathExpression
	"Return true if the current value of the attribute AccessPathExpression carries information."

	^(attAccessPathExpression ~= nil)!

attHasDataType
	"Return true if the current value of the attribute DataType carries information."

	^(attDataType ~= nil)!

attHasName
	"Return true if the current value of the attribute Name carries information."

	^(attName ~= nil)!

attHasPosition
	"Return true if the current value of the attribute Position carries information."

	^(attPosition ~= nil)!

attCreateName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetName: (nil)!

attCreateAccessPathExpression
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetAccessPathExpression: (String new: 32767)!

attCreateDataType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetDataType: (String new: 64)!

attCreateName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetName: (nil)!

attCreatePosition
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetPosition: (0)!

attDeleteAccessPathExpression
	"Set the attribute value to undefined, or to a value that makes attIqAccessPathExpression return 0."

	^self attSetAccessPathExpression: nil!

attDeleteDataType
	"Set the attribute value to undefined, or to a value that makes attIqDataType return 0."

	^self attSetDataType: nil!

attDeleteName
	"Set the attribute value to undefined, or to a value that makes attIqName return 0."

	^self attSetName: nil!

attDeletePosition
	"Set the attribute value to undefined, or to a value that makes attIqPosition return 0."

	^self attSetPosition: nil!

attSetAccessPathExpression: value 
	"Set the value of attribute AccessPathExpression to value, if it is not already equal to value."

	(attAccessPathExpression = value) ifFalse: [
		attAccessPathExpression := value.
		self changed: #attAccessPathExpression.
	]!

attSetDataType: value 
	"Set the value of attribute DataType to value, if it is not already equal to value."

	(attDataType = value) ifFalse: [
		attDataType := value.
		self changed: #attDataType.
	]!

attSetName: value 
	"Set the value of attribute Name to value, if it is not already equal to value."

	(attName = value) ifFalse: [
		attName := value.
		self changed: #attName.
	]!

attSetPosition: value 
	"Set the value of attribute Position to value, if it is not already equal to value."

	(attPosition = value) ifFalse: [
		attPosition := value.
		self changed: #attPosition.
	]!

attInitName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attName := nil!

attInitAccessPathExpression
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetAccessPathExpression: (String new: 32767)!

attInitDataType
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetDataType: (String new: 64)!

attInitPosition
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetPosition: (0)!

 !

!DocumentDictionary100.Core.Model.XParameter methodsFor: 'relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XParameter methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XParameter methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Model.XParameter methodsFor: 'testing'!

classPrefix
	"Return 'PS' which is a unique prefix for class Parameter within the application."

	^'PS'!

 !

