"XSubModelLogRecord_AutoAPI.st Generated at 2018-09-22 00:07:57.357."
'Class AutoAPI file for Class SubModelLogRecord.'!

!DocumentDictionary100.Core.Model.XSubModelLogRecord class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XSubModelLogRecord in the DomainModel DocumentDictionary100f"

	^'Superclass for model specific log entries. These record changes made in a part-of hierarchy sub model. The root object (e.g. DataDictionary) of the sub model hierarcy owns the log.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XSubModelLogRecord'.!

 !

!DocumentDictionary100.Core.Model.XSubModelLogRecord methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XSubModelLogRecord in the DomainModel DocumentDictionary100f."

	^'Superclass for model specific log entries. These record changes made in a part-of hierarchy sub model. The root object (e.g. DataDictionary) of the sub model hierarcy owns the log.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitAttributeName.
	self attInitChangeActionName.
	self attInitClassName.
	self attInitInstanceHighId.
	self attInitInstanceLowId.
	self attInitInstanceVersion.
	self attInitName.
	self attInitNewDtModified.
	self attInitNewModifiedBy.
	self attInitNewText.
	self attInitNewValue.
	self attInitOldDtModified.
	self attInitOldModifiedBy.
	self attInitOldText.
	self attInitOldValue.
	self attInitRemark.



	
!
canDelete
	"Return true if this SubModelLogRecord can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XSubModelLogRecord if there is one, else return nil."


	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."





	super delete!

 !

!DocumentDictionary100.Core.Model.XSubModelLogRecord methodsFor: 'attributeAPI'!

attGetAttributeName
	"Get value of attribute AttributeName"
	"The name of the attribute of the instance that has been changed."

	^attAttributeName.!

attGetChangeActionName
	"Get value of attribute ChangeActionName"
	"One of 11 names for the action that caused this log record to be generated."

	^attChangeActionName.!

attGetClassName
	"Get value of attribute ClassName"
	"The name of the class of the instance that has been changed."

	^attClassName.!

attGetInstanceHighId
	"Get value of attribute InstanceHighId"
	"Higher part of globally unique object identifier of the instance that has been changed."

	^attInstanceHighId.!

attGetInstanceLowId
	"Get value of attribute InstanceLowId"
	"Lower part of globally unique object identifier of the instance that has been changed."

	^attInstanceLowId.!

attGetInstanceVersion
	"Get value of attribute InstanceVersion"
	"Version identifier for the instance that has been changed."

	^attInstanceVersion.!

attGetName
	"Get value of attribute Name"
	"An identifier for the affected instance. Primarily used for human identification of a particular instance in a loglist. This value is computed when log operations are conducted."

	^attName.!

attGetNewDtModified
	"Get value of attribute NewDtModified"
	"Timestamp when this object was last modified holding the new value."

	^attNewDtModified.!

attGetNewModifiedBy
	"Get value of attribute NewModifiedBy"
	"Login identifier for the user who did the modification to the newValue."

	^attNewModifiedBy.!

attGetNewText
	"Get value of attribute NewText"
	"An XML-representation of the new value after the change."

	^attNewText.!

attGetNewValue
	"Get value of attribute NewValue"
	"A string representation of the new value after the change."

	^attNewValue.!

attGetOldDtModified
	"Get value of attribute OldDtModified"
	"Timestamp when this object was last modified holding the old value."

	^attOldDtModified.!

attGetOldModifiedBy
	"Get value of attribute OldModifiedBy"
	"Login identifier for the user who did the latest modification of the oldValue."

	^attOldModifiedBy.!

attGetOldText
	"Get value of attribute OldText"
	"An XML-representation of the old value before the change."

	^attOldText.!

attGetOldValue
	"Get value of attribute OldValue"
	"A string representation of the old value before the change."

	^attOldValue.!

attGetRemark
	"Get value of attribute Remark"
	"Enables a manually written comment on the change. Should not be necessary for most changes."

	^attRemark.!

attIqAttributeName
	"Return the information quantity of attribute AttributeName"
	"180413 This is a default implementation that can be extended later"

	^attAttributeName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqChangeActionName
	"Return the information quantity of attribute ChangeActionName"
	"180413 This is a default implementation that can be extended later"

	^attChangeActionName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqClassName
	"Return the information quantity of attribute ClassName"
	"180413 This is a default implementation that can be extended later"

	^attClassName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqInstanceHighId
	"Return the information quantity of attribute InstanceHighId"
	"180413 This is a default implementation that can be extended later"

	^attInstanceHighId ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqInstanceLowId
	"Return the information quantity of attribute InstanceLowId"
	"180413 This is a default implementation that can be extended later"

	^attInstanceLowId ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqInstanceVersion
	"Return the information quantity of attribute InstanceVersion"
	"180413 This is a default implementation that can be extended later"

	^attInstanceVersion ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqName
	"Return the information quantity of attribute Name"
	"180413 This is a default implementation that can be extended later"

	^attName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqNewDtModified
	"Return the information quantity of attribute NewDtModified"
	"180413 This is a default implementation that can be extended later"

	^attNewDtModified ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqNewModifiedBy
	"Return the information quantity of attribute NewModifiedBy"
	"180413 This is a default implementation that can be extended later"

	^attNewModifiedBy ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqNewText
	"Return the information quantity of attribute NewText"
	"180413 This is a default implementation that can be extended later"

	^attNewText ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqNewValue
	"Return the information quantity of attribute NewValue"
	"180413 This is a default implementation that can be extended later"

	^attNewValue ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqOldDtModified
	"Return the information quantity of attribute OldDtModified"
	"180413 This is a default implementation that can be extended later"

	^attOldDtModified ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqOldModifiedBy
	"Return the information quantity of attribute OldModifiedBy"
	"180413 This is a default implementation that can be extended later"

	^attOldModifiedBy ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqOldText
	"Return the information quantity of attribute OldText"
	"180413 This is a default implementation that can be extended later"

	^attOldText ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqOldValue
	"Return the information quantity of attribute OldValue"
	"180413 This is a default implementation that can be extended later"

	^attOldValue ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqRemark
	"Return the information quantity of attribute Remark"
	"180413 This is a default implementation that can be extended later"

	^attRemark ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasAttributeName
	"Return true if the current value of the attribute AttributeName carries information."

	^(attAttributeName ~= nil)!

attHasChangeActionName
	"Return true if the current value of the attribute ChangeActionName carries information."

	^(attChangeActionName ~= nil)!

attHasClassName
	"Return true if the current value of the attribute ClassName carries information."

	^(attClassName ~= nil)!

attHasInstanceHighId
	"Return true if the current value of the attribute InstanceHighId carries information."

	^(attInstanceHighId ~= nil)!

attHasInstanceLowId
	"Return true if the current value of the attribute InstanceLowId carries information."

	^(attInstanceLowId ~= nil)!

attHasInstanceVersion
	"Return true if the current value of the attribute InstanceVersion carries information."

	^(attInstanceVersion ~= nil)!

attHasName
	"Return true if the current value of the attribute Name carries information."

	^(attName ~= nil)!

attHasNewDtModified
	"Return true if the current value of the attribute NewDtModified carries information."

	^(attNewDtModified ~= nil)!

attHasNewModifiedBy
	"Return true if the current value of the attribute NewModifiedBy carries information."

	^(attNewModifiedBy ~= nil)!

attHasNewText
	"Return true if the current value of the attribute NewText carries information."

	^(attNewText ~= nil)!

attHasNewValue
	"Return true if the current value of the attribute NewValue carries information."

	^(attNewValue ~= nil)!

attHasOldDtModified
	"Return true if the current value of the attribute OldDtModified carries information."

	^(attOldDtModified ~= nil)!

attHasOldModifiedBy
	"Return true if the current value of the attribute OldModifiedBy carries information."

	^(attOldModifiedBy ~= nil)!

attHasOldText
	"Return true if the current value of the attribute OldText carries information."

	^(attOldText ~= nil)!

attHasOldValue
	"Return true if the current value of the attribute OldValue carries information."

	^(attOldValue ~= nil)!

attHasRemark
	"Return true if the current value of the attribute Remark carries information."

	^(attRemark ~= nil)!

attCreateAttributeName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetAttributeName: (nil)!

attCreateChangeActionName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetChangeActionName: (nil)!

attCreateClassName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetClassName: (nil)!

attCreateName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetName: (nil)!

attCreateNewText
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetNewText: (nil)!

attCreateNewValue
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetNewValue: (nil)!

attCreateOldText
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetOldText: (nil)!

attCreateOldValue
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetOldValue: (nil)!

attCreateRemark
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetRemark: (nil)!

attCreateAttributeName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetAttributeName: (nil)!

attCreateChangeActionName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetChangeActionName: (nil)!

attCreateClassName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetClassName: (nil)!

attCreateInstanceHighId
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetInstanceHighId: (0)!

attCreateInstanceLowId
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetInstanceLowId: (0)!

attCreateInstanceVersion
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetInstanceVersion: (String new: 32)!

attCreateName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetName: (nil)!

attCreateNewDtModified
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetNewDtModified: (TimeStampFactory current)!

attCreateNewModifiedBy
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetNewModifiedBy: (String new: 32)!

attCreateNewText
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetNewText: (nil)!

attCreateNewValue
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetNewValue: (nil)!

attCreateOldDtModified
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetOldDtModified: (TimeStampFactory current)!

attCreateOldModifiedBy
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetOldModifiedBy: (String new: 32)!

attCreateOldText
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetOldText: (nil)!

attCreateOldValue
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetOldValue: (nil)!

attCreateRemark
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetRemark: (nil)!

attDeleteAttributeName
	"Set the attribute value to undefined, or to a value that makes attIqAttributeName return 0."

	^self attSetAttributeName: nil!

attDeleteChangeActionName
	"Set the attribute value to undefined, or to a value that makes attIqChangeActionName return 0."

	^self attSetChangeActionName: nil!

attDeleteClassName
	"Set the attribute value to undefined, or to a value that makes attIqClassName return 0."

	^self attSetClassName: nil!

attDeleteInstanceHighId
	"Set the attribute value to undefined, or to a value that makes attIqInstanceHighId return 0."

	^self attSetInstanceHighId: nil!

attDeleteInstanceLowId
	"Set the attribute value to undefined, or to a value that makes attIqInstanceLowId return 0."

	^self attSetInstanceLowId: nil!

attDeleteInstanceVersion
	"Set the attribute value to undefined, or to a value that makes attIqInstanceVersion return 0."

	^self attSetInstanceVersion: nil!

attDeleteName
	"Set the attribute value to undefined, or to a value that makes attIqName return 0."

	^self attSetName: nil!

attDeleteNewDtModified
	"Set the attribute value to undefined, or to a value that makes attIqNewDtModified return 0."

	^self attSetNewDtModified: nil!

attDeleteNewModifiedBy
	"Set the attribute value to undefined, or to a value that makes attIqNewModifiedBy return 0."

	^self attSetNewModifiedBy: nil!

attDeleteNewText
	"Set the attribute value to undefined, or to a value that makes attIqNewText return 0."

	^self attSetNewText: nil!

attDeleteNewValue
	"Set the attribute value to undefined, or to a value that makes attIqNewValue return 0."

	^self attSetNewValue: nil!

attDeleteOldDtModified
	"Set the attribute value to undefined, or to a value that makes attIqOldDtModified return 0."

	^self attSetOldDtModified: nil!

attDeleteOldModifiedBy
	"Set the attribute value to undefined, or to a value that makes attIqOldModifiedBy return 0."

	^self attSetOldModifiedBy: nil!

attDeleteOldText
	"Set the attribute value to undefined, or to a value that makes attIqOldText return 0."

	^self attSetOldText: nil!

attDeleteOldValue
	"Set the attribute value to undefined, or to a value that makes attIqOldValue return 0."

	^self attSetOldValue: nil!

attDeleteRemark
	"Set the attribute value to undefined, or to a value that makes attIqRemark return 0."

	^self attSetRemark: nil!

attSetAttributeName: value 
	"Set the value of attribute AttributeName to value, if it is not already equal to value."

	(attAttributeName = value) ifFalse: [
		attAttributeName := value.
		self changed: #attAttributeName.
	]!

attSetChangeActionName: value 
	"Set the value of attribute ChangeActionName to value, if it is not already equal to value."

	(attChangeActionName = value) ifFalse: [
		attChangeActionName := value.
		self changed: #attChangeActionName.
	]!

attSetClassName: value 
	"Set the value of attribute ClassName to value, if it is not already equal to value."

	(attClassName = value) ifFalse: [
		attClassName := value.
		self changed: #attClassName.
	]!

attSetInstanceHighId: value 
	"Set the value of attribute InstanceHighId to value, if it is not already equal to value."

	(attInstanceHighId = value) ifFalse: [
		attInstanceHighId := value.
		self changed: #attInstanceHighId.
	]!

attSetInstanceLowId: value 
	"Set the value of attribute InstanceLowId to value, if it is not already equal to value."

	(attInstanceLowId = value) ifFalse: [
		attInstanceLowId := value.
		self changed: #attInstanceLowId.
	]!

attSetInstanceVersion: value 
	"Set the value of attribute InstanceVersion to value, if it is not already equal to value."

	(attInstanceVersion = value) ifFalse: [
		attInstanceVersion := value.
		self changed: #attInstanceVersion.
	]!

attSetName: value 
	"Set the value of attribute Name to value, if it is not already equal to value."

	(attName = value) ifFalse: [
		attName := value.
		self changed: #attName.
	]!

attSetNewDtModified: value 
	"Set the value of attribute NewDtModified to value, if it is not already equal to value."

	(attNewDtModified = value) ifFalse: [
		attNewDtModified := value.
		self changed: #attNewDtModified.
	]!

attSetNewModifiedBy: value 
	"Set the value of attribute NewModifiedBy to value, if it is not already equal to value."

	(attNewModifiedBy = value) ifFalse: [
		attNewModifiedBy := value.
		self changed: #attNewModifiedBy.
	]!

attSetNewText: value 
	"Set the value of attribute NewText to value, if it is not already equal to value."

	(attNewText = value) ifFalse: [
		attNewText := value.
		self changed: #attNewText.
	]!

attSetNewValue: value 
	"Set the value of attribute NewValue to value, if it is not already equal to value."

	(attNewValue = value) ifFalse: [
		attNewValue := value.
		self changed: #attNewValue.
	]!

attSetOldDtModified: value 
	"Set the value of attribute OldDtModified to value, if it is not already equal to value."

	(attOldDtModified = value) ifFalse: [
		attOldDtModified := value.
		self changed: #attOldDtModified.
	]!

attSetOldModifiedBy: value 
	"Set the value of attribute OldModifiedBy to value, if it is not already equal to value."

	(attOldModifiedBy = value) ifFalse: [
		attOldModifiedBy := value.
		self changed: #attOldModifiedBy.
	]!

attSetOldText: value 
	"Set the value of attribute OldText to value, if it is not already equal to value."

	(attOldText = value) ifFalse: [
		attOldText := value.
		self changed: #attOldText.
	]!

attSetOldValue: value 
	"Set the value of attribute OldValue to value, if it is not already equal to value."

	(attOldValue = value) ifFalse: [
		attOldValue := value.
		self changed: #attOldValue.
	]!

attSetRemark: value 
	"Set the value of attribute Remark to value, if it is not already equal to value."

	(attRemark = value) ifFalse: [
		attRemark := value.
		self changed: #attRemark.
	]!

attInitAttributeName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attAttributeName := nil!

attInitChangeActionName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attChangeActionName := nil!

attInitClassName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attClassName := nil!

attInitName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attName := nil!

attInitNewText
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attNewText := nil!

attInitNewValue
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attNewValue := nil!

attInitOldText
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attOldText := nil!

attInitOldValue
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attOldValue := nil!

attInitRemark
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attRemark := nil!

attInitInstanceHighId
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetInstanceHighId: (0)!

attInitInstanceLowId
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetInstanceLowId: (0)!

attInitInstanceVersion
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetInstanceVersion: (String new: 32)!

attInitNewDtModified
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetNewDtModified: (TimeStampFactory current)!

attInitNewModifiedBy
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetNewModifiedBy: (String new: 32)!

attInitOldDtModified
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetOldDtModified: (TimeStampFactory current)!

attInitOldModifiedBy
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetOldModifiedBy: (String new: 32)!

 !

!DocumentDictionary100.Core.Model.XSubModelLogRecord methodsFor: 'relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XSubModelLogRecord methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XSubModelLogRecord methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Model.XSubModelLogRecord methodsFor: 'testing'!

classPrefix
	"Return 'LO' which is a unique prefix for class SubModelLogRecord within the application."

	^'LO'!

 !

