"XAttributeDefinition_AutoAPI.st Generated at 2018-09-22 00:00:51.942."
'Class AutoAPI file for Class AttributeDefinition.'!

!DocumentDictionary100.Core.Profile.XAttributeDefinition class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XAttributeDefinition in the DomainModel DocumentDictionary100f"

	^'Defines a attribute in the profile that extends the predefined meta-model.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XAttributeDefinition'.!

 !

!DocumentDictionary100.Core.Profile.XAttributeDefinition methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XAttributeDefinition in the DomainModel DocumentDictionary100f."

	^'Defines a attribute in the profile that extends the predefined meta-model.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitDefaultValue.
	self attInitType.


	self relInitClassDefinition.

	
!
canDelete
	"Return true if this AttributeDefinition can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XAttributeDefinition if there is one, else return nil."

	self relHasClassDefinition ifTrue: [ ^self relGetClassDefinition ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."



	self relRemoveAllClassDefinition.


	super delete!

 !

!DocumentDictionary100.Core.Profile.XAttributeDefinition methodsFor: 'attributeAPI'!

attGetDefaultValue
	"Get value of attribute DefaultValue"
	"Default value set for AttributeValues, when they are created for the first time."

	^attDefaultValue.!

attGetType
	"Get value of attribute Type"
	"All AttributeValue values are stored as strings in the model. This type is used for temporary definition of the semantic data type during model development, e.g. a DataElementType or Corba type."

	^attType.!

attIqDefaultValue
	"Return the information quantity of attribute DefaultValue"
	"180413 This is a default implementation that can be extended later"

	^attDefaultValue ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqType
	"Return the information quantity of attribute Type"
	"180413 This is a default implementation that can be extended later"

	^attType ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasDefaultValue
	"Return true if the current value of the attribute DefaultValue carries information."

	^(attDefaultValue ~= nil)!

attHasType
	"Return true if the current value of the attribute Type carries information."

	^(attType ~= nil)!

attCreateDefaultValue
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetDefaultValue: (nil)!

attCreateType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetType: (nil)!

attCreateDefaultValue
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetDefaultValue: (nil)!

attCreateType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetType: (nil)!

attDeleteDefaultValue
	"Set the attribute value to undefined, or to a value that makes attIqDefaultValue return 0."

	^self attSetDefaultValue: nil!

attDeleteType
	"Set the attribute value to undefined, or to a value that makes attIqType return 0."

	^self attSetType: nil!

attSetDefaultValue: value 
	"Set the value of attribute DefaultValue to value, if it is not already equal to value."

	(attDefaultValue = value) ifFalse: [
		attDefaultValue := value.
		self changed: #attDefaultValue.
	]!

attSetType: value 
	"Set the value of attribute Type to value, if it is not already equal to value."

	(attType = value) ifFalse: [
		attType := value.
		self changed: #attType.
	]!

attInitDefaultValue
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attDefaultValue := nil!

attInitType
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attType := nil!

 !

!DocumentDictionary100.Core.Profile.XAttributeDefinition methodsFor: 'relationshipAPI'!

relRemoveAllClassDefinition
	"Remove a XClassDefinition from 1-N relationship2 ClassDefinition if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllClassDefinition) do: [:prcd1 | self relRemoveClassDefinition: prcd1].!

relAllClassDefinition
	"Return collection of 1-N relationship classDefinition"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relClassDefinition ifNil: [ ^coll ].
	coll add: relClassDefinition.
	^coll.!

relSizeClassDefinition
	"Return the integer size of the collection returned by relAllClassDefinition"
	"Keeps compatibility with 1-N relationships"

	^relClassDefinition ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasClassDefinition
	"Return true if the 1-N relations2 classDefinition holds an object, else return false."

	^relClassDefinition notNil.!

relCreateClassDefinition
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XClassDefinition to 1-N relationship ClassDefinition."

	| prcd1a prcd1 |
	( prcd1a := self relGetClassDefinition ) ifNotNil: [
		self dberror: 'XClassDefinition:relCreateClassDefinition: Error ' message: 
			'XClassDefinition (', self  asString , ') already has a XClassDefinition (', prcd1a asString, ') in 1-N relation ClassDefinition.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XClassDefinition) ifTrue: [
		prcd1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XClassDefinition.
		prcd1 relAddAttributeDefinitions: self.
		"prcd1 addDefaultOwner."
		^prcd1.
	] ifFalse: [
		self dberror: 'XAttributeDefinition.relCreateClassDefinition Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XClassDefinition. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetClassDefinition
	"Return the XClassDefinition object on the other side of the 1-N relationship2 classDefinition."

	^relClassDefinition!

relSetClassDefinition: prcd1
	"Set other end of 1-1 relations2 ClassDefinition"

	prcd1 ifNotNil: [
		( prcd1 isKindOf: DocumentDictionary100.Core.Profile.XClassDefinition ) ifFalse: [
			self dberror: 'XAttributeDefinition:relSetClassDefinition: Error ' message: ( prcd1 asString ,
				' is not a XClassDefinition, and can not be set to' ,
				' this XAttributeDefinition (', self asString, ') relation2 ClassDefinition.' ).
			^nil.
		]
	].

	self relHasClassDefinition ifTrue: [ 
		"Special treatment needed if NOT_FOUND.mustExist1 == true or mustExist2 == true. "
		self relRemoveAllClassDefinition. 
	].
	prcd1 ifNotNil: [ prcd1 relAddAttributeDefinitions: self. ].
	^prcd1!

relRemoveClassDefinition: prcd1
	"Removes a XClassDefinition prcd1 from 1-N relationship2 ClassDefinition."

	prcd1 ifNil: [
		self dberror: 'XAttributeDefinition:relRemoveClassDefinition: Error ' message: ( 'wrong class of parameter prcd1, ',
			' nil is not a XClassDefinition, and can not be removed from' ,
			' this XAttributeDefinition (', self asString, ') relation2 ClassDefinition.' ).
		^nil.
	].

	prcd1 ifNotNil: [
		( prcd1 isKindOf: DocumentDictionary100.Core.Profile.XClassDefinition ) ifFalse: [
			self dberror: 'XAttributeDefinition:relRemoveClassDefinition: Error ' message: ( prcd1 asString ,
				' is not a XClassDefinition, and can not be removed from' ,
				' this XAttributeDefinition (', self asString, ') relation2 ClassDefinition.' ).
			^nil.
		]
	].

	prcd1 ifNotNil: [ prcd1 relRemoveAttributeDefinitions: self. ].
	^prcd1!

relRemoveAllClassDefinition
	"Remove a XClassDefinition from 1-N relationship2 ClassDefinition if there is one."
	"Available for API completeness reasons."

	(self relAllClassDefinition) do: [:prcd1 | self relRemoveClassDefinition: prcd1].!

relDeleteNOT_FOUND: prcd1
	"Deletes a DocumentDictionary100.Core.Profile.XClassDefinition prcd1 from 1-N relationship2 ClassDefinition."

	prcd1 ifNil: [
		self dberror: 'XAttributeDefinition:relDeleteClassDefinition: Error ' message: ( 'wrong class of parameter prcd1, ',
			' nil is not a XClassDefinition, and can not be deleted from' ,
			' this XAttributeDefinition (', self asString, ') relation2 ClassDefinition.' ).
		^nil.
	].

	prcd1 ifNotNil: [
		( prcd1 isKindOf: DocumentDictionary100.Core.Profile.XClassDefinition ) ifFalse: [
			self dberror: 'XAttributeDefinition:relDeleteClassDefinition: Error ' message: ( prcd1 asString ,
				' is not a XClassDefinition, and can not be deleted from' ,
				' this XAttributeDefinition (', self asString, ') relation2 ClassDefinition.' ).
			^nil.
		]
	].

	prcd1 ifNotNil: [ prcd1 relRemoveAttributeDefinitions: self. ].
	prcd1 delete!

relDeleteAllClassDefinition
	"Deletes a XClassDefinition from 1-N relationship2 ClassDefinition if there is one."
	"Available for API completeness reasons."

	(self relAllClassDefinition) do: [:prcd1 | self relDeleteClassDefinition: prcd1].!

relInitClassDefinition
	"Initialize pointer of 1-N relationship1 ClassDefinition "

	relClassDefinition := nil!

 !

!DocumentDictionary100.Core.Profile.XAttributeDefinition methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetClassDefinition: prcd1
	"Set other end of 1-N relationship1 AttributeDefinitions"

	"prcd1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying prcd1.
	]."

  "( prcd1 isKindOf: NOT_FOUND.XClassDefinition ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relClassDefinition == prcd1 ) ifFalse: [
		relClassDefinition := prcd1.
		prcd1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying prcd1."
	  ].
	  self changed: #relClassDefinition.
	].
	^relClassDefinition!

 !

!DocumentDictionary100.Core.Profile.XAttributeDefinition methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Profile.XAttributeDefinition methodsFor: 'testing'!

classPrefix
	"Return 'prad' which is a unique prefix for class AttributeDefinition within the application."

	^'prad'!

 !

