"XClassDefinition_AutoAPI.st Generated at 2018-09-22 00:02:09.110."
'Class AutoAPI file for Class ClassDefinition.'!

!DocumentDictionary100.Core.Profile.XClassDefinition class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XClassDefinition in the DomainModel DocumentDictionary100f"

	^'A class defined in the profile, which extends the meta-model with a new class that is not already defined there. This class definition is similar to stereotypes in UML.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XClassDefinition'.!

 !

!DocumentDictionary100.Core.Profile.XClassDefinition methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XClassDefinition in the DomainModel DocumentDictionary100f."

	^'A class defined in the profile, which extends the meta-model with a new class that is not already defined there. This class definition is similar to stereotypes in UML.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitBaseClass.

	self relInitAttributeDefinitions.
	self relInitGeneralizations.
	self relInitSpecializations.

	self relInitProfile.

	
!
canDelete
	"Return true if this ClassDefinition can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XClassDefinition if there is one, else return nil."

	self relHasProfile ifTrue: [ ^self relGetProfile ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."

	self relDeleteAllAttributeDefinitions.
	self relDeleteAllGeneralizations.
	self relDeleteAllSpecializations.


	self relRemoveAllProfile.


	super delete!

 !

!DocumentDictionary100.Core.Profile.XClassDefinition methodsFor: 'attributeAPI'!

attGetBaseClass
	"Get value of attribute BaseClass"
	"The base class in the application domainmodel for which all new instances shall receive the extra attributes definied by this class definition. If the base class is left unspecified, the class definition instances are stored in ObjectInstances."

	^attBaseClass.!

attIqBaseClass
	"Return the information quantity of attribute BaseClass"
	"180413 This is a default implementation that can be extended later"

	^attBaseClass ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasBaseClass
	"Return true if the current value of the attribute BaseClass carries information."

	^(attBaseClass ~= nil)!

attCreateBaseClass
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetBaseClass: (nil)!

attCreateBaseClass
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetBaseClass: (nil)!

attDeleteBaseClass
	"Set the attribute value to undefined, or to a value that makes attIqBaseClass return 0."

	^self attSetBaseClass: nil!

attSetBaseClass: value 
	"Set the value of attribute BaseClass to value, if it is not already equal to value."

	(attBaseClass = value) ifFalse: [
		attBaseClass := value.
		self changed: #attBaseClass.
	]!

attInitBaseClass
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attBaseClass := nil!

 !

!DocumentDictionary100.Core.Profile.XClassDefinition methodsFor: 'relationshipAPI'!

relRemoveAllProfile
	"Remove a XProfile from 1-N relationship2 Profile if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllProfile) do: [:prpe1 | self relRemoveProfile: prpe1].!

relAllAttributeDefinitions
	"Return collection of all attributeDefinitions"

	^relAttributeDefinitions copy.!

relAllGeneralizations
	"Return collection of all generalizations"

	^relGeneralizations copy.!

relAllSpecializations
	"Return collection of all specializations"

	^relSpecializations copy.!

relSizeAttributeDefinitions
	"Return the integer size of the collection returned by relAllAttributeDefinitions"

	^relAttributeDefinitions size!

relSizeGeneralizations
	"Return the integer size of the collection returned by relAllGeneralizations"

	^relGeneralizations size!

relSizeSpecializations
	"Return the integer size of the collection returned by relAllSpecializations"

	^relSpecializations size!

relHasAttributeDefinitions
	"Return true if the 1-N relationship1 attributeDefinitions holds at least one object, else return false."

	^relAttributeDefinitions size > 0!

relHasGeneralizations
	"Return true if the 1-N relationship1 generalizations holds at least one object, else return false."

	^relGeneralizations size > 0!

relHasSpecializations
	"Return true if the 1-N relationship1 specializations holds at least one object, else return false."

	^relSpecializations size > 0!

relCreateAttributeDefinitions
	"Creates and adds a new XAttributeDefinition to 1-N relationship AttributeDefinitions."

	| prad2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XAttributeDefinition) ifTrue: [
		prad2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XAttributeDefinition.
		self relAddAttributeDefinitions: prad2.
		^prad2.
	] ifFalse: [
		self dberror: 'XClassDefinition.relCreateAttributeDefinitions Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XAttributeDefinition. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateGeneralizations
	"Creates and adds a new XGeneralizationDefinition to 1-N relationship Generalizations."

	| prgd2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XGeneralizationDefinition) ifTrue: [
		prgd2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XGeneralizationDefinition.
		self relAddGeneralizations: prgd2.
		^prgd2.
	] ifFalse: [
		self dberror: 'XClassDefinition.relCreateGeneralizations Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XGeneralizationDefinition. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateSpecializations
	"Creates and adds a new XGeneralizationDefinition to 1-N relationship Specializations."

	| prgd2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XGeneralizationDefinition) ifTrue: [
		prgd2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XGeneralizationDefinition.
		self relAddSpecializations: prgd2.
		^prgd2.
	] ifFalse: [
		self dberror: 'XClassDefinition.relCreateSpecializations Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XGeneralizationDefinition. Please open an appropriate substorage first.'.
		^nil.
	].!

relAddAttributeDefinitions: prad2
	"Adds a XAttributeDefinition prad2 to 1-N relationship AttributeDefinitions."

	| prcd1a |
	( prad2 isKindOf: DocumentDictionary100.Core.Profile.XAttributeDefinition ) ifFalse: [
		self dberror: 'XClassDefinition:relAddAttributeDefinitions: Error ' message: ( prad2 asString ,
			' is not a XAttributeDefinition, and can not be added to AttributeDefinitions for ',
			' this XClassDefinition (', self asString, ').' ).
		^nil.
	].
	( (relAttributeDefinitions identityIndexOf: prad2) > 0 ) ifTrue: [
		self dberror: 'XClassDefinition:relAddAttributeDefinitions: Error ' message: 
			'XAttributeDefinition (', prad2 asString , ') is already added to this XClassDefinition (', self asString, ').'.
		^nil.
	].
	( prcd1a := prad2 relGetClassDefinition ) ifNotNil: [ 
		self dberror: 'XClassDefinition:relAddAttributeDefinitions: Error ' message: 
			'XAttributeDefinition (', prad2 asString , ') is already added to another XClassDefinition (', prcd1a asString , ').'.
		^nil.
	]. 
	relAttributeDefinitions add: prad2.
	prad2 relPrivateSetClassDefinition: self.
	^prad2!

relAddGeneralizations: prgd2
	"Adds a XGeneralizationDefinition prgd2 to 1-N relationship Generalizations."

	| prcd1a |
	( prgd2 isKindOf: DocumentDictionary100.Core.Profile.XGeneralizationDefinition ) ifFalse: [
		self dberror: 'XClassDefinition:relAddGeneralizations: Error ' message: ( prgd2 asString ,
			' is not a XGeneralizationDefinition, and can not be added to Generalizations for ',
			' this XClassDefinition (', self asString, ').' ).
		^nil.
	].
	( (relGeneralizations identityIndexOf: prgd2) > 0 ) ifTrue: [
		self dberror: 'XClassDefinition:relAddGeneralizations: Error ' message: 
			'XGeneralizationDefinition (', prgd2 asString , ') is already added to this XClassDefinition (', self asString, ').'.
		^nil.
	].
	( prcd1a := prgd2 relGetSubclass ) ifNotNil: [ 
		self dberror: 'XClassDefinition:relAddGeneralizations: Error ' message: 
			'XGeneralizationDefinition (', prgd2 asString , ') is already added to another XClassDefinition (', prcd1a asString , ').'.
		^nil.
	]. 
	relGeneralizations add: prgd2.
	prgd2 relPrivateSetSubclass: self.
	^prgd2!

relAddSpecializations: prgd2
	"Adds a XGeneralizationDefinition prgd2 to 1-N relationship Specializations."

	| prcd1a |
	( prgd2 isKindOf: DocumentDictionary100.Core.Profile.XGeneralizationDefinition ) ifFalse: [
		self dberror: 'XClassDefinition:relAddSpecializations: Error ' message: ( prgd2 asString ,
			' is not a XGeneralizationDefinition, and can not be added to Specializations for ',
			' this XClassDefinition (', self asString, ').' ).
		^nil.
	].
	( (relSpecializations identityIndexOf: prgd2) > 0 ) ifTrue: [
		self dberror: 'XClassDefinition:relAddSpecializations: Error ' message: 
			'XGeneralizationDefinition (', prgd2 asString , ') is already added to this XClassDefinition (', self asString, ').'.
		^nil.
	].
	( prcd1a := prgd2 relGetSuperclass ) ifNotNil: [ 
		self dberror: 'XClassDefinition:relAddSpecializations: Error ' message: 
			'XGeneralizationDefinition (', prgd2 asString , ') is already added to another XClassDefinition (', prcd1a asString , ').'.
		^nil.
	]. 
	relSpecializations add: prgd2.
	prgd2 relPrivateSetSuperclass: self.
	^prgd2!

relGetAttributeDefinitions
	"Return the first XAttributeDefinition object on the other side of the 1-N relations1 attributeDefinitions."
	"Provides compatibility with 1-1 relationships."

	( relAttributeDefinitions size = 0 ) ifTrue: [ ^nil ].
	^relAttributeDefinitions first!

relGetGeneralizations
	"Return the first XGeneralizationDefinition object on the other side of the 1-N relations1 generalizations."
	"Provides compatibility with 1-1 relationships."

	( relGeneralizations size = 0 ) ifTrue: [ ^nil ].
	^relGeneralizations first!

relGetSpecializations
	"Return the first XGeneralizationDefinition object on the other side of the 1-N relations1 specializations."
	"Provides compatibility with 1-1 relationships."

	( relSpecializations size = 0 ) ifTrue: [ ^nil ].
	^relSpecializations first!

relSetAttributeDefinitions: prad2
	"Force set other end of 1-N relationship to one XAttributeDefinition prad2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| prcd1a |
	prad2 ifNil: [
		self relDeleteAllAttributeDefinitions.
		^nil.
	].
	( prad2 isKindOf: DocumentDictionary100.Core.Profile.XAttributeDefinition ) ifFalse: [
		self dberror: 'XClassDefinition:relSetAttributeDefinitions: Error ' message: ( prad2 asString ,
			' is not a XAttributeDefinition, and can not be added to' ,
			' this XClassDefinition (', self asString, ').' ).
		^nil.
	].
	(( ( relAttributeDefinitions identityIndexOf: prad2 ) > 0 ) and: [ relAttributeDefinitions size = 1 ]) ifTrue: [
		"XAttributeDefinition prad2 is already added to this XClassDefinition, and it is the only one."
		^nil.
	].
	( relAttributeDefinitions size > 0 ) ifTrue: [
		self relDeleteAllAttributeDefinitions.
	].

	( prcd1a := prad2 relGetClassDefinition ) ifNotNil: [ 
		prad2 relRemoveAllClassDefinition
	]. 
	relAttributeDefinitions add: prad2.
	prad2 relPrivateSetClassDefinition: self.
	^prad2!

relSetGeneralizations: prgd2
	"Force set other end of 1-N relationship to one XGeneralizationDefinition prgd2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| prcd1a |
	prgd2 ifNil: [
		self relDeleteAllGeneralizations.
		^nil.
	].
	( prgd2 isKindOf: DocumentDictionary100.Core.Profile.XGeneralizationDefinition ) ifFalse: [
		self dberror: 'XClassDefinition:relSetGeneralizations: Error ' message: ( prgd2 asString ,
			' is not a XGeneralizationDefinition, and can not be added to' ,
			' this XClassDefinition (', self asString, ').' ).
		^nil.
	].
	(( ( relGeneralizations identityIndexOf: prgd2 ) > 0 ) and: [ relGeneralizations size = 1 ]) ifTrue: [
		"XGeneralizationDefinition prgd2 is already added to this XClassDefinition, and it is the only one."
		^nil.
	].
	( relGeneralizations size > 0 ) ifTrue: [
		self relDeleteAllGeneralizations.
	].

	( prcd1a := prgd2 relGetSubclass ) ifNotNil: [ 
		prgd2 relRemoveAllSubclass
	]. 
	relGeneralizations add: prgd2.
	prgd2 relPrivateSetSubclass: self.
	^prgd2!

relSetSpecializations: prgd2
	"Force set other end of 1-N relationship to one XGeneralizationDefinition prgd2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| prcd1a |
	prgd2 ifNil: [
		self relRemoveAllSpecializations.
		^nil.
	].
	( prgd2 isKindOf: DocumentDictionary100.Core.Profile.XGeneralizationDefinition ) ifFalse: [
		self dberror: 'XClassDefinition:relSetSpecializations: Error ' message: ( prgd2 asString ,
			' is not a XGeneralizationDefinition, and can not be added to' ,
			' this XClassDefinition (', self asString, ').' ).
		^nil.
	].
	(( ( relSpecializations identityIndexOf: prgd2 ) > 0 ) and: [ relSpecializations size = 1 ]) ifTrue: [
		"XGeneralizationDefinition prgd2 is already added to this XClassDefinition, and it is the only one."
		^nil.
	].
	( relSpecializations size > 0 ) ifTrue: [
		self relRemoveAllSpecializations.
	].

	( prcd1a := prgd2 relGetSuperclass ) ifNotNil: [ 
		prgd2 relRemoveAllSuperclass
	]. 
	relSpecializations add: prgd2.
	prgd2 relPrivateSetSuperclass: self.
	^prgd2!

relRemoveAttributeDefinitions: prad2
	"Removes a XAttributeDefinition prad2 from 1-N relationship1 AttributeDefinitions."

	| prcd1 index |
	( prad2 isKindOf: DocumentDictionary100.Core.Profile.XAttributeDefinition ) ifFalse: [
		self dberror: 'XClassDefinition:relRemoveAttributeDefinitions: Error ' message: ( prad2 asString ,
			' is not a XAttributeDefinition, and can not possibly be removed from AttributeDefinitions on' ,
			' this XClassDefinition (', self asString, ').' ).
		^nil.
	].
	( ( prcd1 := prad2 relGetClassDefinition ) == self ) ifFalse:[
		self dberror: 'XClassDefinition:relRemoveAttributeDefinitions Error ' message: 
			'XAttributeDefinition (', prad2 asString , ') is added to XClassDefinition (', prcd1 asString, ') ',
			'instead of this XClassDefinition (', self asString , ').'.
		^nil.
	].
	index := relAttributeDefinitions identityIndexOf: prad2.
	(index = 0) ifTrue: [
		self dberror: 'XClassDefinition:relRemoveAttributeDefinitions Error ' message: 
			'XAttributeDefinition (', prad2 asString , ') can not be found in AttributeDefinitions of this XClassDefinition(', self asString , ').'.
		^nil.
	]. 
	relAttributeDefinitions removeAtIndex: index.
	prad2 relPrivateSetClassDefinition: nil.
	^prad2.!

relRemoveGeneralizations: prgd2
	"Removes a XGeneralizationDefinition prgd2 from 1-N relationship1 Generalizations."

	| prcd1 index |
	( prgd2 isKindOf: DocumentDictionary100.Core.Profile.XGeneralizationDefinition ) ifFalse: [
		self dberror: 'XClassDefinition:relRemoveGeneralizations: Error ' message: ( prgd2 asString ,
			' is not a XGeneralizationDefinition, and can not possibly be removed from Generalizations on' ,
			' this XClassDefinition (', self asString, ').' ).
		^nil.
	].
	( ( prcd1 := prgd2 relGetSubclass ) == self ) ifFalse:[
		self dberror: 'XClassDefinition:relRemoveGeneralizations Error ' message: 
			'XGeneralizationDefinition (', prgd2 asString , ') is added to XClassDefinition (', prcd1 asString, ') ',
			'instead of this XClassDefinition (', self asString , ').'.
		^nil.
	].
	index := relGeneralizations identityIndexOf: prgd2.
	(index = 0) ifTrue: [
		self dberror: 'XClassDefinition:relRemoveGeneralizations Error ' message: 
			'XGeneralizationDefinition (', prgd2 asString , ') can not be found in Generalizations of this XClassDefinition(', self asString , ').'.
		^nil.
	]. 
	relGeneralizations removeAtIndex: index.
	prgd2 relPrivateSetSubclass: nil.
	^prgd2.!

relRemoveSpecializations: prgd2
	"Removes a XGeneralizationDefinition prgd2 from 1-N relationship1 Specializations."

	| prcd1 index |
	( prgd2 isKindOf: DocumentDictionary100.Core.Profile.XGeneralizationDefinition ) ifFalse: [
		self dberror: 'XClassDefinition:relRemoveSpecializations: Error ' message: ( prgd2 asString ,
			' is not a XGeneralizationDefinition, and can not possibly be removed from Specializations on' ,
			' this XClassDefinition (', self asString, ').' ).
		^nil.
	].
	( ( prcd1 := prgd2 relGetSuperclass ) == self ) ifFalse:[
		self dberror: 'XClassDefinition:relRemoveSpecializations Error ' message: 
			'XGeneralizationDefinition (', prgd2 asString , ') is added to XClassDefinition (', prcd1 asString, ') ',
			'instead of this XClassDefinition (', self asString , ').'.
		^nil.
	].
	index := relSpecializations identityIndexOf: prgd2.
	(index = 0) ifTrue: [
		self dberror: 'XClassDefinition:relRemoveSpecializations Error ' message: 
			'XGeneralizationDefinition (', prgd2 asString , ') can not be found in Specializations of this XClassDefinition(', self asString , ').'.
		^nil.
	]. 
	relSpecializations removeAtIndex: index.
	prgd2 relPrivateSetSuperclass: nil.
	^prgd2.!

relRemoveAllAttributeDefinitions 
	"Remove all XAttributeDefinition instances from 1-N relationship1 AttributeDefinitions and return them in a collection."

	| prad2Coll |
	( prad2Coll := relAttributeDefinitions copy ) do: [:prad2 |
		self relRemoveAttributeDefinitions: prad2
	].
	^prad2Coll.!

relRemoveAllGeneralizations 
	"Remove all XGeneralizationDefinition instances from 1-N relationship1 Generalizations and return them in a collection."

	| prgd2Coll |
	( prgd2Coll := relGeneralizations copy ) do: [:prgd2 |
		self relRemoveGeneralizations: prgd2
	].
	^prgd2Coll.!

relRemoveAllSpecializations 
	"Remove all XGeneralizationDefinition instances from 1-N relationship1 Specializations and return them in a collection."

	| prgd2Coll |
	( prgd2Coll := relSpecializations copy ) do: [:prgd2 |
		self relRemoveSpecializations: prgd2
	].
	^prgd2Coll.!

relDeleteAttributeDefinitions: prad2
	"Remove a XAttributeDefinition prad2 from 1-1 relationship1 AttributeDefinitions and delete it."
	"Return true if operation succeded else return false."

	| prcd1 index |
	( prad2 isKindOf: DocumentDictionary100.Core.Profile.XAttributeDefinition ) ifFalse: [
		self dberror: 'XClassDefinition:relDeleteAttributeDefinitions: Error ' message: ( prad2 asString ,
			' is not a XAttributeDefinition, and can not possibly be deleted from AttributeDefinitions on' ,
			' this XClassDefinition (', self asString, ').' ).
		^false.
	].
	(( prcd1 := prad2 relGetClassDefinition ) = self ) ifFalse:[
		self dberror: 'XClassDefinition:relDeleteAttributeDefinitions Error ' message: 
			'XAttributeDefinition (', prad2 asString , ') is added to XClassDefinition (', prcd1 asString, ') ',
			'instead of this XClassDefinition (', self asString , ').'.
		^false.
	].
	index := relAttributeDefinitions identityIndexOf: prad2.
	(index = 0) ifTrue: [
		self dberror: 'XClassDefinition:relDeleteAttributeDefinitions Error ' message: 
			'XAttributeDefinition (', prad2 asString , ') can not be found in AttributeDefinitions of this XClassDefinition(', self asString , ').'.
		^false.
	]. 
	relAttributeDefinitions removeAtIndex: index.
	prad2 relPrivateSetClassDefinition: nil.
	prad2 delete.
	^true.!

relDeleteGeneralizations: prgd2
	"Remove a XGeneralizationDefinition prgd2 from 1-1 relationship1 Generalizations and delete it."
	"Return true if operation succeded else return false."

	| prcd1 index |
	( prgd2 isKindOf: DocumentDictionary100.Core.Profile.XGeneralizationDefinition ) ifFalse: [
		self dberror: 'XClassDefinition:relDeleteGeneralizations: Error ' message: ( prgd2 asString ,
			' is not a XGeneralizationDefinition, and can not possibly be deleted from Generalizations on' ,
			' this XClassDefinition (', self asString, ').' ).
		^false.
	].
	(( prcd1 := prgd2 relGetSubclass ) = self ) ifFalse:[
		self dberror: 'XClassDefinition:relDeleteGeneralizations Error ' message: 
			'XGeneralizationDefinition (', prgd2 asString , ') is added to XClassDefinition (', prcd1 asString, ') ',
			'instead of this XClassDefinition (', self asString , ').'.
		^false.
	].
	index := relGeneralizations identityIndexOf: prgd2.
	(index = 0) ifTrue: [
		self dberror: 'XClassDefinition:relDeleteGeneralizations Error ' message: 
			'XGeneralizationDefinition (', prgd2 asString , ') can not be found in Generalizations of this XClassDefinition(', self asString , ').'.
		^false.
	]. 
	relGeneralizations removeAtIndex: index.
	prgd2 relPrivateSetSubclass: nil.
	prgd2 delete.
	^true.!

relDeleteSpecializations: prgd2
	"Remove a XGeneralizationDefinition prgd2 from 1-1 relationship1 Specializations and delete it."
	"Return true if operation succeded else return false."

	| prcd1 index |
	( prgd2 isKindOf: DocumentDictionary100.Core.Profile.XGeneralizationDefinition ) ifFalse: [
		self dberror: 'XClassDefinition:relDeleteSpecializations: Error ' message: ( prgd2 asString ,
			' is not a XGeneralizationDefinition, and can not possibly be deleted from Specializations on' ,
			' this XClassDefinition (', self asString, ').' ).
		^false.
	].
	(( prcd1 := prgd2 relGetSuperclass ) = self ) ifFalse:[
		self dberror: 'XClassDefinition:relDeleteSpecializations Error ' message: 
			'XGeneralizationDefinition (', prgd2 asString , ') is added to XClassDefinition (', prcd1 asString, ') ',
			'instead of this XClassDefinition (', self asString , ').'.
		^false.
	].
	index := relSpecializations identityIndexOf: prgd2.
	(index = 0) ifTrue: [
		self dberror: 'XClassDefinition:relDeleteSpecializations Error ' message: 
			'XGeneralizationDefinition (', prgd2 asString , ') can not be found in Specializations of this XClassDefinition(', self asString , ').'.
		^false.
	]. 
	relSpecializations removeAtIndex: index.
	prgd2 relPrivateSetSuperclass: nil.
	prgd2 delete.
	^true.!

relDeleteAllAttributeDefinitions 
	"Delete all XAttributeDefinition from 1-N relationship1 AttributeDefinitions, and return the count of deleted objects."

	| prad2Size prad2Coll |
	prad2Size := relAttributeDefinitions size.
	prad2Coll := relAttributeDefinitions.
	self relInitAttributeDefinitions.
	prad2Coll do: [:prad2 |
		prad2 relPrivateSetClassDefinition: nil.
		prad2 delete.
	].
	^prad2Size.!

relDeleteAllGeneralizations 
	"Delete all XGeneralizationDefinition from 1-N relationship1 Generalizations, and return the count of deleted objects."

	| prgd2Size prgd2Coll |
	prgd2Size := relGeneralizations size.
	prgd2Coll := relGeneralizations.
	self relInitGeneralizations.
	prgd2Coll do: [:prgd2 |
		prgd2 relPrivateSetSubclass: nil.
		prgd2 delete.
	].
	^prgd2Size.!

relDeleteAllSpecializations 
	"Delete all XGeneralizationDefinition from 1-N relationship1 Specializations, and return the count of deleted objects."

	| prgd2Size prgd2Coll |
	prgd2Size := relSpecializations size.
	prgd2Coll := relSpecializations.
	self relInitSpecializations.
	prgd2Coll do: [:prgd2 |
		prgd2 relPrivateSetSuperclass: nil.
		prgd2 delete.
	].
	^prgd2Size.!

relInitAttributeDefinitions
	"Initialize collection of 1-N relationship1 AttributeDefinitions"

	relAttributeDefinitions := OrderedCollection new!

relInitGeneralizations
	"Initialize collection of 1-N relationship1 Generalizations"

	relGeneralizations := OrderedCollection new!

relInitSpecializations
	"Initialize collection of 1-N relationship1 Specializations"

	relSpecializations := OrderedCollection new!

relAllProfile
	"Return collection of 1-N relationship profile"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relProfile ifNil: [ ^coll ].
	coll add: relProfile.
	^coll.!

relSizeProfile
	"Return the integer size of the collection returned by relAllProfile"
	"Keeps compatibility with 1-N relationships"

	^relProfile ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasProfile
	"Return true if the 1-N relations2 profile holds an object, else return false."

	^relProfile notNil.!

relCreateProfile
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XProfile to 1-N relationship Profile."

	| prpe1a prpe1 |
	( prpe1a := self relGetProfile ) ifNotNil: [
		self dberror: 'XProfile:relCreateProfile: Error ' message: 
			'XProfile (', self  asString , ') already has a XProfile (', prpe1a asString, ') in 1-N relation Profile.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XProfile) ifTrue: [
		prpe1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XProfile.
		prpe1 relAddClassDefinitions: self.
		"prpe1 addDefaultOwner."
		^prpe1.
	] ifFalse: [
		self dberror: 'XClassDefinition.relCreateProfile Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XProfile. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetProfile
	"Return the XProfile object on the other side of the 1-N relationship2 profile."

	^relProfile!

relRemoveProfile: prpe1
	"Removes a XProfile prpe1 from 1-N relationship2 Profile."

	prpe1 ifNil: [
		self dberror: 'XClassDefinition:relRemoveProfile: Error ' message: ( 'wrong class of parameter prpe1, ',
			' nil is not a XProfile, and can not be removed from' ,
			' this XClassDefinition (', self asString, ') relation2 Profile.' ).
		^nil.
	].

	prpe1 ifNotNil: [
		( prpe1 isKindOf: DocumentDictionary100.Core.Profile.XProfile ) ifFalse: [
			self dberror: 'XClassDefinition:relRemoveProfile: Error ' message: ( prpe1 asString ,
				' is not a XProfile, and can not be removed from' ,
				' this XClassDefinition (', self asString, ') relation2 Profile.' ).
			^nil.
		]
	].

	prpe1 ifNotNil: [ prpe1 relRemoveClassDefinitions: self. ].
	^prpe1!

relInitProfile
	"Initialize pointer of 1-N relationship1 Profile "

	relProfile := nil!

 !

!DocumentDictionary100.Core.Profile.XClassDefinition methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetProfile: prpe1
	"Set other end of 1-N relationship1 ClassDefinitions"

	"prpe1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying prpe1.
	]."

  "( prpe1 isKindOf: NOT_FOUND.XProfile ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relProfile == prpe1 ) ifFalse: [
		relProfile := prpe1.
		prpe1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying prpe1."
	  ].
	  self changed: #relProfile.
	].
	^relProfile!

 !

!DocumentDictionary100.Core.Profile.XClassDefinition methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Profile.XClassDefinition methodsFor: 'testing'!

classPrefix
	"Return 'prcd' which is a unique prefix for class ClassDefinition within the application."

	^'prcd'!

 !

