"XGeneralizationDefinition_AutoAPI.st Generated at 2018-09-22 00:05:15.920."
'Class AutoAPI file for Class GeneralizationDefinition.'!

!DocumentDictionary100.Core.Profile.XGeneralizationDefinition class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XGeneralizationDefinition in the DomainModel DocumentDictionary100f"

	^'Defines a generalization for a ClassDefinition within the profile.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XGeneralizationDefinition'.!

 !

!DocumentDictionary100.Core.Profile.XGeneralizationDefinition methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XGeneralizationDefinition in the DomainModel DocumentDictionary100f."

	^'Defines a generalization for a ClassDefinition within the profile.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitDiscriminator.


	self relInitSubclass.
	self relInitSuperclass.

	
!
canDelete
	"Return true if this GeneralizationDefinition can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XGeneralizationDefinition if there is one, else return nil."

	self relHasSubclass ifTrue: [ ^self relGetSubclass ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."



	self relRemoveAllSubclass.
	self relRemoveAllSuperclass.


	super delete!

 !

!DocumentDictionary100.Core.Profile.XGeneralizationDefinition methodsFor: 'attributeAPI'!

attGetDiscriminator
	"Get value of attribute Discriminator"
	"Designates an optional partition to which the GeneralizationDefinition belongs within the subclass."

	^attDiscriminator.!

attIqDiscriminator
	"Return the information quantity of attribute Discriminator"
	"180413 This is a default implementation that can be extended later"

	^attDiscriminator ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasDiscriminator
	"Return true if the current value of the attribute Discriminator carries information."

	^(attDiscriminator ~= nil)!

attCreateDiscriminator
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetDiscriminator: (nil)!

attCreateDiscriminator
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetDiscriminator: (nil)!

attDeleteDiscriminator
	"Set the attribute value to undefined, or to a value that makes attIqDiscriminator return 0."

	^self attSetDiscriminator: nil!

attSetDiscriminator: value 
	"Set the value of attribute Discriminator to value, if it is not already equal to value."

	(attDiscriminator = value) ifFalse: [
		attDiscriminator := value.
		self changed: #attDiscriminator.
	]!

attInitDiscriminator
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attDiscriminator := nil!

 !

!DocumentDictionary100.Core.Profile.XGeneralizationDefinition methodsFor: 'relationshipAPI'!

relRemoveAllSubclass
	"Remove a XClassDefinition from 1-N relationship2 Subclass if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllSubclass) do: [:prcd1 | self relRemoveSubclass: prcd1].!

relRemoveAllSuperclass
	"Remove a XClassDefinition from 1-N relationship2 Superclass if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllSuperclass) do: [:prcd1 | self relRemoveSuperclass: prcd1].!

relAllSubclass
	"Return collection of 1-N relationship subclass"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relSubclass ifNil: [ ^coll ].
	coll add: relSubclass.
	^coll.!

relAllSuperclass
	"Return collection of 1-N relationship superclass"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relSuperclass ifNil: [ ^coll ].
	coll add: relSuperclass.
	^coll.!

relSizeSubclass
	"Return the integer size of the collection returned by relAllSubclass"
	"Keeps compatibility with 1-N relationships"

	^relSubclass ifNil: [ 0 ] ifNotNil: [ 1 ].!

relSizeSuperclass
	"Return the integer size of the collection returned by relAllSuperclass"
	"Keeps compatibility with 1-N relationships"

	^relSuperclass ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasSubclass
	"Return true if the 1-N relations2 subclass holds an object, else return false."

	^relSubclass notNil.!

relHasSuperclass
	"Return true if the 1-N relations2 superclass holds an object, else return false."

	^relSuperclass notNil.!

relCreateSubclass
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XClassDefinition to 1-N relationship Subclass."

	| prcd1a prcd1 |
	( prcd1a := self relGetSubclass ) ifNotNil: [
		self dberror: 'XClassDefinition:relCreateSubclass: Error ' message: 
			'XClassDefinition (', self  asString , ') already has a XClassDefinition (', prcd1a asString, ') in 1-N relation Subclass.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XClassDefinition) ifTrue: [
		prcd1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XClassDefinition.
		prcd1 relAddGeneralizations: self.
		"prcd1 addDefaultOwner."
		^prcd1.
	] ifFalse: [
		self dberror: 'XGeneralizationDefinition.relCreateSubclass Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XClassDefinition. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateSuperclass
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XClassDefinition to 1-N relationship Superclass."

	| prcd1a prcd1 |
	( prcd1a := self relGetSuperclass ) ifNotNil: [
		self dberror: 'XClassDefinition:relCreateSuperclass: Error ' message: 
			'XClassDefinition (', self  asString , ') already has a XClassDefinition (', prcd1a asString, ') in 1-N relation Superclass.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XClassDefinition) ifTrue: [
		prcd1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XClassDefinition.
		prcd1 relAddSpecializations: self.
		"prcd1 addDefaultOwner."
		^prcd1.
	] ifFalse: [
		self dberror: 'XGeneralizationDefinition.relCreateSuperclass Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XClassDefinition. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetSubclass
	"Return the XClassDefinition object on the other side of the 1-N relationship2 subclass."

	^relSubclass!

relGetSuperclass
	"Return the XClassDefinition object on the other side of the 1-N relationship2 superclass."

	^relSuperclass!

relSetSuperclass: prcd1
	"Set other end of 1-1 relations2 Superclass"

	prcd1 ifNotNil: [
		( prcd1 isKindOf: DocumentDictionary100.Core.Profile.XClassDefinition ) ifFalse: [
			self dberror: 'XGeneralizationDefinition:relSetSuperclass: Error ' message: ( prcd1 asString ,
				' is not a XClassDefinition, and can not be set to' ,
				' this XGeneralizationDefinition (', self asString, ') relation2 Superclass.' ).
			^nil.
		]
	].

	self relHasSuperclass ifTrue: [ 
		"Special treatment needed if NOT_FOUND.mustExist1 == true or mustExist2 == true. "
		self relRemoveAllSuperclass. 
	].
	prcd1 ifNotNil: [ prcd1 relAddSpecializations: self. ].
	^prcd1!

relRemoveSubclass: prcd1
	"Removes a XClassDefinition prcd1 from 1-N relationship2 Subclass."

	prcd1 ifNil: [
		self dberror: 'XGeneralizationDefinition:relRemoveSubclass: Error ' message: ( 'wrong class of parameter prcd1, ',
			' nil is not a XClassDefinition, and can not be removed from' ,
			' this XGeneralizationDefinition (', self asString, ') relation2 Subclass.' ).
		^nil.
	].

	prcd1 ifNotNil: [
		( prcd1 isKindOf: DocumentDictionary100.Core.Profile.XClassDefinition ) ifFalse: [
			self dberror: 'XGeneralizationDefinition:relRemoveSubclass: Error ' message: ( prcd1 asString ,
				' is not a XClassDefinition, and can not be removed from' ,
				' this XGeneralizationDefinition (', self asString, ') relation2 Subclass.' ).
			^nil.
		]
	].

	prcd1 ifNotNil: [ prcd1 relRemoveGeneralizations: self. ].
	^prcd1!

relRemoveSuperclass: prcd1
	"Removes a XClassDefinition prcd1 from 1-N relationship2 Superclass."

	prcd1 ifNil: [
		self dberror: 'XGeneralizationDefinition:relRemoveSuperclass: Error ' message: ( 'wrong class of parameter prcd1, ',
			' nil is not a XClassDefinition, and can not be removed from' ,
			' this XGeneralizationDefinition (', self asString, ') relation2 Superclass.' ).
		^nil.
	].

	prcd1 ifNotNil: [
		( prcd1 isKindOf: DocumentDictionary100.Core.Profile.XClassDefinition ) ifFalse: [
			self dberror: 'XGeneralizationDefinition:relRemoveSuperclass: Error ' message: ( prcd1 asString ,
				' is not a XClassDefinition, and can not be removed from' ,
				' this XGeneralizationDefinition (', self asString, ') relation2 Superclass.' ).
			^nil.
		]
	].

	prcd1 ifNotNil: [ prcd1 relRemoveSpecializations: self. ].
	^prcd1!

relRemoveAllSuperclass
	"Remove a XClassDefinition from 1-N relationship2 Superclass if there is one."
	"Available for API completeness reasons."

	(self relAllSuperclass) do: [:prcd1 | self relRemoveSuperclass: prcd1].!

relDeleteNOT_FOUND: prcd1
	"Deletes a DocumentDictionary100.Core.Profile.XClassDefinition prcd1 from 1-N relationship2 Superclass."

	prcd1 ifNil: [
		self dberror: 'XGeneralizationDefinition:relDeleteSuperclass: Error ' message: ( 'wrong class of parameter prcd1, ',
			' nil is not a XClassDefinition, and can not be deleted from' ,
			' this XGeneralizationDefinition (', self asString, ') relation2 Superclass.' ).
		^nil.
	].

	prcd1 ifNotNil: [
		( prcd1 isKindOf: DocumentDictionary100.Core.Profile.XClassDefinition ) ifFalse: [
			self dberror: 'XGeneralizationDefinition:relDeleteSuperclass: Error ' message: ( prcd1 asString ,
				' is not a XClassDefinition, and can not be deleted from' ,
				' this XGeneralizationDefinition (', self asString, ') relation2 Superclass.' ).
			^nil.
		]
	].

	prcd1 ifNotNil: [ prcd1 relRemoveSpecializations: self. ].
	prcd1 delete!

relDeleteAllSuperclass
	"Deletes a XClassDefinition from 1-N relationship2 Superclass if there is one."
	"Available for API completeness reasons."

	(self relAllSuperclass) do: [:prcd1 | self relDeleteSuperclass: prcd1].!

relInitSubclass
	"Initialize pointer of 1-N relationship1 Subclass "

	relSubclass := nil!

relInitSuperclass
	"Initialize pointer of 1-N relationship1 Superclass "

	relSuperclass := nil!

 !

!DocumentDictionary100.Core.Profile.XGeneralizationDefinition methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetSubclass: prcd1
	"Set other end of 1-N relationship1 Generalizations"

	"prcd1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying prcd1.
	]."

  "( prcd1 isKindOf: NOT_FOUND.XClassDefinition ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relSubclass == prcd1 ) ifFalse: [
		relSubclass := prcd1.
		prcd1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying prcd1."
	  ].
	  self changed: #relSubclass.
	].
	^relSubclass!

relPrivateSetSuperclass: prcd1
	"Set other end of 1-N relationship1 Specializations"

	"prcd1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying prcd1.
	]."

  "( prcd1 isKindOf: NOT_FOUND.XClassDefinition ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relSuperclass == prcd1 ) ifFalse: [
		relSuperclass := prcd1.
		prcd1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying prcd1."
	  ].
	  self changed: #relSuperclass.
	].
	^relSuperclass!

 !

!DocumentDictionary100.Core.Profile.XGeneralizationDefinition methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Profile.XGeneralizationDefinition methodsFor: 'testing'!

classPrefix
	"Return 'prgd' which is a unique prefix for class GeneralizationDefinition within the application."

	^'prgd'!

 !

