"XProfileLink_AutoAPI.st Generated at 2018-09-22 00:07:14.012."
'Class AutoAPI file for Class ProfileLink.'!

!DocumentDictionary100.Core.Profile.XProfileLink class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XProfileLink in the DomainModel DocumentDictionary100f"

	^'Stores a link that connects a master object with one of its details, for a relationship that has been defined in a profile.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XProfileLink'.!

 !

!DocumentDictionary100.Core.Profile.XProfileLink methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XProfileLink in the DomainModel DocumentDictionary100f."

	^'Stores a link that connects a master object with one of its details, for a relationship that has been defined in a profile.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitDetailClass.
	self attInitMasterClass.
	self attInitRelationshipName.


	self relInitProfileDetail.
	self relInitProfileMaster.

	
!
canDelete
	"Return true if this ProfileLink can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XProfileLink if there is one, else return nil."

	self relHasProfileMaster ifTrue: [ ^self relGetProfileMaster ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."



	self relRemoveAllProfileDetail.
	self relRemoveAllProfileMaster.


	super delete!

 !

!DocumentDictionary100.Core.Profile.XProfileLink methodsFor: 'attributeAPI'!

attGetDetailClass
	"Get value of attribute DetailClass"
	"Class name used to indentify the class of the detail object referenced by this RelationshipLink."

	^attDetailClass.!

attGetMasterClass
	"Get value of attribute MasterClass"
	"Class name used to indentify the class of the master object that owns this RelationshipLink."

	^attMasterClass.!

attGetRelationshipName
	"Get value of attribute RelationshipName"
	"Name of the RelationshipDefinition in a Profile that specifies the semantics of this link."

	^attRelationshipName.!

attIqDetailClass
	"Return the information quantity of attribute DetailClass"
	"180413 This is a default implementation that can be extended later"

	^attDetailClass ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqMasterClass
	"Return the information quantity of attribute MasterClass"
	"180413 This is a default implementation that can be extended later"

	^attMasterClass ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqRelationshipName
	"Return the information quantity of attribute RelationshipName"
	"180413 This is a default implementation that can be extended later"

	^attRelationshipName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasDetailClass
	"Return true if the current value of the attribute DetailClass carries information."

	^(attDetailClass ~= nil)!

attHasMasterClass
	"Return true if the current value of the attribute MasterClass carries information."

	^(attMasterClass ~= nil)!

attHasRelationshipName
	"Return true if the current value of the attribute RelationshipName carries information."

	^(attRelationshipName ~= nil)!

attCreateDetailClass
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetDetailClass: (nil)!

attCreateMasterClass
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetMasterClass: (nil)!

attCreateRelationshipName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetRelationshipName: (nil)!

attCreateDetailClass
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetDetailClass: (nil)!

attCreateMasterClass
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetMasterClass: (nil)!

attCreateRelationshipName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetRelationshipName: (nil)!

attDeleteDetailClass
	"Set the attribute value to undefined, or to a value that makes attIqDetailClass return 0."

	^self attSetDetailClass: nil!

attDeleteMasterClass
	"Set the attribute value to undefined, or to a value that makes attIqMasterClass return 0."

	^self attSetMasterClass: nil!

attDeleteRelationshipName
	"Set the attribute value to undefined, or to a value that makes attIqRelationshipName return 0."

	^self attSetRelationshipName: nil!

attSetDetailClass: value 
	"Set the value of attribute DetailClass to value, if it is not already equal to value."

	(attDetailClass = value) ifFalse: [
		attDetailClass := value.
		self changed: #attDetailClass.
	]!

attSetMasterClass: value 
	"Set the value of attribute MasterClass to value, if it is not already equal to value."

	(attMasterClass = value) ifFalse: [
		attMasterClass := value.
		self changed: #attMasterClass.
	]!

attSetRelationshipName: value 
	"Set the value of attribute RelationshipName to value, if it is not already equal to value."

	(attRelationshipName = value) ifFalse: [
		attRelationshipName := value.
		self changed: #attRelationshipName.
	]!

attInitDetailClass
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attDetailClass := nil!

attInitMasterClass
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attMasterClass := nil!

attInitRelationshipName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attRelationshipName := nil!

 !

!DocumentDictionary100.Core.Profile.XProfileLink methodsFor: 'relationshipAPI'!

relRemoveAllProfileDetail
	"Remove a XModelElement from 1-N relationship2 ProfileDetail if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllProfileDetail) do: [:ME1 | self relRemoveProfileDetail: ME1].!

relRemoveAllProfileMaster
	"Remove a XModelElement from 1-N relationship2 ProfileMaster if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllProfileMaster) do: [:ME1 | self relRemoveProfileMaster: ME1].!

relAllProfileDetail
	"Return collection of 1-N relationship profileDetail"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relProfileDetail ifNil: [ ^coll ].
	coll add: relProfileDetail.
	^coll.!

relAllProfileMaster
	"Return collection of 1-N relationship profileMaster"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relProfileMaster ifNil: [ ^coll ].
	coll add: relProfileMaster.
	^coll.!

relSizeProfileDetail
	"Return the integer size of the collection returned by relAllProfileDetail"
	"Keeps compatibility with 1-N relationships"

	^relProfileDetail ifNil: [ 0 ] ifNotNil: [ 1 ].!

relSizeProfileMaster
	"Return the integer size of the collection returned by relAllProfileMaster"
	"Keeps compatibility with 1-N relationships"

	^relProfileMaster ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasProfileDetail
	"Return true if the 1-N relations2 profileDetail holds an object, else return false."

	^relProfileDetail notNil.!

relHasProfileMaster
	"Return true if the 1-N relations2 profileMaster holds an object, else return false."

	^relProfileMaster notNil.!

relCreateProfileDetail
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XModelElement to 1-N relationship ProfileDetail."

	| ME1a ME1 |
	( ME1a := self relGetProfileDetail ) ifNotNil: [
		self dberror: 'XModelElement:relCreateProfileDetail: Error ' message: 
			'XModelElement (', self  asString , ') already has a XModelElement (', ME1a asString, ') in 1-N relation ProfileDetail.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XModelElement) ifTrue: [
		ME1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XModelElement.
		ME1 relAddProfileMasters: self.
		"ME1 addDefaultOwner."
		^ME1.
	] ifFalse: [
		self dberror: 'XProfileLink.relCreateProfileDetail Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XModelElement. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateProfileMaster
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XModelElement to 1-N relationship ProfileMaster."

	| ME1a ME1 |
	( ME1a := self relGetProfileMaster ) ifNotNil: [
		self dberror: 'XModelElement:relCreateProfileMaster: Error ' message: 
			'XModelElement (', self  asString , ') already has a XModelElement (', ME1a asString, ') in 1-N relation ProfileMaster.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XModelElement) ifTrue: [
		ME1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XModelElement.
		ME1 relAddProfileDetails: self.
		"ME1 addDefaultOwner."
		^ME1.
	] ifFalse: [
		self dberror: 'XProfileLink.relCreateProfileMaster Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XModelElement. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetProfileDetail
	"Return the XModelElement object on the other side of the 1-N relationship2 profileDetail."

	^relProfileDetail!

relGetProfileMaster
	"Return the XModelElement object on the other side of the 1-N relationship2 profileMaster."

	^relProfileMaster!

relRemoveProfileDetail: ME1
	"Removes a XModelElement ME1 from 1-N relationship2 ProfileDetail."

	ME1 ifNil: [
		self dberror: 'XProfileLink:relRemoveProfileDetail: Error ' message: ( 'wrong class of parameter ME1, ',
			' nil is not a XModelElement, and can not be removed from' ,
			' this XProfileLink (', self asString, ') relation2 ProfileDetail.' ).
		^nil.
	].

	ME1 ifNotNil: [
		( ME1 isKindOf: DocumentDictionary100.Core.Model.XModelElement ) ifFalse: [
			self dberror: 'XProfileLink:relRemoveProfileDetail: Error ' message: ( ME1 asString ,
				' is not a XModelElement, and can not be removed from' ,
				' this XProfileLink (', self asString, ') relation2 ProfileDetail.' ).
			^nil.
		]
	].

	ME1 ifNotNil: [ ME1 relRemoveProfileMasters: self. ].
	^ME1!

relRemoveProfileMaster: ME1
	"Removes a XModelElement ME1 from 1-N relationship2 ProfileMaster."

	ME1 ifNil: [
		self dberror: 'XProfileLink:relRemoveProfileMaster: Error ' message: ( 'wrong class of parameter ME1, ',
			' nil is not a XModelElement, and can not be removed from' ,
			' this XProfileLink (', self asString, ') relation2 ProfileMaster.' ).
		^nil.
	].

	ME1 ifNotNil: [
		( ME1 isKindOf: DocumentDictionary100.Core.Model.XModelElement ) ifFalse: [
			self dberror: 'XProfileLink:relRemoveProfileMaster: Error ' message: ( ME1 asString ,
				' is not a XModelElement, and can not be removed from' ,
				' this XProfileLink (', self asString, ') relation2 ProfileMaster.' ).
			^nil.
		]
	].

	ME1 ifNotNil: [ ME1 relRemoveProfileDetails: self. ].
	^ME1!

relInitProfileDetail
	"Initialize pointer of 1-N relationship1 ProfileDetail "

	relProfileDetail := nil!

relInitProfileMaster
	"Initialize pointer of 1-N relationship1 ProfileMaster "

	relProfileMaster := nil!

 !

!DocumentDictionary100.Core.Profile.XProfileLink methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetProfileDetail: ME1
	"Set other end of 1-N relationship1 ProfileMasters"

	"ME1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying ME1.
	]."

  "( ME1 isKindOf: NOT_FOUND.XModelElement ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relProfileDetail == ME1 ) ifFalse: [
		relProfileDetail := ME1.
		ME1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying ME1."
	  ].
	  self changed: #relProfileDetail.
	].
	^relProfileDetail!

relPrivateSetProfileMaster: ME1
	"Set other end of 1-N relationship1 ProfileDetails"

	"ME1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying ME1.
	]."

  "( ME1 isKindOf: NOT_FOUND.XModelElement ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relProfileMaster == ME1 ) ifFalse: [
		relProfileMaster := ME1.
		ME1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying ME1."
	  ].
	  self changed: #relProfileMaster.
	].
	^relProfileMaster!

 !

!DocumentDictionary100.Core.Profile.XProfileLink methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Profile.XProfileLink methodsFor: 'testing'!

classPrefix
	"Return 'prpl' which is a unique prefix for class ProfileLink within the application."

	^'prpl'!

 !

