"XProfileObject_AutoAPI.st Generated at 2018-09-22 00:07:28.144."
'Class AutoAPI file for Class ProfileObject.'!

!DocumentDictionary100.Core.Profile.XProfileObject class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XProfileObject in the DomainModel DocumentDictionary100f"

	^'Stores an object instance of a class definined in a profile. Profile objects store instances for subclasses of ModelElement that are NOT specialized in the application domain model.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XProfileObject'.!

 !

!DocumentDictionary100.Core.Profile.XProfileObject methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XProfileObject in the DomainModel DocumentDictionary100f."

	^'Stores an object instance of a class definined in a profile. Profile objects store instances for subclasses of ModelElement that are NOT specialized in the application domain model.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitClassName.


	self relInitModel.

	
!
canDelete
	"Return true if this ProfileObject can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XProfileObject if there is one, else return nil."

	self relHasModel ifTrue: [ ^self relGetModel ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."



	self relRemoveAllModel.


	super delete!

 !

!DocumentDictionary100.Core.Profile.XProfileObject methodsFor: 'attributeAPI'!

attGetClassName
	"Get value of attribute ClassName"
	"Name of the ClassDefinition that was used when this object instance was created."

	^attClassName.!

attIqClassName
	"Return the information quantity of attribute ClassName"
	"180413 This is a default implementation that can be extended later"

	^attClassName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasClassName
	"Return true if the current value of the attribute ClassName carries information."

	^(attClassName ~= nil)!

attCreateClassName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetClassName: (nil)!

attCreateClassName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetClassName: (nil)!

attDeleteClassName
	"Set the attribute value to undefined, or to a value that makes attIqClassName return 0."

	^self attSetClassName: nil!

attSetClassName: value 
	"Set the value of attribute ClassName to value, if it is not already equal to value."

	(attClassName = value) ifFalse: [
		attClassName := value.
		self changed: #attClassName.
	]!

attInitClassName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attClassName := nil!

 !

!DocumentDictionary100.Core.Profile.XProfileObject methodsFor: 'relationshipAPI'!

relRemoveAllModel
	"Remove a XModel from 1-N relationship2 Model if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllModel) do: [:MD1 | self relRemoveModel: MD1].!

relAllModel
	"Return collection of 1-N relationship model"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relModel ifNil: [ ^coll ].
	coll add: relModel.
	^coll.!

relSizeModel
	"Return the integer size of the collection returned by relAllModel"
	"Keeps compatibility with 1-N relationships"

	^relModel ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasModel
	"Return true if the 1-N relations2 model holds an object, else return false."

	^relModel notNil.!

relCreateModel
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XModel to 1-N relationship Model."

	| MD1a MD1 |
	( MD1a := self relGetModel ) ifNotNil: [
		self dberror: 'XModel:relCreateModel: Error ' message: 
			'XModel (', self  asString , ') already has a XModel (', MD1a asString, ') in 1-N relation Model.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XModel) ifTrue: [
		MD1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XModel.
		MD1 relAddProfileObjects: self.
		"MD1 addDefaultOwner."
		^MD1.
	] ifFalse: [
		self dberror: 'XProfileObject.relCreateModel Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XModel. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetModel
	"Return the XModel object on the other side of the 1-N relationship2 model."

	^relModel!

relRemoveModel: MD1
	"Removes a XModel MD1 from 1-N relationship2 Model."

	MD1 ifNil: [
		self dberror: 'XProfileObject:relRemoveModel: Error ' message: ( 'wrong class of parameter MD1, ',
			' nil is not a XModel, and can not be removed from' ,
			' this XProfileObject (', self asString, ') relation2 Model.' ).
		^nil.
	].

	MD1 ifNotNil: [
		( MD1 isKindOf: DocumentDictionary100.Core.Model.XModel ) ifFalse: [
			self dberror: 'XProfileObject:relRemoveModel: Error ' message: ( MD1 asString ,
				' is not a XModel, and can not be removed from' ,
				' this XProfileObject (', self asString, ') relation2 Model.' ).
			^nil.
		]
	].

	MD1 ifNotNil: [ MD1 relRemoveProfileObjects: self. ].
	^MD1!

relInitModel
	"Initialize pointer of 1-N relationship1 Model "

	relModel := nil!

 !

!DocumentDictionary100.Core.Profile.XProfileObject methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetModel: MD1
	"Set other end of 1-N relationship1 ProfileObjects"

	"MD1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying MD1.
	]."

  "( MD1 isKindOf: NOT_FOUND.XModel ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relModel == MD1 ) ifFalse: [
		relModel := MD1.
		MD1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying MD1."
	  ].
	  self changed: #relModel.
	].
	^relModel!

 !

!DocumentDictionary100.Core.Profile.XProfileObject methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Profile.XProfileObject methodsFor: 'testing'!

classPrefix
	"Return 'prpo' which is a unique prefix for class ProfileObject within the application."

	^'prpo'!

 !

