"XProfile_AutoAPI.st Generated at 2018-09-22 00:06:53.471."
'Class AutoAPI file for Class Profile.'!

!DocumentDictionary100.Core.Profile.XProfile class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XProfile in the DomainModel DocumentDictionary100f"

	^'Profiles are used if the meta-model of the  application must be extended with new attributes, relationships or classes. Profiles allow this without recompiling the application.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XProfile'.!

 !

!DocumentDictionary100.Core.Profile.XProfile methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XProfile in the DomainModel DocumentDictionary100f."

	^'Profiles are used if the meta-model of the  application must be extended with new attributes, relationships or classes. Profiles allow this without recompiling the application.'.!

initialize
	"initialize attributes and relationships"

	super initialize.

	self relInitClassDefinitions.
	self relInitRelationshipDefinitions.

	self relInitModel.

	
!
canDelete
	"Return true if this Profile can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XProfile if there is one, else return nil."

	self relHasModel ifTrue: [ ^self relGetModel ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."

	self relDeleteAllClassDefinitions.
	self relDeleteAllRelationshipDefinitions.


	self relRemoveAllModel.


	super delete!

 !

!DocumentDictionary100.Core.Profile.XProfile methodsFor: 'attributeAPI'!

 !

!DocumentDictionary100.Core.Profile.XProfile methodsFor: 'relationshipAPI'!

relRemoveAllModel
	"Remove a XModel from 1-N relationship2 Model if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllModel) do: [:MD1 | self relRemoveModel: MD1].!

relAllClassDefinitions
	"Return collection of all classDefinitions"

	^relClassDefinitions copy.!

relAllRelationshipDefinitions
	"Return collection of all relationshipDefinitions"

	^relRelationshipDefinitions copy.!

relSizeClassDefinitions
	"Return the integer size of the collection returned by relAllClassDefinitions"

	^relClassDefinitions size!

relSizeRelationshipDefinitions
	"Return the integer size of the collection returned by relAllRelationshipDefinitions"

	^relRelationshipDefinitions size!

relHasClassDefinitions
	"Return true if the 1-N relationship1 classDefinitions holds at least one object, else return false."

	^relClassDefinitions size > 0!

relHasRelationshipDefinitions
	"Return true if the 1-N relationship1 relationshipDefinitions holds at least one object, else return false."

	^relRelationshipDefinitions size > 0!

relCreateClassDefinitions
	"Creates and adds a new XClassDefinition to 1-N relationship ClassDefinitions."

	| prcd2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XClassDefinition) ifTrue: [
		prcd2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XClassDefinition.
		self relAddClassDefinitions: prcd2.
		^prcd2.
	] ifFalse: [
		self dberror: 'XProfile.relCreateClassDefinitions Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XClassDefinition. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateRelationshipDefinitions
	"Creates and adds a new XRelationshipDefinition to 1-N relationship RelationshipDefinitions."

	| prrd2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XRelationshipDefinition) ifTrue: [
		prrd2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XRelationshipDefinition.
		self relAddRelationshipDefinitions: prrd2.
		^prrd2.
	] ifFalse: [
		self dberror: 'XProfile.relCreateRelationshipDefinitions Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XRelationshipDefinition. Please open an appropriate substorage first.'.
		^nil.
	].!

relAddClassDefinitions: prcd2
	"Adds a XClassDefinition prcd2 to 1-N relationship ClassDefinitions."

	| prpe1a |
	( prcd2 isKindOf: DocumentDictionary100.Core.Profile.XClassDefinition ) ifFalse: [
		self dberror: 'XProfile:relAddClassDefinitions: Error ' message: ( prcd2 asString ,
			' is not a XClassDefinition, and can not be added to ClassDefinitions for ',
			' this XProfile (', self asString, ').' ).
		^nil.
	].
	( (relClassDefinitions identityIndexOf: prcd2) > 0 ) ifTrue: [
		self dberror: 'XProfile:relAddClassDefinitions: Error ' message: 
			'XClassDefinition (', prcd2 asString , ') is already added to this XProfile (', self asString, ').'.
		^nil.
	].
	( prpe1a := prcd2 relGetProfile ) ifNotNil: [ 
		self dberror: 'XProfile:relAddClassDefinitions: Error ' message: 
			'XClassDefinition (', prcd2 asString , ') is already added to another XProfile (', prpe1a asString , ').'.
		^nil.
	]. 
	relClassDefinitions add: prcd2.
	prcd2 relPrivateSetProfile: self.
	^prcd2!

relAddRelationshipDefinitions: prrd2
	"Adds a XRelationshipDefinition prrd2 to 1-N relationship RelationshipDefinitions."

	| prpe1a |
	( prrd2 isKindOf: DocumentDictionary100.Core.Profile.XRelationshipDefinition ) ifFalse: [
		self dberror: 'XProfile:relAddRelationshipDefinitions: Error ' message: ( prrd2 asString ,
			' is not a XRelationshipDefinition, and can not be added to RelationshipDefinitions for ',
			' this XProfile (', self asString, ').' ).
		^nil.
	].
	( (relRelationshipDefinitions identityIndexOf: prrd2) > 0 ) ifTrue: [
		self dberror: 'XProfile:relAddRelationshipDefinitions: Error ' message: 
			'XRelationshipDefinition (', prrd2 asString , ') is already added to this XProfile (', self asString, ').'.
		^nil.
	].
	( prpe1a := prrd2 relGetProfile ) ifNotNil: [ 
		self dberror: 'XProfile:relAddRelationshipDefinitions: Error ' message: 
			'XRelationshipDefinition (', prrd2 asString , ') is already added to another XProfile (', prpe1a asString , ').'.
		^nil.
	]. 
	relRelationshipDefinitions add: prrd2.
	prrd2 relPrivateSetProfile: self.
	^prrd2!

relGetClassDefinitions
	"Return the first XClassDefinition object on the other side of the 1-N relations1 classDefinitions."
	"Provides compatibility with 1-1 relationships."

	( relClassDefinitions size = 0 ) ifTrue: [ ^nil ].
	^relClassDefinitions first!

relGetRelationshipDefinitions
	"Return the first XRelationshipDefinition object on the other side of the 1-N relations1 relationshipDefinitions."
	"Provides compatibility with 1-1 relationships."

	( relRelationshipDefinitions size = 0 ) ifTrue: [ ^nil ].
	^relRelationshipDefinitions first!

relSetClassDefinitions: prcd2
	"Force set other end of 1-N relationship to one XClassDefinition prcd2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| prpe1a |
	prcd2 ifNil: [
		self relDeleteAllClassDefinitions.
		^nil.
	].
	( prcd2 isKindOf: DocumentDictionary100.Core.Profile.XClassDefinition ) ifFalse: [
		self dberror: 'XProfile:relSetClassDefinitions: Error ' message: ( prcd2 asString ,
			' is not a XClassDefinition, and can not be added to' ,
			' this XProfile (', self asString, ').' ).
		^nil.
	].
	(( ( relClassDefinitions identityIndexOf: prcd2 ) > 0 ) and: [ relClassDefinitions size = 1 ]) ifTrue: [
		"XClassDefinition prcd2 is already added to this XProfile, and it is the only one."
		^nil.
	].
	( relClassDefinitions size > 0 ) ifTrue: [
		self relDeleteAllClassDefinitions.
	].

	( prpe1a := prcd2 relGetProfile ) ifNotNil: [ 
		prcd2 relRemoveAllProfile
	]. 
	relClassDefinitions add: prcd2.
	prcd2 relPrivateSetProfile: self.
	^prcd2!

relSetRelationshipDefinitions: prrd2
	"Force set other end of 1-N relationship to one XRelationshipDefinition prrd2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| prpe1a |
	prrd2 ifNil: [
		self relDeleteAllRelationshipDefinitions.
		^nil.
	].
	( prrd2 isKindOf: DocumentDictionary100.Core.Profile.XRelationshipDefinition ) ifFalse: [
		self dberror: 'XProfile:relSetRelationshipDefinitions: Error ' message: ( prrd2 asString ,
			' is not a XRelationshipDefinition, and can not be added to' ,
			' this XProfile (', self asString, ').' ).
		^nil.
	].
	(( ( relRelationshipDefinitions identityIndexOf: prrd2 ) > 0 ) and: [ relRelationshipDefinitions size = 1 ]) ifTrue: [
		"XRelationshipDefinition prrd2 is already added to this XProfile, and it is the only one."
		^nil.
	].
	( relRelationshipDefinitions size > 0 ) ifTrue: [
		self relDeleteAllRelationshipDefinitions.
	].

	( prpe1a := prrd2 relGetProfile ) ifNotNil: [ 
		prrd2 relRemoveAllProfile
	]. 
	relRelationshipDefinitions add: prrd2.
	prrd2 relPrivateSetProfile: self.
	^prrd2!

relRemoveClassDefinitions: prcd2
	"Removes a XClassDefinition prcd2 from 1-N relationship1 ClassDefinitions."

	| prpe1 index |
	( prcd2 isKindOf: DocumentDictionary100.Core.Profile.XClassDefinition ) ifFalse: [
		self dberror: 'XProfile:relRemoveClassDefinitions: Error ' message: ( prcd2 asString ,
			' is not a XClassDefinition, and can not possibly be removed from ClassDefinitions on' ,
			' this XProfile (', self asString, ').' ).
		^nil.
	].
	( ( prpe1 := prcd2 relGetProfile ) == self ) ifFalse:[
		self dberror: 'XProfile:relRemoveClassDefinitions Error ' message: 
			'XClassDefinition (', prcd2 asString , ') is added to XProfile (', prpe1 asString, ') ',
			'instead of this XProfile (', self asString , ').'.
		^nil.
	].
	index := relClassDefinitions identityIndexOf: prcd2.
	(index = 0) ifTrue: [
		self dberror: 'XProfile:relRemoveClassDefinitions Error ' message: 
			'XClassDefinition (', prcd2 asString , ') can not be found in ClassDefinitions of this XProfile(', self asString , ').'.
		^nil.
	]. 
	relClassDefinitions removeAtIndex: index.
	prcd2 relPrivateSetProfile: nil.
	^prcd2.!

relRemoveRelationshipDefinitions: prrd2
	"Removes a XRelationshipDefinition prrd2 from 1-N relationship1 RelationshipDefinitions."

	| prpe1 index |
	( prrd2 isKindOf: DocumentDictionary100.Core.Profile.XRelationshipDefinition ) ifFalse: [
		self dberror: 'XProfile:relRemoveRelationshipDefinitions: Error ' message: ( prrd2 asString ,
			' is not a XRelationshipDefinition, and can not possibly be removed from RelationshipDefinitions on' ,
			' this XProfile (', self asString, ').' ).
		^nil.
	].
	( ( prpe1 := prrd2 relGetProfile ) == self ) ifFalse:[
		self dberror: 'XProfile:relRemoveRelationshipDefinitions Error ' message: 
			'XRelationshipDefinition (', prrd2 asString , ') is added to XProfile (', prpe1 asString, ') ',
			'instead of this XProfile (', self asString , ').'.
		^nil.
	].
	index := relRelationshipDefinitions identityIndexOf: prrd2.
	(index = 0) ifTrue: [
		self dberror: 'XProfile:relRemoveRelationshipDefinitions Error ' message: 
			'XRelationshipDefinition (', prrd2 asString , ') can not be found in RelationshipDefinitions of this XProfile(', self asString , ').'.
		^nil.
	]. 
	relRelationshipDefinitions removeAtIndex: index.
	prrd2 relPrivateSetProfile: nil.
	^prrd2.!

relRemoveAllClassDefinitions 
	"Remove all XClassDefinition instances from 1-N relationship1 ClassDefinitions and return them in a collection."

	| prcd2Coll |
	( prcd2Coll := relClassDefinitions copy ) do: [:prcd2 |
		self relRemoveClassDefinitions: prcd2
	].
	^prcd2Coll.!

relRemoveAllRelationshipDefinitions 
	"Remove all XRelationshipDefinition instances from 1-N relationship1 RelationshipDefinitions and return them in a collection."

	| prrd2Coll |
	( prrd2Coll := relRelationshipDefinitions copy ) do: [:prrd2 |
		self relRemoveRelationshipDefinitions: prrd2
	].
	^prrd2Coll.!

relDeleteClassDefinitions: prcd2
	"Remove a XClassDefinition prcd2 from 1-1 relationship1 ClassDefinitions and delete it."
	"Return true if operation succeded else return false."

	| prpe1 index |
	( prcd2 isKindOf: DocumentDictionary100.Core.Profile.XClassDefinition ) ifFalse: [
		self dberror: 'XProfile:relDeleteClassDefinitions: Error ' message: ( prcd2 asString ,
			' is not a XClassDefinition, and can not possibly be deleted from ClassDefinitions on' ,
			' this XProfile (', self asString, ').' ).
		^false.
	].
	(( prpe1 := prcd2 relGetProfile ) = self ) ifFalse:[
		self dberror: 'XProfile:relDeleteClassDefinitions Error ' message: 
			'XClassDefinition (', prcd2 asString , ') is added to XProfile (', prpe1 asString, ') ',
			'instead of this XProfile (', self asString , ').'.
		^false.
	].
	index := relClassDefinitions identityIndexOf: prcd2.
	(index = 0) ifTrue: [
		self dberror: 'XProfile:relDeleteClassDefinitions Error ' message: 
			'XClassDefinition (', prcd2 asString , ') can not be found in ClassDefinitions of this XProfile(', self asString , ').'.
		^false.
	]. 
	relClassDefinitions removeAtIndex: index.
	prcd2 relPrivateSetProfile: nil.
	prcd2 delete.
	^true.!

relDeleteRelationshipDefinitions: prrd2
	"Remove a XRelationshipDefinition prrd2 from 1-1 relationship1 RelationshipDefinitions and delete it."
	"Return true if operation succeded else return false."

	| prpe1 index |
	( prrd2 isKindOf: DocumentDictionary100.Core.Profile.XRelationshipDefinition ) ifFalse: [
		self dberror: 'XProfile:relDeleteRelationshipDefinitions: Error ' message: ( prrd2 asString ,
			' is not a XRelationshipDefinition, and can not possibly be deleted from RelationshipDefinitions on' ,
			' this XProfile (', self asString, ').' ).
		^false.
	].
	(( prpe1 := prrd2 relGetProfile ) = self ) ifFalse:[
		self dberror: 'XProfile:relDeleteRelationshipDefinitions Error ' message: 
			'XRelationshipDefinition (', prrd2 asString , ') is added to XProfile (', prpe1 asString, ') ',
			'instead of this XProfile (', self asString , ').'.
		^false.
	].
	index := relRelationshipDefinitions identityIndexOf: prrd2.
	(index = 0) ifTrue: [
		self dberror: 'XProfile:relDeleteRelationshipDefinitions Error ' message: 
			'XRelationshipDefinition (', prrd2 asString , ') can not be found in RelationshipDefinitions of this XProfile(', self asString , ').'.
		^false.
	]. 
	relRelationshipDefinitions removeAtIndex: index.
	prrd2 relPrivateSetProfile: nil.
	prrd2 delete.
	^true.!

relDeleteAllClassDefinitions 
	"Delete all XClassDefinition from 1-N relationship1 ClassDefinitions, and return the count of deleted objects."

	| prcd2Size prcd2Coll |
	prcd2Size := relClassDefinitions size.
	prcd2Coll := relClassDefinitions.
	self relInitClassDefinitions.
	prcd2Coll do: [:prcd2 |
		prcd2 relPrivateSetProfile: nil.
		prcd2 delete.
	].
	^prcd2Size.!

relDeleteAllRelationshipDefinitions 
	"Delete all XRelationshipDefinition from 1-N relationship1 RelationshipDefinitions, and return the count of deleted objects."

	| prrd2Size prrd2Coll |
	prrd2Size := relRelationshipDefinitions size.
	prrd2Coll := relRelationshipDefinitions.
	self relInitRelationshipDefinitions.
	prrd2Coll do: [:prrd2 |
		prrd2 relPrivateSetProfile: nil.
		prrd2 delete.
	].
	^prrd2Size.!

relInitClassDefinitions
	"Initialize collection of 1-N relationship1 ClassDefinitions"

	relClassDefinitions := OrderedCollection new!

relInitRelationshipDefinitions
	"Initialize collection of 1-N relationship1 RelationshipDefinitions"

	relRelationshipDefinitions := OrderedCollection new!

relAllModel
	"Return collection of 1-N relationship model"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relModel ifNil: [ ^coll ].
	coll add: relModel.
	^coll.!

relSizeModel
	"Return the integer size of the collection returned by relAllModel"
	"Keeps compatibility with 1-N relationships"

	^relModel ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasModel
	"Return true if the 1-N relations2 model holds an object, else return false."

	^relModel notNil.!

relCreateModel
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XModel to 1-N relationship Model."

	| MD1a MD1 |
	( MD1a := self relGetModel ) ifNotNil: [
		self dberror: 'XModel:relCreateModel: Error ' message: 
			'XModel (', self  asString , ') already has a XModel (', MD1a asString, ') in 1-N relation Model.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XModel) ifTrue: [
		MD1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XModel.
		MD1 relAddProfiles: self.
		"MD1 addDefaultOwner."
		^MD1.
	] ifFalse: [
		self dberror: 'XProfile.relCreateModel Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XModel. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetModel
	"Return the XModel object on the other side of the 1-N relationship2 model."

	^relModel!

relRemoveModel: MD1
	"Removes a XModel MD1 from 1-N relationship2 Model."

	MD1 ifNil: [
		self dberror: 'XProfile:relRemoveModel: Error ' message: ( 'wrong class of parameter MD1, ',
			' nil is not a XModel, and can not be removed from' ,
			' this XProfile (', self asString, ') relation2 Model.' ).
		^nil.
	].

	MD1 ifNotNil: [
		( MD1 isKindOf: DocumentDictionary100.Core.Model.XModel ) ifFalse: [
			self dberror: 'XProfile:relRemoveModel: Error ' message: ( MD1 asString ,
				' is not a XModel, and can not be removed from' ,
				' this XProfile (', self asString, ') relation2 Model.' ).
			^nil.
		]
	].

	MD1 ifNotNil: [ MD1 relRemoveProfiles: self. ].
	^MD1!

relInitModel
	"Initialize pointer of 1-N relationship1 Model "

	relModel := nil!

 !

!DocumentDictionary100.Core.Profile.XProfile methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetModel: MD1
	"Set other end of 1-N relationship1 Profiles"

	"MD1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying MD1.
	]."

  "( MD1 isKindOf: NOT_FOUND.XModel ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relModel == MD1 ) ifFalse: [
		relModel := MD1.
		MD1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying MD1."
	  ].
	  self changed: #relModel.
	].
	^relModel!

 !

!DocumentDictionary100.Core.Profile.XProfile methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Profile.XProfile methodsFor: 'testing'!

classPrefix
	"Return 'prpe' which is a unique prefix for class Profile within the application."

	^'prpe'!

 !

