"XRelationshipDefinition_AutoAPI.st Generated at 2018-09-22 00:07:44.853."
'Class AutoAPI file for Class RelationshipDefinition.'!

!DocumentDictionary100.Core.Profile.XRelationshipDefinition class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XRelationshipDefinition in the DomainModel DocumentDictionary100f"

	^'Definines a binary relationship between two classes in the profile or the meta-model. A copy of the name of the RelationshipDefinition will be placed in the relationshipName of each instansiated RelationshipLink.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XRelationshipDefinition'.!

 !

!DocumentDictionary100.Core.Profile.XRelationshipDefinition methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XRelationshipDefinition in the DomainModel DocumentDictionary100f."

	^'Definines a binary relationship between two classes in the profile or the meta-model. A copy of the name of the RelationshipDefinition will be placed in the relationshipName of each instansiated RelationshipLink.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitDetailClass.
	self attInitIsAvailable.
	self attInitIsVisible.
	self attInitMasterClass.
	self attInitNameDetailToMaster.
	self attInitNameMasterToDetail.
	self attInitOwnsMasterToDetail.
	self attInitRelationshipType.


	self relInitProfile.

	
!
canDelete
	"Return true if this RelationshipDefinition can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XRelationshipDefinition if there is one, else return nil."

	self relHasProfile ifTrue: [ ^self relGetProfile ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."



	self relRemoveAllProfile.


	super delete!

 !

!DocumentDictionary100.Core.Profile.XRelationshipDefinition methodsFor: 'attributeAPI'!

attGetDetailClass
	"Get value of attribute DetailClass"
	"Specifies the name of the class which is on the detail side of this relationship. The class may be defined in the application domain model, or the profile."

	^attDetailClass.!

attGetIsAvailable
	"Get value of attribute IsAvailable"
	"Flag that may be set to true when the relationship definition is complete. RelationshipDefinitions that have isAvailable = true may be used in the model."

	^attIsAvailable.!

attGetIsVisible
	"Get value of attribute IsVisible"
	"Flag that may be set to true for available relationships that shall be visible in the user interface."

	^attIsVisible.!

attGetMasterClass
	"Get value of attribute MasterClass"
	"Specifies the name of the class which is on the master side of this relationship. The class may be defined in the application domain model, or the profile. The masterClass is always on the 1 side of an 1-N relationship."

	^attMasterClass.!

attGetNameDetailToMaster
	"Get value of attribute NameDetailToMaster"
	"Role name of the master object, or set of master objects, when reffering to it from the detail object."

	^attNameDetailToMaster.!

attGetNameMasterToDetail
	"Get value of attribute NameMasterToDetail"
	"Role name of the detail object, or set of details objects, when reffering to it from the master object."

	^attNameMasterToDetail.!

attGetOwnsMasterToDetail
	"Get value of attribute OwnsMasterToDetail"
	"Set to true if the defined relationship is a part-of relationship, where the master objects own detail objects. If true, deleting a master implies deleting all its details. If false, the details are just disconnected before the master is deleted."

	^attOwnsMasterToDetail.!

attGetRelationshipType
	"Get value of attribute RelationshipType"
	"Can be any of :  1-1,1-N or M-N. In a M-N relationship each model element can have M masters and N details. Strictly hierarchical part-of structures are of type 1-N. More strict cardinalities can be documented as 1..1-0..*."

	^attRelationshipType.!

attIqDetailClass
	"Return the information quantity of attribute DetailClass"
	"180413 This is a default implementation that can be extended later"

	^attDetailClass ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqIsAvailable
	"Return the information quantity of attribute IsAvailable"
	"180413 This is a default implementation that can be extended later"

	^attIsAvailable ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqIsVisible
	"Return the information quantity of attribute IsVisible"
	"180413 This is a default implementation that can be extended later"

	^attIsVisible ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqMasterClass
	"Return the information quantity of attribute MasterClass"
	"180413 This is a default implementation that can be extended later"

	^attMasterClass ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqNameDetailToMaster
	"Return the information quantity of attribute NameDetailToMaster"
	"180413 This is a default implementation that can be extended later"

	^attNameDetailToMaster ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqNameMasterToDetail
	"Return the information quantity of attribute NameMasterToDetail"
	"180413 This is a default implementation that can be extended later"

	^attNameMasterToDetail ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqOwnsMasterToDetail
	"Return the information quantity of attribute OwnsMasterToDetail"
	"180413 This is a default implementation that can be extended later"

	^attOwnsMasterToDetail ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqRelationshipType
	"Return the information quantity of attribute RelationshipType"
	"180413 This is a default implementation that can be extended later"

	^attRelationshipType ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasDetailClass
	"Return true if the current value of the attribute DetailClass carries information."

	^(attDetailClass ~= nil)!

attHasIsAvailable
	"Return true if the current value of the attribute IsAvailable carries information."

	^(attIsAvailable ~= nil)!

attHasIsVisible
	"Return true if the current value of the attribute IsVisible carries information."

	^(attIsVisible ~= nil)!

attHasMasterClass
	"Return true if the current value of the attribute MasterClass carries information."

	^(attMasterClass ~= nil)!

attHasNameDetailToMaster
	"Return true if the current value of the attribute NameDetailToMaster carries information."

	^(attNameDetailToMaster ~= nil)!

attHasNameMasterToDetail
	"Return true if the current value of the attribute NameMasterToDetail carries information."

	^(attNameMasterToDetail ~= nil)!

attHasOwnsMasterToDetail
	"Return true if the current value of the attribute OwnsMasterToDetail carries information."

	^(attOwnsMasterToDetail ~= nil)!

attHasRelationshipType
	"Return true if the current value of the attribute RelationshipType carries information."

	^(attRelationshipType ~= nil)!

attCreateDetailClass
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetDetailClass: (nil)!

attCreateIsAvailable
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetIsAvailable: (nil)!

attCreateIsVisible
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetIsVisible: (nil)!

attCreateMasterClass
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetMasterClass: (nil)!

attCreateNameDetailToMaster
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetNameDetailToMaster: (nil)!

attCreateNameMasterToDetail
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetNameMasterToDetail: (nil)!

attCreateOwnsMasterToDetail
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetOwnsMasterToDetail: (nil)!

attCreateRelationshipType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetRelationshipType: (nil)!

attCreateDetailClass
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetDetailClass: (nil)!

attCreateIsAvailable
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetIsAvailable: (nil)!

attCreateIsVisible
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetIsVisible: (nil)!

attCreateMasterClass
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetMasterClass: (nil)!

attCreateNameDetailToMaster
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetNameDetailToMaster: (nil)!

attCreateNameMasterToDetail
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetNameMasterToDetail: (nil)!

attCreateOwnsMasterToDetail
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetOwnsMasterToDetail: (nil)!

attCreateRelationshipType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetRelationshipType: (nil)!

attDeleteDetailClass
	"Set the attribute value to undefined, or to a value that makes attIqDetailClass return 0."

	^self attSetDetailClass: nil!

attDeleteIsAvailable
	"Set the attribute value to undefined, or to a value that makes attIqIsAvailable return 0."

	^self attSetIsAvailable: nil!

attDeleteIsVisible
	"Set the attribute value to undefined, or to a value that makes attIqIsVisible return 0."

	^self attSetIsVisible: nil!

attDeleteMasterClass
	"Set the attribute value to undefined, or to a value that makes attIqMasterClass return 0."

	^self attSetMasterClass: nil!

attDeleteNameDetailToMaster
	"Set the attribute value to undefined, or to a value that makes attIqNameDetailToMaster return 0."

	^self attSetNameDetailToMaster: nil!

attDeleteNameMasterToDetail
	"Set the attribute value to undefined, or to a value that makes attIqNameMasterToDetail return 0."

	^self attSetNameMasterToDetail: nil!

attDeleteOwnsMasterToDetail
	"Set the attribute value to undefined, or to a value that makes attIqOwnsMasterToDetail return 0."

	^self attSetOwnsMasterToDetail: nil!

attDeleteRelationshipType
	"Set the attribute value to undefined, or to a value that makes attIqRelationshipType return 0."

	^self attSetRelationshipType: nil!

attSetDetailClass: value 
	"Set the value of attribute DetailClass to value, if it is not already equal to value."

	(attDetailClass = value) ifFalse: [
		attDetailClass := value.
		self changed: #attDetailClass.
	]!

attSetIsAvailable: value 
	"Set the value of attribute IsAvailable to value, if it is not already equal to value."

	(attIsAvailable = value) ifFalse: [
		attIsAvailable := value.
		self changed: #attIsAvailable.
	]!

attSetIsVisible: value 
	"Set the value of attribute IsVisible to value, if it is not already equal to value."

	(attIsVisible = value) ifFalse: [
		attIsVisible := value.
		self changed: #attIsVisible.
	]!

attSetMasterClass: value 
	"Set the value of attribute MasterClass to value, if it is not already equal to value."

	(attMasterClass = value) ifFalse: [
		attMasterClass := value.
		self changed: #attMasterClass.
	]!

attSetNameDetailToMaster: value 
	"Set the value of attribute NameDetailToMaster to value, if it is not already equal to value."

	(attNameDetailToMaster = value) ifFalse: [
		attNameDetailToMaster := value.
		self changed: #attNameDetailToMaster.
	]!

attSetNameMasterToDetail: value 
	"Set the value of attribute NameMasterToDetail to value, if it is not already equal to value."

	(attNameMasterToDetail = value) ifFalse: [
		attNameMasterToDetail := value.
		self changed: #attNameMasterToDetail.
	]!

attSetOwnsMasterToDetail: value 
	"Set the value of attribute OwnsMasterToDetail to value, if it is not already equal to value."

	(attOwnsMasterToDetail = value) ifFalse: [
		attOwnsMasterToDetail := value.
		self changed: #attOwnsMasterToDetail.
	]!

attSetRelationshipType: value 
	"Set the value of attribute RelationshipType to value, if it is not already equal to value."

	(attRelationshipType = value) ifFalse: [
		attRelationshipType := value.
		self changed: #attRelationshipType.
	]!

attInitDetailClass
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attDetailClass := nil!

attInitIsAvailable
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attIsAvailable := nil!

attInitIsVisible
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attIsVisible := nil!

attInitMasterClass
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attMasterClass := nil!

attInitNameDetailToMaster
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attNameDetailToMaster := nil!

attInitNameMasterToDetail
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attNameMasterToDetail := nil!

attInitOwnsMasterToDetail
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attOwnsMasterToDetail := nil!

attInitRelationshipType
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attRelationshipType := nil!

 !

!DocumentDictionary100.Core.Profile.XRelationshipDefinition methodsFor: 'relationshipAPI'!

relRemoveAllProfile
	"Remove a XProfile from 1-N relationship2 Profile if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllProfile) do: [:prpe1 | self relRemoveProfile: prpe1].!

relAllProfile
	"Return collection of 1-N relationship profile"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relProfile ifNil: [ ^coll ].
	coll add: relProfile.
	^coll.!

relSizeProfile
	"Return the integer size of the collection returned by relAllProfile"
	"Keeps compatibility with 1-N relationships"

	^relProfile ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasProfile
	"Return true if the 1-N relations2 profile holds an object, else return false."

	^relProfile notNil.!

relCreateProfile
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XProfile to 1-N relationship Profile."

	| prpe1a prpe1 |
	( prpe1a := self relGetProfile ) ifNotNil: [
		self dberror: 'XProfile:relCreateProfile: Error ' message: 
			'XProfile (', self  asString , ') already has a XProfile (', prpe1a asString, ') in 1-N relation Profile.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XProfile) ifTrue: [
		prpe1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XProfile.
		prpe1 relAddRelationshipDefinitions: self.
		"prpe1 addDefaultOwner."
		^prpe1.
	] ifFalse: [
		self dberror: 'XRelationshipDefinition.relCreateProfile Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XProfile. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetProfile
	"Return the XProfile object on the other side of the 1-N relationship2 profile."

	^relProfile!

relRemoveProfile: prpe1
	"Removes a XProfile prpe1 from 1-N relationship2 Profile."

	prpe1 ifNil: [
		self dberror: 'XRelationshipDefinition:relRemoveProfile: Error ' message: ( 'wrong class of parameter prpe1, ',
			' nil is not a XProfile, and can not be removed from' ,
			' this XRelationshipDefinition (', self asString, ') relation2 Profile.' ).
		^nil.
	].

	prpe1 ifNotNil: [
		( prpe1 isKindOf: DocumentDictionary100.Core.Profile.XProfile ) ifFalse: [
			self dberror: 'XRelationshipDefinition:relRemoveProfile: Error ' message: ( prpe1 asString ,
				' is not a XProfile, and can not be removed from' ,
				' this XRelationshipDefinition (', self asString, ') relation2 Profile.' ).
			^nil.
		]
	].

	prpe1 ifNotNil: [ prpe1 relRemoveRelationshipDefinitions: self. ].
	^prpe1!

relInitProfile
	"Initialize pointer of 1-N relationship1 Profile "

	relProfile := nil!

 !

!DocumentDictionary100.Core.Profile.XRelationshipDefinition methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetProfile: prpe1
	"Set other end of 1-N relationship1 RelationshipDefinitions"

	"prpe1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying prpe1.
	]."

  "( prpe1 isKindOf: NOT_FOUND.XProfile ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relProfile == prpe1 ) ifFalse: [
		relProfile := prpe1.
		prpe1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying prpe1."
	  ].
	  self changed: #relProfile.
	].
	^relProfile!

 !

!DocumentDictionary100.Core.Profile.XRelationshipDefinition methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Profile.XRelationshipDefinition methodsFor: 'testing'!

classPrefix
	"Return 'prrd' which is a unique prefix for class RelationshipDefinition within the application."

	^'prrd'!

 !

