"XAuthorDocument_AutoAPI.st Generated at 2018-09-22 00:00:59.369."
'Class AutoAPI file for Class AuthorDocument.'!

!DocumentDictionary100.Main.XAuthorDocument class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XAuthorDocument in the DomainModel DocumentDictionary100f"

	^'Designates the contribution of an author to a particular document that is recorded in a DocumentRecord.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XAuthorDocument'.!

 !

!DocumentDictionary100.Main.XAuthorDocument methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XAuthorDocument in the DomainModel DocumentDictionary100f."

	^'Designates the contribution of an author to a particular document that is recorded in a DocumentRecord.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitAuthorRole.


	self relInitAuthorRecord.
	self relInitDocumentRecord.

	
!
canDelete
	"Return true if this AuthorDocument can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XAuthorDocument if there is one, else return nil."

	self relHasDocumentRecord ifTrue: [ ^self relGetDocumentRecord ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."



	self relRemoveAllAuthorRecord.
	self relRemoveAllDocumentRecord.


	super delete!

 !

!DocumentDictionary100.Main.XAuthorDocument methodsFor: 'attributeAPI'!

attGetAuthorRole
	"Get value of attribute AuthorRole"
	"Role with regards to the recorded document. It may be author or editor."

	^attAuthorRole.!

attIqAuthorRole
	"Return the information quantity of attribute AuthorRole"
	"180413 This is a default implementation that can be extended later"

	^attAuthorRole ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasAuthorRole
	"Return true if the current value of the attribute AuthorRole carries information."

	^(attAuthorRole ~= nil)!

attCreateAuthorRole
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetAuthorRole: (nil)!

attCreateAuthorRole
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetAuthorRole: (nil)!

attDeleteAuthorRole
	"Set the attribute value to undefined, or to a value that makes attIqAuthorRole return 0."

	^self attSetAuthorRole: nil!

attSetAuthorRole: value 
	"Set the value of attribute AuthorRole to value, if it is not already equal to value."

	(attAuthorRole = value) ifFalse: [
		attAuthorRole := value.
		self changed: #attAuthorRole.
	]!

attInitAuthorRole
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attAuthorRole := nil!

 !

!DocumentDictionary100.Main.XAuthorDocument methodsFor: 'relationshipAPI'!

relRemoveAllAuthorRecord
	"Remove a XAuthorRecord from 1-N relationship2 AuthorRecord if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllAuthorRecord) do: [:au1 | self relRemoveAuthorRecord: au1].!

relRemoveAllDocumentRecord
	"Remove a XDocumentRecord from 1-N relationship2 DocumentRecord if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllDocumentRecord) do: [:dr1 | self relRemoveDocumentRecord: dr1].!

relAllAuthorRecord
	"Return collection of 1-N relationship authorRecord"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relAuthorRecord ifNil: [ ^coll ].
	coll add: relAuthorRecord.
	^coll.!

relAllDocumentRecord
	"Return collection of 1-N relationship documentRecord"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relDocumentRecord ifNil: [ ^coll ].
	coll add: relDocumentRecord.
	^coll.!

relSizeAuthorRecord
	"Return the integer size of the collection returned by relAllAuthorRecord"
	"Keeps compatibility with 1-N relationships"

	^relAuthorRecord ifNil: [ 0 ] ifNotNil: [ 1 ].!

relSizeDocumentRecord
	"Return the integer size of the collection returned by relAllDocumentRecord"
	"Keeps compatibility with 1-N relationships"

	^relDocumentRecord ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasAuthorRecord
	"Return true if the 1-N relations2 authorRecord holds an object, else return false."

	^relAuthorRecord notNil.!

relHasDocumentRecord
	"Return true if the 1-N relations2 documentRecord holds an object, else return false."

	^relDocumentRecord notNil.!

relCreateAuthorRecord
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XAuthorRecord to 1-N relationship AuthorRecord."

	| au1a au1 |
	( au1a := self relGetAuthorRecord ) ifNotNil: [
		self dberror: 'XAuthorRecord:relCreateAuthorRecord: Error ' message: 
			'XAuthorRecord (', self  asString , ') already has a XAuthorRecord (', au1a asString, ') in 1-N relation AuthorRecord.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XAuthorRecord) ifTrue: [
		au1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XAuthorRecord.
		au1 relAddAuthorDocuments: self.
		"au1 addDefaultOwner."
		^au1.
	] ifFalse: [
		self dberror: 'XAuthorDocument.relCreateAuthorRecord Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XAuthorRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateDocumentRecord
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XDocumentRecord to 1-N relationship DocumentRecord."

	| dr1a dr1 |
	( dr1a := self relGetDocumentRecord ) ifNotNil: [
		self dberror: 'XDocumentRecord:relCreateDocumentRecord: Error ' message: 
			'XDocumentRecord (', self  asString , ') already has a XDocumentRecord (', dr1a asString, ') in 1-N relation DocumentRecord.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentRecord) ifTrue: [
		dr1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentRecord.
		dr1 relAddAuthorDocuments: self.
		"dr1 addDefaultOwner."
		^dr1.
	] ifFalse: [
		self dberror: 'XAuthorDocument.relCreateDocumentRecord Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetAuthorRecord
	"Return the XAuthorRecord object on the other side of the 1-N relationship2 authorRecord."

	^relAuthorRecord!

relGetDocumentRecord
	"Return the XDocumentRecord object on the other side of the 1-N relationship2 documentRecord."

	^relDocumentRecord!

relRemoveAuthorRecord: au1
	"Removes a XAuthorRecord au1 from 1-N relationship2 AuthorRecord."

	au1 ifNil: [
		self dberror: 'XAuthorDocument:relRemoveAuthorRecord: Error ' message: ( 'wrong class of parameter au1, ',
			' nil is not a XAuthorRecord, and can not be removed from' ,
			' this XAuthorDocument (', self asString, ') relation2 AuthorRecord.' ).
		^nil.
	].

	au1 ifNotNil: [
		( au1 isKindOf: DocumentDictionary100.Main.XAuthorRecord ) ifFalse: [
			self dberror: 'XAuthorDocument:relRemoveAuthorRecord: Error ' message: ( au1 asString ,
				' is not a XAuthorRecord, and can not be removed from' ,
				' this XAuthorDocument (', self asString, ') relation2 AuthorRecord.' ).
			^nil.
		]
	].

	au1 ifNotNil: [ au1 relRemoveAuthorDocuments: self. ].
	^au1!

relRemoveDocumentRecord: dr1
	"Removes a XDocumentRecord dr1 from 1-N relationship2 DocumentRecord."

	dr1 ifNil: [
		self dberror: 'XAuthorDocument:relRemoveDocumentRecord: Error ' message: ( 'wrong class of parameter dr1, ',
			' nil is not a XDocumentRecord, and can not be removed from' ,
			' this XAuthorDocument (', self asString, ') relation2 DocumentRecord.' ).
		^nil.
	].

	dr1 ifNotNil: [
		( dr1 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
			self dberror: 'XAuthorDocument:relRemoveDocumentRecord: Error ' message: ( dr1 asString ,
				' is not a XDocumentRecord, and can not be removed from' ,
				' this XAuthorDocument (', self asString, ') relation2 DocumentRecord.' ).
			^nil.
		]
	].

	dr1 ifNotNil: [ dr1 relRemoveAuthorDocuments: self. ].
	^dr1!

relInitAuthorRecord
	"Initialize pointer of 1-N relationship1 AuthorRecord "

	relAuthorRecord := nil!

relInitDocumentRecord
	"Initialize pointer of 1-N relationship1 DocumentRecord "

	relDocumentRecord := nil!

 !

!DocumentDictionary100.Main.XAuthorDocument methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetAuthorRecord: au1
	"Set other end of 1-N relationship1 AuthorDocuments"

	"au1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying au1.
	]."

  "( au1 isKindOf: NOT_FOUND.XAuthorRecord ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relAuthorRecord == au1 ) ifFalse: [
		relAuthorRecord := au1.
		au1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying au1."
	  ].
	  self changed: #relAuthorRecord.
	].
	^relAuthorRecord!

relPrivateSetDocumentRecord: dr1
	"Set other end of 1-N relationship1 AuthorDocuments"

	"dr1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying dr1.
	]."

  "( dr1 isKindOf: NOT_FOUND.XDocumentRecord ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relDocumentRecord == dr1 ) ifFalse: [
		relDocumentRecord := dr1.
		dr1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying dr1."
	  ].
	  self changed: #relDocumentRecord.
	].
	^relDocumentRecord!

 !

!DocumentDictionary100.Main.XAuthorDocument methodsFor: 'converting'!

 !

!DocumentDictionary100.Main.XAuthorDocument methodsFor: 'testing'!

classPrefix
	"Return 'ad' which is a unique prefix for class AuthorDocument within the application."

	^'ad'!

 !

