"XAuthorRecord_AutoAPI.st Generated at 2018-09-22 00:01:10.324."
'Class AutoAPI file for Class AuthorRecord.'!

!DocumentDictionary100.Main.XAuthorRecord class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XAuthorRecord in the DomainModel DocumentDictionary100f"

	^'The name attribute value of an AuthorRecord is the most frequent name used in the DocumentRecord.authors field.
An Author may have a www DocumentRecord, which may own ElectronicEdition objects with URLs.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XAuthorRecord'.!

 !

!DocumentDictionary100.Main.XAuthorRecord methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XAuthorRecord in the DomainModel DocumentDictionary100f."

	^'The name attribute value of an AuthorRecord is the most frequent name used in the DocumentRecord.authors field.
An Author may have a www DocumentRecord, which may own ElectronicEdition objects with URLs.'.!

initialize
	"initialize attributes and relationships"

	super initialize.

	self relInitAuthorDocuments.

	self relInitDocumentDictionary.

	
!
canDelete
	"Return true if this AuthorRecord can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XAuthorRecord if there is one, else return nil."

	self relHasDocumentDictionary ifTrue: [ ^self relGetDocumentDictionary ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."

	self relDeleteAllAuthorDocuments.


	self relRemoveAllDocumentDictionary.


	super delete!

 !

!DocumentDictionary100.Main.XAuthorRecord methodsFor: 'attributeAPI'!

 !

!DocumentDictionary100.Main.XAuthorRecord methodsFor: 'relationshipAPI'!

relRemoveAllDocumentDictionary
	"Remove a XDocumentDictionary from 1-N relationship2 DocumentDictionary if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllDocumentDictionary) do: [:dd1 | self relRemoveDocumentDictionary: dd1].!

relAllAuthorDocuments
	"Return collection of all authorDocuments"

	^relAuthorDocuments copy.!

relSizeAuthorDocuments
	"Return the integer size of the collection returned by relAllAuthorDocuments"

	^relAuthorDocuments size!

relHasAuthorDocuments
	"Return true if the 1-N relationship1 authorDocuments holds at least one object, else return false."

	^relAuthorDocuments size > 0!

relCreateAuthorDocuments
	"Creates and adds a new XAuthorDocument to 1-N relationship AuthorDocuments."

	| ad2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XAuthorDocument) ifTrue: [
		ad2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XAuthorDocument.
		self relAddAuthorDocuments: ad2.
		^ad2.
	] ifFalse: [
		self dberror: 'XAuthorRecord.relCreateAuthorDocuments Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XAuthorDocument. Please open an appropriate substorage first.'.
		^nil.
	].!

relAddAuthorDocuments: ad2
	"Adds a XAuthorDocument ad2 to 1-N relationship AuthorDocuments."

	| au1a |
	( ad2 isKindOf: DocumentDictionary100.Main.XAuthorDocument ) ifFalse: [
		self dberror: 'XAuthorRecord:relAddAuthorDocuments: Error ' message: ( ad2 asString ,
			' is not a XAuthorDocument, and can not be added to AuthorDocuments for ',
			' this XAuthorRecord (', self asString, ').' ).
		^nil.
	].
	( (relAuthorDocuments identityIndexOf: ad2) > 0 ) ifTrue: [
		self dberror: 'XAuthorRecord:relAddAuthorDocuments: Error ' message: 
			'XAuthorDocument (', ad2 asString , ') is already added to this XAuthorRecord (', self asString, ').'.
		^nil.
	].
	( au1a := ad2 relGetAuthorRecord ) ifNotNil: [ 
		self dberror: 'XAuthorRecord:relAddAuthorDocuments: Error ' message: 
			'XAuthorDocument (', ad2 asString , ') is already added to another XAuthorRecord (', au1a asString , ').'.
		^nil.
	]. 
	relAuthorDocuments add: ad2.
	ad2 relPrivateSetAuthorRecord: self.
	^ad2!

relGetAuthorDocuments
	"Return the first XAuthorDocument object on the other side of the 1-N relations1 authorDocuments."
	"Provides compatibility with 1-1 relationships."

	( relAuthorDocuments size = 0 ) ifTrue: [ ^nil ].
	^relAuthorDocuments first!

relSetAuthorDocuments: ad2
	"Force set other end of 1-N relationship to one XAuthorDocument ad2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| au1a |
	ad2 ifNil: [
		self relRemoveAllAuthorDocuments.
		^nil.
	].
	( ad2 isKindOf: DocumentDictionary100.Main.XAuthorDocument ) ifFalse: [
		self dberror: 'XAuthorRecord:relSetAuthorDocuments: Error ' message: ( ad2 asString ,
			' is not a XAuthorDocument, and can not be added to' ,
			' this XAuthorRecord (', self asString, ').' ).
		^nil.
	].
	(( ( relAuthorDocuments identityIndexOf: ad2 ) > 0 ) and: [ relAuthorDocuments size = 1 ]) ifTrue: [
		"XAuthorDocument ad2 is already added to this XAuthorRecord, and it is the only one."
		^nil.
	].
	( relAuthorDocuments size > 0 ) ifTrue: [
		self relRemoveAllAuthorDocuments.
	].

	( au1a := ad2 relGetAuthorRecord ) ifNotNil: [ 
		ad2 relRemoveAllAuthorRecord
	]. 
	relAuthorDocuments add: ad2.
	ad2 relPrivateSetAuthorRecord: self.
	^ad2!

relRemoveAuthorDocuments: ad2
	"Removes a XAuthorDocument ad2 from 1-N relationship1 AuthorDocuments."

	| au1 index |
	( ad2 isKindOf: DocumentDictionary100.Main.XAuthorDocument ) ifFalse: [
		self dberror: 'XAuthorRecord:relRemoveAuthorDocuments: Error ' message: ( ad2 asString ,
			' is not a XAuthorDocument, and can not possibly be removed from AuthorDocuments on' ,
			' this XAuthorRecord (', self asString, ').' ).
		^nil.
	].
	( ( au1 := ad2 relGetAuthorRecord ) == self ) ifFalse:[
		self dberror: 'XAuthorRecord:relRemoveAuthorDocuments Error ' message: 
			'XAuthorDocument (', ad2 asString , ') is added to XAuthorRecord (', au1 asString, ') ',
			'instead of this XAuthorRecord (', self asString , ').'.
		^nil.
	].
	index := relAuthorDocuments identityIndexOf: ad2.
	(index = 0) ifTrue: [
		self dberror: 'XAuthorRecord:relRemoveAuthorDocuments Error ' message: 
			'XAuthorDocument (', ad2 asString , ') can not be found in AuthorDocuments of this XAuthorRecord(', self asString , ').'.
		^nil.
	]. 
	relAuthorDocuments removeAtIndex: index.
	ad2 relPrivateSetAuthorRecord: nil.
	^ad2.!

relRemoveAllAuthorDocuments 
	"Remove all XAuthorDocument instances from 1-N relationship1 AuthorDocuments and return them in a collection."

	| ad2Coll |
	( ad2Coll := relAuthorDocuments copy ) do: [:ad2 |
		self relRemoveAuthorDocuments: ad2
	].
	^ad2Coll.!

relDeleteAuthorDocuments: ad2
	"Remove a XAuthorDocument ad2 from 1-1 relationship1 AuthorDocuments and delete it."
	"Return true if operation succeded else return false."

	| au1 index |
	( ad2 isKindOf: DocumentDictionary100.Main.XAuthorDocument ) ifFalse: [
		self dberror: 'XAuthorRecord:relDeleteAuthorDocuments: Error ' message: ( ad2 asString ,
			' is not a XAuthorDocument, and can not possibly be deleted from AuthorDocuments on' ,
			' this XAuthorRecord (', self asString, ').' ).
		^false.
	].
	(( au1 := ad2 relGetAuthorRecord ) = self ) ifFalse:[
		self dberror: 'XAuthorRecord:relDeleteAuthorDocuments Error ' message: 
			'XAuthorDocument (', ad2 asString , ') is added to XAuthorRecord (', au1 asString, ') ',
			'instead of this XAuthorRecord (', self asString , ').'.
		^false.
	].
	index := relAuthorDocuments identityIndexOf: ad2.
	(index = 0) ifTrue: [
		self dberror: 'XAuthorRecord:relDeleteAuthorDocuments Error ' message: 
			'XAuthorDocument (', ad2 asString , ') can not be found in AuthorDocuments of this XAuthorRecord(', self asString , ').'.
		^false.
	]. 
	relAuthorDocuments removeAtIndex: index.
	ad2 relPrivateSetAuthorRecord: nil.
	ad2 delete.
	^true.!

relDeleteAllAuthorDocuments 
	"Delete all XAuthorDocument from 1-N relationship1 AuthorDocuments, and return the count of deleted objects."

	| ad2Size ad2Coll |
	ad2Size := relAuthorDocuments size.
	ad2Coll := relAuthorDocuments.
	self relInitAuthorDocuments.
	ad2Coll do: [:ad2 |
		ad2 relPrivateSetAuthorRecord: nil.
		ad2 delete.
	].
	^ad2Size.!

relInitAuthorDocuments
	"Initialize collection of 1-N relationship1 AuthorDocuments"

	relAuthorDocuments := OrderedCollection new!

relAllDocumentDictionary
	"Return collection of 1-N relationship documentDictionary"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relDocumentDictionary ifNil: [ ^coll ].
	coll add: relDocumentDictionary.
	^coll.!

relSizeDocumentDictionary
	"Return the integer size of the collection returned by relAllDocumentDictionary"
	"Keeps compatibility with 1-N relationships"

	^relDocumentDictionary ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasDocumentDictionary
	"Return true if the 1-N relations2 documentDictionary holds an object, else return false."

	^relDocumentDictionary notNil.!

relCreateDocumentDictionary
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XDocumentDictionary to 1-N relationship DocumentDictionary."

	| dd1a dd1 |
	( dd1a := self relGetDocumentDictionary ) ifNotNil: [
		self dberror: 'XDocumentDictionary:relCreateDocumentDictionary: Error ' message: 
			'XDocumentDictionary (', self  asString , ') already has a XDocumentDictionary (', dd1a asString, ') in 1-N relation DocumentDictionary.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentDictionary) ifTrue: [
		dd1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentDictionary.
		dd1 relAddAuthorRecords: self.
		"dd1 addDefaultOwner."
		^dd1.
	] ifFalse: [
		self dberror: 'XAuthorRecord.relCreateDocumentDictionary Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentDictionary. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetDocumentDictionary
	"Return the XDocumentDictionary object on the other side of the 1-N relationship2 documentDictionary."

	^relDocumentDictionary!

relRemoveDocumentDictionary: dd1
	"Removes a XDocumentDictionary dd1 from 1-N relationship2 DocumentDictionary."

	dd1 ifNil: [
		self dberror: 'XAuthorRecord:relRemoveDocumentDictionary: Error ' message: ( 'wrong class of parameter dd1, ',
			' nil is not a XDocumentDictionary, and can not be removed from' ,
			' this XAuthorRecord (', self asString, ') relation2 DocumentDictionary.' ).
		^nil.
	].

	dd1 ifNotNil: [
		( dd1 isKindOf: DocumentDictionary100.Main.XDocumentDictionary ) ifFalse: [
			self dberror: 'XAuthorRecord:relRemoveDocumentDictionary: Error ' message: ( dd1 asString ,
				' is not a XDocumentDictionary, and can not be removed from' ,
				' this XAuthorRecord (', self asString, ') relation2 DocumentDictionary.' ).
			^nil.
		]
	].

	dd1 ifNotNil: [ dd1 relRemoveAuthorRecords: self. ].
	^dd1!

relInitDocumentDictionary
	"Initialize pointer of 1-N relationship1 DocumentDictionary "

	relDocumentDictionary := nil!

 !

!DocumentDictionary100.Main.XAuthorRecord methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetDocumentDictionary: dd1
	"Set other end of 1-N relationship1 AuthorRecords"

	"dd1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying dd1.
	]."

  "( dd1 isKindOf: NOT_FOUND.XDocumentDictionary ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relDocumentDictionary == dd1 ) ifFalse: [
		relDocumentDictionary := dd1.
		dd1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying dd1."
	  ].
	  self changed: #relDocumentDictionary.
	].
	^relDocumentDictionary!

 !

!DocumentDictionary100.Main.XAuthorRecord methodsFor: 'converting'!

 !

!DocumentDictionary100.Main.XAuthorRecord methodsFor: 'testing'!

classPrefix
	"Return 'au' which is a unique prefix for class AuthorRecord within the application."

	^'au'!

 !

