"XCategoryLink_AutoAPI.st Generated at 2018-09-22 00:01:45.594."
'Class AutoAPI file for Class CategoryLink.'!

!DocumentDictionary100.Main.XCategoryLink class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XCategoryLink in the DomainModel DocumentDictionary100f"

	^'Links a ModelElement to a Category.
The link should prefferably cache the Name and Definition of the linked memberOfCategories ModelElement, for the sake of filtered loading from large or huge repositories, to allow the user of a local copy created from a filtered model load, quick access to metadata of the components that are missing in the loaded model.
The information in the cached attributes of a link should be treated for the caches they are, thus repository implementations may chose to trigger updates of changes in ModelElement Name and Definition to the cached data in their memberOfCategories CategoryLink objects.
This this will allow filter syncronizing users to get updates on the latest changes at the next time of synchronization.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XCategoryLink'.!

 !

!DocumentDictionary100.Main.XCategoryLink methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XCategoryLink in the DomainModel DocumentDictionary100f."

	^'Links a ModelElement to a Category.
The link should prefferably cache the Name and Definition of the linked memberOfCategories ModelElement, for the sake of filtered loading from large or huge repositories, to allow the user of a local copy created from a filtered model load, quick access to metadata of the components that are missing in the loaded model.
The information in the cached attributes of a link should be treated for the caches they are, thus repository implementations may chose to trigger updates of changes in ModelElement Name and Definition to the cached data in their memberOfCategories CategoryLink objects.
This this will allow filter syncronizing users to get updates on the latest changes at the next time of synchronization.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitCategoryRole.


	self relInitCategory.
	self relInitModelElement.

	
!
canDelete
	"Return true if this CategoryLink can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XCategoryLink if there is one, else return nil."

	self relHasCategory ifTrue: [ ^self relGetCategory ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."



	self relRemoveAllCategory.
	self relRemoveAllModelElement.


	super delete!

 !

!DocumentDictionary100.Main.XCategoryLink methodsFor: 'attributeAPI'!

attGetCategoryRole
	"Get value of attribute CategoryRole"
	"Role that the model element plays in the particular category. The category role is determined by a user defined unique name."

	^attCategoryRole.!

attIqCategoryRole
	"Return the information quantity of attribute CategoryRole"
	"180413 This is a default implementation that can be extended later"

	^attCategoryRole ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasCategoryRole
	"Return true if the current value of the attribute CategoryRole carries information."

	^(attCategoryRole ~= nil)!

attCreateCategoryRole
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetCategoryRole: (nil)!

attCreateCategoryRole
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetCategoryRole: (nil)!

attDeleteCategoryRole
	"Set the attribute value to undefined, or to a value that makes attIqCategoryRole return 0."

	^self attSetCategoryRole: nil!

attSetCategoryRole: value 
	"Set the value of attribute CategoryRole to value, if it is not already equal to value."

	(attCategoryRole = value) ifFalse: [
		attCategoryRole := value.
		self changed: #attCategoryRole.
	]!

attInitCategoryRole
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attCategoryRole := nil!

 !

!DocumentDictionary100.Main.XCategoryLink methodsFor: 'relationshipAPI'!

relRemoveAllCategory
	"Remove a XCategory from 1-N relationship2 Category if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllCategory) do: [:caco1 | self relRemoveCategory: caco1].!

relRemoveAllModelElement
	"Remove a XModelElement from 1-N relationship2 ModelElement if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllModelElement) do: [:ME1 | self relRemoveModelElement: ME1].!

relAllCategory
	"Return collection of 1-N relationship category"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relCategory ifNil: [ ^coll ].
	coll add: relCategory.
	^coll.!

relAllModelElement
	"Return collection of 1-N relationship modelElement"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relModelElement ifNil: [ ^coll ].
	coll add: relModelElement.
	^coll.!

relSizeCategory
	"Return the integer size of the collection returned by relAllCategory"
	"Keeps compatibility with 1-N relationships"

	^relCategory ifNil: [ 0 ] ifNotNil: [ 1 ].!

relSizeModelElement
	"Return the integer size of the collection returned by relAllModelElement"
	"Keeps compatibility with 1-N relationships"

	^relModelElement ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasCategory
	"Return true if the 1-N relations2 category holds an object, else return false."

	^relCategory notNil.!

relHasModelElement
	"Return true if the 1-N relations2 modelElement holds an object, else return false."

	^relModelElement notNil.!

relCreateCategory
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XCategory to 1-N relationship Category."

	| caco1a caco1 |
	( caco1a := self relGetCategory ) ifNotNil: [
		self dberror: 'XCategory:relCreateCategory: Error ' message: 
			'XCategory (', self  asString , ') already has a XCategory (', caco1a asString, ') in 1-N relation Category.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XCategory) ifTrue: [
		caco1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XCategory.
		caco1 relAddCategoryLinks: self.
		"caco1 addDefaultOwner."
		^caco1.
	] ifFalse: [
		self dberror: 'XCategoryLink.relCreateCategory Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XCategory. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateModelElement
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XModelElement to 1-N relationship ModelElement."

	| ME1a ME1 |
	( ME1a := self relGetModelElement ) ifNotNil: [
		self dberror: 'XModelElement:relCreateModelElement: Error ' message: 
			'XModelElement (', self  asString , ') already has a XModelElement (', ME1a asString, ') in 1-N relation ModelElement.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XModelElement) ifTrue: [
		ME1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XModelElement.
		ME1 relAddMemberOfCategories: self.
		"ME1 addDefaultOwner."
		^ME1.
	] ifFalse: [
		self dberror: 'XCategoryLink.relCreateModelElement Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XModelElement. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetCategory
	"Return the XCategory object on the other side of the 1-N relationship2 category."

	^relCategory!

relGetModelElement
	"Return the XModelElement object on the other side of the 1-N relationship2 modelElement."

	^relModelElement!

relRemoveCategory: caco1
	"Removes a XCategory caco1 from 1-N relationship2 Category."

	caco1 ifNil: [
		self dberror: 'XCategoryLink:relRemoveCategory: Error ' message: ( 'wrong class of parameter caco1, ',
			' nil is not a XCategory, and can not be removed from' ,
			' this XCategoryLink (', self asString, ') relation2 Category.' ).
		^nil.
	].

	caco1 ifNotNil: [
		( caco1 isKindOf: DocumentDictionary100.Main.XCategory ) ifFalse: [
			self dberror: 'XCategoryLink:relRemoveCategory: Error ' message: ( caco1 asString ,
				' is not a XCategory, and can not be removed from' ,
				' this XCategoryLink (', self asString, ') relation2 Category.' ).
			^nil.
		]
	].

	caco1 ifNotNil: [ caco1 relRemoveCategoryLinks: self. ].
	^caco1!

relRemoveModelElement: ME1
	"Removes a XModelElement ME1 from 1-N relationship2 ModelElement."

	ME1 ifNil: [
		self dberror: 'XCategoryLink:relRemoveModelElement: Error ' message: ( 'wrong class of parameter ME1, ',
			' nil is not a XModelElement, and can not be removed from' ,
			' this XCategoryLink (', self asString, ') relation2 ModelElement.' ).
		^nil.
	].

	ME1 ifNotNil: [
		( ME1 isKindOf: DocumentDictionary100.Core.Model.XModelElement ) ifFalse: [
			self dberror: 'XCategoryLink:relRemoveModelElement: Error ' message: ( ME1 asString ,
				' is not a XModelElement, and can not be removed from' ,
				' this XCategoryLink (', self asString, ') relation2 ModelElement.' ).
			^nil.
		]
	].

	ME1 ifNotNil: [ ME1 relRemoveMemberOfCategories: self. ].
	^ME1!

relInitCategory
	"Initialize pointer of 1-N relationship1 Category "

	relCategory := nil!

relInitModelElement
	"Initialize pointer of 1-N relationship1 ModelElement "

	relModelElement := nil!

 !

!DocumentDictionary100.Main.XCategoryLink methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetCategory: caco1
	"Set other end of 1-N relationship1 CategoryLinks"

	"caco1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying caco1.
	]."

  "( caco1 isKindOf: NOT_FOUND.XCategory ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relCategory == caco1 ) ifFalse: [
		relCategory := caco1.
		caco1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying caco1."
	  ].
	  self changed: #relCategory.
	].
	^relCategory!

relPrivateSetModelElement: ME1
	"Set other end of 1-N relationship1 MemberOfCategories"

	"ME1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying ME1.
	]."

  "( ME1 isKindOf: NOT_FOUND.XModelElement ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relModelElement == ME1 ) ifFalse: [
		relModelElement := ME1.
		ME1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying ME1."
	  ].
	  self changed: #relModelElement.
	].
	^relModelElement!

 !

!DocumentDictionary100.Main.XCategoryLink methodsFor: 'converting'!

 !

!DocumentDictionary100.Main.XCategoryLink methodsFor: 'testing'!

classPrefix
	"Return 'cacl' which is a unique prefix for class CategoryLink within the application."

	^'cacl'!

 !

