"XCategory_AutoAPI.st Generated at 2018-09-22 00:01:22.469."
'Class AutoAPI file for Class Category.'!

!DocumentDictionary100.Main.XCategory class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XCategory in the DomainModel DocumentDictionary100f"

	^'Category for building manual indexes over model elements.
For documents, '.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XCategory'.!

 !

!DocumentDictionary100.Main.XCategory methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XCategory in the DomainModel DocumentDictionary100f."

	^'Category for building manual indexes over model elements.
For documents, '.!

initialize
	"initialize attributes and relationships"

	super initialize.

	self relInitCategoryLinks.
	self relInitSubcategories.

	self relInitDocumentDictionary.
	self relInitMainCategory.

	
!
canDelete
	"Return true if this Category can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XCategory if there is one, else return nil."

	self relHasDocumentDictionary ifTrue: [ ^self relGetDocumentDictionary ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."

	self relDeleteAllCategoryLinks.
	self relDeleteAllSubcategories.


	self relRemoveAllDocumentDictionary.
	self relRemoveAllMainCategory.


	super delete!

 !

!DocumentDictionary100.Main.XCategory methodsFor: 'attributeAPI'!

 !

!DocumentDictionary100.Main.XCategory methodsFor: 'relationshipAPI'!

relRemoveAllDocumentDictionary
	"Remove a XDocumentDictionary from 1-N relationship2 DocumentDictionary if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllDocumentDictionary) do: [:dd1 | self relRemoveDocumentDictionary: dd1].!

relRemoveAllMainCategory
	"Remove a XCategory from 1-N relationship2 MainCategory if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllMainCategory) do: [:caco1 | self relRemoveMainCategory: caco1].!

relAllCategoryLinks
	"Return collection of all categoryLinks"

	^relCategoryLinks copy.!

relAllSubcategories
	"Return collection of all subcategories"

	^relSubcategories copy.!

relSizeCategoryLinks
	"Return the integer size of the collection returned by relAllCategoryLinks"

	^relCategoryLinks size!

relSizeSubcategories
	"Return the integer size of the collection returned by relAllSubcategories"

	^relSubcategories size!

relHasCategoryLinks
	"Return true if the 1-N relationship1 categoryLinks holds at least one object, else return false."

	^relCategoryLinks size > 0!

relHasSubcategories
	"Return true if the 1-N relationship1 subcategories holds at least one object, else return false."

	^relSubcategories size > 0!

relCreateCategoryLinks
	"Creates and adds a new XCategoryLink to 1-N relationship CategoryLinks."

	| cacl2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XCategoryLink) ifTrue: [
		cacl2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XCategoryLink.
		self relAddCategoryLinks: cacl2.
		^cacl2.
	] ifFalse: [
		self dberror: 'XCategory.relCreateCategoryLinks Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XCategoryLink. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateSubcategories
	"Creates and adds a new XCategory to 1-N relationship Subcategories."

	| caco2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XCategory) ifTrue: [
		caco2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XCategory.
		self relAddSubcategories: caco2.
		^caco2.
	] ifFalse: [
		self dberror: 'XCategory.relCreateSubcategories Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XCategory. Please open an appropriate substorage first.'.
		^nil.
	].!

relAddCategoryLinks: cacl2
	"Adds a XCategoryLink cacl2 to 1-N relationship CategoryLinks."

	| caco1a |
	( cacl2 isKindOf: DocumentDictionary100.Main.XCategoryLink ) ifFalse: [
		self dberror: 'XCategory:relAddCategoryLinks: Error ' message: ( cacl2 asString ,
			' is not a XCategoryLink, and can not be added to CategoryLinks for ',
			' this XCategory (', self asString, ').' ).
		^nil.
	].
	( (relCategoryLinks identityIndexOf: cacl2) > 0 ) ifTrue: [
		self dberror: 'XCategory:relAddCategoryLinks: Error ' message: 
			'XCategoryLink (', cacl2 asString , ') is already added to this XCategory (', self asString, ').'.
		^nil.
	].
	( caco1a := cacl2 relGetCategory ) ifNotNil: [ 
		self dberror: 'XCategory:relAddCategoryLinks: Error ' message: 
			'XCategoryLink (', cacl2 asString , ') is already added to another XCategory (', caco1a asString , ').'.
		^nil.
	]. 
	relCategoryLinks add: cacl2.
	cacl2 relPrivateSetCategory: self.
	^cacl2!

relAddSubcategories: caco2
	"Adds a XCategory caco2 to 1-N relationship Subcategories."

	| caco1a |
	( caco2 isKindOf: DocumentDictionary100.Main.XCategory ) ifFalse: [
		self dberror: 'XCategory:relAddSubcategories: Error ' message: ( caco2 asString ,
			' is not a XCategory, and can not be added to Subcategories for ',
			' this XCategory (', self asString, ').' ).
		^nil.
	].
	( (relSubcategories identityIndexOf: caco2) > 0 ) ifTrue: [
		self dberror: 'XCategory:relAddSubcategories: Error ' message: 
			'XCategory (', caco2 asString , ') is already added to this XCategory (', self asString, ').'.
		^nil.
	].
	( caco1a := caco2 relGetMainCategory ) ifNotNil: [ 
		self dberror: 'XCategory:relAddSubcategories: Error ' message: 
			'XCategory (', caco2 asString , ') is already added to another XCategory (', caco1a asString , ').'.
		^nil.
	]. 
	relSubcategories add: caco2.
	caco2 relPrivateSetMainCategory: self.
	^caco2!

relGetCategoryLinks
	"Return the first XCategoryLink object on the other side of the 1-N relations1 categoryLinks."
	"Provides compatibility with 1-1 relationships."

	( relCategoryLinks size = 0 ) ifTrue: [ ^nil ].
	^relCategoryLinks first!

relGetSubcategories
	"Return the first XCategory object on the other side of the 1-N relations1 subcategories."
	"Provides compatibility with 1-1 relationships."

	( relSubcategories size = 0 ) ifTrue: [ ^nil ].
	^relSubcategories first!

relSetCategoryLinks: cacl2
	"Force set other end of 1-N relationship to one XCategoryLink cacl2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| caco1a |
	cacl2 ifNil: [
		self relDeleteAllCategoryLinks.
		^nil.
	].
	( cacl2 isKindOf: DocumentDictionary100.Main.XCategoryLink ) ifFalse: [
		self dberror: 'XCategory:relSetCategoryLinks: Error ' message: ( cacl2 asString ,
			' is not a XCategoryLink, and can not be added to' ,
			' this XCategory (', self asString, ').' ).
		^nil.
	].
	(( ( relCategoryLinks identityIndexOf: cacl2 ) > 0 ) and: [ relCategoryLinks size = 1 ]) ifTrue: [
		"XCategoryLink cacl2 is already added to this XCategory, and it is the only one."
		^nil.
	].
	( relCategoryLinks size > 0 ) ifTrue: [
		self relDeleteAllCategoryLinks.
	].

	( caco1a := cacl2 relGetCategory ) ifNotNil: [ 
		cacl2 relRemoveAllCategory
	]. 
	relCategoryLinks add: cacl2.
	cacl2 relPrivateSetCategory: self.
	^cacl2!

relSetSubcategories: caco2
	"Force set other end of 1-N relationship to one XCategory caco2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| caco1a |
	caco2 ifNil: [
		self relRemoveAllSubcategories.
		^nil.
	].
	( caco2 isKindOf: DocumentDictionary100.Main.XCategory ) ifFalse: [
		self dberror: 'XCategory:relSetSubcategories: Error ' message: ( caco2 asString ,
			' is not a XCategory, and can not be added to' ,
			' this XCategory (', self asString, ').' ).
		^nil.
	].
	(( ( relSubcategories identityIndexOf: caco2 ) > 0 ) and: [ relSubcategories size = 1 ]) ifTrue: [
		"XCategory caco2 is already added to this XCategory, and it is the only one."
		^nil.
	].
	( relSubcategories size > 0 ) ifTrue: [
		self relRemoveAllSubcategories.
	].

	( caco1a := caco2 relGetMainCategory ) ifNotNil: [ 
		caco2 relRemoveAllMainCategory
	]. 
	relSubcategories add: caco2.
	caco2 relPrivateSetMainCategory: self.
	^caco2!

relRemoveCategoryLinks: cacl2
	"Removes a XCategoryLink cacl2 from 1-N relationship1 CategoryLinks."

	| caco1 index |
	( cacl2 isKindOf: DocumentDictionary100.Main.XCategoryLink ) ifFalse: [
		self dberror: 'XCategory:relRemoveCategoryLinks: Error ' message: ( cacl2 asString ,
			' is not a XCategoryLink, and can not possibly be removed from CategoryLinks on' ,
			' this XCategory (', self asString, ').' ).
		^nil.
	].
	( ( caco1 := cacl2 relGetCategory ) == self ) ifFalse:[
		self dberror: 'XCategory:relRemoveCategoryLinks Error ' message: 
			'XCategoryLink (', cacl2 asString , ') is added to XCategory (', caco1 asString, ') ',
			'instead of this XCategory (', self asString , ').'.
		^nil.
	].
	index := relCategoryLinks identityIndexOf: cacl2.
	(index = 0) ifTrue: [
		self dberror: 'XCategory:relRemoveCategoryLinks Error ' message: 
			'XCategoryLink (', cacl2 asString , ') can not be found in CategoryLinks of this XCategory(', self asString , ').'.
		^nil.
	]. 
	relCategoryLinks removeAtIndex: index.
	cacl2 relPrivateSetCategory: nil.
	^cacl2.!

relRemoveSubcategories: caco2
	"Removes a XCategory caco2 from 1-N relationship1 Subcategories."

	| caco1 index |
	( caco2 isKindOf: DocumentDictionary100.Main.XCategory ) ifFalse: [
		self dberror: 'XCategory:relRemoveSubcategories: Error ' message: ( caco2 asString ,
			' is not a XCategory, and can not possibly be removed from Subcategories on' ,
			' this XCategory (', self asString, ').' ).
		^nil.
	].
	( ( caco1 := caco2 relGetMainCategory ) == self ) ifFalse:[
		self dberror: 'XCategory:relRemoveSubcategories Error ' message: 
			'XCategory (', caco2 asString , ') is added to XCategory (', caco1 asString, ') ',
			'instead of this XCategory (', self asString , ').'.
		^nil.
	].
	index := relSubcategories identityIndexOf: caco2.
	(index = 0) ifTrue: [
		self dberror: 'XCategory:relRemoveSubcategories Error ' message: 
			'XCategory (', caco2 asString , ') can not be found in Subcategories of this XCategory(', self asString , ').'.
		^nil.
	]. 
	relSubcategories removeAtIndex: index.
	caco2 relPrivateSetMainCategory: nil.
	^caco2.!

relRemoveAllCategoryLinks 
	"Remove all XCategoryLink instances from 1-N relationship1 CategoryLinks and return them in a collection."

	| cacl2Coll |
	( cacl2Coll := relCategoryLinks copy ) do: [:cacl2 |
		self relRemoveCategoryLinks: cacl2
	].
	^cacl2Coll.!

relRemoveAllSubcategories 
	"Remove all XCategory instances from 1-N relationship1 Subcategories and return them in a collection."

	| caco2Coll |
	( caco2Coll := relSubcategories copy ) do: [:caco2 |
		self relRemoveSubcategories: caco2
	].
	^caco2Coll.!

relDeleteCategoryLinks: cacl2
	"Remove a XCategoryLink cacl2 from 1-1 relationship1 CategoryLinks and delete it."
	"Return true if operation succeded else return false."

	| caco1 index |
	( cacl2 isKindOf: DocumentDictionary100.Main.XCategoryLink ) ifFalse: [
		self dberror: 'XCategory:relDeleteCategoryLinks: Error ' message: ( cacl2 asString ,
			' is not a XCategoryLink, and can not possibly be deleted from CategoryLinks on' ,
			' this XCategory (', self asString, ').' ).
		^false.
	].
	(( caco1 := cacl2 relGetCategory ) = self ) ifFalse:[
		self dberror: 'XCategory:relDeleteCategoryLinks Error ' message: 
			'XCategoryLink (', cacl2 asString , ') is added to XCategory (', caco1 asString, ') ',
			'instead of this XCategory (', self asString , ').'.
		^false.
	].
	index := relCategoryLinks identityIndexOf: cacl2.
	(index = 0) ifTrue: [
		self dberror: 'XCategory:relDeleteCategoryLinks Error ' message: 
			'XCategoryLink (', cacl2 asString , ') can not be found in CategoryLinks of this XCategory(', self asString , ').'.
		^false.
	]. 
	relCategoryLinks removeAtIndex: index.
	cacl2 relPrivateSetCategory: nil.
	cacl2 delete.
	^true.!

relDeleteSubcategories: caco2
	"Remove a XCategory caco2 from 1-1 relationship1 Subcategories and delete it."
	"Return true if operation succeded else return false."

	| caco1 index |
	( caco2 isKindOf: DocumentDictionary100.Main.XCategory ) ifFalse: [
		self dberror: 'XCategory:relDeleteSubcategories: Error ' message: ( caco2 asString ,
			' is not a XCategory, and can not possibly be deleted from Subcategories on' ,
			' this XCategory (', self asString, ').' ).
		^false.
	].
	(( caco1 := caco2 relGetMainCategory ) = self ) ifFalse:[
		self dberror: 'XCategory:relDeleteSubcategories Error ' message: 
			'XCategory (', caco2 asString , ') is added to XCategory (', caco1 asString, ') ',
			'instead of this XCategory (', self asString , ').'.
		^false.
	].
	index := relSubcategories identityIndexOf: caco2.
	(index = 0) ifTrue: [
		self dberror: 'XCategory:relDeleteSubcategories Error ' message: 
			'XCategory (', caco2 asString , ') can not be found in Subcategories of this XCategory(', self asString , ').'.
		^false.
	]. 
	relSubcategories removeAtIndex: index.
	caco2 relPrivateSetMainCategory: nil.
	caco2 delete.
	^true.!

relDeleteAllCategoryLinks 
	"Delete all XCategoryLink from 1-N relationship1 CategoryLinks, and return the count of deleted objects."

	| cacl2Size cacl2Coll |
	cacl2Size := relCategoryLinks size.
	cacl2Coll := relCategoryLinks.
	self relInitCategoryLinks.
	cacl2Coll do: [:cacl2 |
		cacl2 relPrivateSetCategory: nil.
		cacl2 delete.
	].
	^cacl2Size.!

relDeleteAllSubcategories 
	"Delete all XCategory from 1-N relationship1 Subcategories, and return the count of deleted objects."

	| caco2Size caco2Coll |
	caco2Size := relSubcategories size.
	caco2Coll := relSubcategories.
	self relInitSubcategories.
	caco2Coll do: [:caco2 |
		caco2 relPrivateSetMainCategory: nil.
		caco2 delete.
	].
	^caco2Size.!

relInitCategoryLinks
	"Initialize collection of 1-N relationship1 CategoryLinks"

	relCategoryLinks := OrderedCollection new!

relInitSubcategories
	"Initialize collection of 1-N relationship1 Subcategories"

	relSubcategories := OrderedCollection new!

relAllDocumentDictionary
	"Return collection of 1-N relationship documentDictionary"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relDocumentDictionary ifNil: [ ^coll ].
	coll add: relDocumentDictionary.
	^coll.!

relAllMainCategory
	"Return collection of 1-N relationship mainCategory"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relMainCategory ifNil: [ ^coll ].
	coll add: relMainCategory.
	^coll.!

relSizeDocumentDictionary
	"Return the integer size of the collection returned by relAllDocumentDictionary"
	"Keeps compatibility with 1-N relationships"

	^relDocumentDictionary ifNil: [ 0 ] ifNotNil: [ 1 ].!

relSizeMainCategory
	"Return the integer size of the collection returned by relAllMainCategory"
	"Keeps compatibility with 1-N relationships"

	^relMainCategory ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasDocumentDictionary
	"Return true if the 1-N relations2 documentDictionary holds an object, else return false."

	^relDocumentDictionary notNil.!

relHasMainCategory
	"Return true if the 1-N relations2 mainCategory holds an object, else return false."

	^relMainCategory notNil.!

relCreateDocumentDictionary
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XDocumentDictionary to 1-N relationship DocumentDictionary."

	| dd1a dd1 |
	( dd1a := self relGetDocumentDictionary ) ifNotNil: [
		self dberror: 'XDocumentDictionary:relCreateDocumentDictionary: Error ' message: 
			'XDocumentDictionary (', self  asString , ') already has a XDocumentDictionary (', dd1a asString, ') in 1-N relation DocumentDictionary.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentDictionary) ifTrue: [
		dd1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentDictionary.
		dd1 relAddCategories: self.
		"dd1 addDefaultOwner."
		^dd1.
	] ifFalse: [
		self dberror: 'XCategory.relCreateDocumentDictionary Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentDictionary. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateMainCategory
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XCategory to 1-N relationship MainCategory."

	| caco1a caco1 |
	( caco1a := self relGetMainCategory ) ifNotNil: [
		self dberror: 'XCategory:relCreateMainCategory: Error ' message: 
			'XCategory (', self  asString , ') already has a XCategory (', caco1a asString, ') in 1-N relation MainCategory.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XCategory) ifTrue: [
		caco1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XCategory.
		caco1 relAddSubcategories: self.
		"caco1 addDefaultOwner."
		^caco1.
	] ifFalse: [
		self dberror: 'XCategory.relCreateMainCategory Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XCategory. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetDocumentDictionary
	"Return the XDocumentDictionary object on the other side of the 1-N relationship2 documentDictionary."

	^relDocumentDictionary!

relGetMainCategory
	"Return the XCategory object on the other side of the 1-N relationship2 mainCategory."

	^relMainCategory!

relSetMainCategory: caco1
	"Set other end of 1-1 relations2 MainCategory"

	caco1 ifNotNil: [
		( caco1 isKindOf: DocumentDictionary100.Main.XCategory ) ifFalse: [
			self dberror: 'XCategory:relSetMainCategory: Error ' message: ( caco1 asString ,
				' is not a XCategory, and can not be set to' ,
				' this XCategory (', self asString, ') relation2 MainCategory.' ).
			^nil.
		]
	].

	self relHasMainCategory ifTrue: [ 
		"Special treatment needed if NOT_FOUND.mustExist1 == true or mustExist2 == true. "
		self relRemoveAllMainCategory. 
	].
	caco1 ifNotNil: [ caco1 relAddSubcategories: self. ].
	^caco1!

relRemoveDocumentDictionary: dd1
	"Removes a XDocumentDictionary dd1 from 1-N relationship2 DocumentDictionary."

	dd1 ifNil: [
		self dberror: 'XCategory:relRemoveDocumentDictionary: Error ' message: ( 'wrong class of parameter dd1, ',
			' nil is not a XDocumentDictionary, and can not be removed from' ,
			' this XCategory (', self asString, ') relation2 DocumentDictionary.' ).
		^nil.
	].

	dd1 ifNotNil: [
		( dd1 isKindOf: DocumentDictionary100.Main.XDocumentDictionary ) ifFalse: [
			self dberror: 'XCategory:relRemoveDocumentDictionary: Error ' message: ( dd1 asString ,
				' is not a XDocumentDictionary, and can not be removed from' ,
				' this XCategory (', self asString, ') relation2 DocumentDictionary.' ).
			^nil.
		]
	].

	dd1 ifNotNil: [ dd1 relRemoveCategories: self. ].
	^dd1!

relRemoveMainCategory: caco1
	"Removes a XCategory caco1 from 1-N relationship2 MainCategory."

	caco1 ifNil: [
		self dberror: 'XCategory:relRemoveMainCategory: Error ' message: ( 'wrong class of parameter caco1, ',
			' nil is not a XCategory, and can not be removed from' ,
			' this XCategory (', self asString, ') relation2 MainCategory.' ).
		^nil.
	].

	caco1 ifNotNil: [
		( caco1 isKindOf: DocumentDictionary100.Main.XCategory ) ifFalse: [
			self dberror: 'XCategory:relRemoveMainCategory: Error ' message: ( caco1 asString ,
				' is not a XCategory, and can not be removed from' ,
				' this XCategory (', self asString, ') relation2 MainCategory.' ).
			^nil.
		]
	].

	caco1 ifNotNil: [ caco1 relRemoveSubcategories: self. ].
	^caco1!

relRemoveAllMainCategory
	"Remove a XCategory from 1-N relationship2 MainCategory if there is one."
	"Available for API completeness reasons."

	(self relAllMainCategory) do: [:caco1 | self relRemoveMainCategory: caco1].!

relDeleteNOT_FOUND: caco1
	"Deletes a DocumentDictionary100.Main.XCategory caco1 from 1-N relationship2 MainCategory."

	caco1 ifNil: [
		self dberror: 'XCategory:relDeleteMainCategory: Error ' message: ( 'wrong class of parameter caco1, ',
			' nil is not a XCategory, and can not be deleted from' ,
			' this XCategory (', self asString, ') relation2 MainCategory.' ).
		^nil.
	].

	caco1 ifNotNil: [
		( caco1 isKindOf: DocumentDictionary100.Main.XCategory ) ifFalse: [
			self dberror: 'XCategory:relDeleteMainCategory: Error ' message: ( caco1 asString ,
				' is not a XCategory, and can not be deleted from' ,
				' this XCategory (', self asString, ') relation2 MainCategory.' ).
			^nil.
		]
	].

	caco1 ifNotNil: [ caco1 relRemoveSubcategories: self. ].
	caco1 delete!

relDeleteAllMainCategory
	"Deletes a XCategory from 1-N relationship2 MainCategory if there is one."
	"Available for API completeness reasons."

	(self relAllMainCategory) do: [:caco1 | self relDeleteMainCategory: caco1].!

relInitDocumentDictionary
	"Initialize pointer of 1-N relationship1 DocumentDictionary "

	relDocumentDictionary := nil!

relInitMainCategory
	"Initialize pointer of 1-N relationship1 MainCategory "

	relMainCategory := nil!

 !

!DocumentDictionary100.Main.XCategory methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetDocumentDictionary: dd1
	"Set other end of 1-N relationship1 Categories"

	"dd1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying dd1.
	]."

  "( dd1 isKindOf: NOT_FOUND.XDocumentDictionary ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relDocumentDictionary == dd1 ) ifFalse: [
		relDocumentDictionary := dd1.
		dd1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying dd1."
	  ].
	  self changed: #relDocumentDictionary.
	].
	^relDocumentDictionary!

relPrivateSetMainCategory: caco1
	"Set other end of 1-N relationship1 Subcategories"

	"caco1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying caco1.
	]."

  "( caco1 isKindOf: NOT_FOUND.XCategory ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relMainCategory == caco1 ) ifFalse: [
		relMainCategory := caco1.
		caco1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying caco1."
	  ].
	  self changed: #relMainCategory.
	].
	^relMainCategory!

 !

!DocumentDictionary100.Main.XCategory methodsFor: 'converting'!

 !

!DocumentDictionary100.Main.XCategory methodsFor: 'testing'!

classPrefix
	"Return 'caco' which is a unique prefix for class Category within the application."

	^'caco'!

 !

