"XCite_AutoAPI.st Generated at 2018-09-22 00:01:56.909."
'Class AutoAPI file for Class Cite.'!

!DocumentDictionary100.Main.XCite class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XCite in the DomainModel DocumentDictionary100f"

	^'A Cite corresponds to an entry in the document_s reference list. The label is the by document authors chosen identifier used in the document to refer to an entry in the reference list.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XCite'.!

 !

!DocumentDictionary100.Main.XCite methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XCite in the DomainModel DocumentDictionary100f."

	^'A Cite corresponds to an entry in the document_s reference list. The label is the by document authors chosen identifier used in the document to refer to an entry in the reference list.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitCitedKey.
	self attInitLabel.


	self relInitCited.
	self relInitCitedBy.

	
!
canDelete
	"Return true if this Cite can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XCite if there is one, else return nil."

	self relHasCitedBy ifTrue: [ ^self relGetCitedBy ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."



	self relRemoveAllCited.
	self relRemoveAllCitedBy.


	super delete!

 !

!DocumentDictionary100.Main.XCite methodsFor: 'attributeAPI'!

attGetCitedKey
	"Get value of attribute CitedKey"
	"Foreign key to the cited document.
Used for dump loading of records, and building the relationship cited_citedBy  in a post processing stage.
"

	^attCitedKey.!

attGetLabel
	"Get value of attribute Label"
	"A label used as reference identifier in the reference list of the citing document."

	^attLabel.!

attIqCitedKey
	"Return the information quantity of attribute CitedKey"
	"180413 This is a default implementation that can be extended later"

	^attCitedKey ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqLabel
	"Return the information quantity of attribute Label"
	"180413 This is a default implementation that can be extended later"

	^attLabel ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasCitedKey
	"Return true if the current value of the attribute CitedKey carries information."

	^(attCitedKey ~= nil)!

attHasLabel
	"Return true if the current value of the attribute Label carries information."

	^(attLabel ~= nil)!

attCreateCitedKey
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetCitedKey: (nil)!

attCreateLabel
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetLabel: (nil)!

attCreateCitedKey
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetCitedKey: (nil)!

attCreateLabel
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetLabel: (nil)!

attDeleteCitedKey
	"Set the attribute value to undefined, or to a value that makes attIqCitedKey return 0."

	^self attSetCitedKey: nil!

attDeleteLabel
	"Set the attribute value to undefined, or to a value that makes attIqLabel return 0."

	^self attSetLabel: nil!

attSetCitedKey: value 
	"Set the value of attribute CitedKey to value, if it is not already equal to value."

	(attCitedKey = value) ifFalse: [
		attCitedKey := value.
		self changed: #attCitedKey.
	]!

attSetLabel: value 
	"Set the value of attribute Label to value, if it is not already equal to value."

	(attLabel = value) ifFalse: [
		attLabel := value.
		self changed: #attLabel.
	]!

attInitCitedKey
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attCitedKey := nil!

attInitLabel
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attLabel := nil!

 !

!DocumentDictionary100.Main.XCite methodsFor: 'relationshipAPI'!

relRemoveAllCited
	"Remove a XDocumentRecord from 1-N relationship2 Cited if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllCited) do: [:dr1 | self relRemoveCited: dr1].!

relRemoveAllCitedBy
	"Remove a XDocumentRecord from 1-N relationship2 CitedBy if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllCitedBy) do: [:dr1 | self relRemoveCitedBy: dr1].!

relAllCited
	"Return collection of 1-N relationship cited"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relCited ifNil: [ ^coll ].
	coll add: relCited.
	^coll.!

relAllCitedBy
	"Return collection of 1-N relationship citedBy"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relCitedBy ifNil: [ ^coll ].
	coll add: relCitedBy.
	^coll.!

relSizeCited
	"Return the integer size of the collection returned by relAllCited"
	"Keeps compatibility with 1-N relationships"

	^relCited ifNil: [ 0 ] ifNotNil: [ 1 ].!

relSizeCitedBy
	"Return the integer size of the collection returned by relAllCitedBy"
	"Keeps compatibility with 1-N relationships"

	^relCitedBy ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasCited
	"Return true if the 1-N relations2 cited holds an object, else return false."

	^relCited notNil.!

relHasCitedBy
	"Return true if the 1-N relations2 citedBy holds an object, else return false."

	^relCitedBy notNil.!

relCreateCited
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XDocumentRecord to 1-N relationship Cited."

	| dr1a dr1 |
	( dr1a := self relGetCited ) ifNotNil: [
		self dberror: 'XDocumentRecord:relCreateCited: Error ' message: 
			'XDocumentRecord (', self  asString , ') already has a XDocumentRecord (', dr1a asString, ') in 1-N relation Cited.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentRecord) ifTrue: [
		dr1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentRecord.
		dr1 relAddCitedBy: self.
		"dr1 addDefaultOwner."
		^dr1.
	] ifFalse: [
		self dberror: 'XCite.relCreateCited Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateCitedBy
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XDocumentRecord to 1-N relationship CitedBy."

	| dr1a dr1 |
	( dr1a := self relGetCitedBy ) ifNotNil: [
		self dberror: 'XDocumentRecord:relCreateCitedBy: Error ' message: 
			'XDocumentRecord (', self  asString , ') already has a XDocumentRecord (', dr1a asString, ') in 1-N relation CitedBy.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentRecord) ifTrue: [
		dr1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentRecord.
		dr1 relAddCites: self.
		"dr1 addDefaultOwner."
		^dr1.
	] ifFalse: [
		self dberror: 'XCite.relCreateCitedBy Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetCited
	"Return the XDocumentRecord object on the other side of the 1-N relationship2 cited."

	^relCited!

relGetCitedBy
	"Return the XDocumentRecord object on the other side of the 1-N relationship2 citedBy."

	^relCitedBy!

relSetCited: dr1
	"Set other end of 1-1 relations2 Cited"

	dr1 ifNotNil: [
		( dr1 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
			self dberror: 'XCite:relSetCited: Error ' message: ( dr1 asString ,
				' is not a XDocumentRecord, and can not be set to' ,
				' this XCite (', self asString, ') relation2 Cited.' ).
			^nil.
		]
	].

	self relHasCited ifTrue: [ 
		"Special treatment needed if NOT_FOUND.mustExist1 == true or mustExist2 == true. "
		self relRemoveAllCited. 
	].
	dr1 ifNotNil: [ dr1 relAddCitedBy: self. ].
	^dr1!

relRemoveCited: dr1
	"Removes a XDocumentRecord dr1 from 1-N relationship2 Cited."

	dr1 ifNil: [
		self dberror: 'XCite:relRemoveCited: Error ' message: ( 'wrong class of parameter dr1, ',
			' nil is not a XDocumentRecord, and can not be removed from' ,
			' this XCite (', self asString, ') relation2 Cited.' ).
		^nil.
	].

	dr1 ifNotNil: [
		( dr1 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
			self dberror: 'XCite:relRemoveCited: Error ' message: ( dr1 asString ,
				' is not a XDocumentRecord, and can not be removed from' ,
				' this XCite (', self asString, ') relation2 Cited.' ).
			^nil.
		]
	].

	dr1 ifNotNil: [ dr1 relRemoveCitedBy: self. ].
	^dr1!

relRemoveCitedBy: dr1
	"Removes a XDocumentRecord dr1 from 1-N relationship2 CitedBy."

	dr1 ifNil: [
		self dberror: 'XCite:relRemoveCitedBy: Error ' message: ( 'wrong class of parameter dr1, ',
			' nil is not a XDocumentRecord, and can not be removed from' ,
			' this XCite (', self asString, ') relation2 CitedBy.' ).
		^nil.
	].

	dr1 ifNotNil: [
		( dr1 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
			self dberror: 'XCite:relRemoveCitedBy: Error ' message: ( dr1 asString ,
				' is not a XDocumentRecord, and can not be removed from' ,
				' this XCite (', self asString, ') relation2 CitedBy.' ).
			^nil.
		]
	].

	dr1 ifNotNil: [ dr1 relRemoveCites: self. ].
	^dr1!

relRemoveAllCited
	"Remove a XDocumentRecord from 1-N relationship2 Cited if there is one."
	"Available for API completeness reasons."

	(self relAllCited) do: [:dr1 | self relRemoveCited: dr1].!

relDeleteNOT_FOUND: dr1
	"Deletes a DocumentDictionary100.Main.XDocumentRecord dr1 from 1-N relationship2 Cited."

	dr1 ifNil: [
		self dberror: 'XCite:relDeleteCited: Error ' message: ( 'wrong class of parameter dr1, ',
			' nil is not a XDocumentRecord, and can not be deleted from' ,
			' this XCite (', self asString, ') relation2 Cited.' ).
		^nil.
	].

	dr1 ifNotNil: [
		( dr1 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
			self dberror: 'XCite:relDeleteCited: Error ' message: ( dr1 asString ,
				' is not a XDocumentRecord, and can not be deleted from' ,
				' this XCite (', self asString, ') relation2 Cited.' ).
			^nil.
		]
	].

	dr1 ifNotNil: [ dr1 relRemoveCitedBy: self. ].
	dr1 delete!

relDeleteAllCited
	"Deletes a XDocumentRecord from 1-N relationship2 Cited if there is one."
	"Available for API completeness reasons."

	(self relAllCited) do: [:dr1 | self relDeleteCited: dr1].!

relInitCited
	"Initialize pointer of 1-N relationship1 Cited "

	relCited := nil!

relInitCitedBy
	"Initialize pointer of 1-N relationship1 CitedBy "

	relCitedBy := nil!

 !

!DocumentDictionary100.Main.XCite methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetCited: dr1
	"Set other end of 1-N relationship1 CitedBy"

	"dr1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying dr1.
	]."

  "( dr1 isKindOf: NOT_FOUND.XDocumentRecord ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relCited == dr1 ) ifFalse: [
		relCited := dr1.
		dr1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying dr1."
	  ].
	  self changed: #relCited.
	].
	^relCited!

relPrivateSetCitedBy: dr1
	"Set other end of 1-N relationship1 Cites"

	"dr1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying dr1.
	]."

  "( dr1 isKindOf: NOT_FOUND.XDocumentRecord ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relCitedBy == dr1 ) ifFalse: [
		relCitedBy := dr1.
		dr1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying dr1."
	  ].
	  self changed: #relCitedBy.
	].
	^relCitedBy!

 !

!DocumentDictionary100.Main.XCite methodsFor: 'converting'!

 !

!DocumentDictionary100.Main.XCite methodsFor: 'testing'!

classPrefix
	"Return 'ci' which is a unique prefix for class Cite within the application."

	^'ci'!

 !

