"XContentRecord_AutoAPI.st Generated at 2018-09-22 00:02:34.454."
'Class AutoAPI file for Class ContentRecord.'!

!DocumentDictionary100.Main.XContentRecord class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XContentRecord in the DomainModel DocumentDictionary100f"

	^'Represents metadata for a table of contents item within the document.
ModelElement.Label is the chapter number, or hierarchically structured section/subsection number.
ModelElement.Name is the textual headline of the chapter, section/subsection etc.
'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XContentRecord'.!

 !

!DocumentDictionary100.Main.XContentRecord methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XContentRecord in the DomainModel DocumentDictionary100f."

	^'Represents metadata for a table of contents item within the document.
ModelElement.Label is the chapter number, or hierarchically structured section/subsection number.
ModelElement.Name is the textual headline of the chapter, section/subsection etc.
'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitContainerType.
	self attInitEndLine.
	self attInitEndPage.
	self attInitPageCount.
	self attInitStartLine.
	self attInitStartPage.

	self relInitContents.
	self relInitObjectRecords.

	self relInitContentContainer.
	self relInitDocumentRecord.

	
!
canDelete
	"Return true if this ContentRecord can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XContentRecord if there is one, else return nil."

	self relHasDocumentRecord ifTrue: [ ^self relGetDocumentRecord ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."

	self relDeleteAllContents.
	self relDeleteAllObjectRecords.


	self relRemoveAllContentContainer.
	self relRemoveAllDocumentRecord.


	super delete!

 !

!DocumentDictionary100.Main.XContentRecord methodsFor: 'attributeAPI'!

attGetContainerType
	"Get value of attribute ContainerType"
	"The containerType defines the prefix of the label  in a generated table of contents. Typically a container type is (Preface | Part | Chapter | Section | SubSection | Figure | Table | Equation | Code | Paragraph | Quote | Appendix | References | Index ) or other document specific ContentContainer types."

	^attContainerType.!

attGetEndLine
	"Get value of attribute EndLine"
	"Line number where this ContentContainer of containerType (Preface | Part | Chapter | Section | SubSection | Appendix | ReferenceList | Index | Paragraph) or other document specific ContentContainer types, ends."

	^attEndLine.!

attGetEndPage
	"Get value of attribute EndPage"
	"Page number where this ContentContainer of containerType (Preface | Part | Chapter | Section | SubSection | Appendix | ReferenceList | Index ) or other document specific ContentContainer types, ends."

	^attEndPage.!

attGetPageCount
	"Get value of attribute PageCount"
	"The number of pages within the content for convenience in aggreated calculations. This numeric value can be calculated automatically,  in case both startPage and endPage are entered."

	^attPageCount.!

attGetStartLine
	"Get value of attribute StartLine"
	"Line number where this ContentContainer of containerType (Preface | Part | Chapter | Section | SubSection | Appendix | ReferenceList | Index | Paragraph )  or other document specific ContentContainer types, starts."

	^attStartLine.!

attGetStartPage
	"Get value of attribute StartPage"
	"Page number where this ContentContainer of containerType (Preface | Part | Chapter | Section | SubSection | Appendix | ReferenceList | Index )  or other document specific ContentContainer types, starts."

	^attStartPage.!

attIqContainerType
	"Return the information quantity of attribute ContainerType"
	"180413 This is a default implementation that can be extended later"

	^attContainerType ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqEndLine
	"Return the information quantity of attribute EndLine"
	"180413 This is a default implementation that can be extended later"

	^attEndLine ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqEndPage
	"Return the information quantity of attribute EndPage"
	"180413 This is a default implementation that can be extended later"

	^attEndPage ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqPageCount
	"Return the information quantity of attribute PageCount"
	"180413 This is a default implementation that can be extended later"

	^attPageCount ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqStartLine
	"Return the information quantity of attribute StartLine"
	"180413 This is a default implementation that can be extended later"

	^attStartLine ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqStartPage
	"Return the information quantity of attribute StartPage"
	"180413 This is a default implementation that can be extended later"

	^attStartPage ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasContainerType
	"Return true if the current value of the attribute ContainerType carries information."

	^(attContainerType ~= nil)!

attHasEndLine
	"Return true if the current value of the attribute EndLine carries information."

	^(attEndLine ~= nil)!

attHasEndPage
	"Return true if the current value of the attribute EndPage carries information."

	^(attEndPage ~= nil)!

attHasPageCount
	"Return true if the current value of the attribute PageCount carries information."

	^(attPageCount ~= nil)!

attHasStartLine
	"Return true if the current value of the attribute StartLine carries information."

	^(attStartLine ~= nil)!

attHasStartPage
	"Return true if the current value of the attribute StartPage carries information."

	^(attStartPage ~= nil)!

attCreateContainerType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetContainerType: (nil)!

attCreateEndLine
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetEndLine: (nil)!

attCreateEndPage
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetEndPage: (nil)!

attCreatePageCount
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetPageCount: (nil)!

attCreateStartLine
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetStartLine: (nil)!

attCreateStartPage
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetStartPage: (nil)!

attCreateContainerType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetContainerType: (nil)!

attCreateEndLine
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetEndLine: (nil)!

attCreateEndPage
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetEndPage: (nil)!

attCreatePageCount
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetPageCount: (nil)!

attCreateStartLine
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetStartLine: (nil)!

attCreateStartPage
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetStartPage: (nil)!

attDeleteContainerType
	"Set the attribute value to undefined, or to a value that makes attIqContainerType return 0."

	^self attSetContainerType: nil!

attDeleteEndLine
	"Set the attribute value to undefined, or to a value that makes attIqEndLine return 0."

	^self attSetEndLine: nil!

attDeleteEndPage
	"Set the attribute value to undefined, or to a value that makes attIqEndPage return 0."

	^self attSetEndPage: nil!

attDeletePageCount
	"Set the attribute value to undefined, or to a value that makes attIqPageCount return 0."

	^self attSetPageCount: nil!

attDeleteStartLine
	"Set the attribute value to undefined, or to a value that makes attIqStartLine return 0."

	^self attSetStartLine: nil!

attDeleteStartPage
	"Set the attribute value to undefined, or to a value that makes attIqStartPage return 0."

	^self attSetStartPage: nil!

attSetContainerType: value 
	"Set the value of attribute ContainerType to value, if it is not already equal to value."

	(attContainerType = value) ifFalse: [
		attContainerType := value.
		self changed: #attContainerType.
	]!

attSetEndLine: value 
	"Set the value of attribute EndLine to value, if it is not already equal to value."

	(attEndLine = value) ifFalse: [
		attEndLine := value.
		self changed: #attEndLine.
	]!

attSetEndPage: value 
	"Set the value of attribute EndPage to value, if it is not already equal to value."

	(attEndPage = value) ifFalse: [
		attEndPage := value.
		self changed: #attEndPage.
	]!

attSetPageCount: value 
	"Set the value of attribute PageCount to value, if it is not already equal to value."

	(attPageCount = value) ifFalse: [
		attPageCount := value.
		self changed: #attPageCount.
	]!

attSetStartLine: value 
	"Set the value of attribute StartLine to value, if it is not already equal to value."

	(attStartLine = value) ifFalse: [
		attStartLine := value.
		self changed: #attStartLine.
	]!

attSetStartPage: value 
	"Set the value of attribute StartPage to value, if it is not already equal to value."

	(attStartPage = value) ifFalse: [
		attStartPage := value.
		self changed: #attStartPage.
	]!

attInitContainerType
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attContainerType := nil!

attInitEndLine
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attEndLine := nil!

attInitEndPage
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attEndPage := nil!

attInitPageCount
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attPageCount := nil!

attInitStartLine
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attStartLine := nil!

attInitStartPage
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attStartPage := nil!

 !

!DocumentDictionary100.Main.XContentRecord methodsFor: 'relationshipAPI'!

relRemoveAllContentContainer
	"Remove a XContentRecord from 1-N relationship2 ContentContainer if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllContentContainer) do: [:cr1 | self relRemoveContentContainer: cr1].!

relRemoveAllDocumentRecord
	"Remove a XDocumentRecord from 1-N relationship2 DocumentRecord if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllDocumentRecord) do: [:dr1 | self relRemoveDocumentRecord: dr1].!

relAllContents
	"Return collection of all contents"

	^relContents copy.!

relAllObjectRecords
	"Return collection of all objectRecords"

	^relObjectRecords copy.!

relSizeContents
	"Return the integer size of the collection returned by relAllContents"

	^relContents size!

relSizeObjectRecords
	"Return the integer size of the collection returned by relAllObjectRecords"

	^relObjectRecords size!

relHasContents
	"Return true if the 1-N relationship1 contents holds at least one object, else return false."

	^relContents size > 0!

relHasObjectRecords
	"Return true if the 1-N relationship1 objectRecords holds at least one object, else return false."

	^relObjectRecords size > 0!

relCreateContents
	"Creates and adds a new XContentRecord to 1-N relationship Contents."

	| cr2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XContentRecord) ifTrue: [
		cr2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XContentRecord.
		self relAddContents: cr2.
		^cr2.
	] ifFalse: [
		self dberror: 'XContentRecord.relCreateContents Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XContentRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateObjectRecords
	"Creates and adds a new XObjectRecord to 1-N relationship ObjectRecords."

	| or2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XObjectRecord) ifTrue: [
		or2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XObjectRecord.
		self relAddObjectRecords: or2.
		^or2.
	] ifFalse: [
		self dberror: 'XContentRecord.relCreateObjectRecords Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XObjectRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relAddContents: cr2
	"Adds a XContentRecord cr2 to 1-N relationship Contents."

	| cr1a |
	( cr2 isKindOf: DocumentDictionary100.Main.XContentRecord ) ifFalse: [
		self dberror: 'XContentRecord:relAddContents: Error ' message: ( cr2 asString ,
			' is not a XContentRecord, and can not be added to Contents for ',
			' this XContentRecord (', self asString, ').' ).
		^nil.
	].
	( (relContents identityIndexOf: cr2) > 0 ) ifTrue: [
		self dberror: 'XContentRecord:relAddContents: Error ' message: 
			'XContentRecord (', cr2 asString , ') is already added to this XContentRecord (', self asString, ').'.
		^nil.
	].
	( cr1a := cr2 relGetContentContainer ) ifNotNil: [ 
		self dberror: 'XContentRecord:relAddContents: Error ' message: 
			'XContentRecord (', cr2 asString , ') is already added to another XContentRecord (', cr1a asString , ').'.
		^nil.
	]. 
	relContents add: cr2.
	cr2 relPrivateSetContentContainer: self.
	^cr2!

relAddObjectRecords: or2
	"Adds a XObjectRecord or2 to 1-N relationship ObjectRecords."

	| cr1a |
	( or2 isKindOf: DocumentDictionary100.Main.XObjectRecord ) ifFalse: [
		self dberror: 'XContentRecord:relAddObjectRecords: Error ' message: ( or2 asString ,
			' is not a XObjectRecord, and can not be added to ObjectRecords for ',
			' this XContentRecord (', self asString, ').' ).
		^nil.
	].
	( (relObjectRecords identityIndexOf: or2) > 0 ) ifTrue: [
		self dberror: 'XContentRecord:relAddObjectRecords: Error ' message: 
			'XObjectRecord (', or2 asString , ') is already added to this XContentRecord (', self asString, ').'.
		^nil.
	].
	( cr1a := or2 relGetContentRecord ) ifNotNil: [ 
		self dberror: 'XContentRecord:relAddObjectRecords: Error ' message: 
			'XObjectRecord (', or2 asString , ') is already added to another XContentRecord (', cr1a asString , ').'.
		^nil.
	]. 
	relObjectRecords add: or2.
	or2 relPrivateSetContentRecord: self.
	^or2!

relGetContents
	"Return the first XContentRecord object on the other side of the 1-N relations1 contents."
	"Provides compatibility with 1-1 relationships."

	( relContents size = 0 ) ifTrue: [ ^nil ].
	^relContents first!

relGetObjectRecords
	"Return the first XObjectRecord object on the other side of the 1-N relations1 objectRecords."
	"Provides compatibility with 1-1 relationships."

	( relObjectRecords size = 0 ) ifTrue: [ ^nil ].
	^relObjectRecords first!

relSetContents: cr2
	"Force set other end of 1-N relationship to one XContentRecord cr2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| cr1a |
	cr2 ifNil: [
		self relRemoveAllContents.
		^nil.
	].
	( cr2 isKindOf: DocumentDictionary100.Main.XContentRecord ) ifFalse: [
		self dberror: 'XContentRecord:relSetContents: Error ' message: ( cr2 asString ,
			' is not a XContentRecord, and can not be added to' ,
			' this XContentRecord (', self asString, ').' ).
		^nil.
	].
	(( ( relContents identityIndexOf: cr2 ) > 0 ) and: [ relContents size = 1 ]) ifTrue: [
		"XContentRecord cr2 is already added to this XContentRecord, and it is the only one."
		^nil.
	].
	( relContents size > 0 ) ifTrue: [
		self relRemoveAllContents.
	].

	( cr1a := cr2 relGetContentContainer ) ifNotNil: [ 
		cr2 relRemoveAllContentContainer
	]. 
	relContents add: cr2.
	cr2 relPrivateSetContentContainer: self.
	^cr2!

relSetObjectRecords: or2
	"Force set other end of 1-N relationship to one XObjectRecord or2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| cr1a |
	or2 ifNil: [
		self relDeleteAllObjectRecords.
		^nil.
	].
	( or2 isKindOf: DocumentDictionary100.Main.XObjectRecord ) ifFalse: [
		self dberror: 'XContentRecord:relSetObjectRecords: Error ' message: ( or2 asString ,
			' is not a XObjectRecord, and can not be added to' ,
			' this XContentRecord (', self asString, ').' ).
		^nil.
	].
	(( ( relObjectRecords identityIndexOf: or2 ) > 0 ) and: [ relObjectRecords size = 1 ]) ifTrue: [
		"XObjectRecord or2 is already added to this XContentRecord, and it is the only one."
		^nil.
	].
	( relObjectRecords size > 0 ) ifTrue: [
		self relDeleteAllObjectRecords.
	].

	( cr1a := or2 relGetContentRecord ) ifNotNil: [ 
		or2 relRemoveAllContentRecord
	]. 
	relObjectRecords add: or2.
	or2 relPrivateSetContentRecord: self.
	^or2!

relRemoveContents: cr2
	"Removes a XContentRecord cr2 from 1-N relationship1 Contents."

	| cr1 index |
	( cr2 isKindOf: DocumentDictionary100.Main.XContentRecord ) ifFalse: [
		self dberror: 'XContentRecord:relRemoveContents: Error ' message: ( cr2 asString ,
			' is not a XContentRecord, and can not possibly be removed from Contents on' ,
			' this XContentRecord (', self asString, ').' ).
		^nil.
	].
	( ( cr1 := cr2 relGetContentContainer ) == self ) ifFalse:[
		self dberror: 'XContentRecord:relRemoveContents Error ' message: 
			'XContentRecord (', cr2 asString , ') is added to XContentRecord (', cr1 asString, ') ',
			'instead of this XContentRecord (', self asString , ').'.
		^nil.
	].
	index := relContents identityIndexOf: cr2.
	(index = 0) ifTrue: [
		self dberror: 'XContentRecord:relRemoveContents Error ' message: 
			'XContentRecord (', cr2 asString , ') can not be found in Contents of this XContentRecord(', self asString , ').'.
		^nil.
	]. 
	relContents removeAtIndex: index.
	cr2 relPrivateSetContentContainer: nil.
	^cr2.!

relRemoveObjectRecords: or2
	"Removes a XObjectRecord or2 from 1-N relationship1 ObjectRecords."

	| cr1 index |
	( or2 isKindOf: DocumentDictionary100.Main.XObjectRecord ) ifFalse: [
		self dberror: 'XContentRecord:relRemoveObjectRecords: Error ' message: ( or2 asString ,
			' is not a XObjectRecord, and can not possibly be removed from ObjectRecords on' ,
			' this XContentRecord (', self asString, ').' ).
		^nil.
	].
	( ( cr1 := or2 relGetContentRecord ) == self ) ifFalse:[
		self dberror: 'XContentRecord:relRemoveObjectRecords Error ' message: 
			'XObjectRecord (', or2 asString , ') is added to XContentRecord (', cr1 asString, ') ',
			'instead of this XContentRecord (', self asString , ').'.
		^nil.
	].
	index := relObjectRecords identityIndexOf: or2.
	(index = 0) ifTrue: [
		self dberror: 'XContentRecord:relRemoveObjectRecords Error ' message: 
			'XObjectRecord (', or2 asString , ') can not be found in ObjectRecords of this XContentRecord(', self asString , ').'.
		^nil.
	]. 
	relObjectRecords removeAtIndex: index.
	or2 relPrivateSetContentRecord: nil.
	^or2.!

relRemoveAllContents 
	"Remove all XContentRecord instances from 1-N relationship1 Contents and return them in a collection."

	| cr2Coll |
	( cr2Coll := relContents copy ) do: [:cr2 |
		self relRemoveContents: cr2
	].
	^cr2Coll.!

relRemoveAllObjectRecords 
	"Remove all XObjectRecord instances from 1-N relationship1 ObjectRecords and return them in a collection."

	| or2Coll |
	( or2Coll := relObjectRecords copy ) do: [:or2 |
		self relRemoveObjectRecords: or2
	].
	^or2Coll.!

relDeleteContents: cr2
	"Remove a XContentRecord cr2 from 1-1 relationship1 Contents and delete it."
	"Return true if operation succeded else return false."

	| cr1 index |
	( cr2 isKindOf: DocumentDictionary100.Main.XContentRecord ) ifFalse: [
		self dberror: 'XContentRecord:relDeleteContents: Error ' message: ( cr2 asString ,
			' is not a XContentRecord, and can not possibly be deleted from Contents on' ,
			' this XContentRecord (', self asString, ').' ).
		^false.
	].
	(( cr1 := cr2 relGetContentContainer ) = self ) ifFalse:[
		self dberror: 'XContentRecord:relDeleteContents Error ' message: 
			'XContentRecord (', cr2 asString , ') is added to XContentRecord (', cr1 asString, ') ',
			'instead of this XContentRecord (', self asString , ').'.
		^false.
	].
	index := relContents identityIndexOf: cr2.
	(index = 0) ifTrue: [
		self dberror: 'XContentRecord:relDeleteContents Error ' message: 
			'XContentRecord (', cr2 asString , ') can not be found in Contents of this XContentRecord(', self asString , ').'.
		^false.
	]. 
	relContents removeAtIndex: index.
	cr2 relPrivateSetContentContainer: nil.
	cr2 delete.
	^true.!

relDeleteObjectRecords: or2
	"Remove a XObjectRecord or2 from 1-1 relationship1 ObjectRecords and delete it."
	"Return true if operation succeded else return false."

	| cr1 index |
	( or2 isKindOf: DocumentDictionary100.Main.XObjectRecord ) ifFalse: [
		self dberror: 'XContentRecord:relDeleteObjectRecords: Error ' message: ( or2 asString ,
			' is not a XObjectRecord, and can not possibly be deleted from ObjectRecords on' ,
			' this XContentRecord (', self asString, ').' ).
		^false.
	].
	(( cr1 := or2 relGetContentRecord ) = self ) ifFalse:[
		self dberror: 'XContentRecord:relDeleteObjectRecords Error ' message: 
			'XObjectRecord (', or2 asString , ') is added to XContentRecord (', cr1 asString, ') ',
			'instead of this XContentRecord (', self asString , ').'.
		^false.
	].
	index := relObjectRecords identityIndexOf: or2.
	(index = 0) ifTrue: [
		self dberror: 'XContentRecord:relDeleteObjectRecords Error ' message: 
			'XObjectRecord (', or2 asString , ') can not be found in ObjectRecords of this XContentRecord(', self asString , ').'.
		^false.
	]. 
	relObjectRecords removeAtIndex: index.
	or2 relPrivateSetContentRecord: nil.
	or2 delete.
	^true.!

relDeleteAllContents 
	"Delete all XContentRecord from 1-N relationship1 Contents, and return the count of deleted objects."

	| cr2Size cr2Coll |
	cr2Size := relContents size.
	cr2Coll := relContents.
	self relInitContents.
	cr2Coll do: [:cr2 |
		cr2 relPrivateSetContentContainer: nil.
		cr2 delete.
	].
	^cr2Size.!

relDeleteAllObjectRecords 
	"Delete all XObjectRecord from 1-N relationship1 ObjectRecords, and return the count of deleted objects."

	| or2Size or2Coll |
	or2Size := relObjectRecords size.
	or2Coll := relObjectRecords.
	self relInitObjectRecords.
	or2Coll do: [:or2 |
		or2 relPrivateSetContentRecord: nil.
		or2 delete.
	].
	^or2Size.!

relInitContents
	"Initialize collection of 1-N relationship1 Contents"

	relContents := OrderedCollection new!

relInitObjectRecords
	"Initialize collection of 1-N relationship1 ObjectRecords"

	relObjectRecords := OrderedCollection new!

relAllContentContainer
	"Return collection of 1-N relationship contentContainer"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relContentContainer ifNil: [ ^coll ].
	coll add: relContentContainer.
	^coll.!

relAllDocumentRecord
	"Return collection of 1-N relationship documentRecord"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relDocumentRecord ifNil: [ ^coll ].
	coll add: relDocumentRecord.
	^coll.!

relSizeContentContainer
	"Return the integer size of the collection returned by relAllContentContainer"
	"Keeps compatibility with 1-N relationships"

	^relContentContainer ifNil: [ 0 ] ifNotNil: [ 1 ].!

relSizeDocumentRecord
	"Return the integer size of the collection returned by relAllDocumentRecord"
	"Keeps compatibility with 1-N relationships"

	^relDocumentRecord ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasContentContainer
	"Return true if the 1-N relations2 contentContainer holds an object, else return false."

	^relContentContainer notNil.!

relHasDocumentRecord
	"Return true if the 1-N relations2 documentRecord holds an object, else return false."

	^relDocumentRecord notNil.!

relCreateContentContainer
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XContentRecord to 1-N relationship ContentContainer."

	| cr1a cr1 |
	( cr1a := self relGetContentContainer ) ifNotNil: [
		self dberror: 'XContentRecord:relCreateContentContainer: Error ' message: 
			'XContentRecord (', self  asString , ') already has a XContentRecord (', cr1a asString, ') in 1-N relation ContentContainer.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XContentRecord) ifTrue: [
		cr1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XContentRecord.
		cr1 relAddContents: self.
		"cr1 addDefaultOwner."
		^cr1.
	] ifFalse: [
		self dberror: 'XContentRecord.relCreateContentContainer Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XContentRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateDocumentRecord
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XDocumentRecord to 1-N relationship DocumentRecord."

	| dr1a dr1 |
	( dr1a := self relGetDocumentRecord ) ifNotNil: [
		self dberror: 'XDocumentRecord:relCreateDocumentRecord: Error ' message: 
			'XDocumentRecord (', self  asString , ') already has a XDocumentRecord (', dr1a asString, ') in 1-N relation DocumentRecord.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentRecord) ifTrue: [
		dr1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentRecord.
		dr1 relAddContentRecords: self.
		"dr1 addDefaultOwner."
		^dr1.
	] ifFalse: [
		self dberror: 'XContentRecord.relCreateDocumentRecord Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetContentContainer
	"Return the XContentRecord object on the other side of the 1-N relationship2 contentContainer."

	^relContentContainer!

relGetDocumentRecord
	"Return the XDocumentRecord object on the other side of the 1-N relationship2 documentRecord."

	^relDocumentRecord!

relSetContentContainer: cr1
	"Set other end of 1-1 relations2 ContentContainer"

	cr1 ifNotNil: [
		( cr1 isKindOf: DocumentDictionary100.Main.XContentRecord ) ifFalse: [
			self dberror: 'XContentRecord:relSetContentContainer: Error ' message: ( cr1 asString ,
				' is not a XContentRecord, and can not be set to' ,
				' this XContentRecord (', self asString, ') relation2 ContentContainer.' ).
			^nil.
		]
	].

	self relHasContentContainer ifTrue: [ 
		"Special treatment needed if NOT_FOUND.mustExist1 == true or mustExist2 == true. "
		self relRemoveAllContentContainer. 
	].
	cr1 ifNotNil: [ cr1 relAddContents: self. ].
	^cr1!

relRemoveContentContainer: cr1
	"Removes a XContentRecord cr1 from 1-N relationship2 ContentContainer."

	cr1 ifNil: [
		self dberror: 'XContentRecord:relRemoveContentContainer: Error ' message: ( 'wrong class of parameter cr1, ',
			' nil is not a XContentRecord, and can not be removed from' ,
			' this XContentRecord (', self asString, ') relation2 ContentContainer.' ).
		^nil.
	].

	cr1 ifNotNil: [
		( cr1 isKindOf: DocumentDictionary100.Main.XContentRecord ) ifFalse: [
			self dberror: 'XContentRecord:relRemoveContentContainer: Error ' message: ( cr1 asString ,
				' is not a XContentRecord, and can not be removed from' ,
				' this XContentRecord (', self asString, ') relation2 ContentContainer.' ).
			^nil.
		]
	].

	cr1 ifNotNil: [ cr1 relRemoveContents: self. ].
	^cr1!

relRemoveDocumentRecord: dr1
	"Removes a XDocumentRecord dr1 from 1-N relationship2 DocumentRecord."

	dr1 ifNil: [
		self dberror: 'XContentRecord:relRemoveDocumentRecord: Error ' message: ( 'wrong class of parameter dr1, ',
			' nil is not a XDocumentRecord, and can not be removed from' ,
			' this XContentRecord (', self asString, ') relation2 DocumentRecord.' ).
		^nil.
	].

	dr1 ifNotNil: [
		( dr1 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
			self dberror: 'XContentRecord:relRemoveDocumentRecord: Error ' message: ( dr1 asString ,
				' is not a XDocumentRecord, and can not be removed from' ,
				' this XContentRecord (', self asString, ') relation2 DocumentRecord.' ).
			^nil.
		]
	].

	dr1 ifNotNil: [ dr1 relRemoveContentRecords: self. ].
	^dr1!

relRemoveAllContentContainer
	"Remove a XContentRecord from 1-N relationship2 ContentContainer if there is one."
	"Available for API completeness reasons."

	(self relAllContentContainer) do: [:cr1 | self relRemoveContentContainer: cr1].!

relDeleteNOT_FOUND: cr1
	"Deletes a DocumentDictionary100.Main.XContentRecord cr1 from 1-N relationship2 ContentContainer."

	cr1 ifNil: [
		self dberror: 'XContentRecord:relDeleteContentContainer: Error ' message: ( 'wrong class of parameter cr1, ',
			' nil is not a XContentRecord, and can not be deleted from' ,
			' this XContentRecord (', self asString, ') relation2 ContentContainer.' ).
		^nil.
	].

	cr1 ifNotNil: [
		( cr1 isKindOf: DocumentDictionary100.Main.XContentRecord ) ifFalse: [
			self dberror: 'XContentRecord:relDeleteContentContainer: Error ' message: ( cr1 asString ,
				' is not a XContentRecord, and can not be deleted from' ,
				' this XContentRecord (', self asString, ') relation2 ContentContainer.' ).
			^nil.
		]
	].

	cr1 ifNotNil: [ cr1 relRemoveContents: self. ].
	cr1 delete!

relDeleteAllContentContainer
	"Deletes a XContentRecord from 1-N relationship2 ContentContainer if there is one."
	"Available for API completeness reasons."

	(self relAllContentContainer) do: [:cr1 | self relDeleteContentContainer: cr1].!

relInitContentContainer
	"Initialize pointer of 1-N relationship1 ContentContainer "

	relContentContainer := nil!

relInitDocumentRecord
	"Initialize pointer of 1-N relationship1 DocumentRecord "

	relDocumentRecord := nil!

 !

!DocumentDictionary100.Main.XContentRecord methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetContentContainer: cr1
	"Set other end of 1-N relationship1 Contents"

	"cr1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying cr1.
	]."

  "( cr1 isKindOf: NOT_FOUND.XContentRecord ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relContentContainer == cr1 ) ifFalse: [
		relContentContainer := cr1.
		cr1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying cr1."
	  ].
	  self changed: #relContentContainer.
	].
	^relContentContainer!

relPrivateSetDocumentRecord: dr1
	"Set other end of 1-N relationship1 ContentRecords"

	"dr1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying dr1.
	]."

  "( dr1 isKindOf: NOT_FOUND.XDocumentRecord ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relDocumentRecord == dr1 ) ifFalse: [
		relDocumentRecord := dr1.
		dr1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying dr1."
	  ].
	  self changed: #relDocumentRecord.
	].
	^relDocumentRecord!

 !

!DocumentDictionary100.Main.XContentRecord methodsFor: 'converting'!

 !

!DocumentDictionary100.Main.XContentRecord methodsFor: 'testing'!

classPrefix
	"Return 'cr' which is a unique prefix for class ContentRecord within the application."

	^'cr'!

 !

