"XDocumentDictionary_AutoAPI.st Generated at 2018-09-22 00:03:11.817."
'Class AutoAPI file for Class DocumentDictionary.'!

!DocumentDictionary100.Main.XDocumentDictionary class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XDocumentDictionary in the DomainModel DocumentDictionary100f"

	^'Root object providing an entry point for the document reference collection.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XDocumentDictionary'.!

 !

!DocumentDictionary100.Main.XDocumentDictionary methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XDocumentDictionary in the DomainModel DocumentDictionary100f."

	^'Root object providing an entry point for the document reference collection.'.!

initialize
	"initialize attributes and relationships"

	super initialize.

	self relInitAuthorRecords.
	self relInitCategories.
	self relInitDocumentRecords.
	self relInitLogRecords.


	
!
canDelete
	"Return true if this DocumentDictionary can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XDocumentDictionary if there is one, else return nil."


	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."

	self relDeleteAllAuthorRecords.
	self relDeleteAllCategories.
	self relDeleteAllDocumentRecords.
	self relDeleteAllLogRecords.




	super delete!

 !

!DocumentDictionary100.Main.XDocumentDictionary methodsFor: 'attributeAPI'!

 !

!DocumentDictionary100.Main.XDocumentDictionary methodsFor: 'relationshipAPI'!

relAllAuthorRecords
	"Return collection of all authorRecords"

	^relAuthorRecords copy.!

relAllCategories
	"Return collection of all categories"

	^relCategories copy.!

relAllDocumentRecords
	"Return collection of all documentRecords"

	^relDocumentRecords copy.!

relAllLogRecords
	"Return collection of all logRecords"

	^relLogRecords copy.!

relSizeAuthorRecords
	"Return the integer size of the collection returned by relAllAuthorRecords"

	^relAuthorRecords size!

relSizeCategories
	"Return the integer size of the collection returned by relAllCategories"

	^relCategories size!

relSizeDocumentRecords
	"Return the integer size of the collection returned by relAllDocumentRecords"

	^relDocumentRecords size!

relSizeLogRecords
	"Return the integer size of the collection returned by relAllLogRecords"

	^relLogRecords size!

relHasAuthorRecords
	"Return true if the 1-N relationship1 authorRecords holds at least one object, else return false."

	^relAuthorRecords size > 0!

relHasCategories
	"Return true if the 1-N relationship1 categories holds at least one object, else return false."

	^relCategories size > 0!

relHasDocumentRecords
	"Return true if the 1-N relationship1 documentRecords holds at least one object, else return false."

	^relDocumentRecords size > 0!

relHasLogRecords
	"Return true if the 1-N relationship1 logRecords holds at least one object, else return false."

	^relLogRecords size > 0!

relCreateAuthorRecords
	"Creates and adds a new XAuthorRecord to 1-N relationship AuthorRecords."

	| au2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XAuthorRecord) ifTrue: [
		au2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XAuthorRecord.
		self relAddAuthorRecords: au2.
		^au2.
	] ifFalse: [
		self dberror: 'XDocumentDictionary.relCreateAuthorRecords Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XAuthorRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateCategories
	"Creates and adds a new XCategory to 1-N relationship Categories."

	| caco2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XCategory) ifTrue: [
		caco2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XCategory.
		self relAddCategories: caco2.
		^caco2.
	] ifFalse: [
		self dberror: 'XDocumentDictionary.relCreateCategories Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XCategory. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateDocumentRecords
	"Creates and adds a new XDocumentRecord to 1-N relationship DocumentRecords."

	| dr2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentRecord) ifTrue: [
		dr2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentRecord.
		self relAddDocumentRecords: dr2.
		^dr2.
	] ifFalse: [
		self dberror: 'XDocumentDictionary.relCreateDocumentRecords Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateLogRecords
	"Creates and adds a new XDocumentDictionaryLogRecord to 1-N relationship LogRecords."

	| ddl2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentDictionaryLogRecord) ifTrue: [
		ddl2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentDictionaryLogRecord.
		self relAddLogRecords: ddl2.
		^ddl2.
	] ifFalse: [
		self dberror: 'XDocumentDictionary.relCreateLogRecords Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentDictionaryLogRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relAddAuthorRecords: au2
	"Adds a XAuthorRecord au2 to 1-N relationship AuthorRecords."

	| dd1a |
	( au2 isKindOf: DocumentDictionary100.Main.XAuthorRecord ) ifFalse: [
		self dberror: 'XDocumentDictionary:relAddAuthorRecords: Error ' message: ( au2 asString ,
			' is not a XAuthorRecord, and can not be added to AuthorRecords for ',
			' this XDocumentDictionary (', self asString, ').' ).
		^nil.
	].
	( (relAuthorRecords identityIndexOf: au2) > 0 ) ifTrue: [
		self dberror: 'XDocumentDictionary:relAddAuthorRecords: Error ' message: 
			'XAuthorRecord (', au2 asString , ') is already added to this XDocumentDictionary (', self asString, ').'.
		^nil.
	].
	( dd1a := au2 relGetDocumentDictionary ) ifNotNil: [ 
		self dberror: 'XDocumentDictionary:relAddAuthorRecords: Error ' message: 
			'XAuthorRecord (', au2 asString , ') is already added to another XDocumentDictionary (', dd1a asString , ').'.
		^nil.
	]. 
	relAuthorRecords add: au2.
	au2 relPrivateSetDocumentDictionary: self.
	^au2!

relAddCategories: caco2
	"Adds a XCategory caco2 to 1-N relationship Categories."

	| dd1a |
	( caco2 isKindOf: DocumentDictionary100.Main.XCategory ) ifFalse: [
		self dberror: 'XDocumentDictionary:relAddCategories: Error ' message: ( caco2 asString ,
			' is not a XCategory, and can not be added to Categories for ',
			' this XDocumentDictionary (', self asString, ').' ).
		^nil.
	].
	( (relCategories identityIndexOf: caco2) > 0 ) ifTrue: [
		self dberror: 'XDocumentDictionary:relAddCategories: Error ' message: 
			'XCategory (', caco2 asString , ') is already added to this XDocumentDictionary (', self asString, ').'.
		^nil.
	].
	( dd1a := caco2 relGetDocumentDictionary ) ifNotNil: [ 
		self dberror: 'XDocumentDictionary:relAddCategories: Error ' message: 
			'XCategory (', caco2 asString , ') is already added to another XDocumentDictionary (', dd1a asString , ').'.
		^nil.
	]. 
	relCategories add: caco2.
	caco2 relPrivateSetDocumentDictionary: self.
	^caco2!

relAddDocumentRecords: dr2
	"Adds a XDocumentRecord dr2 to 1-N relationship DocumentRecords."

	| dd1a |
	( dr2 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
		self dberror: 'XDocumentDictionary:relAddDocumentRecords: Error ' message: ( dr2 asString ,
			' is not a XDocumentRecord, and can not be added to DocumentRecords for ',
			' this XDocumentDictionary (', self asString, ').' ).
		^nil.
	].
	( (relDocumentRecords identityIndexOf: dr2) > 0 ) ifTrue: [
		self dberror: 'XDocumentDictionary:relAddDocumentRecords: Error ' message: 
			'XDocumentRecord (', dr2 asString , ') is already added to this XDocumentDictionary (', self asString, ').'.
		^nil.
	].
	( dd1a := dr2 relGetDocumentDictionary ) ifNotNil: [ 
		self dberror: 'XDocumentDictionary:relAddDocumentRecords: Error ' message: 
			'XDocumentRecord (', dr2 asString , ') is already added to another XDocumentDictionary (', dd1a asString , ').'.
		^nil.
	]. 
	relDocumentRecords add: dr2.
	dr2 relPrivateSetDocumentDictionary: self.
	^dr2!

relAddLogRecords: ddl2
	"Adds a XDocumentDictionaryLogRecord ddl2 to 1-N relationship LogRecords."

	| dd1a |
	( ddl2 isKindOf: DocumentDictionary100.Main.XDocumentDictionaryLogRecord ) ifFalse: [
		self dberror: 'XDocumentDictionary:relAddLogRecords: Error ' message: ( ddl2 asString ,
			' is not a XDocumentDictionaryLogRecord, and can not be added to LogRecords for ',
			' this XDocumentDictionary (', self asString, ').' ).
		^nil.
	].
	( (relLogRecords identityIndexOf: ddl2) > 0 ) ifTrue: [
		self dberror: 'XDocumentDictionary:relAddLogRecords: Error ' message: 
			'XDocumentDictionaryLogRecord (', ddl2 asString , ') is already added to this XDocumentDictionary (', self asString, ').'.
		^nil.
	].
	( dd1a := ddl2 relGetLogOwner ) ifNotNil: [ 
		self dberror: 'XDocumentDictionary:relAddLogRecords: Error ' message: 
			'XDocumentDictionaryLogRecord (', ddl2 asString , ') is already added to another XDocumentDictionary (', dd1a asString , ').'.
		^nil.
	]. 
	relLogRecords add: ddl2.
	ddl2 relPrivateSetLogOwner: self.
	^ddl2!

relGetAuthorRecords
	"Return the first XAuthorRecord object on the other side of the 1-N relations1 authorRecords."
	"Provides compatibility with 1-1 relationships."

	( relAuthorRecords size = 0 ) ifTrue: [ ^nil ].
	^relAuthorRecords first!

relGetCategories
	"Return the first XCategory object on the other side of the 1-N relations1 categories."
	"Provides compatibility with 1-1 relationships."

	( relCategories size = 0 ) ifTrue: [ ^nil ].
	^relCategories first!

relGetDocumentRecords
	"Return the first XDocumentRecord object on the other side of the 1-N relations1 documentRecords."
	"Provides compatibility with 1-1 relationships."

	( relDocumentRecords size = 0 ) ifTrue: [ ^nil ].
	^relDocumentRecords first!

relGetLogRecords
	"Return the first XDocumentDictionaryLogRecord object on the other side of the 1-N relations1 logRecords."
	"Provides compatibility with 1-1 relationships."

	( relLogRecords size = 0 ) ifTrue: [ ^nil ].
	^relLogRecords first!

relSetAuthorRecords: au2
	"Force set other end of 1-N relationship to one XAuthorRecord au2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| dd1a |
	au2 ifNil: [
		self relDeleteAllAuthorRecords.
		^nil.
	].
	( au2 isKindOf: DocumentDictionary100.Main.XAuthorRecord ) ifFalse: [
		self dberror: 'XDocumentDictionary:relSetAuthorRecords: Error ' message: ( au2 asString ,
			' is not a XAuthorRecord, and can not be added to' ,
			' this XDocumentDictionary (', self asString, ').' ).
		^nil.
	].
	(( ( relAuthorRecords identityIndexOf: au2 ) > 0 ) and: [ relAuthorRecords size = 1 ]) ifTrue: [
		"XAuthorRecord au2 is already added to this XDocumentDictionary, and it is the only one."
		^nil.
	].
	( relAuthorRecords size > 0 ) ifTrue: [
		self relDeleteAllAuthorRecords.
	].

	( dd1a := au2 relGetDocumentDictionary ) ifNotNil: [ 
		au2 relRemoveAllDocumentDictionary
	]. 
	relAuthorRecords add: au2.
	au2 relPrivateSetDocumentDictionary: self.
	^au2!

relSetCategories: caco2
	"Force set other end of 1-N relationship to one XCategory caco2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| dd1a |
	caco2 ifNil: [
		self relDeleteAllCategories.
		^nil.
	].
	( caco2 isKindOf: DocumentDictionary100.Main.XCategory ) ifFalse: [
		self dberror: 'XDocumentDictionary:relSetCategories: Error ' message: ( caco2 asString ,
			' is not a XCategory, and can not be added to' ,
			' this XDocumentDictionary (', self asString, ').' ).
		^nil.
	].
	(( ( relCategories identityIndexOf: caco2 ) > 0 ) and: [ relCategories size = 1 ]) ifTrue: [
		"XCategory caco2 is already added to this XDocumentDictionary, and it is the only one."
		^nil.
	].
	( relCategories size > 0 ) ifTrue: [
		self relDeleteAllCategories.
	].

	( dd1a := caco2 relGetDocumentDictionary ) ifNotNil: [ 
		caco2 relRemoveAllDocumentDictionary
	]. 
	relCategories add: caco2.
	caco2 relPrivateSetDocumentDictionary: self.
	^caco2!

relSetDocumentRecords: dr2
	"Force set other end of 1-N relationship to one XDocumentRecord dr2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| dd1a |
	dr2 ifNil: [
		self relDeleteAllDocumentRecords.
		^nil.
	].
	( dr2 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
		self dberror: 'XDocumentDictionary:relSetDocumentRecords: Error ' message: ( dr2 asString ,
			' is not a XDocumentRecord, and can not be added to' ,
			' this XDocumentDictionary (', self asString, ').' ).
		^nil.
	].
	(( ( relDocumentRecords identityIndexOf: dr2 ) > 0 ) and: [ relDocumentRecords size = 1 ]) ifTrue: [
		"XDocumentRecord dr2 is already added to this XDocumentDictionary, and it is the only one."
		^nil.
	].
	( relDocumentRecords size > 0 ) ifTrue: [
		self relDeleteAllDocumentRecords.
	].

	( dd1a := dr2 relGetDocumentDictionary ) ifNotNil: [ 
		dr2 relRemoveAllDocumentDictionary
	]. 
	relDocumentRecords add: dr2.
	dr2 relPrivateSetDocumentDictionary: self.
	^dr2!

relSetLogRecords: ddl2
	"Force set other end of 1-N relationship to one XDocumentDictionaryLogRecord ddl2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| dd1a |
	ddl2 ifNil: [
		self relDeleteAllLogRecords.
		^nil.
	].
	( ddl2 isKindOf: DocumentDictionary100.Main.XDocumentDictionaryLogRecord ) ifFalse: [
		self dberror: 'XDocumentDictionary:relSetLogRecords: Error ' message: ( ddl2 asString ,
			' is not a XDocumentDictionaryLogRecord, and can not be added to' ,
			' this XDocumentDictionary (', self asString, ').' ).
		^nil.
	].
	(( ( relLogRecords identityIndexOf: ddl2 ) > 0 ) and: [ relLogRecords size = 1 ]) ifTrue: [
		"XDocumentDictionaryLogRecord ddl2 is already added to this XDocumentDictionary, and it is the only one."
		^nil.
	].
	( relLogRecords size > 0 ) ifTrue: [
		self relDeleteAllLogRecords.
	].

	( dd1a := ddl2 relGetLogOwner ) ifNotNil: [ 
		ddl2 relRemoveAllLogOwner
	]. 
	relLogRecords add: ddl2.
	ddl2 relPrivateSetLogOwner: self.
	^ddl2!

relRemoveAuthorRecords: au2
	"Removes a XAuthorRecord au2 from 1-N relationship1 AuthorRecords."

	| dd1 index |
	( au2 isKindOf: DocumentDictionary100.Main.XAuthorRecord ) ifFalse: [
		self dberror: 'XDocumentDictionary:relRemoveAuthorRecords: Error ' message: ( au2 asString ,
			' is not a XAuthorRecord, and can not possibly be removed from AuthorRecords on' ,
			' this XDocumentDictionary (', self asString, ').' ).
		^nil.
	].
	( ( dd1 := au2 relGetDocumentDictionary ) == self ) ifFalse:[
		self dberror: 'XDocumentDictionary:relRemoveAuthorRecords Error ' message: 
			'XAuthorRecord (', au2 asString , ') is added to XDocumentDictionary (', dd1 asString, ') ',
			'instead of this XDocumentDictionary (', self asString , ').'.
		^nil.
	].
	index := relAuthorRecords identityIndexOf: au2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentDictionary:relRemoveAuthorRecords Error ' message: 
			'XAuthorRecord (', au2 asString , ') can not be found in AuthorRecords of this XDocumentDictionary(', self asString , ').'.
		^nil.
	]. 
	relAuthorRecords removeAtIndex: index.
	au2 relPrivateSetDocumentDictionary: nil.
	^au2.!

relRemoveCategories: caco2
	"Removes a XCategory caco2 from 1-N relationship1 Categories."

	| dd1 index |
	( caco2 isKindOf: DocumentDictionary100.Main.XCategory ) ifFalse: [
		self dberror: 'XDocumentDictionary:relRemoveCategories: Error ' message: ( caco2 asString ,
			' is not a XCategory, and can not possibly be removed from Categories on' ,
			' this XDocumentDictionary (', self asString, ').' ).
		^nil.
	].
	( ( dd1 := caco2 relGetDocumentDictionary ) == self ) ifFalse:[
		self dberror: 'XDocumentDictionary:relRemoveCategories Error ' message: 
			'XCategory (', caco2 asString , ') is added to XDocumentDictionary (', dd1 asString, ') ',
			'instead of this XDocumentDictionary (', self asString , ').'.
		^nil.
	].
	index := relCategories identityIndexOf: caco2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentDictionary:relRemoveCategories Error ' message: 
			'XCategory (', caco2 asString , ') can not be found in Categories of this XDocumentDictionary(', self asString , ').'.
		^nil.
	]. 
	relCategories removeAtIndex: index.
	caco2 relPrivateSetDocumentDictionary: nil.
	^caco2.!

relRemoveDocumentRecords: dr2
	"Removes a XDocumentRecord dr2 from 1-N relationship1 DocumentRecords."

	| dd1 index |
	( dr2 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
		self dberror: 'XDocumentDictionary:relRemoveDocumentRecords: Error ' message: ( dr2 asString ,
			' is not a XDocumentRecord, and can not possibly be removed from DocumentRecords on' ,
			' this XDocumentDictionary (', self asString, ').' ).
		^nil.
	].
	( ( dd1 := dr2 relGetDocumentDictionary ) == self ) ifFalse:[
		self dberror: 'XDocumentDictionary:relRemoveDocumentRecords Error ' message: 
			'XDocumentRecord (', dr2 asString , ') is added to XDocumentDictionary (', dd1 asString, ') ',
			'instead of this XDocumentDictionary (', self asString , ').'.
		^nil.
	].
	index := relDocumentRecords identityIndexOf: dr2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentDictionary:relRemoveDocumentRecords Error ' message: 
			'XDocumentRecord (', dr2 asString , ') can not be found in DocumentRecords of this XDocumentDictionary(', self asString , ').'.
		^nil.
	]. 
	relDocumentRecords removeAtIndex: index.
	dr2 relPrivateSetDocumentDictionary: nil.
	^dr2.!

relRemoveLogRecords: ddl2
	"Removes a XDocumentDictionaryLogRecord ddl2 from 1-N relationship1 LogRecords."

	| dd1 index |
	( ddl2 isKindOf: DocumentDictionary100.Main.XDocumentDictionaryLogRecord ) ifFalse: [
		self dberror: 'XDocumentDictionary:relRemoveLogRecords: Error ' message: ( ddl2 asString ,
			' is not a XDocumentDictionaryLogRecord, and can not possibly be removed from LogRecords on' ,
			' this XDocumentDictionary (', self asString, ').' ).
		^nil.
	].
	( ( dd1 := ddl2 relGetLogOwner ) == self ) ifFalse:[
		self dberror: 'XDocumentDictionary:relRemoveLogRecords Error ' message: 
			'XDocumentDictionaryLogRecord (', ddl2 asString , ') is added to XDocumentDictionary (', dd1 asString, ') ',
			'instead of this XDocumentDictionary (', self asString , ').'.
		^nil.
	].
	index := relLogRecords identityIndexOf: ddl2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentDictionary:relRemoveLogRecords Error ' message: 
			'XDocumentDictionaryLogRecord (', ddl2 asString , ') can not be found in LogRecords of this XDocumentDictionary(', self asString , ').'.
		^nil.
	]. 
	relLogRecords removeAtIndex: index.
	ddl2 relPrivateSetLogOwner: nil.
	^ddl2.!

relRemoveAllAuthorRecords 
	"Remove all XAuthorRecord instances from 1-N relationship1 AuthorRecords and return them in a collection."

	| au2Coll |
	( au2Coll := relAuthorRecords copy ) do: [:au2 |
		self relRemoveAuthorRecords: au2
	].
	^au2Coll.!

relRemoveAllCategories 
	"Remove all XCategory instances from 1-N relationship1 Categories and return them in a collection."

	| caco2Coll |
	( caco2Coll := relCategories copy ) do: [:caco2 |
		self relRemoveCategories: caco2
	].
	^caco2Coll.!

relRemoveAllDocumentRecords 
	"Remove all XDocumentRecord instances from 1-N relationship1 DocumentRecords and return them in a collection."

	| dr2Coll |
	( dr2Coll := relDocumentRecords copy ) do: [:dr2 |
		self relRemoveDocumentRecords: dr2
	].
	^dr2Coll.!

relRemoveAllLogRecords 
	"Remove all XDocumentDictionaryLogRecord instances from 1-N relationship1 LogRecords and return them in a collection."

	| ddl2Coll |
	( ddl2Coll := relLogRecords copy ) do: [:ddl2 |
		self relRemoveLogRecords: ddl2
	].
	^ddl2Coll.!

relDeleteAuthorRecords: au2
	"Remove a XAuthorRecord au2 from 1-1 relationship1 AuthorRecords and delete it."
	"Return true if operation succeded else return false."

	| dd1 index |
	( au2 isKindOf: DocumentDictionary100.Main.XAuthorRecord ) ifFalse: [
		self dberror: 'XDocumentDictionary:relDeleteAuthorRecords: Error ' message: ( au2 asString ,
			' is not a XAuthorRecord, and can not possibly be deleted from AuthorRecords on' ,
			' this XDocumentDictionary (', self asString, ').' ).
		^false.
	].
	(( dd1 := au2 relGetDocumentDictionary ) = self ) ifFalse:[
		self dberror: 'XDocumentDictionary:relDeleteAuthorRecords Error ' message: 
			'XAuthorRecord (', au2 asString , ') is added to XDocumentDictionary (', dd1 asString, ') ',
			'instead of this XDocumentDictionary (', self asString , ').'.
		^false.
	].
	index := relAuthorRecords identityIndexOf: au2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentDictionary:relDeleteAuthorRecords Error ' message: 
			'XAuthorRecord (', au2 asString , ') can not be found in AuthorRecords of this XDocumentDictionary(', self asString , ').'.
		^false.
	]. 
	relAuthorRecords removeAtIndex: index.
	au2 relPrivateSetDocumentDictionary: nil.
	au2 delete.
	^true.!

relDeleteCategories: caco2
	"Remove a XCategory caco2 from 1-1 relationship1 Categories and delete it."
	"Return true if operation succeded else return false."

	| dd1 index |
	( caco2 isKindOf: DocumentDictionary100.Main.XCategory ) ifFalse: [
		self dberror: 'XDocumentDictionary:relDeleteCategories: Error ' message: ( caco2 asString ,
			' is not a XCategory, and can not possibly be deleted from Categories on' ,
			' this XDocumentDictionary (', self asString, ').' ).
		^false.
	].
	(( dd1 := caco2 relGetDocumentDictionary ) = self ) ifFalse:[
		self dberror: 'XDocumentDictionary:relDeleteCategories Error ' message: 
			'XCategory (', caco2 asString , ') is added to XDocumentDictionary (', dd1 asString, ') ',
			'instead of this XDocumentDictionary (', self asString , ').'.
		^false.
	].
	index := relCategories identityIndexOf: caco2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentDictionary:relDeleteCategories Error ' message: 
			'XCategory (', caco2 asString , ') can not be found in Categories of this XDocumentDictionary(', self asString , ').'.
		^false.
	]. 
	relCategories removeAtIndex: index.
	caco2 relPrivateSetDocumentDictionary: nil.
	caco2 delete.
	^true.!

relDeleteDocumentRecords: dr2
	"Remove a XDocumentRecord dr2 from 1-1 relationship1 DocumentRecords and delete it."
	"Return true if operation succeded else return false."

	| dd1 index |
	( dr2 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
		self dberror: 'XDocumentDictionary:relDeleteDocumentRecords: Error ' message: ( dr2 asString ,
			' is not a XDocumentRecord, and can not possibly be deleted from DocumentRecords on' ,
			' this XDocumentDictionary (', self asString, ').' ).
		^false.
	].
	(( dd1 := dr2 relGetDocumentDictionary ) = self ) ifFalse:[
		self dberror: 'XDocumentDictionary:relDeleteDocumentRecords Error ' message: 
			'XDocumentRecord (', dr2 asString , ') is added to XDocumentDictionary (', dd1 asString, ') ',
			'instead of this XDocumentDictionary (', self asString , ').'.
		^false.
	].
	index := relDocumentRecords identityIndexOf: dr2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentDictionary:relDeleteDocumentRecords Error ' message: 
			'XDocumentRecord (', dr2 asString , ') can not be found in DocumentRecords of this XDocumentDictionary(', self asString , ').'.
		^false.
	]. 
	relDocumentRecords removeAtIndex: index.
	dr2 relPrivateSetDocumentDictionary: nil.
	dr2 delete.
	^true.!

relDeleteLogRecords: ddl2
	"Remove a XDocumentDictionaryLogRecord ddl2 from 1-1 relationship1 LogRecords and delete it."
	"Return true if operation succeded else return false."

	| dd1 index |
	( ddl2 isKindOf: DocumentDictionary100.Main.XDocumentDictionaryLogRecord ) ifFalse: [
		self dberror: 'XDocumentDictionary:relDeleteLogRecords: Error ' message: ( ddl2 asString ,
			' is not a XDocumentDictionaryLogRecord, and can not possibly be deleted from LogRecords on' ,
			' this XDocumentDictionary (', self asString, ').' ).
		^false.
	].
	(( dd1 := ddl2 relGetLogOwner ) = self ) ifFalse:[
		self dberror: 'XDocumentDictionary:relDeleteLogRecords Error ' message: 
			'XDocumentDictionaryLogRecord (', ddl2 asString , ') is added to XDocumentDictionary (', dd1 asString, ') ',
			'instead of this XDocumentDictionary (', self asString , ').'.
		^false.
	].
	index := relLogRecords identityIndexOf: ddl2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentDictionary:relDeleteLogRecords Error ' message: 
			'XDocumentDictionaryLogRecord (', ddl2 asString , ') can not be found in LogRecords of this XDocumentDictionary(', self asString , ').'.
		^false.
	]. 
	relLogRecords removeAtIndex: index.
	ddl2 relPrivateSetLogOwner: nil.
	ddl2 delete.
	^true.!

relDeleteAllAuthorRecords 
	"Delete all XAuthorRecord from 1-N relationship1 AuthorRecords, and return the count of deleted objects."

	| au2Size au2Coll |
	au2Size := relAuthorRecords size.
	au2Coll := relAuthorRecords.
	self relInitAuthorRecords.
	au2Coll do: [:au2 |
		au2 relPrivateSetDocumentDictionary: nil.
		au2 delete.
	].
	^au2Size.!

relDeleteAllCategories 
	"Delete all XCategory from 1-N relationship1 Categories, and return the count of deleted objects."

	| caco2Size caco2Coll |
	caco2Size := relCategories size.
	caco2Coll := relCategories.
	self relInitCategories.
	caco2Coll do: [:caco2 |
		caco2 relPrivateSetDocumentDictionary: nil.
		caco2 delete.
	].
	^caco2Size.!

relDeleteAllDocumentRecords 
	"Delete all XDocumentRecord from 1-N relationship1 DocumentRecords, and return the count of deleted objects."

	| dr2Size dr2Coll |
	dr2Size := relDocumentRecords size.
	dr2Coll := relDocumentRecords.
	self relInitDocumentRecords.
	dr2Coll do: [:dr2 |
		dr2 relPrivateSetDocumentDictionary: nil.
		dr2 delete.
	].
	^dr2Size.!

relDeleteAllLogRecords 
	"Delete all XDocumentDictionaryLogRecord from 1-N relationship1 LogRecords, and return the count of deleted objects."

	| ddl2Size ddl2Coll |
	ddl2Size := relLogRecords size.
	ddl2Coll := relLogRecords.
	self relInitLogRecords.
	ddl2Coll do: [:ddl2 |
		ddl2 relPrivateSetLogOwner: nil.
		ddl2 delete.
	].
	^ddl2Size.!

relInitAuthorRecords
	"Initialize collection of 1-N relationship1 AuthorRecords"

	relAuthorRecords := OrderedCollection new!

relInitCategories
	"Initialize collection of 1-N relationship1 Categories"

	relCategories := OrderedCollection new!

relInitDocumentRecords
	"Initialize collection of 1-N relationship1 DocumentRecords"

	relDocumentRecords := OrderedCollection new!

relInitLogRecords
	"Initialize collection of 1-N relationship1 LogRecords"

	relLogRecords := OrderedCollection new!

 !

!DocumentDictionary100.Main.XDocumentDictionary methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

 !

!DocumentDictionary100.Main.XDocumentDictionary methodsFor: 'converting'!

 !

!DocumentDictionary100.Main.XDocumentDictionary methodsFor: 'testing'!

classPrefix
	"Return 'dd' which is a unique prefix for class DocumentDictionary within the application."

	^'dd'!

 !

