"XDocumentRecord_AutoAPI.st Generated at 2018-09-22 00:03:44.565."
'Class AutoAPI file for Class DocumentRecord.'!

!DocumentDictionary100.Main.XDocumentRecord class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XDocumentRecord in the DomainModel DocumentDictionary100f"

	^'A record of a document of a particular document type, that serves a purpose in a reference list or for study effort calculations.
ModelElement.Definition can be used for the abstract of the document.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XDocumentRecord'.!

 !

!DocumentDictionary100.Main.XDocumentRecord methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XDocumentRecord in the DomainModel DocumentDictionary100f."

	^'A record of a document of a particular document type, that serves a purpose in a reference list or for study effort calculations.
ModelElement.Definition can be used for the abstract of the document.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitAuthors.
	self attInitBooktitle.
	self attInitCdrom.
	self attInitCrossref.
	self attInitEditors.
	self attInitEndPage.
	self attInitIsbn.
	self attInitJournal.
	self attInitModificationDate.
	self attInitMonth.
	self attInitNumber.
	self attInitPageCount.
	self attInitPages.
	self attInitPublicationType.
	self attInitPublisher.
	self attInitRating.
	self attInitRecordType.
	self attInitReviewid.
	self attInitSchool.
	self attInitSeries.
	self attInitSourcekey.
	self attInitStartPage.
	self attInitTableOfContentsUrl.
	self attInitTitle.
	self attInitVolume.
	self attInitYear.

	self relInitAuthorDocuments.
	self relInitCitedBy.
	self relInitCites.
	self relInitContentRecords.
	self relInitCrossrefs.
	self relInitElectronicEditions.
	self relInitNotes.

	self relInitCrossref.
	self relInitDocumentDictionary.

	
!
canDelete
	"Return true if this DocumentRecord can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XDocumentRecord if there is one, else return nil."

	self relHasDocumentDictionary ifTrue: [ ^self relGetDocumentDictionary ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."

	self relDeleteAllAuthorDocuments.
	self relDeleteAllCites.
	self relDeleteAllContentRecords.
	self relDeleteAllElectronicEditions.
	self relDeleteAllNotes.

	self relRemoveAllCitedBy.
	self relRemoveAllCrossrefs.

	self relRemoveAllCrossref.
	self relRemoveAllDocumentDictionary.


	super delete!

 !

!DocumentDictionary100.Main.XDocumentRecord methodsFor: 'attributeAPI'!

attGetAuthors
	"Get value of attribute Authors"
	"Authors firstname, optional middle names and lastname separated by one space. First and middle names must if abbrevated be followed by a dot. Multiple authors appear in the same order as on the document, separated by comma."

	^attAuthors.!

attGetBooktitle
	"Get value of attribute Booktitle"
	"[bibtexml 2006]: Title of a book, part of which is being cited.  See the LaTeX book for how to type titles.  For book entries, use the title field instead."

	^attBooktitle.!

attGetCdrom
	"Get value of attribute Cdrom"
	"Unix path to the particular paper on the proceedings cdrom."

	^attCdrom.!

attGetCrossref
	"Get value of attribute Crossref"
	"Textual foreign key to the document record of the assembly document that contains this document. E.g. a pointer to the proceedings that published it."

	^attCrossref.!

attGetEditors
	"Get value of attribute Editors"
	"Editors firstname, optional middle names and lastname separated by one space. First and middle names must if abbrevated be followed by a dot. Multiple editors appear in the same order as on the document, separated by comma."

	^attEditors.!

attGetEndPage
	"Get value of attribute EndPage"
	"Page number where this ContentContainer of containerType (Preface | Part | Chapter | Section | SubSection | Appendix | ReferenceList | Index ) or other document specific ContentContainer types, ends."

	^attEndPage.!

attGetIsbn
	"Get value of attribute Isbn"
	"International Standard Book Number. A standard for identification of printed media. ISBN was created in Great Britain in 1966, and was adopted as an international standard in 1970 [ISO 2108]."

	^attIsbn.!

attGetJournal
	"Get value of attribute Journal"
	"Name of the Journal that published an article. Primarily used for recordType = article, but also proceedings."

	^attJournal.!

attGetModificationDate
	"Get value of attribute ModificationDate"
	"modificationDate is the date of the last modification of this record before being imported. The format complies with ISO 8601, i.e. YYYY-MM-DD.
Named mdate in DBLP [Ley 2009]."

	^attModificationDate.!

attGetMonth
	"Get value of attribute Month"
	"The month of Journals that use that issue identification system.
"

	^attMonth.!

attGetNumber
	"Get value of attribute Number"
	"The number of a journal, magazine, technical report, or of a work in a series."

	^attNumber.!

attGetPageCount
	"Get value of attribute PageCount"
	"The number of pages within the content for convenience in aggreated calculations. This numeric value can be calculated automatically,  in case both startPage and endPage are entered or can be computed from contentRecords."

	^attPageCount.!

attGetPages
	"Get value of attribute Pages"
	"Pages within a book or collection in the format from-to. E.g. 42-61.
"

	^attPages.!

attGetPublicationType
	"Get value of attribute PublicationType"
	"Defines the status of the publication.
Examples of values used in dblp:
data
disambiguation
edited
encyclopedia
group
habil
informal
informal withdrawn
survey
withdrawn
"

	^attPublicationType.!

attGetPublisher
	"Get value of attribute Publisher"
	"Name of the publisher.
Note: In dblp, the href attribute of this element type was only available in less than 1% of the publisher elements, and only contained 3 distinct values, thus omitted.
"

	^attPublisher.!

attGetRating
	"Get value of attribute Rating"
	"Rating for a Journal Article. May be (NETURAL, POS, SUPERB)."

	^attRating.!

attGetRecordType
	"Get value of attribute RecordType"
	"Identifier of the dblp record type according to the dtd element dblp in the evolved xml standard of DBLP  [Ley 2009]. ( article | inproceedings | proceedings | book | incollection | phdthesis | mastersthesis | www )"

	^attRecordType.!

attGetReviewid
	"Get value of attribute Reviewid"
	"Identifier of a review.
"

	^attReviewid.!

attGetSchool
	"Get value of attribute School"
	"The name of the school where a thesis was written. This attribute is relevant for DocumentRectords where recordType = ( phdthesis | masterthesis | books ), where books had the small number of 31 instances."

	^attSchool.!

attGetSeries
	"Get value of attribute Series"
	"The name of a series or set of books.  When citing an entire book, the the title field gives its title and an optional series field gives the name of a series or multi-volume set in which the book is published."

	^attSeries.!

attGetSourcekey
	"Get value of attribute Sourcekey"
	"sourcekey is a unique key of the record. A value convention is a slash separated Unix file name to the document itself under some directory in the users file system or external archive disks. Named key in DBLP, but that is a reserved word in SQL.
"

	^attSourcekey.!

attGetStartPage
	"Get value of attribute StartPage"
	"Page number where this ContentContainer of containerType (Preface | Part | Chapter | Section | SubSection | Appendix | ReferenceList | Index )  or other document specific ContentContainer types, starts."

	^attStartPage.!

attGetTableOfContentsUrl
	"Get value of attribute TableOfContentsUrl"
	"Url to the table of contents of the item containing the recorded document.
This field is called url in dblp [Ley 2009]."

	^attTableOfContentsUrl.!

attGetTitle
	"Get value of attribute Title"
	"The title choosen by the authors of the document. Expressed in plain text that can be included in any type of generated reference list, and is easy to search with pattern matching.
All non 128 bit ascii characters are replaced by underscore (_)."

	^attTitle.!

attGetVolume
	"Get value of attribute Volume"
	"[bibtexml 2006]: bibtexml.dtd
The volume of a journal or multivolume book."

	^attVolume.!

attGetYear
	"Get value of attribute Year"
	"The year element should always contain a four digit number
to be interpreted according to the Gregorian calendar."

	^attYear.!

attIqAuthors
	"Return the information quantity of attribute Authors"
	"180413 This is a default implementation that can be extended later"

	^attAuthors ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqBooktitle
	"Return the information quantity of attribute Booktitle"
	"180413 This is a default implementation that can be extended later"

	^attBooktitle ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqCdrom
	"Return the information quantity of attribute Cdrom"
	"180413 This is a default implementation that can be extended later"

	^attCdrom ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqCrossref
	"Return the information quantity of attribute Crossref"
	"180413 This is a default implementation that can be extended later"

	^attCrossref ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqEditors
	"Return the information quantity of attribute Editors"
	"180413 This is a default implementation that can be extended later"

	^attEditors ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqEndPage
	"Return the information quantity of attribute EndPage"
	"180413 This is a default implementation that can be extended later"

	^attEndPage ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqIsbn
	"Return the information quantity of attribute Isbn"
	"180413 This is a default implementation that can be extended later"

	^attIsbn ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqJournal
	"Return the information quantity of attribute Journal"
	"180413 This is a default implementation that can be extended later"

	^attJournal ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqModificationDate
	"Return the information quantity of attribute ModificationDate"
	"180413 This is a default implementation that can be extended later"

	^attModificationDate ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqMonth
	"Return the information quantity of attribute Month"
	"180413 This is a default implementation that can be extended later"

	^attMonth ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqNumber
	"Return the information quantity of attribute Number"
	"180413 This is a default implementation that can be extended later"

	^attNumber ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqPageCount
	"Return the information quantity of attribute PageCount"
	"180413 This is a default implementation that can be extended later"

	^attPageCount ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqPages
	"Return the information quantity of attribute Pages"
	"180413 This is a default implementation that can be extended later"

	^attPages ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqPublicationType
	"Return the information quantity of attribute PublicationType"
	"180413 This is a default implementation that can be extended later"

	^attPublicationType ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqPublisher
	"Return the information quantity of attribute Publisher"
	"180413 This is a default implementation that can be extended later"

	^attPublisher ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqRating
	"Return the information quantity of attribute Rating"
	"180413 This is a default implementation that can be extended later"

	^attRating ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqRecordType
	"Return the information quantity of attribute RecordType"
	"180413 This is a default implementation that can be extended later"

	^attRecordType ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqReviewid
	"Return the information quantity of attribute Reviewid"
	"180413 This is a default implementation that can be extended later"

	^attReviewid ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqSchool
	"Return the information quantity of attribute School"
	"180413 This is a default implementation that can be extended later"

	^attSchool ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqSeries
	"Return the information quantity of attribute Series"
	"180413 This is a default implementation that can be extended later"

	^attSeries ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqSourcekey
	"Return the information quantity of attribute Sourcekey"
	"180413 This is a default implementation that can be extended later"

	^attSourcekey ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqStartPage
	"Return the information quantity of attribute StartPage"
	"180413 This is a default implementation that can be extended later"

	^attStartPage ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqTableOfContentsUrl
	"Return the information quantity of attribute TableOfContentsUrl"
	"180413 This is a default implementation that can be extended later"

	^attTableOfContentsUrl ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqTitle
	"Return the information quantity of attribute Title"
	"180413 This is a default implementation that can be extended later"

	^attTitle ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqVolume
	"Return the information quantity of attribute Volume"
	"180413 This is a default implementation that can be extended later"

	^attVolume ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqYear
	"Return the information quantity of attribute Year"
	"180413 This is a default implementation that can be extended later"

	^attYear ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasAuthors
	"Return true if the current value of the attribute Authors carries information."

	^(attAuthors ~= nil)!

attHasBooktitle
	"Return true if the current value of the attribute Booktitle carries information."

	^(attBooktitle ~= nil)!

attHasCdrom
	"Return true if the current value of the attribute Cdrom carries information."

	^(attCdrom ~= nil)!

attHasCrossref
	"Return true if the current value of the attribute Crossref carries information."

	^(attCrossref ~= nil)!

attHasEditors
	"Return true if the current value of the attribute Editors carries information."

	^(attEditors ~= nil)!

attHasEndPage
	"Return true if the current value of the attribute EndPage carries information."

	^(attEndPage ~= nil)!

attHasIsbn
	"Return true if the current value of the attribute Isbn carries information."

	^(attIsbn ~= nil)!

attHasJournal
	"Return true if the current value of the attribute Journal carries information."

	^(attJournal ~= nil)!

attHasModificationDate
	"Return true if the current value of the attribute ModificationDate carries information."

	^(attModificationDate ~= nil)!

attHasMonth
	"Return true if the current value of the attribute Month carries information."

	^(attMonth ~= nil)!

attHasNumber
	"Return true if the current value of the attribute Number carries information."

	^(attNumber ~= nil)!

attHasPageCount
	"Return true if the current value of the attribute PageCount carries information."

	^(attPageCount ~= nil)!

attHasPages
	"Return true if the current value of the attribute Pages carries information."

	^(attPages ~= nil)!

attHasPublicationType
	"Return true if the current value of the attribute PublicationType carries information."

	^(attPublicationType ~= nil)!

attHasPublisher
	"Return true if the current value of the attribute Publisher carries information."

	^(attPublisher ~= nil)!

attHasRating
	"Return true if the current value of the attribute Rating carries information."

	^(attRating ~= nil)!

attHasRecordType
	"Return true if the current value of the attribute RecordType carries information."

	^(attRecordType ~= nil)!

attHasReviewid
	"Return true if the current value of the attribute Reviewid carries information."

	^(attReviewid ~= nil)!

attHasSchool
	"Return true if the current value of the attribute School carries information."

	^(attSchool ~= nil)!

attHasSeries
	"Return true if the current value of the attribute Series carries information."

	^(attSeries ~= nil)!

attHasSourcekey
	"Return true if the current value of the attribute Sourcekey carries information."

	^(attSourcekey ~= nil)!

attHasStartPage
	"Return true if the current value of the attribute StartPage carries information."

	^(attStartPage ~= nil)!

attHasTableOfContentsUrl
	"Return true if the current value of the attribute TableOfContentsUrl carries information."

	^(attTableOfContentsUrl ~= nil)!

attHasTitle
	"Return true if the current value of the attribute Title carries information."

	^(attTitle ~= nil)!

attHasVolume
	"Return true if the current value of the attribute Volume carries information."

	^(attVolume ~= nil)!

attHasYear
	"Return true if the current value of the attribute Year carries information."

	^(attYear ~= nil)!

attCreateAuthors
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetAuthors: (nil)!

attCreateBooktitle
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetBooktitle: (nil)!

attCreateCdrom
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetCdrom: (nil)!

attCreateCrossref
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetCrossref: (nil)!

attCreateEditors
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetEditors: (nil)!

attCreateEndPage
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetEndPage: (nil)!

attCreateIsbn
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetIsbn: (nil)!

attCreateJournal
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetJournal: (nil)!

attCreateModificationDate
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetModificationDate: (nil)!

attCreateMonth
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetMonth: (nil)!

attCreateNumber
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetNumber: (nil)!

attCreatePageCount
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetPageCount: (nil)!

attCreatePages
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetPages: (nil)!

attCreatePublicationType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetPublicationType: (nil)!

attCreatePublisher
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetPublisher: (nil)!

attCreateRating
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetRating: (nil)!

attCreateRecordType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetRecordType: (nil)!

attCreateReviewid
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetReviewid: (nil)!

attCreateSchool
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetSchool: (nil)!

attCreateSeries
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetSeries: (nil)!

attCreateStartPage
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetStartPage: (nil)!

attCreateTableOfContentsUrl
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetTableOfContentsUrl: (nil)!

attCreateTitle
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetTitle: (nil)!

attCreateVolume
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetVolume: (nil)!

attCreateYear
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetYear: (nil)!

attCreateAuthors
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetAuthors: (nil)!

attCreateBooktitle
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetBooktitle: (nil)!

attCreateCdrom
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetCdrom: (nil)!

attCreateCrossref
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetCrossref: (nil)!

attCreateEditors
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetEditors: (nil)!

attCreateEndPage
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetEndPage: (nil)!

attCreateIsbn
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetIsbn: (nil)!

attCreateJournal
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetJournal: (nil)!

attCreateModificationDate
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetModificationDate: (nil)!

attCreateMonth
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetMonth: (nil)!

attCreateNumber
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetNumber: (nil)!

attCreatePageCount
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetPageCount: (nil)!

attCreatePages
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetPages: (nil)!

attCreatePublicationType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetPublicationType: (nil)!

attCreatePublisher
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetPublisher: (nil)!

attCreateRating
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetRating: (nil)!

attCreateRecordType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetRecordType: (nil)!

attCreateReviewid
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetReviewid: (nil)!

attCreateSchool
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetSchool: (nil)!

attCreateSeries
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetSeries: (nil)!

attCreateSourcekey
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetSourcekey: ('\')!

attCreateStartPage
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetStartPage: (nil)!

attCreateTableOfContentsUrl
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetTableOfContentsUrl: (nil)!

attCreateTitle
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetTitle: (nil)!

attCreateVolume
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetVolume: (nil)!

attCreateYear
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetYear: (nil)!

attDeleteAuthors
	"Set the attribute value to undefined, or to a value that makes attIqAuthors return 0."

	^self attSetAuthors: nil!

attDeleteBooktitle
	"Set the attribute value to undefined, or to a value that makes attIqBooktitle return 0."

	^self attSetBooktitle: nil!

attDeleteCdrom
	"Set the attribute value to undefined, or to a value that makes attIqCdrom return 0."

	^self attSetCdrom: nil!

attDeleteCrossref
	"Set the attribute value to undefined, or to a value that makes attIqCrossref return 0."

	^self attSetCrossref: nil!

attDeleteEditors
	"Set the attribute value to undefined, or to a value that makes attIqEditors return 0."

	^self attSetEditors: nil!

attDeleteEndPage
	"Set the attribute value to undefined, or to a value that makes attIqEndPage return 0."

	^self attSetEndPage: nil!

attDeleteIsbn
	"Set the attribute value to undefined, or to a value that makes attIqIsbn return 0."

	^self attSetIsbn: nil!

attDeleteJournal
	"Set the attribute value to undefined, or to a value that makes attIqJournal return 0."

	^self attSetJournal: nil!

attDeleteModificationDate
	"Set the attribute value to undefined, or to a value that makes attIqModificationDate return 0."

	^self attSetModificationDate: nil!

attDeleteMonth
	"Set the attribute value to undefined, or to a value that makes attIqMonth return 0."

	^self attSetMonth: nil!

attDeleteNumber
	"Set the attribute value to undefined, or to a value that makes attIqNumber return 0."

	^self attSetNumber: nil!

attDeletePageCount
	"Set the attribute value to undefined, or to a value that makes attIqPageCount return 0."

	^self attSetPageCount: nil!

attDeletePages
	"Set the attribute value to undefined, or to a value that makes attIqPages return 0."

	^self attSetPages: nil!

attDeletePublicationType
	"Set the attribute value to undefined, or to a value that makes attIqPublicationType return 0."

	^self attSetPublicationType: nil!

attDeletePublisher
	"Set the attribute value to undefined, or to a value that makes attIqPublisher return 0."

	^self attSetPublisher: nil!

attDeleteRating
	"Set the attribute value to undefined, or to a value that makes attIqRating return 0."

	^self attSetRating: nil!

attDeleteRecordType
	"Set the attribute value to undefined, or to a value that makes attIqRecordType return 0."

	^self attSetRecordType: nil!

attDeleteReviewid
	"Set the attribute value to undefined, or to a value that makes attIqReviewid return 0."

	^self attSetReviewid: nil!

attDeleteSchool
	"Set the attribute value to undefined, or to a value that makes attIqSchool return 0."

	^self attSetSchool: nil!

attDeleteSeries
	"Set the attribute value to undefined, or to a value that makes attIqSeries return 0."

	^self attSetSeries: nil!

attDeleteSourcekey
	"Set the attribute value to undefined, or to a value that makes attIqSourcekey return 0."

	^self attSetSourcekey: nil!

attDeleteStartPage
	"Set the attribute value to undefined, or to a value that makes attIqStartPage return 0."

	^self attSetStartPage: nil!

attDeleteTableOfContentsUrl
	"Set the attribute value to undefined, or to a value that makes attIqTableOfContentsUrl return 0."

	^self attSetTableOfContentsUrl: nil!

attDeleteTitle
	"Set the attribute value to undefined, or to a value that makes attIqTitle return 0."

	^self attSetTitle: nil!

attDeleteVolume
	"Set the attribute value to undefined, or to a value that makes attIqVolume return 0."

	^self attSetVolume: nil!

attDeleteYear
	"Set the attribute value to undefined, or to a value that makes attIqYear return 0."

	^self attSetYear: nil!

attSetAuthors: value 
	"Set the value of attribute Authors to value, if it is not already equal to value."

	(attAuthors = value) ifFalse: [
		attAuthors := value.
		self changed: #attAuthors.
	]!

attSetBooktitle: value 
	"Set the value of attribute Booktitle to value, if it is not already equal to value."

	(attBooktitle = value) ifFalse: [
		attBooktitle := value.
		self changed: #attBooktitle.
	]!

attSetCdrom: value 
	"Set the value of attribute Cdrom to value, if it is not already equal to value."

	(attCdrom = value) ifFalse: [
		attCdrom := value.
		self changed: #attCdrom.
	]!

attSetCrossref: value 
	"Set the value of attribute Crossref to value, if it is not already equal to value."

	(attCrossref = value) ifFalse: [
		attCrossref := value.
		self changed: #attCrossref.
	]!

attSetEditors: value 
	"Set the value of attribute Editors to value, if it is not already equal to value."

	(attEditors = value) ifFalse: [
		attEditors := value.
		self changed: #attEditors.
	]!

attSetEndPage: value 
	"Set the value of attribute EndPage to value, if it is not already equal to value."

	(attEndPage = value) ifFalse: [
		attEndPage := value.
		self changed: #attEndPage.
	]!

attSetIsbn: value 
	"Set the value of attribute Isbn to value, if it is not already equal to value."

	(attIsbn = value) ifFalse: [
		attIsbn := value.
		self changed: #attIsbn.
	]!

attSetJournal: value 
	"Set the value of attribute Journal to value, if it is not already equal to value."

	(attJournal = value) ifFalse: [
		attJournal := value.
		self changed: #attJournal.
	]!

attSetModificationDate: value 
	"Set the value of attribute ModificationDate to value, if it is not already equal to value."

	(attModificationDate = value) ifFalse: [
		attModificationDate := value.
		self changed: #attModificationDate.
	]!

attSetMonth: value 
	"Set the value of attribute Month to value, if it is not already equal to value."

	(attMonth = value) ifFalse: [
		attMonth := value.
		self changed: #attMonth.
	]!

attSetNumber: value 
	"Set the value of attribute Number to value, if it is not already equal to value."

	(attNumber = value) ifFalse: [
		attNumber := value.
		self changed: #attNumber.
	]!

attSetPageCount: value 
	"Set the value of attribute PageCount to value, if it is not already equal to value."

	(attPageCount = value) ifFalse: [
		attPageCount := value.
		self changed: #attPageCount.
	]!

attSetPages: value 
	"Set the value of attribute Pages to value, if it is not already equal to value."

	(attPages = value) ifFalse: [
		attPages := value.
		self changed: #attPages.
	]!

attSetPublicationType: value 
	"Set the value of attribute PublicationType to value, if it is not already equal to value."

	(attPublicationType = value) ifFalse: [
		attPublicationType := value.
		self changed: #attPublicationType.
	]!

attSetPublisher: value 
	"Set the value of attribute Publisher to value, if it is not already equal to value."

	(attPublisher = value) ifFalse: [
		attPublisher := value.
		self changed: #attPublisher.
	]!

attSetRating: value 
	"Set the value of attribute Rating to value, if it is not already equal to value."

	(attRating = value) ifFalse: [
		attRating := value.
		self changed: #attRating.
	]!

attSetRecordType: value 
	"Set the value of attribute RecordType to value, if it is not already equal to value."

	(attRecordType = value) ifFalse: [
		attRecordType := value.
		self changed: #attRecordType.
	]!

attSetReviewid: value 
	"Set the value of attribute Reviewid to value, if it is not already equal to value."

	(attReviewid = value) ifFalse: [
		attReviewid := value.
		self changed: #attReviewid.
	]!

attSetSchool: value 
	"Set the value of attribute School to value, if it is not already equal to value."

	(attSchool = value) ifFalse: [
		attSchool := value.
		self changed: #attSchool.
	]!

attSetSeries: value 
	"Set the value of attribute Series to value, if it is not already equal to value."

	(attSeries = value) ifFalse: [
		attSeries := value.
		self changed: #attSeries.
	]!

attSetSourcekey: value 
	"Set the value of attribute Sourcekey to value, if it is not already equal to value."

	(attSourcekey = value) ifFalse: [
		attSourcekey := value.
		self changed: #attSourcekey.
	]!

attSetStartPage: value 
	"Set the value of attribute StartPage to value, if it is not already equal to value."

	(attStartPage = value) ifFalse: [
		attStartPage := value.
		self changed: #attStartPage.
	]!

attSetTableOfContentsUrl: value 
	"Set the value of attribute TableOfContentsUrl to value, if it is not already equal to value."

	(attTableOfContentsUrl = value) ifFalse: [
		attTableOfContentsUrl := value.
		self changed: #attTableOfContentsUrl.
	]!

attSetTitle: value 
	"Set the value of attribute Title to value, if it is not already equal to value."

	(attTitle = value) ifFalse: [
		attTitle := value.
		self changed: #attTitle.
	]!

attSetVolume: value 
	"Set the value of attribute Volume to value, if it is not already equal to value."

	(attVolume = value) ifFalse: [
		attVolume := value.
		self changed: #attVolume.
	]!

attSetYear: value 
	"Set the value of attribute Year to value, if it is not already equal to value."

	(attYear = value) ifFalse: [
		attYear := value.
		self changed: #attYear.
	]!

attInitAuthors
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attAuthors := nil!

attInitBooktitle
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attBooktitle := nil!

attInitCdrom
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attCdrom := nil!

attInitCrossref
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attCrossref := nil!

attInitEditors
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attEditors := nil!

attInitEndPage
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attEndPage := nil!

attInitIsbn
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attIsbn := nil!

attInitJournal
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attJournal := nil!

attInitModificationDate
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attModificationDate := nil!

attInitMonth
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attMonth := nil!

attInitNumber
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attNumber := nil!

attInitPageCount
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attPageCount := nil!

attInitPages
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attPages := nil!

attInitPublicationType
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attPublicationType := nil!

attInitPublisher
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attPublisher := nil!

attInitRating
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attRating := nil!

attInitRecordType
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attRecordType := nil!

attInitReviewid
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attReviewid := nil!

attInitSchool
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attSchool := nil!

attInitSeries
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attSeries := nil!

attInitStartPage
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attStartPage := nil!

attInitTableOfContentsUrl
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attTableOfContentsUrl := nil!

attInitTitle
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attTitle := nil!

attInitVolume
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attVolume := nil!

attInitYear
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attYear := nil!

attInitSourcekey
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetSourcekey: ('\')!

 !

!DocumentDictionary100.Main.XDocumentRecord methodsFor: 'relationshipAPI'!

relRemoveAllCrossref
	"Remove a XDocumentRecord from 1-N relationship2 Crossref if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllCrossref) do: [:dr1 | self relRemoveCrossref: dr1].!

relRemoveAllDocumentDictionary
	"Remove a XDocumentDictionary from 1-N relationship2 DocumentDictionary if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllDocumentDictionary) do: [:dd1 | self relRemoveDocumentDictionary: dd1].!

relAllAuthorDocuments
	"Return collection of all authorDocuments"

	^relAuthorDocuments copy.!

relAllCitedBy
	"Return collection of all citedBy"

	^relCitedBy copy.!

relAllCites
	"Return collection of all cites"

	^relCites copy.!

relAllContentRecords
	"Return collection of all contentRecords"

	^relContentRecords copy.!

relAllCrossrefs
	"Return collection of all crossrefs"

	^relCrossrefs copy.!

relAllElectronicEditions
	"Return collection of all electronicEditions"

	^relElectronicEditions copy.!

relAllNotes
	"Return collection of all notes"

	^relNotes copy.!

relSizeAuthorDocuments
	"Return the integer size of the collection returned by relAllAuthorDocuments"

	^relAuthorDocuments size!

relSizeCitedBy
	"Return the integer size of the collection returned by relAllCitedBy"

	^relCitedBy size!

relSizeCites
	"Return the integer size of the collection returned by relAllCites"

	^relCites size!

relSizeContentRecords
	"Return the integer size of the collection returned by relAllContentRecords"

	^relContentRecords size!

relSizeCrossrefs
	"Return the integer size of the collection returned by relAllCrossrefs"

	^relCrossrefs size!

relSizeElectronicEditions
	"Return the integer size of the collection returned by relAllElectronicEditions"

	^relElectronicEditions size!

relSizeNotes
	"Return the integer size of the collection returned by relAllNotes"

	^relNotes size!

relHasAuthorDocuments
	"Return true if the 1-N relationship1 authorDocuments holds at least one object, else return false."

	^relAuthorDocuments size > 0!

relHasCitedBy
	"Return true if the 1-N relationship1 citedBy holds at least one object, else return false."

	^relCitedBy size > 0!

relHasCites
	"Return true if the 1-N relationship1 cites holds at least one object, else return false."

	^relCites size > 0!

relHasContentRecords
	"Return true if the 1-N relationship1 contentRecords holds at least one object, else return false."

	^relContentRecords size > 0!

relHasCrossrefs
	"Return true if the 1-N relationship1 crossrefs holds at least one object, else return false."

	^relCrossrefs size > 0!

relHasElectronicEditions
	"Return true if the 1-N relationship1 electronicEditions holds at least one object, else return false."

	^relElectronicEditions size > 0!

relHasNotes
	"Return true if the 1-N relationship1 notes holds at least one object, else return false."

	^relNotes size > 0!

relCreateAuthorDocuments
	"Creates and adds a new XAuthorDocument to 1-N relationship AuthorDocuments."

	| ad2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XAuthorDocument) ifTrue: [
		ad2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XAuthorDocument.
		self relAddAuthorDocuments: ad2.
		^ad2.
	] ifFalse: [
		self dberror: 'XDocumentRecord.relCreateAuthorDocuments Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XAuthorDocument. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateCitedBy
	"Creates and adds a new XCite to 1-N relationship CitedBy."

	| ci2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XCite) ifTrue: [
		ci2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XCite.
		self relAddCitedBy: ci2.
		^ci2.
	] ifFalse: [
		self dberror: 'XDocumentRecord.relCreateCitedBy Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XCite. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateCites
	"Creates and adds a new XCite to 1-N relationship Cites."

	| ci2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XCite) ifTrue: [
		ci2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XCite.
		self relAddCites: ci2.
		^ci2.
	] ifFalse: [
		self dberror: 'XDocumentRecord.relCreateCites Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XCite. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateContentRecords
	"Creates and adds a new XContentRecord to 1-N relationship ContentRecords."

	| cr2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XContentRecord) ifTrue: [
		cr2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XContentRecord.
		self relAddContentRecords: cr2.
		^cr2.
	] ifFalse: [
		self dberror: 'XDocumentRecord.relCreateContentRecords Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XContentRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateCrossrefs
	"Creates and adds a new XDocumentRecord to 1-N relationship Crossrefs."

	| dr2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentRecord) ifTrue: [
		dr2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentRecord.
		self relAddCrossrefs: dr2.
		^dr2.
	] ifFalse: [
		self dberror: 'XDocumentRecord.relCreateCrossrefs Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateElectronicEditions
	"Creates and adds a new XElectronicEdition to 1-N relationship ElectronicEditions."

	| ee2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XElectronicEdition) ifTrue: [
		ee2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XElectronicEdition.
		self relAddElectronicEditions: ee2.
		^ee2.
	] ifFalse: [
		self dberror: 'XDocumentRecord.relCreateElectronicEditions Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XElectronicEdition. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateNotes
	"Creates and adds a new XNote to 1-N relationship Notes."

	| no2 |
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XNote) ifTrue: [
		no2 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XNote.
		self relAddNotes: no2.
		^no2.
	] ifFalse: [
		self dberror: 'XDocumentRecord.relCreateNotes Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XNote. Please open an appropriate substorage first.'.
		^nil.
	].!

relAddAuthorDocuments: ad2
	"Adds a XAuthorDocument ad2 to 1-N relationship AuthorDocuments."

	| dr1a |
	( ad2 isKindOf: DocumentDictionary100.Main.XAuthorDocument ) ifFalse: [
		self dberror: 'XDocumentRecord:relAddAuthorDocuments: Error ' message: ( ad2 asString ,
			' is not a XAuthorDocument, and can not be added to AuthorDocuments for ',
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( (relAuthorDocuments identityIndexOf: ad2) > 0 ) ifTrue: [
		self dberror: 'XDocumentRecord:relAddAuthorDocuments: Error ' message: 
			'XAuthorDocument (', ad2 asString , ') is already added to this XDocumentRecord (', self asString, ').'.
		^nil.
	].
	( dr1a := ad2 relGetDocumentRecord ) ifNotNil: [ 
		self dberror: 'XDocumentRecord:relAddAuthorDocuments: Error ' message: 
			'XAuthorDocument (', ad2 asString , ') is already added to another XDocumentRecord (', dr1a asString , ').'.
		^nil.
	]. 
	relAuthorDocuments add: ad2.
	ad2 relPrivateSetDocumentRecord: self.
	^ad2!

relAddCitedBy: ci2
	"Adds a XCite ci2 to 1-N relationship CitedBy."

	| dr1a |
	( ci2 isKindOf: DocumentDictionary100.Main.XCite ) ifFalse: [
		self dberror: 'XDocumentRecord:relAddCitedBy: Error ' message: ( ci2 asString ,
			' is not a XCite, and can not be added to CitedBy for ',
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( (relCitedBy identityIndexOf: ci2) > 0 ) ifTrue: [
		self dberror: 'XDocumentRecord:relAddCitedBy: Error ' message: 
			'XCite (', ci2 asString , ') is already added to this XDocumentRecord (', self asString, ').'.
		^nil.
	].
	( dr1a := ci2 relGetCited ) ifNotNil: [ 
		self dberror: 'XDocumentRecord:relAddCitedBy: Error ' message: 
			'XCite (', ci2 asString , ') is already added to another XDocumentRecord (', dr1a asString , ').'.
		^nil.
	]. 
	relCitedBy add: ci2.
	ci2 relPrivateSetCited: self.
	^ci2!

relAddCites: ci2
	"Adds a XCite ci2 to 1-N relationship Cites."

	| dr1a |
	( ci2 isKindOf: DocumentDictionary100.Main.XCite ) ifFalse: [
		self dberror: 'XDocumentRecord:relAddCites: Error ' message: ( ci2 asString ,
			' is not a XCite, and can not be added to Cites for ',
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( (relCites identityIndexOf: ci2) > 0 ) ifTrue: [
		self dberror: 'XDocumentRecord:relAddCites: Error ' message: 
			'XCite (', ci2 asString , ') is already added to this XDocumentRecord (', self asString, ').'.
		^nil.
	].
	( dr1a := ci2 relGetCitedBy ) ifNotNil: [ 
		self dberror: 'XDocumentRecord:relAddCites: Error ' message: 
			'XCite (', ci2 asString , ') is already added to another XDocumentRecord (', dr1a asString , ').'.
		^nil.
	]. 
	relCites add: ci2.
	ci2 relPrivateSetCitedBy: self.
	^ci2!

relAddContentRecords: cr2
	"Adds a XContentRecord cr2 to 1-N relationship ContentRecords."

	| dr1a |
	( cr2 isKindOf: DocumentDictionary100.Main.XContentRecord ) ifFalse: [
		self dberror: 'XDocumentRecord:relAddContentRecords: Error ' message: ( cr2 asString ,
			' is not a XContentRecord, and can not be added to ContentRecords for ',
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( (relContentRecords identityIndexOf: cr2) > 0 ) ifTrue: [
		self dberror: 'XDocumentRecord:relAddContentRecords: Error ' message: 
			'XContentRecord (', cr2 asString , ') is already added to this XDocumentRecord (', self asString, ').'.
		^nil.
	].
	( dr1a := cr2 relGetDocumentRecord ) ifNotNil: [ 
		self dberror: 'XDocumentRecord:relAddContentRecords: Error ' message: 
			'XContentRecord (', cr2 asString , ') is already added to another XDocumentRecord (', dr1a asString , ').'.
		^nil.
	]. 
	relContentRecords add: cr2.
	cr2 relPrivateSetDocumentRecord: self.
	^cr2!

relAddCrossrefs: dr2
	"Adds a XDocumentRecord dr2 to 1-N relationship Crossrefs."

	| dr1a |
	( dr2 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
		self dberror: 'XDocumentRecord:relAddCrossrefs: Error ' message: ( dr2 asString ,
			' is not a XDocumentRecord, and can not be added to Crossrefs for ',
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( (relCrossrefs identityIndexOf: dr2) > 0 ) ifTrue: [
		self dberror: 'XDocumentRecord:relAddCrossrefs: Error ' message: 
			'XDocumentRecord (', dr2 asString , ') is already added to this XDocumentRecord (', self asString, ').'.
		^nil.
	].
	( dr1a := dr2 relGetCrossref ) ifNotNil: [ 
		self dberror: 'XDocumentRecord:relAddCrossrefs: Error ' message: 
			'XDocumentRecord (', dr2 asString , ') is already added to another XDocumentRecord (', dr1a asString , ').'.
		^nil.
	]. 
	relCrossrefs add: dr2.
	dr2 relPrivateSetCrossref: self.
	^dr2!

relAddElectronicEditions: ee2
	"Adds a XElectronicEdition ee2 to 1-N relationship ElectronicEditions."

	| dr1a |
	( ee2 isKindOf: DocumentDictionary100.Main.XElectronicEdition ) ifFalse: [
		self dberror: 'XDocumentRecord:relAddElectronicEditions: Error ' message: ( ee2 asString ,
			' is not a XElectronicEdition, and can not be added to ElectronicEditions for ',
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( (relElectronicEditions identityIndexOf: ee2) > 0 ) ifTrue: [
		self dberror: 'XDocumentRecord:relAddElectronicEditions: Error ' message: 
			'XElectronicEdition (', ee2 asString , ') is already added to this XDocumentRecord (', self asString, ').'.
		^nil.
	].
	( dr1a := ee2 relGetDocumentRecord ) ifNotNil: [ 
		self dberror: 'XDocumentRecord:relAddElectronicEditions: Error ' message: 
			'XElectronicEdition (', ee2 asString , ') is already added to another XDocumentRecord (', dr1a asString , ').'.
		^nil.
	]. 
	relElectronicEditions add: ee2.
	ee2 relPrivateSetDocumentRecord: self.
	^ee2!

relAddNotes: no2
	"Adds a XNote no2 to 1-N relationship Notes."

	| dr1a |
	( no2 isKindOf: DocumentDictionary100.Main.XNote ) ifFalse: [
		self dberror: 'XDocumentRecord:relAddNotes: Error ' message: ( no2 asString ,
			' is not a XNote, and can not be added to Notes for ',
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( (relNotes identityIndexOf: no2) > 0 ) ifTrue: [
		self dberror: 'XDocumentRecord:relAddNotes: Error ' message: 
			'XNote (', no2 asString , ') is already added to this XDocumentRecord (', self asString, ').'.
		^nil.
	].
	( dr1a := no2 relGetDocumentRecord ) ifNotNil: [ 
		self dberror: 'XDocumentRecord:relAddNotes: Error ' message: 
			'XNote (', no2 asString , ') is already added to another XDocumentRecord (', dr1a asString , ').'.
		^nil.
	]. 
	relNotes add: no2.
	no2 relPrivateSetDocumentRecord: self.
	^no2!

relGetAuthorDocuments
	"Return the first XAuthorDocument object on the other side of the 1-N relations1 authorDocuments."
	"Provides compatibility with 1-1 relationships."

	( relAuthorDocuments size = 0 ) ifTrue: [ ^nil ].
	^relAuthorDocuments first!

relGetCitedBy
	"Return the first XCite object on the other side of the 1-N relations1 citedBy."
	"Provides compatibility with 1-1 relationships."

	( relCitedBy size = 0 ) ifTrue: [ ^nil ].
	^relCitedBy first!

relGetCites
	"Return the first XCite object on the other side of the 1-N relations1 cites."
	"Provides compatibility with 1-1 relationships."

	( relCites size = 0 ) ifTrue: [ ^nil ].
	^relCites first!

relGetContentRecords
	"Return the first XContentRecord object on the other side of the 1-N relations1 contentRecords."
	"Provides compatibility with 1-1 relationships."

	( relContentRecords size = 0 ) ifTrue: [ ^nil ].
	^relContentRecords first!

relGetCrossrefs
	"Return the first XDocumentRecord object on the other side of the 1-N relations1 crossrefs."
	"Provides compatibility with 1-1 relationships."

	( relCrossrefs size = 0 ) ifTrue: [ ^nil ].
	^relCrossrefs first!

relGetElectronicEditions
	"Return the first XElectronicEdition object on the other side of the 1-N relations1 electronicEditions."
	"Provides compatibility with 1-1 relationships."

	( relElectronicEditions size = 0 ) ifTrue: [ ^nil ].
	^relElectronicEditions first!

relGetNotes
	"Return the first XNote object on the other side of the 1-N relations1 notes."
	"Provides compatibility with 1-1 relationships."

	( relNotes size = 0 ) ifTrue: [ ^nil ].
	^relNotes first!

relSetAuthorDocuments: ad2
	"Force set other end of 1-N relationship to one XAuthorDocument ad2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| dr1a |
	ad2 ifNil: [
		self relDeleteAllAuthorDocuments.
		^nil.
	].
	( ad2 isKindOf: DocumentDictionary100.Main.XAuthorDocument ) ifFalse: [
		self dberror: 'XDocumentRecord:relSetAuthorDocuments: Error ' message: ( ad2 asString ,
			' is not a XAuthorDocument, and can not be added to' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	(( ( relAuthorDocuments identityIndexOf: ad2 ) > 0 ) and: [ relAuthorDocuments size = 1 ]) ifTrue: [
		"XAuthorDocument ad2 is already added to this XDocumentRecord, and it is the only one."
		^nil.
	].
	( relAuthorDocuments size > 0 ) ifTrue: [
		self relDeleteAllAuthorDocuments.
	].

	( dr1a := ad2 relGetDocumentRecord ) ifNotNil: [ 
		ad2 relRemoveAllDocumentRecord
	]. 
	relAuthorDocuments add: ad2.
	ad2 relPrivateSetDocumentRecord: self.
	^ad2!

relSetCitedBy: ci2
	"Force set other end of 1-N relationship to one XCite ci2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| dr1a |
	ci2 ifNil: [
		self relRemoveAllCitedBy.
		^nil.
	].
	( ci2 isKindOf: DocumentDictionary100.Main.XCite ) ifFalse: [
		self dberror: 'XDocumentRecord:relSetCitedBy: Error ' message: ( ci2 asString ,
			' is not a XCite, and can not be added to' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	(( ( relCitedBy identityIndexOf: ci2 ) > 0 ) and: [ relCitedBy size = 1 ]) ifTrue: [
		"XCite ci2 is already added to this XDocumentRecord, and it is the only one."
		^nil.
	].
	( relCitedBy size > 0 ) ifTrue: [
		self relRemoveAllCitedBy.
	].

	( dr1a := ci2 relGetCited ) ifNotNil: [ 
		ci2 relRemoveAllCited
	]. 
	relCitedBy add: ci2.
	ci2 relPrivateSetCited: self.
	^ci2!

relSetCites: ci2
	"Force set other end of 1-N relationship to one XCite ci2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| dr1a |
	ci2 ifNil: [
		self relDeleteAllCites.
		^nil.
	].
	( ci2 isKindOf: DocumentDictionary100.Main.XCite ) ifFalse: [
		self dberror: 'XDocumentRecord:relSetCites: Error ' message: ( ci2 asString ,
			' is not a XCite, and can not be added to' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	(( ( relCites identityIndexOf: ci2 ) > 0 ) and: [ relCites size = 1 ]) ifTrue: [
		"XCite ci2 is already added to this XDocumentRecord, and it is the only one."
		^nil.
	].
	( relCites size > 0 ) ifTrue: [
		self relDeleteAllCites.
	].

	( dr1a := ci2 relGetCitedBy ) ifNotNil: [ 
		ci2 relRemoveAllCitedBy
	]. 
	relCites add: ci2.
	ci2 relPrivateSetCitedBy: self.
	^ci2!

relSetContentRecords: cr2
	"Force set other end of 1-N relationship to one XContentRecord cr2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| dr1a |
	cr2 ifNil: [
		self relDeleteAllContentRecords.
		^nil.
	].
	( cr2 isKindOf: DocumentDictionary100.Main.XContentRecord ) ifFalse: [
		self dberror: 'XDocumentRecord:relSetContentRecords: Error ' message: ( cr2 asString ,
			' is not a XContentRecord, and can not be added to' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	(( ( relContentRecords identityIndexOf: cr2 ) > 0 ) and: [ relContentRecords size = 1 ]) ifTrue: [
		"XContentRecord cr2 is already added to this XDocumentRecord, and it is the only one."
		^nil.
	].
	( relContentRecords size > 0 ) ifTrue: [
		self relDeleteAllContentRecords.
	].

	( dr1a := cr2 relGetDocumentRecord ) ifNotNil: [ 
		cr2 relRemoveAllDocumentRecord
	]. 
	relContentRecords add: cr2.
	cr2 relPrivateSetDocumentRecord: self.
	^cr2!

relSetCrossrefs: dr2
	"Force set other end of 1-N relationship to one XDocumentRecord dr2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| dr1a |
	dr2 ifNil: [
		self relRemoveAllCrossrefs.
		^nil.
	].
	( dr2 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
		self dberror: 'XDocumentRecord:relSetCrossrefs: Error ' message: ( dr2 asString ,
			' is not a XDocumentRecord, and can not be added to' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	(( ( relCrossrefs identityIndexOf: dr2 ) > 0 ) and: [ relCrossrefs size = 1 ]) ifTrue: [
		"XDocumentRecord dr2 is already added to this XDocumentRecord, and it is the only one."
		^nil.
	].
	( relCrossrefs size > 0 ) ifTrue: [
		self relRemoveAllCrossrefs.
	].

	( dr1a := dr2 relGetCrossref ) ifNotNil: [ 
		dr2 relRemoveAllCrossref
	]. 
	relCrossrefs add: dr2.
	dr2 relPrivateSetCrossref: self.
	^dr2!

relSetElectronicEditions: ee2
	"Force set other end of 1-N relationship to one XElectronicEdition ee2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| dr1a |
	ee2 ifNil: [
		self relDeleteAllElectronicEditions.
		^nil.
	].
	( ee2 isKindOf: DocumentDictionary100.Main.XElectronicEdition ) ifFalse: [
		self dberror: 'XDocumentRecord:relSetElectronicEditions: Error ' message: ( ee2 asString ,
			' is not a XElectronicEdition, and can not be added to' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	(( ( relElectronicEditions identityIndexOf: ee2 ) > 0 ) and: [ relElectronicEditions size = 1 ]) ifTrue: [
		"XElectronicEdition ee2 is already added to this XDocumentRecord, and it is the only one."
		^nil.
	].
	( relElectronicEditions size > 0 ) ifTrue: [
		self relDeleteAllElectronicEditions.
	].

	( dr1a := ee2 relGetDocumentRecord ) ifNotNil: [ 
		ee2 relRemoveAllDocumentRecord
	]. 
	relElectronicEditions add: ee2.
	ee2 relPrivateSetDocumentRecord: self.
	^ee2!

relSetNotes: no2
	"Force set other end of 1-N relationship to one XNote no2 with brutal maintenance of cardinality constraints."
	"Provides compatibility with 1-1 relationships."

	| dr1a |
	no2 ifNil: [
		self relDeleteAllNotes.
		^nil.
	].
	( no2 isKindOf: DocumentDictionary100.Main.XNote ) ifFalse: [
		self dberror: 'XDocumentRecord:relSetNotes: Error ' message: ( no2 asString ,
			' is not a XNote, and can not be added to' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	(( ( relNotes identityIndexOf: no2 ) > 0 ) and: [ relNotes size = 1 ]) ifTrue: [
		"XNote no2 is already added to this XDocumentRecord, and it is the only one."
		^nil.
	].
	( relNotes size > 0 ) ifTrue: [
		self relDeleteAllNotes.
	].

	( dr1a := no2 relGetDocumentRecord ) ifNotNil: [ 
		no2 relRemoveAllDocumentRecord
	]. 
	relNotes add: no2.
	no2 relPrivateSetDocumentRecord: self.
	^no2!

relRemoveAuthorDocuments: ad2
	"Removes a XAuthorDocument ad2 from 1-N relationship1 AuthorDocuments."

	| dr1 index |
	( ad2 isKindOf: DocumentDictionary100.Main.XAuthorDocument ) ifFalse: [
		self dberror: 'XDocumentRecord:relRemoveAuthorDocuments: Error ' message: ( ad2 asString ,
			' is not a XAuthorDocument, and can not possibly be removed from AuthorDocuments on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( ( dr1 := ad2 relGetDocumentRecord ) == self ) ifFalse:[
		self dberror: 'XDocumentRecord:relRemoveAuthorDocuments Error ' message: 
			'XAuthorDocument (', ad2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^nil.
	].
	index := relAuthorDocuments identityIndexOf: ad2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relRemoveAuthorDocuments Error ' message: 
			'XAuthorDocument (', ad2 asString , ') can not be found in AuthorDocuments of this XDocumentRecord(', self asString , ').'.
		^nil.
	]. 
	relAuthorDocuments removeAtIndex: index.
	ad2 relPrivateSetDocumentRecord: nil.
	^ad2.!

relRemoveCitedBy: ci2
	"Removes a XCite ci2 from 1-N relationship1 CitedBy."

	| dr1 index |
	( ci2 isKindOf: DocumentDictionary100.Main.XCite ) ifFalse: [
		self dberror: 'XDocumentRecord:relRemoveCitedBy: Error ' message: ( ci2 asString ,
			' is not a XCite, and can not possibly be removed from CitedBy on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( ( dr1 := ci2 relGetCited ) == self ) ifFalse:[
		self dberror: 'XDocumentRecord:relRemoveCitedBy Error ' message: 
			'XCite (', ci2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^nil.
	].
	index := relCitedBy identityIndexOf: ci2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relRemoveCitedBy Error ' message: 
			'XCite (', ci2 asString , ') can not be found in CitedBy of this XDocumentRecord(', self asString , ').'.
		^nil.
	]. 
	relCitedBy removeAtIndex: index.
	ci2 relPrivateSetCited: nil.
	^ci2.!

relRemoveCites: ci2
	"Removes a XCite ci2 from 1-N relationship1 Cites."

	| dr1 index |
	( ci2 isKindOf: DocumentDictionary100.Main.XCite ) ifFalse: [
		self dberror: 'XDocumentRecord:relRemoveCites: Error ' message: ( ci2 asString ,
			' is not a XCite, and can not possibly be removed from Cites on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( ( dr1 := ci2 relGetCitedBy ) == self ) ifFalse:[
		self dberror: 'XDocumentRecord:relRemoveCites Error ' message: 
			'XCite (', ci2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^nil.
	].
	index := relCites identityIndexOf: ci2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relRemoveCites Error ' message: 
			'XCite (', ci2 asString , ') can not be found in Cites of this XDocumentRecord(', self asString , ').'.
		^nil.
	]. 
	relCites removeAtIndex: index.
	ci2 relPrivateSetCitedBy: nil.
	^ci2.!

relRemoveContentRecords: cr2
	"Removes a XContentRecord cr2 from 1-N relationship1 ContentRecords."

	| dr1 index |
	( cr2 isKindOf: DocumentDictionary100.Main.XContentRecord ) ifFalse: [
		self dberror: 'XDocumentRecord:relRemoveContentRecords: Error ' message: ( cr2 asString ,
			' is not a XContentRecord, and can not possibly be removed from ContentRecords on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( ( dr1 := cr2 relGetDocumentRecord ) == self ) ifFalse:[
		self dberror: 'XDocumentRecord:relRemoveContentRecords Error ' message: 
			'XContentRecord (', cr2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^nil.
	].
	index := relContentRecords identityIndexOf: cr2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relRemoveContentRecords Error ' message: 
			'XContentRecord (', cr2 asString , ') can not be found in ContentRecords of this XDocumentRecord(', self asString , ').'.
		^nil.
	]. 
	relContentRecords removeAtIndex: index.
	cr2 relPrivateSetDocumentRecord: nil.
	^cr2.!

relRemoveCrossrefs: dr2
	"Removes a XDocumentRecord dr2 from 1-N relationship1 Crossrefs."

	| dr1 index |
	( dr2 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
		self dberror: 'XDocumentRecord:relRemoveCrossrefs: Error ' message: ( dr2 asString ,
			' is not a XDocumentRecord, and can not possibly be removed from Crossrefs on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( ( dr1 := dr2 relGetCrossref ) == self ) ifFalse:[
		self dberror: 'XDocumentRecord:relRemoveCrossrefs Error ' message: 
			'XDocumentRecord (', dr2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^nil.
	].
	index := relCrossrefs identityIndexOf: dr2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relRemoveCrossrefs Error ' message: 
			'XDocumentRecord (', dr2 asString , ') can not be found in Crossrefs of this XDocumentRecord(', self asString , ').'.
		^nil.
	]. 
	relCrossrefs removeAtIndex: index.
	dr2 relPrivateSetCrossref: nil.
	^dr2.!

relRemoveElectronicEditions: ee2
	"Removes a XElectronicEdition ee2 from 1-N relationship1 ElectronicEditions."

	| dr1 index |
	( ee2 isKindOf: DocumentDictionary100.Main.XElectronicEdition ) ifFalse: [
		self dberror: 'XDocumentRecord:relRemoveElectronicEditions: Error ' message: ( ee2 asString ,
			' is not a XElectronicEdition, and can not possibly be removed from ElectronicEditions on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( ( dr1 := ee2 relGetDocumentRecord ) == self ) ifFalse:[
		self dberror: 'XDocumentRecord:relRemoveElectronicEditions Error ' message: 
			'XElectronicEdition (', ee2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^nil.
	].
	index := relElectronicEditions identityIndexOf: ee2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relRemoveElectronicEditions Error ' message: 
			'XElectronicEdition (', ee2 asString , ') can not be found in ElectronicEditions of this XDocumentRecord(', self asString , ').'.
		^nil.
	]. 
	relElectronicEditions removeAtIndex: index.
	ee2 relPrivateSetDocumentRecord: nil.
	^ee2.!

relRemoveNotes: no2
	"Removes a XNote no2 from 1-N relationship1 Notes."

	| dr1 index |
	( no2 isKindOf: DocumentDictionary100.Main.XNote ) ifFalse: [
		self dberror: 'XDocumentRecord:relRemoveNotes: Error ' message: ( no2 asString ,
			' is not a XNote, and can not possibly be removed from Notes on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^nil.
	].
	( ( dr1 := no2 relGetDocumentRecord ) == self ) ifFalse:[
		self dberror: 'XDocumentRecord:relRemoveNotes Error ' message: 
			'XNote (', no2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^nil.
	].
	index := relNotes identityIndexOf: no2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relRemoveNotes Error ' message: 
			'XNote (', no2 asString , ') can not be found in Notes of this XDocumentRecord(', self asString , ').'.
		^nil.
	]. 
	relNotes removeAtIndex: index.
	no2 relPrivateSetDocumentRecord: nil.
	^no2.!

relRemoveAllAuthorDocuments 
	"Remove all XAuthorDocument instances from 1-N relationship1 AuthorDocuments and return them in a collection."

	| ad2Coll |
	( ad2Coll := relAuthorDocuments copy ) do: [:ad2 |
		self relRemoveAuthorDocuments: ad2
	].
	^ad2Coll.!

relRemoveAllCitedBy 
	"Remove all XCite instances from 1-N relationship1 CitedBy and return them in a collection."

	| ci2Coll |
	( ci2Coll := relCitedBy copy ) do: [:ci2 |
		self relRemoveCitedBy: ci2
	].
	^ci2Coll.!

relRemoveAllCites 
	"Remove all XCite instances from 1-N relationship1 Cites and return them in a collection."

	| ci2Coll |
	( ci2Coll := relCites copy ) do: [:ci2 |
		self relRemoveCites: ci2
	].
	^ci2Coll.!

relRemoveAllContentRecords 
	"Remove all XContentRecord instances from 1-N relationship1 ContentRecords and return them in a collection."

	| cr2Coll |
	( cr2Coll := relContentRecords copy ) do: [:cr2 |
		self relRemoveContentRecords: cr2
	].
	^cr2Coll.!

relRemoveAllCrossrefs 
	"Remove all XDocumentRecord instances from 1-N relationship1 Crossrefs and return them in a collection."

	| dr2Coll |
	( dr2Coll := relCrossrefs copy ) do: [:dr2 |
		self relRemoveCrossrefs: dr2
	].
	^dr2Coll.!

relRemoveAllElectronicEditions 
	"Remove all XElectronicEdition instances from 1-N relationship1 ElectronicEditions and return them in a collection."

	| ee2Coll |
	( ee2Coll := relElectronicEditions copy ) do: [:ee2 |
		self relRemoveElectronicEditions: ee2
	].
	^ee2Coll.!

relRemoveAllNotes 
	"Remove all XNote instances from 1-N relationship1 Notes and return them in a collection."

	| no2Coll |
	( no2Coll := relNotes copy ) do: [:no2 |
		self relRemoveNotes: no2
	].
	^no2Coll.!

relDeleteAuthorDocuments: ad2
	"Remove a XAuthorDocument ad2 from 1-1 relationship1 AuthorDocuments and delete it."
	"Return true if operation succeded else return false."

	| dr1 index |
	( ad2 isKindOf: DocumentDictionary100.Main.XAuthorDocument ) ifFalse: [
		self dberror: 'XDocumentRecord:relDeleteAuthorDocuments: Error ' message: ( ad2 asString ,
			' is not a XAuthorDocument, and can not possibly be deleted from AuthorDocuments on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^false.
	].
	(( dr1 := ad2 relGetDocumentRecord ) = self ) ifFalse:[
		self dberror: 'XDocumentRecord:relDeleteAuthorDocuments Error ' message: 
			'XAuthorDocument (', ad2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^false.
	].
	index := relAuthorDocuments identityIndexOf: ad2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relDeleteAuthorDocuments Error ' message: 
			'XAuthorDocument (', ad2 asString , ') can not be found in AuthorDocuments of this XDocumentRecord(', self asString , ').'.
		^false.
	]. 
	relAuthorDocuments removeAtIndex: index.
	ad2 relPrivateSetDocumentRecord: nil.
	ad2 delete.
	^true.!

relDeleteCitedBy: ci2
	"Remove a XCite ci2 from 1-1 relationship1 CitedBy and delete it."
	"Return true if operation succeded else return false."

	| dr1 index |
	( ci2 isKindOf: DocumentDictionary100.Main.XCite ) ifFalse: [
		self dberror: 'XDocumentRecord:relDeleteCitedBy: Error ' message: ( ci2 asString ,
			' is not a XCite, and can not possibly be deleted from CitedBy on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^false.
	].
	(( dr1 := ci2 relGetCited ) = self ) ifFalse:[
		self dberror: 'XDocumentRecord:relDeleteCitedBy Error ' message: 
			'XCite (', ci2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^false.
	].
	index := relCitedBy identityIndexOf: ci2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relDeleteCitedBy Error ' message: 
			'XCite (', ci2 asString , ') can not be found in CitedBy of this XDocumentRecord(', self asString , ').'.
		^false.
	]. 
	relCitedBy removeAtIndex: index.
	ci2 relPrivateSetCited: nil.
	ci2 delete.
	^true.!

relDeleteCites: ci2
	"Remove a XCite ci2 from 1-1 relationship1 Cites and delete it."
	"Return true if operation succeded else return false."

	| dr1 index |
	( ci2 isKindOf: DocumentDictionary100.Main.XCite ) ifFalse: [
		self dberror: 'XDocumentRecord:relDeleteCites: Error ' message: ( ci2 asString ,
			' is not a XCite, and can not possibly be deleted from Cites on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^false.
	].
	(( dr1 := ci2 relGetCitedBy ) = self ) ifFalse:[
		self dberror: 'XDocumentRecord:relDeleteCites Error ' message: 
			'XCite (', ci2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^false.
	].
	index := relCites identityIndexOf: ci2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relDeleteCites Error ' message: 
			'XCite (', ci2 asString , ') can not be found in Cites of this XDocumentRecord(', self asString , ').'.
		^false.
	]. 
	relCites removeAtIndex: index.
	ci2 relPrivateSetCitedBy: nil.
	ci2 delete.
	^true.!

relDeleteContentRecords: cr2
	"Remove a XContentRecord cr2 from 1-1 relationship1 ContentRecords and delete it."
	"Return true if operation succeded else return false."

	| dr1 index |
	( cr2 isKindOf: DocumentDictionary100.Main.XContentRecord ) ifFalse: [
		self dberror: 'XDocumentRecord:relDeleteContentRecords: Error ' message: ( cr2 asString ,
			' is not a XContentRecord, and can not possibly be deleted from ContentRecords on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^false.
	].
	(( dr1 := cr2 relGetDocumentRecord ) = self ) ifFalse:[
		self dberror: 'XDocumentRecord:relDeleteContentRecords Error ' message: 
			'XContentRecord (', cr2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^false.
	].
	index := relContentRecords identityIndexOf: cr2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relDeleteContentRecords Error ' message: 
			'XContentRecord (', cr2 asString , ') can not be found in ContentRecords of this XDocumentRecord(', self asString , ').'.
		^false.
	]. 
	relContentRecords removeAtIndex: index.
	cr2 relPrivateSetDocumentRecord: nil.
	cr2 delete.
	^true.!

relDeleteCrossrefs: dr2
	"Remove a XDocumentRecord dr2 from 1-1 relationship1 Crossrefs and delete it."
	"Return true if operation succeded else return false."

	| dr1 index |
	( dr2 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
		self dberror: 'XDocumentRecord:relDeleteCrossrefs: Error ' message: ( dr2 asString ,
			' is not a XDocumentRecord, and can not possibly be deleted from Crossrefs on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^false.
	].
	(( dr1 := dr2 relGetCrossref ) = self ) ifFalse:[
		self dberror: 'XDocumentRecord:relDeleteCrossrefs Error ' message: 
			'XDocumentRecord (', dr2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^false.
	].
	index := relCrossrefs identityIndexOf: dr2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relDeleteCrossrefs Error ' message: 
			'XDocumentRecord (', dr2 asString , ') can not be found in Crossrefs of this XDocumentRecord(', self asString , ').'.
		^false.
	]. 
	relCrossrefs removeAtIndex: index.
	dr2 relPrivateSetCrossref: nil.
	dr2 delete.
	^true.!

relDeleteElectronicEditions: ee2
	"Remove a XElectronicEdition ee2 from 1-1 relationship1 ElectronicEditions and delete it."
	"Return true if operation succeded else return false."

	| dr1 index |
	( ee2 isKindOf: DocumentDictionary100.Main.XElectronicEdition ) ifFalse: [
		self dberror: 'XDocumentRecord:relDeleteElectronicEditions: Error ' message: ( ee2 asString ,
			' is not a XElectronicEdition, and can not possibly be deleted from ElectronicEditions on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^false.
	].
	(( dr1 := ee2 relGetDocumentRecord ) = self ) ifFalse:[
		self dberror: 'XDocumentRecord:relDeleteElectronicEditions Error ' message: 
			'XElectronicEdition (', ee2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^false.
	].
	index := relElectronicEditions identityIndexOf: ee2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relDeleteElectronicEditions Error ' message: 
			'XElectronicEdition (', ee2 asString , ') can not be found in ElectronicEditions of this XDocumentRecord(', self asString , ').'.
		^false.
	]. 
	relElectronicEditions removeAtIndex: index.
	ee2 relPrivateSetDocumentRecord: nil.
	ee2 delete.
	^true.!

relDeleteNotes: no2
	"Remove a XNote no2 from 1-1 relationship1 Notes and delete it."
	"Return true if operation succeded else return false."

	| dr1 index |
	( no2 isKindOf: DocumentDictionary100.Main.XNote ) ifFalse: [
		self dberror: 'XDocumentRecord:relDeleteNotes: Error ' message: ( no2 asString ,
			' is not a XNote, and can not possibly be deleted from Notes on' ,
			' this XDocumentRecord (', self asString, ').' ).
		^false.
	].
	(( dr1 := no2 relGetDocumentRecord ) = self ) ifFalse:[
		self dberror: 'XDocumentRecord:relDeleteNotes Error ' message: 
			'XNote (', no2 asString , ') is added to XDocumentRecord (', dr1 asString, ') ',
			'instead of this XDocumentRecord (', self asString , ').'.
		^false.
	].
	index := relNotes identityIndexOf: no2.
	(index = 0) ifTrue: [
		self dberror: 'XDocumentRecord:relDeleteNotes Error ' message: 
			'XNote (', no2 asString , ') can not be found in Notes of this XDocumentRecord(', self asString , ').'.
		^false.
	]. 
	relNotes removeAtIndex: index.
	no2 relPrivateSetDocumentRecord: nil.
	no2 delete.
	^true.!

relDeleteAllAuthorDocuments 
	"Delete all XAuthorDocument from 1-N relationship1 AuthorDocuments, and return the count of deleted objects."

	| ad2Size ad2Coll |
	ad2Size := relAuthorDocuments size.
	ad2Coll := relAuthorDocuments.
	self relInitAuthorDocuments.
	ad2Coll do: [:ad2 |
		ad2 relPrivateSetDocumentRecord: nil.
		ad2 delete.
	].
	^ad2Size.!

relDeleteAllCitedBy 
	"Delete all XCite from 1-N relationship1 CitedBy, and return the count of deleted objects."

	| ci2Size ci2Coll |
	ci2Size := relCitedBy size.
	ci2Coll := relCitedBy.
	self relInitCitedBy.
	ci2Coll do: [:ci2 |
		ci2 relPrivateSetCited: nil.
		ci2 delete.
	].
	^ci2Size.!

relDeleteAllCites 
	"Delete all XCite from 1-N relationship1 Cites, and return the count of deleted objects."

	| ci2Size ci2Coll |
	ci2Size := relCites size.
	ci2Coll := relCites.
	self relInitCites.
	ci2Coll do: [:ci2 |
		ci2 relPrivateSetCitedBy: nil.
		ci2 delete.
	].
	^ci2Size.!

relDeleteAllContentRecords 
	"Delete all XContentRecord from 1-N relationship1 ContentRecords, and return the count of deleted objects."

	| cr2Size cr2Coll |
	cr2Size := relContentRecords size.
	cr2Coll := relContentRecords.
	self relInitContentRecords.
	cr2Coll do: [:cr2 |
		cr2 relPrivateSetDocumentRecord: nil.
		cr2 delete.
	].
	^cr2Size.!

relDeleteAllCrossrefs 
	"Delete all XDocumentRecord from 1-N relationship1 Crossrefs, and return the count of deleted objects."

	| dr2Size dr2Coll |
	dr2Size := relCrossrefs size.
	dr2Coll := relCrossrefs.
	self relInitCrossrefs.
	dr2Coll do: [:dr2 |
		dr2 relPrivateSetCrossref: nil.
		dr2 delete.
	].
	^dr2Size.!

relDeleteAllElectronicEditions 
	"Delete all XElectronicEdition from 1-N relationship1 ElectronicEditions, and return the count of deleted objects."

	| ee2Size ee2Coll |
	ee2Size := relElectronicEditions size.
	ee2Coll := relElectronicEditions.
	self relInitElectronicEditions.
	ee2Coll do: [:ee2 |
		ee2 relPrivateSetDocumentRecord: nil.
		ee2 delete.
	].
	^ee2Size.!

relDeleteAllNotes 
	"Delete all XNote from 1-N relationship1 Notes, and return the count of deleted objects."

	| no2Size no2Coll |
	no2Size := relNotes size.
	no2Coll := relNotes.
	self relInitNotes.
	no2Coll do: [:no2 |
		no2 relPrivateSetDocumentRecord: nil.
		no2 delete.
	].
	^no2Size.!

relInitAuthorDocuments
	"Initialize collection of 1-N relationship1 AuthorDocuments"

	relAuthorDocuments := OrderedCollection new!

relInitCitedBy
	"Initialize collection of 1-N relationship1 CitedBy"

	relCitedBy := OrderedCollection new!

relInitCites
	"Initialize collection of 1-N relationship1 Cites"

	relCites := OrderedCollection new!

relInitContentRecords
	"Initialize collection of 1-N relationship1 ContentRecords"

	relContentRecords := OrderedCollection new!

relInitCrossrefs
	"Initialize collection of 1-N relationship1 Crossrefs"

	relCrossrefs := OrderedCollection new!

relInitElectronicEditions
	"Initialize collection of 1-N relationship1 ElectronicEditions"

	relElectronicEditions := OrderedCollection new!

relInitNotes
	"Initialize collection of 1-N relationship1 Notes"

	relNotes := OrderedCollection new!

relAllCrossref
	"Return collection of 1-N relationship crossref"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relCrossref ifNil: [ ^coll ].
	coll add: relCrossref.
	^coll.!

relAllDocumentDictionary
	"Return collection of 1-N relationship documentDictionary"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relDocumentDictionary ifNil: [ ^coll ].
	coll add: relDocumentDictionary.
	^coll.!

relSizeCrossref
	"Return the integer size of the collection returned by relAllCrossref"
	"Keeps compatibility with 1-N relationships"

	^relCrossref ifNil: [ 0 ] ifNotNil: [ 1 ].!

relSizeDocumentDictionary
	"Return the integer size of the collection returned by relAllDocumentDictionary"
	"Keeps compatibility with 1-N relationships"

	^relDocumentDictionary ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasCrossref
	"Return true if the 1-N relations2 crossref holds an object, else return false."

	^relCrossref notNil.!

relHasDocumentDictionary
	"Return true if the 1-N relations2 documentDictionary holds an object, else return false."

	^relDocumentDictionary notNil.!

relCreateCrossref
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XDocumentRecord to 1-N relationship Crossref."

	| dr1a dr1 |
	( dr1a := self relGetCrossref ) ifNotNil: [
		self dberror: 'XDocumentRecord:relCreateCrossref: Error ' message: 
			'XDocumentRecord (', self  asString , ') already has a XDocumentRecord (', dr1a asString, ') in 1-N relation Crossref.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentRecord) ifTrue: [
		dr1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentRecord.
		dr1 relAddCrossrefs: self.
		"dr1 addDefaultOwner."
		^dr1.
	] ifFalse: [
		self dberror: 'XDocumentRecord.relCreateCrossref Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relCreateDocumentDictionary
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XDocumentDictionary to 1-N relationship DocumentDictionary."

	| dd1a dd1 |
	( dd1a := self relGetDocumentDictionary ) ifNotNil: [
		self dberror: 'XDocumentDictionary:relCreateDocumentDictionary: Error ' message: 
			'XDocumentDictionary (', self  asString , ') already has a XDocumentDictionary (', dd1a asString, ') in 1-N relation DocumentDictionary.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentDictionary) ifTrue: [
		dd1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentDictionary.
		dd1 relAddDocumentRecords: self.
		"dd1 addDefaultOwner."
		^dd1.
	] ifFalse: [
		self dberror: 'XDocumentRecord.relCreateDocumentDictionary Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentDictionary. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetCrossref
	"Return the XDocumentRecord object on the other side of the 1-N relationship2 crossref."

	^relCrossref!

relGetDocumentDictionary
	"Return the XDocumentDictionary object on the other side of the 1-N relationship2 documentDictionary."

	^relDocumentDictionary!

relSetCrossref: dr1
	"Set other end of 1-1 relations2 Crossref"

	dr1 ifNotNil: [
		( dr1 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
			self dberror: 'XDocumentRecord:relSetCrossref: Error ' message: ( dr1 asString ,
				' is not a XDocumentRecord, and can not be set to' ,
				' this XDocumentRecord (', self asString, ') relation2 Crossref.' ).
			^nil.
		]
	].

	self relHasCrossref ifTrue: [ 
		"Special treatment needed if NOT_FOUND.mustExist1 == true or mustExist2 == true. "
		self relRemoveAllCrossref. 
	].
	dr1 ifNotNil: [ dr1 relAddCrossrefs: self. ].
	^dr1!

relRemoveCrossref: dr1
	"Removes a XDocumentRecord dr1 from 1-N relationship2 Crossref."

	dr1 ifNil: [
		self dberror: 'XDocumentRecord:relRemoveCrossref: Error ' message: ( 'wrong class of parameter dr1, ',
			' nil is not a XDocumentRecord, and can not be removed from' ,
			' this XDocumentRecord (', self asString, ') relation2 Crossref.' ).
		^nil.
	].

	dr1 ifNotNil: [
		( dr1 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
			self dberror: 'XDocumentRecord:relRemoveCrossref: Error ' message: ( dr1 asString ,
				' is not a XDocumentRecord, and can not be removed from' ,
				' this XDocumentRecord (', self asString, ') relation2 Crossref.' ).
			^nil.
		]
	].

	dr1 ifNotNil: [ dr1 relRemoveCrossrefs: self. ].
	^dr1!

relRemoveDocumentDictionary: dd1
	"Removes a XDocumentDictionary dd1 from 1-N relationship2 DocumentDictionary."

	dd1 ifNil: [
		self dberror: 'XDocumentRecord:relRemoveDocumentDictionary: Error ' message: ( 'wrong class of parameter dd1, ',
			' nil is not a XDocumentDictionary, and can not be removed from' ,
			' this XDocumentRecord (', self asString, ') relation2 DocumentDictionary.' ).
		^nil.
	].

	dd1 ifNotNil: [
		( dd1 isKindOf: DocumentDictionary100.Main.XDocumentDictionary ) ifFalse: [
			self dberror: 'XDocumentRecord:relRemoveDocumentDictionary: Error ' message: ( dd1 asString ,
				' is not a XDocumentDictionary, and can not be removed from' ,
				' this XDocumentRecord (', self asString, ') relation2 DocumentDictionary.' ).
			^nil.
		]
	].

	dd1 ifNotNil: [ dd1 relRemoveDocumentRecords: self. ].
	^dd1!

relRemoveAllCrossref
	"Remove a XDocumentRecord from 1-N relationship2 Crossref if there is one."
	"Available for API completeness reasons."

	(self relAllCrossref) do: [:dr1 | self relRemoveCrossref: dr1].!

relDeleteNOT_FOUND: dr1
	"Deletes a DocumentDictionary100.Main.XDocumentRecord dr1 from 1-N relationship2 Crossref."

	dr1 ifNil: [
		self dberror: 'XDocumentRecord:relDeleteCrossref: Error ' message: ( 'wrong class of parameter dr1, ',
			' nil is not a XDocumentRecord, and can not be deleted from' ,
			' this XDocumentRecord (', self asString, ') relation2 Crossref.' ).
		^nil.
	].

	dr1 ifNotNil: [
		( dr1 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
			self dberror: 'XDocumentRecord:relDeleteCrossref: Error ' message: ( dr1 asString ,
				' is not a XDocumentRecord, and can not be deleted from' ,
				' this XDocumentRecord (', self asString, ') relation2 Crossref.' ).
			^nil.
		]
	].

	dr1 ifNotNil: [ dr1 relRemoveCrossrefs: self. ].
	dr1 delete!

relDeleteAllCrossref
	"Deletes a XDocumentRecord from 1-N relationship2 Crossref if there is one."
	"Available for API completeness reasons."

	(self relAllCrossref) do: [:dr1 | self relDeleteCrossref: dr1].!

relInitCrossref
	"Initialize pointer of 1-N relationship1 Crossref "

	relCrossref := nil!

relInitDocumentDictionary
	"Initialize pointer of 1-N relationship1 DocumentDictionary "

	relDocumentDictionary := nil!

 !

!DocumentDictionary100.Main.XDocumentRecord methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetCrossref: dr1
	"Set other end of 1-N relationship1 Crossrefs"

	"dr1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying dr1.
	]."

  "( dr1 isKindOf: NOT_FOUND.XDocumentRecord ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relCrossref == dr1 ) ifFalse: [
		relCrossref := dr1.
		dr1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying dr1."
	  ].
	  self changed: #relCrossref.
	].
	^relCrossref!

relPrivateSetDocumentDictionary: dd1
	"Set other end of 1-N relationship1 DocumentRecords"

	"dd1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying dd1.
	]."

  "( dd1 isKindOf: NOT_FOUND.XDocumentDictionary ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relDocumentDictionary == dd1 ) ifFalse: [
		relDocumentDictionary := dd1.
		dd1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying dd1."
	  ].
	  self changed: #relDocumentDictionary.
	].
	^relDocumentDictionary!

 !

!DocumentDictionary100.Main.XDocumentRecord methodsFor: 'converting'!

 !

!DocumentDictionary100.Main.XDocumentRecord methodsFor: 'testing'!

classPrefix
	"Return 'dr' which is a unique prefix for class DocumentRecord within the application."

	^'dr'!

 !

