"XElectronicEdition_AutoAPI.st Generated at 2018-09-22 00:05:01.406."
'Class AutoAPI file for Class ElectronicEdition.'!

!DocumentDictionary100.Main.XElectronicEdition class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XElectronicEdition in the DomainModel DocumentDictionary100f"

	^'Url to electronic edition (ee) of the document registered in the DocumentRecord.
According to analyzed statistics, some dblp documents have up to 8 <ee> entries.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XElectronicEdition'.!

 !

!DocumentDictionary100.Main.XElectronicEdition methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XElectronicEdition in the DomainModel DocumentDictionary100f."

	^'Url to electronic edition (ee) of the document registered in the DocumentRecord.
According to analyzed statistics, some dblp documents have up to 8 <ee> entries.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitAccessDate.
	self attInitUrl.


	self relInitDocumentRecord.

	
!
canDelete
	"Return true if this ElectronicEdition can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XElectronicEdition if there is one, else return nil."

	self relHasDocumentRecord ifTrue: [ ^self relGetDocumentRecord ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."



	self relRemoveAllDocumentRecord.


	super delete!

 !

!DocumentDictionary100.Main.XElectronicEdition methodsFor: 'attributeAPI'!

attGetAccessDate
	"Get value of attribute AccessDate"
	"Date when the url of the electronic edition was last accessed, and thus known to be available."

	^attAccessDate.!

attGetUrl
	"Get value of attribute Url"
	"Url to electronic edition (ee).
ee = position of the electronic edition. 
See the definition of the class."

	^attUrl.!

attIqAccessDate
	"Return the information quantity of attribute AccessDate"
	"180413 This is a default implementation that can be extended later"

	^attAccessDate ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqUrl
	"Return the information quantity of attribute Url"
	"180413 This is a default implementation that can be extended later"

	^attUrl ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasAccessDate
	"Return true if the current value of the attribute AccessDate carries information."

	^(attAccessDate ~= nil)!

attHasUrl
	"Return true if the current value of the attribute Url carries information."

	^(attUrl ~= nil)!

attCreateAccessDate
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetAccessDate: (nil)!

attCreateUrl
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetUrl: (nil)!

attCreateAccessDate
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetAccessDate: (nil)!

attCreateUrl
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetUrl: (nil)!

attDeleteAccessDate
	"Set the attribute value to undefined, or to a value that makes attIqAccessDate return 0."

	^self attSetAccessDate: nil!

attDeleteUrl
	"Set the attribute value to undefined, or to a value that makes attIqUrl return 0."

	^self attSetUrl: nil!

attSetAccessDate: value 
	"Set the value of attribute AccessDate to value, if it is not already equal to value."

	(attAccessDate = value) ifFalse: [
		attAccessDate := value.
		self changed: #attAccessDate.
	]!

attSetUrl: value 
	"Set the value of attribute Url to value, if it is not already equal to value."

	(attUrl = value) ifFalse: [
		attUrl := value.
		self changed: #attUrl.
	]!

attInitAccessDate
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attAccessDate := nil!

attInitUrl
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attUrl := nil!

 !

!DocumentDictionary100.Main.XElectronicEdition methodsFor: 'relationshipAPI'!

relRemoveAllDocumentRecord
	"Remove a XDocumentRecord from 1-N relationship2 DocumentRecord if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllDocumentRecord) do: [:dr1 | self relRemoveDocumentRecord: dr1].!

relAllDocumentRecord
	"Return collection of 1-N relationship documentRecord"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relDocumentRecord ifNil: [ ^coll ].
	coll add: relDocumentRecord.
	^coll.!

relSizeDocumentRecord
	"Return the integer size of the collection returned by relAllDocumentRecord"
	"Keeps compatibility with 1-N relationships"

	^relDocumentRecord ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasDocumentRecord
	"Return true if the 1-N relations2 documentRecord holds an object, else return false."

	^relDocumentRecord notNil.!

relCreateDocumentRecord
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XDocumentRecord to 1-N relationship DocumentRecord."

	| dr1a dr1 |
	( dr1a := self relGetDocumentRecord ) ifNotNil: [
		self dberror: 'XDocumentRecord:relCreateDocumentRecord: Error ' message: 
			'XDocumentRecord (', self  asString , ') already has a XDocumentRecord (', dr1a asString, ') in 1-N relation DocumentRecord.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentRecord) ifTrue: [
		dr1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentRecord.
		dr1 relAddElectronicEditions: self.
		"dr1 addDefaultOwner."
		^dr1.
	] ifFalse: [
		self dberror: 'XElectronicEdition.relCreateDocumentRecord Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetDocumentRecord
	"Return the XDocumentRecord object on the other side of the 1-N relationship2 documentRecord."

	^relDocumentRecord!

relRemoveDocumentRecord: dr1
	"Removes a XDocumentRecord dr1 from 1-N relationship2 DocumentRecord."

	dr1 ifNil: [
		self dberror: 'XElectronicEdition:relRemoveDocumentRecord: Error ' message: ( 'wrong class of parameter dr1, ',
			' nil is not a XDocumentRecord, and can not be removed from' ,
			' this XElectronicEdition (', self asString, ') relation2 DocumentRecord.' ).
		^nil.
	].

	dr1 ifNotNil: [
		( dr1 isKindOf: DocumentDictionary100.Main.XDocumentRecord ) ifFalse: [
			self dberror: 'XElectronicEdition:relRemoveDocumentRecord: Error ' message: ( dr1 asString ,
				' is not a XDocumentRecord, and can not be removed from' ,
				' this XElectronicEdition (', self asString, ') relation2 DocumentRecord.' ).
			^nil.
		]
	].

	dr1 ifNotNil: [ dr1 relRemoveElectronicEditions: self. ].
	^dr1!

relInitDocumentRecord
	"Initialize pointer of 1-N relationship1 DocumentRecord "

	relDocumentRecord := nil!

 !

!DocumentDictionary100.Main.XElectronicEdition methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetDocumentRecord: dr1
	"Set other end of 1-N relationship1 ElectronicEditions"

	"dr1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying dr1.
	]."

  "( dr1 isKindOf: NOT_FOUND.XDocumentRecord ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relDocumentRecord == dr1 ) ifFalse: [
		relDocumentRecord := dr1.
		dr1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying dr1."
	  ].
	  self changed: #relDocumentRecord.
	].
	^relDocumentRecord!

 !

!DocumentDictionary100.Main.XElectronicEdition methodsFor: 'converting'!

 !

!DocumentDictionary100.Main.XElectronicEdition methodsFor: 'testing'!

classPrefix
	"Return 'ee' which is a unique prefix for class ElectronicEdition within the application."

	^'ee'!

 !

