"XLabelModelElement_AutoAPI.st Generated at 2018-09-22 00:05:36.258."
'Class AutoAPI file for Class LabelModelElement.'!

!DocumentDictionary100.Main.XLabelModelElement class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XLabelModelElement in the DomainModel DocumentDictionary100f"

	^'Model element that manages the functionality of sorting and structuring of labelled and ordered ModelElements in interactive lists and reports.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XLabelModelElement'.!

 !

!DocumentDictionary100.Main.XLabelModelElement methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XLabelModelElement in the DomainModel DocumentDictionary100f."

	^'Model element that manages the functionality of sorting and structuring of labelled and ordered ModelElements in interactive lists and reports.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitLabel.
	self attInitOrdinalPosition.



	
!
canDelete
	"Return true if this LabelModelElement can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XLabelModelElement if there is one, else return nil."


	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."





	super delete!

 !

!DocumentDictionary100.Main.XLabelModelElement methodsFor: 'attributeAPI'!

attGetLabel
	"Get value of attribute Label"
	"A number or character string used for shorthand identification and ordering of objects on the same level in their main hierarchy. The position in the hierarchy can be represented by a hierarchy path of object.labels (example 1.2.1.4)."

	^attLabel.!

attGetOrdinalPosition
	"Get value of attribute OrdinalPosition"
	"Ordinal position of a LabelModelElement, for e g a ContentRecord within its owning container, e g a DocumentRecord. 
The first ContentRecord in a table of contents typically has ordinalPosition = 1.
A container per default, sorts its owned LabelModelElements by ordinalPosition, label, name.
A NULL ordinalPosition comes first in the sort order."

	^attOrdinalPosition.!

attIqLabel
	"Return the information quantity of attribute Label"
	"180413 This is a default implementation that can be extended later"

	^attLabel ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqOrdinalPosition
	"Return the information quantity of attribute OrdinalPosition"
	"180413 This is a default implementation that can be extended later"

	^attOrdinalPosition ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasLabel
	"Return true if the current value of the attribute Label carries information."

	^(attLabel ~= nil)!

attHasOrdinalPosition
	"Return true if the current value of the attribute OrdinalPosition carries information."

	^(attOrdinalPosition ~= nil)!

attCreateLabel
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetLabel: (nil)!

attCreateOrdinalPosition
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetOrdinalPosition: (nil)!

attCreateLabel
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetLabel: (nil)!

attCreateOrdinalPosition
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetOrdinalPosition: (nil)!

attDeleteLabel
	"Set the attribute value to undefined, or to a value that makes attIqLabel return 0."

	^self attSetLabel: nil!

attDeleteOrdinalPosition
	"Set the attribute value to undefined, or to a value that makes attIqOrdinalPosition return 0."

	^self attSetOrdinalPosition: nil!

attSetLabel: value 
	"Set the value of attribute Label to value, if it is not already equal to value."

	(attLabel = value) ifFalse: [
		attLabel := value.
		self changed: #attLabel.
	]!

attSetOrdinalPosition: value 
	"Set the value of attribute OrdinalPosition to value, if it is not already equal to value."

	(attOrdinalPosition = value) ifFalse: [
		attOrdinalPosition := value.
		self changed: #attOrdinalPosition.
	]!

attInitLabel
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attLabel := nil!

attInitOrdinalPosition
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attOrdinalPosition := nil!

 !

!DocumentDictionary100.Main.XLabelModelElement methodsFor: 'relationshipAPI'!

 !

!DocumentDictionary100.Main.XLabelModelElement methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

 !

!DocumentDictionary100.Main.XLabelModelElement methodsFor: 'converting'!

 !

!DocumentDictionary100.Main.XLabelModelElement methodsFor: 'testing'!

classPrefix
	"Return 'LE' which is a unique prefix for class LabelModelElement within the application."

	^'LE'!

 !

