"XObjectRecord_AutoAPI.st Generated at 2018-09-22 00:06:39.533."
'Class AutoAPI file for Class ObjectRecord.'!

!DocumentDictionary100.Main.XObjectRecord class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XObjectRecord in the DomainModel DocumentDictionary100f"

	^'The ObjectRecord serves as a high speed cache for interactive browsing of previously absorbed knowledge content.
This cache is for private personal use only, or organizational use when the organization has created the information themselves or acquired the right to distribute the material within its organizational boarders this way.
'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XObjectRecord'.!

 !

!DocumentDictionary100.Main.XObjectRecord methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XObjectRecord in the DomainModel DocumentDictionary100f."

	^'The ObjectRecord serves as a high speed cache for interactive browsing of previously absorbed knowledge content.
This cache is for private personal use only, or organizational use when the organization has created the information themselves or acquired the right to distribute the material within its organizational boarders this way.
'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitData.
	self attInitObjectType.


	self relInitContentRecord.

	
!
canDelete
	"Return true if this ObjectRecord can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XObjectRecord if there is one, else return nil."

	self relHasContentRecord ifTrue: [ ^self relGetContentRecord ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."



	self relRemoveAllContentRecord.


	super delete!

 !

!DocumentDictionary100.Main.XObjectRecord methodsFor: 'attributeAPI'!

attGetData
	"Get value of attribute Data"
	"This attribute may be used to specify an URI, URL, local network or local computer file location of the object_s data, for instance image data for objects defining images. In case the data value content_s syntax can not be interpreted as a reference pointer, the data value itself can be a serialized form of an object which can be used to recreate it_s representation.
Common practice for all standardized serialzed data representation forms is that they have some kind of unique easy to detect entry tag within the header of the serialization format, that allows a set of automated data readers to determine which one to use for reading the object data representation.
Due to the present state of conditions for the IT infrastructure available to communicate information to the capillars of this endowment, this field has the DateElementType of text, where the stored representation should be 127 bit ascii characters, thus self-detectable base64 representation is needed for any binary data storage format."

	^attData.!

attGetObjectType
	"Get value of attribute ObjectType"
	"The optional objectType defines the category or sub category of object whose representation is stored in the data attribute.  Example of category and subcategories is:

Image
  JPEG
  PNG

"

	^attObjectType.!

attIqData
	"Return the information quantity of attribute Data"
	"180413 This is a default implementation that can be extended later"

	^attData ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqObjectType
	"Return the information quantity of attribute ObjectType"
	"180413 This is a default implementation that can be extended later"

	^attObjectType ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasData
	"Return true if the current value of the attribute Data carries information."

	^(attData ~= nil)!

attHasObjectType
	"Return true if the current value of the attribute ObjectType carries information."

	^(attObjectType ~= nil)!

attCreateData
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetData: (nil)!

attCreateObjectType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetObjectType: (nil)!

attCreateData
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetData: (nil)!

attCreateObjectType
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetObjectType: (nil)!

attDeleteData
	"Set the attribute value to undefined, or to a value that makes attIqData return 0."

	^self attSetData: nil!

attDeleteObjectType
	"Set the attribute value to undefined, or to a value that makes attIqObjectType return 0."

	^self attSetObjectType: nil!

attSetData: value 
	"Set the value of attribute Data to value, if it is not already equal to value."

	(attData = value) ifFalse: [
		attData := value.
		self changed: #attData.
	]!

attSetObjectType: value 
	"Set the value of attribute ObjectType to value, if it is not already equal to value."

	(attObjectType = value) ifFalse: [
		attObjectType := value.
		self changed: #attObjectType.
	]!

attInitData
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attData := nil!

attInitObjectType
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attObjectType := nil!

 !

!DocumentDictionary100.Main.XObjectRecord methodsFor: 'relationshipAPI'!

relRemoveAllContentRecord
	"Remove a XContentRecord from 1-N relationship2 ContentRecord if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllContentRecord) do: [:cr1 | self relRemoveContentRecord: cr1].!

relAllContentRecord
	"Return collection of 1-N relationship contentRecord"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relContentRecord ifNil: [ ^coll ].
	coll add: relContentRecord.
	^coll.!

relSizeContentRecord
	"Return the integer size of the collection returned by relAllContentRecord"
	"Keeps compatibility with 1-N relationships"

	^relContentRecord ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasContentRecord
	"Return true if the 1-N relations2 contentRecord holds an object, else return false."

	^relContentRecord notNil.!

relCreateContentRecord
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XContentRecord to 1-N relationship ContentRecord."

	| cr1a cr1 |
	( cr1a := self relGetContentRecord ) ifNotNil: [
		self dberror: 'XContentRecord:relCreateContentRecord: Error ' message: 
			'XContentRecord (', self  asString , ') already has a XContentRecord (', cr1a asString, ') in 1-N relation ContentRecord.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XContentRecord) ifTrue: [
		cr1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XContentRecord.
		cr1 relAddObjectRecords: self.
		"cr1 addDefaultOwner."
		^cr1.
	] ifFalse: [
		self dberror: 'XObjectRecord.relCreateContentRecord Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XContentRecord. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetContentRecord
	"Return the XContentRecord object on the other side of the 1-N relationship2 contentRecord."

	^relContentRecord!

relRemoveContentRecord: cr1
	"Removes a XContentRecord cr1 from 1-N relationship2 ContentRecord."

	cr1 ifNil: [
		self dberror: 'XObjectRecord:relRemoveContentRecord: Error ' message: ( 'wrong class of parameter cr1, ',
			' nil is not a XContentRecord, and can not be removed from' ,
			' this XObjectRecord (', self asString, ') relation2 ContentRecord.' ).
		^nil.
	].

	cr1 ifNotNil: [
		( cr1 isKindOf: DocumentDictionary100.Main.XContentRecord ) ifFalse: [
			self dberror: 'XObjectRecord:relRemoveContentRecord: Error ' message: ( cr1 asString ,
				' is not a XContentRecord, and can not be removed from' ,
				' this XObjectRecord (', self asString, ') relation2 ContentRecord.' ).
			^nil.
		]
	].

	cr1 ifNotNil: [ cr1 relRemoveObjectRecords: self. ].
	^cr1!

relInitContentRecord
	"Initialize pointer of 1-N relationship1 ContentRecord "

	relContentRecord := nil!

 !

!DocumentDictionary100.Main.XObjectRecord methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetContentRecord: cr1
	"Set other end of 1-N relationship1 ObjectRecords"

	"cr1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying cr1.
	]."

  "( cr1 isKindOf: NOT_FOUND.XContentRecord ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relContentRecord == cr1 ) ifFalse: [
		relContentRecord := cr1.
		cr1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying cr1."
	  ].
	  self changed: #relContentRecord.
	].
	^relContentRecord!

 !

!DocumentDictionary100.Main.XObjectRecord methodsFor: 'converting'!

 !

!DocumentDictionary100.Main.XObjectRecord methodsFor: 'testing'!

classPrefix
	"Return 'or' which is a unique prefix for class ObjectRecord within the application."

	^'or'!

 !

