"XDocumentDictionaryLogRecord_AutoAPI.st Generated at 2018-09-22 00:03:38.100."
'Class AutoAPI file for Class DocumentDictionaryLogRecord.'!

!DocumentDictionary100.Main.XDocumentDictionaryLogRecord class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XDocumentDictionaryLogRecord in the DomainModel DocumentDictionary100f"

	^'Repository synchronization log support.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XDocumentDictionaryLogRecord'.!

 !

!DocumentDictionary100.Main.XDocumentDictionaryLogRecord methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XDocumentDictionaryLogRecord in the DomainModel DocumentDictionary100f."

	^'Repository synchronization log support.'.!

initialize
	"initialize attributes and relationships"

	super initialize.


	self relInitLogOwner.

	
!
canDelete
	"Return true if this DocumentDictionaryLogRecord can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XDocumentDictionaryLogRecord if there is one, else return nil."

	self relHasLogOwner ifTrue: [ ^self relGetLogOwner ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."



	self relRemoveAllLogOwner.


	super delete!

 !

!DocumentDictionary100.Main.XDocumentDictionaryLogRecord methodsFor: 'attributeAPI'!

 !

!DocumentDictionary100.Main.XDocumentDictionaryLogRecord methodsFor: 'relationshipAPI'!

relRemoveAllLogOwner
	"Remove a XDocumentDictionary from 1-N relationship2 LogOwner if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllLogOwner) do: [:dd1 | self relRemoveLogOwner: dd1].!

relAllLogOwner
	"Return collection of 1-N relationship logOwner"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relLogOwner ifNil: [ ^coll ].
	coll add: relLogOwner.
	^coll.!

relSizeLogOwner
	"Return the integer size of the collection returned by relAllLogOwner"
	"Keeps compatibility with 1-N relationships"

	^relLogOwner ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasLogOwner
	"Return true if the 1-N relations2 logOwner holds an object, else return false."

	^relLogOwner notNil.!

relCreateLogOwner
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XDocumentDictionary to 1-N relationship LogOwner."

	| dd1a dd1 |
	( dd1a := self relGetLogOwner ) ifNotNil: [
		self dberror: 'XDocumentDictionary:relCreateLogOwner: Error ' message: 
			'XDocumentDictionary (', self  asString , ') already has a XDocumentDictionary (', dd1a asString, ') in 1-N relation LogOwner.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Main.XDocumentDictionary) ifTrue: [
		dd1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Main.XDocumentDictionary.
		dd1 relAddLogRecords: self.
		"dd1 addDefaultOwner."
		^dd1.
	] ifFalse: [
		self dberror: 'XDocumentDictionaryLogRecord.relCreateLogOwner Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Main.XDocumentDictionary. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetLogOwner
	"Return the XDocumentDictionary object on the other side of the 1-N relationship2 logOwner."

	^relLogOwner!

relRemoveLogOwner: dd1
	"Removes a XDocumentDictionary dd1 from 1-N relationship2 LogOwner."

	dd1 ifNil: [
		self dberror: 'XDocumentDictionaryLogRecord:relRemoveLogOwner: Error ' message: ( 'wrong class of parameter dd1, ',
			' nil is not a XDocumentDictionary, and can not be removed from' ,
			' this XDocumentDictionaryLogRecord (', self asString, ') relation2 LogOwner.' ).
		^nil.
	].

	dd1 ifNotNil: [
		( dd1 isKindOf: DocumentDictionary100.Main.XDocumentDictionary ) ifFalse: [
			self dberror: 'XDocumentDictionaryLogRecord:relRemoveLogOwner: Error ' message: ( dd1 asString ,
				' is not a XDocumentDictionary, and can not be removed from' ,
				' this XDocumentDictionaryLogRecord (', self asString, ') relation2 LogOwner.' ).
			^nil.
		]
	].

	dd1 ifNotNil: [ dd1 relRemoveLogRecords: self. ].
	^dd1!

relInitLogOwner
	"Initialize pointer of 1-N relationship1 LogOwner "

	relLogOwner := nil!

 !

!DocumentDictionary100.Main.XDocumentDictionaryLogRecord methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetLogOwner: dd1
	"Set other end of 1-N relationship1 LogRecords"

	"dd1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying dd1.
	]."

  "( dd1 isKindOf: NOT_FOUND.XDocumentDictionary ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relLogOwner == dd1 ) ifFalse: [
		relLogOwner := dd1.
		dd1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying dd1."
	  ].
	  self changed: #relLogOwner.
	].
	^relLogOwner!

 !

!DocumentDictionary100.Main.XDocumentDictionaryLogRecord methodsFor: 'converting'!

 !

!DocumentDictionary100.Main.XDocumentDictionaryLogRecord methodsFor: 'testing'!

classPrefix
	"Return 'ddl' which is a unique prefix for class DocumentDictionaryLogRecord within the application."

	^'ddl'!

 !

